//===- TableGen'erated file -------------------------------------*- C++ -*-===//
//
// DAG Instruction Selector for the PPC target
//
// Automatically generated file, do not edit!
//
//===----------------------------------------------------------------------===//

// *** NOTE: This file is #included into the middle of the target
// *** instruction selector class.  These functions are really methods.

// The main instruction selector code.
SDNode *SelectCode(SDNode *N) {
  // Some target values are emitted as 2 bytes, TARGET_VAL handles
  // this.
  #define TARGET_VAL(X) X & 255, unsigned(X) >> 8
  static const unsigned char MatcherTable[] = {
/*0*/     OPC_SwitchOpcode /*97 cases */, 33,  TARGET_VAL(ISD::PREFETCH),// ->37
/*4*/       OPC_RecordMemRef,
/*5*/       OPC_RecordNode,   // #0 = 'prefetch' chained node
/*6*/       OPC_RecordChild1, // #1 = $dst
/*7*/       OPC_MoveChild, 2,
/*9*/       OPC_CheckInteger, 0, 
/*11*/      OPC_CheckType, MVT::i32,
/*13*/      OPC_MoveParent,
/*14*/      OPC_MoveChild, 3,
/*16*/      OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/*19*/      OPC_MoveParent,
/*20*/      OPC_MoveChild, 4,
/*22*/      OPC_CheckInteger, 1, 
/*24*/      OPC_MoveParent,
/*25*/      OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrIdxOnly:$dst #2 #3
/*28*/      OPC_EmitMergeInputChains1_0,
/*29*/      OPC_MorphNodeTo, TARGET_VAL(PPC::DCBT), 0|OPFL_Chain|OPFL_MemRefs,
                0/*#VTs*/, 2/*#Ops*/, 2, 3, 
            // Src: (prefetch xoaddr:iPTR:$dst, 0:i32, (imm:i32), 1:i32) - Complexity = 25
            // Dst: (DCBT xoaddr:iPTR:$dst)
          /*SwitchOpcode*/ 40,  TARGET_VAL(ISD::MEMBARRIER),// ->80
/*40*/      OPC_RecordNode,   // #0 = 'membarrier' chained node
/*41*/      OPC_MoveChild, 1,
/*43*/      OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/*46*/      OPC_CheckType, MVT::i32,
/*48*/      OPC_MoveParent,
/*49*/      OPC_MoveChild, 2,
/*51*/      OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/*54*/      OPC_MoveParent,
/*55*/      OPC_MoveChild, 3,
/*57*/      OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/*60*/      OPC_MoveParent,
/*61*/      OPC_MoveChild, 4,
/*63*/      OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/*66*/      OPC_MoveParent,
/*67*/      OPC_MoveChild, 5,
/*69*/      OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/*72*/      OPC_MoveParent,
/*73*/      OPC_EmitMergeInputChains1_0,
/*74*/      OPC_MorphNodeTo, TARGET_VAL(PPC::SYNC), 0|OPFL_Chain,
                0/*#VTs*/, 0/*#Ops*/, 
            // Src: (membarrier (imm:i32), (imm:i32), (imm:i32), (imm:i32), (imm:i32)) - Complexity = 18
            // Dst: (SYNC)
          /*SwitchOpcode*/ 73|128,4/*585*/,  TARGET_VAL(ISD::INTRINSIC_VOID),// ->669
/*84*/      OPC_RecordNode,   // #0 = 'intrinsic_void' chained node
/*85*/      OPC_MoveChild, 1,
/*87*/      OPC_Scope, 17, /*->106*/ // 21 children in Scope
/*89*/        OPC_CheckInteger, 55|128,11/*1463*/, 
/*92*/        OPC_MoveParent,
/*93*/        OPC_RecordChild2, // #1 = $dst
/*94*/        OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrIdxOnly:$dst #2 #3
/*97*/        OPC_EmitMergeInputChains1_0,
/*98*/        OPC_MorphNodeTo, TARGET_VAL(PPC::DCBA), 0|OPFL_Chain,
                  0/*#VTs*/, 2/*#Ops*/, 2, 3, 
              // Src: (intrinsic_void 1463:iPTR, xoaddr:iPTR:$dst) - Complexity = 17
              // Dst: (DCBA xoaddr:iPTR:$dst)
/*106*/     /*Scope*/ 17, /*->124*/
/*107*/       OPC_CheckInteger, 56|128,11/*1464*/, 
/*110*/       OPC_MoveParent,
/*111*/       OPC_RecordChild2, // #1 = $dst
/*112*/       OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrIdxOnly:$dst #2 #3
/*115*/       OPC_EmitMergeInputChains1_0,
/*116*/       OPC_MorphNodeTo, TARGET_VAL(PPC::DCBF), 0|OPFL_Chain,
                  0/*#VTs*/, 2/*#Ops*/, 2, 3, 
              // Src: (intrinsic_void 1464:iPTR, xoaddr:iPTR:$dst) - Complexity = 17
              // Dst: (DCBF xoaddr:iPTR:$dst)
/*124*/     /*Scope*/ 17, /*->142*/
/*125*/       OPC_CheckInteger, 57|128,11/*1465*/, 
/*128*/       OPC_MoveParent,
/*129*/       OPC_RecordChild2, // #1 = $dst
/*130*/       OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrIdxOnly:$dst #2 #3
/*133*/       OPC_EmitMergeInputChains1_0,
/*134*/       OPC_MorphNodeTo, TARGET_VAL(PPC::DCBI), 0|OPFL_Chain,
                  0/*#VTs*/, 2/*#Ops*/, 2, 3, 
              // Src: (intrinsic_void 1465:iPTR, xoaddr:iPTR:$dst) - Complexity = 17
              // Dst: (DCBI xoaddr:iPTR:$dst)
/*142*/     /*Scope*/ 17, /*->160*/
/*143*/       OPC_CheckInteger, 58|128,11/*1466*/, 
/*146*/       OPC_MoveParent,
/*147*/       OPC_RecordChild2, // #1 = $dst
/*148*/       OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrIdxOnly:$dst #2 #3
/*151*/       OPC_EmitMergeInputChains1_0,
/*152*/       OPC_MorphNodeTo, TARGET_VAL(PPC::DCBST), 0|OPFL_Chain,
                  0/*#VTs*/, 2/*#Ops*/, 2, 3, 
              // Src: (intrinsic_void 1466:iPTR, xoaddr:iPTR:$dst) - Complexity = 17
              // Dst: (DCBST xoaddr:iPTR:$dst)
/*160*/     /*Scope*/ 17, /*->178*/
/*161*/       OPC_CheckInteger, 59|128,11/*1467*/, 
/*164*/       OPC_MoveParent,
/*165*/       OPC_RecordChild2, // #1 = $dst
/*166*/       OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrIdxOnly:$dst #2 #3
/*169*/       OPC_EmitMergeInputChains1_0,
/*170*/       OPC_MorphNodeTo, TARGET_VAL(PPC::DCBT), 0|OPFL_Chain,
                  0/*#VTs*/, 2/*#Ops*/, 2, 3, 
              // Src: (intrinsic_void 1467:iPTR, xoaddr:iPTR:$dst) - Complexity = 17
              // Dst: (DCBT xoaddr:iPTR:$dst)
/*178*/     /*Scope*/ 17, /*->196*/
/*179*/       OPC_CheckInteger, 60|128,11/*1468*/, 
/*182*/       OPC_MoveParent,
/*183*/       OPC_RecordChild2, // #1 = $dst
/*184*/       OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrIdxOnly:$dst #2 #3
/*187*/       OPC_EmitMergeInputChains1_0,
/*188*/       OPC_MorphNodeTo, TARGET_VAL(PPC::DCBTST), 0|OPFL_Chain,
                  0/*#VTs*/, 2/*#Ops*/, 2, 3, 
              // Src: (intrinsic_void 1468:iPTR, xoaddr:iPTR:$dst) - Complexity = 17
              // Dst: (DCBTST xoaddr:iPTR:$dst)
/*196*/     /*Scope*/ 17, /*->214*/
/*197*/       OPC_CheckInteger, 61|128,11/*1469*/, 
/*200*/       OPC_MoveParent,
/*201*/       OPC_RecordChild2, // #1 = $dst
/*202*/       OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrIdxOnly:$dst #2 #3
/*205*/       OPC_EmitMergeInputChains1_0,
/*206*/       OPC_MorphNodeTo, TARGET_VAL(PPC::DCBZ), 0|OPFL_Chain,
                  0/*#VTs*/, 2/*#Ops*/, 2, 3, 
              // Src: (intrinsic_void 1469:iPTR, xoaddr:iPTR:$dst) - Complexity = 17
              // Dst: (DCBZ xoaddr:iPTR:$dst)
/*214*/     /*Scope*/ 17, /*->232*/
/*215*/       OPC_CheckInteger, 62|128,11/*1470*/, 
/*218*/       OPC_MoveParent,
/*219*/       OPC_RecordChild2, // #1 = $dst
/*220*/       OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrIdxOnly:$dst #2 #3
/*223*/       OPC_EmitMergeInputChains1_0,
/*224*/       OPC_MorphNodeTo, TARGET_VAL(PPC::DCBZL), 0|OPFL_Chain,
                  0/*#VTs*/, 2/*#Ops*/, 2, 3, 
              // Src: (intrinsic_void 1470:iPTR, xoaddr:iPTR:$dst) - Complexity = 17
              // Dst: (DCBZL xoaddr:iPTR:$dst)
/*232*/     /*Scope*/ 19, /*->252*/
/*233*/       OPC_CheckInteger, 51|128,10/*1331*/, 
/*236*/       OPC_MoveParent,
/*237*/       OPC_RecordChild2, // #1 = $rS
/*238*/       OPC_RecordChild3, // #2 = $dst
/*239*/       OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddrIdxOnly:$dst #3 #4
/*242*/       OPC_EmitMergeInputChains1_0,
/*243*/       OPC_MorphNodeTo, TARGET_VAL(PPC::STVEBX), 0|OPFL_Chain,
                  0/*#VTs*/, 3/*#Ops*/, 1, 3, 4, 
              // Src: (intrinsic_void 1331:iPTR, VRRC:v16i8:$rS, xoaddr:iPTR:$dst) - Complexity = 17
              // Dst: (STVEBX VRRC:v16i8:$rS, xoaddr:iPTR:$dst)
/*252*/     /*Scope*/ 19, /*->272*/
/*253*/       OPC_CheckInteger, 52|128,10/*1332*/, 
/*256*/       OPC_MoveParent,
/*257*/       OPC_RecordChild2, // #1 = $rS
/*258*/       OPC_RecordChild3, // #2 = $dst
/*259*/       OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddrIdxOnly:$dst #3 #4
/*262*/       OPC_EmitMergeInputChains1_0,
/*263*/       OPC_MorphNodeTo, TARGET_VAL(PPC::STVEHX), 0|OPFL_Chain,
                  0/*#VTs*/, 3/*#Ops*/, 1, 3, 4, 
              // Src: (intrinsic_void 1332:iPTR, VRRC:v8i16:$rS, xoaddr:iPTR:$dst) - Complexity = 17
              // Dst: (STVEHX VRRC:v8i16:$rS, xoaddr:iPTR:$dst)
/*272*/     /*Scope*/ 19, /*->292*/
/*273*/       OPC_CheckInteger, 53|128,10/*1333*/, 
/*276*/       OPC_MoveParent,
/*277*/       OPC_RecordChild2, // #1 = $rS
/*278*/       OPC_RecordChild3, // #2 = $dst
/*279*/       OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddrIdxOnly:$dst #3 #4
/*282*/       OPC_EmitMergeInputChains1_0,
/*283*/       OPC_MorphNodeTo, TARGET_VAL(PPC::STVEWX), 0|OPFL_Chain,
                  0/*#VTs*/, 3/*#Ops*/, 1, 3, 4, 
              // Src: (intrinsic_void 1333:iPTR, VRRC:v4i32:$rS, xoaddr:iPTR:$dst) - Complexity = 17
              // Dst: (STVEWX VRRC:v4i32:$rS, xoaddr:iPTR:$dst)
/*292*/     /*Scope*/ 19, /*->312*/
/*293*/       OPC_CheckInteger, 54|128,10/*1334*/, 
/*296*/       OPC_MoveParent,
/*297*/       OPC_RecordChild2, // #1 = $rS
/*298*/       OPC_RecordChild3, // #2 = $dst
/*299*/       OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddrIdxOnly:$dst #3 #4
/*302*/       OPC_EmitMergeInputChains1_0,
/*303*/       OPC_MorphNodeTo, TARGET_VAL(PPC::STVX), 0|OPFL_Chain,
                  0/*#VTs*/, 3/*#Ops*/, 1, 3, 4, 
              // Src: (intrinsic_void 1334:iPTR, VRRC:v4i32:$rS, xoaddr:iPTR:$dst) - Complexity = 17
              // Dst: (STVX VRRC:v4i32:$rS, xoaddr:iPTR:$dst)
/*312*/     /*Scope*/ 19, /*->332*/
/*313*/       OPC_CheckInteger, 55|128,10/*1335*/, 
/*316*/       OPC_MoveParent,
/*317*/       OPC_RecordChild2, // #1 = $rS
/*318*/       OPC_RecordChild3, // #2 = $dst
/*319*/       OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddrIdxOnly:$dst #3 #4
/*322*/       OPC_EmitMergeInputChains1_0,
/*323*/       OPC_MorphNodeTo, TARGET_VAL(PPC::STVXL), 0|OPFL_Chain,
                  0/*#VTs*/, 3/*#Ops*/, 1, 3, 4, 
              // Src: (intrinsic_void 1335:iPTR, VRRC:v4i32:$rS, xoaddr:iPTR:$dst) - Complexity = 17
              // Dst: (STVXL VRRC:v4i32:$rS, xoaddr:iPTR:$dst)
/*332*/     /*Scope*/ 33, /*->366*/
/*333*/       OPC_CheckInteger, 36|128,10/*1316*/, 
/*336*/       OPC_MoveParent,
/*337*/       OPC_RecordChild2, // #1 = $STRM
/*338*/       OPC_MoveChild, 2,
/*340*/       OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/*343*/       OPC_MoveParent,
/*344*/       OPC_EmitMergeInputChains1_0,
/*345*/       OPC_EmitInteger, MVT::i32, 0, 
/*348*/       OPC_EmitConvertToTarget, 1,
/*350*/       OPC_EmitInteger, MVT::i32, 0, 
/*353*/       OPC_EmitInteger, MVT::i32, 0, 
/*356*/       OPC_MorphNodeTo, TARGET_VAL(PPC::DSS), 0|OPFL_Chain,
                  0/*#VTs*/, 4/*#Ops*/, 2, 3, 4, 5, 
              // Src: (intrinsic_void 1316:iPTR, (imm:i32):$STRM) - Complexity = 11
              // Dst: (DSS 0:i32, (imm:i32):$STRM, 0:i32, 0:i32)
/*366*/     /*Scope*/ 61, /*->428*/
/*367*/       OPC_CheckInteger, 38|128,10/*1318*/, 
/*370*/       OPC_MoveParent,
/*371*/       OPC_RecordChild2, // #1 = $rA
/*372*/       OPC_Scope, 26, /*->400*/ // 2 children in Scope
/*374*/         OPC_CheckChild2Type, MVT::i32,
/*376*/         OPC_RecordChild3, // #2 = $rB
/*377*/         OPC_RecordChild4, // #3 = $STRM
/*378*/         OPC_MoveChild, 4,
/*380*/         OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/*383*/         OPC_MoveParent,
/*384*/         OPC_EmitMergeInputChains1_0,
/*385*/         OPC_EmitInteger, MVT::i32, 0, 
/*388*/         OPC_EmitConvertToTarget, 3,
/*390*/         OPC_MorphNodeTo, TARGET_VAL(PPC::DST), 0|OPFL_Chain,
                    0/*#VTs*/, 4/*#Ops*/, 4, 5, 1, 2, 
                // Src: (intrinsic_void 1318:iPTR, GPRC:i32:$rA, GPRC:i32:$rB, (imm:i32):$STRM) - Complexity = 11
                // Dst: (DST 0:i32, (imm:i32):$STRM, GPRC:i32:$rA, GPRC:i32:$rB)
/*400*/       /*Scope*/ 26, /*->427*/
/*401*/         OPC_CheckChild2Type, MVT::i64,
/*403*/         OPC_RecordChild3, // #2 = $rB
/*404*/         OPC_RecordChild4, // #3 = $STRM
/*405*/         OPC_MoveChild, 4,
/*407*/         OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/*410*/         OPC_MoveParent,
/*411*/         OPC_EmitMergeInputChains1_0,
/*412*/         OPC_EmitInteger, MVT::i32, 0, 
/*415*/         OPC_EmitConvertToTarget, 3,
/*417*/         OPC_MorphNodeTo, TARGET_VAL(PPC::DST64), 0|OPFL_Chain,
                    0/*#VTs*/, 4/*#Ops*/, 4, 5, 1, 2, 
                // Src: (intrinsic_void 1318:iPTR, G8RC:i64:$rA, GPRC:i32:$rB, (imm:i32):$STRM) - Complexity = 11
                // Dst: (DST64 0:i32, (imm:i32):$STRM, G8RC:i64:$rA, GPRC:i32:$rB)
/*427*/       0, /*End of Scope*/
/*428*/     /*Scope*/ 61, /*->490*/
/*429*/       OPC_CheckInteger, 41|128,10/*1321*/, 
/*432*/       OPC_MoveParent,
/*433*/       OPC_RecordChild2, // #1 = $rA
/*434*/       OPC_Scope, 26, /*->462*/ // 2 children in Scope
/*436*/         OPC_CheckChild2Type, MVT::i32,
/*438*/         OPC_RecordChild3, // #2 = $rB
/*439*/         OPC_RecordChild4, // #3 = $STRM
/*440*/         OPC_MoveChild, 4,
/*442*/         OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/*445*/         OPC_MoveParent,
/*446*/         OPC_EmitMergeInputChains1_0,
/*447*/         OPC_EmitInteger, MVT::i32, 1, 
/*450*/         OPC_EmitConvertToTarget, 3,
/*452*/         OPC_MorphNodeTo, TARGET_VAL(PPC::DSTT), 0|OPFL_Chain,
                    0/*#VTs*/, 4/*#Ops*/, 4, 5, 1, 2, 
                // Src: (intrinsic_void 1321:iPTR, GPRC:i32:$rA, GPRC:i32:$rB, (imm:i32):$STRM) - Complexity = 11
                // Dst: (DSTT 1:i32, (imm:i32):$STRM, GPRC:i32:$rA, GPRC:i32:$rB)
/*462*/       /*Scope*/ 26, /*->489*/
/*463*/         OPC_CheckChild2Type, MVT::i64,
/*465*/         OPC_RecordChild3, // #2 = $rB
/*466*/         OPC_RecordChild4, // #3 = $STRM
/*467*/         OPC_MoveChild, 4,
/*469*/         OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/*472*/         OPC_MoveParent,
/*473*/         OPC_EmitMergeInputChains1_0,
/*474*/         OPC_EmitInteger, MVT::i32, 1, 
/*477*/         OPC_EmitConvertToTarget, 3,
/*479*/         OPC_MorphNodeTo, TARGET_VAL(PPC::DSTT64), 0|OPFL_Chain,
                    0/*#VTs*/, 4/*#Ops*/, 4, 5, 1, 2, 
                // Src: (intrinsic_void 1321:iPTR, G8RC:i64:$rA, GPRC:i32:$rB, (imm:i32):$STRM) - Complexity = 11
                // Dst: (DSTT64 1:i32, (imm:i32):$STRM, G8RC:i64:$rA, GPRC:i32:$rB)
/*489*/       0, /*End of Scope*/
/*490*/     /*Scope*/ 61, /*->552*/
/*491*/       OPC_CheckInteger, 39|128,10/*1319*/, 
/*494*/       OPC_MoveParent,
/*495*/       OPC_RecordChild2, // #1 = $rA
/*496*/       OPC_Scope, 26, /*->524*/ // 2 children in Scope
/*498*/         OPC_CheckChild2Type, MVT::i32,
/*500*/         OPC_RecordChild3, // #2 = $rB
/*501*/         OPC_RecordChild4, // #3 = $STRM
/*502*/         OPC_MoveChild, 4,
/*504*/         OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/*507*/         OPC_MoveParent,
/*508*/         OPC_EmitMergeInputChains1_0,
/*509*/         OPC_EmitInteger, MVT::i32, 0, 
/*512*/         OPC_EmitConvertToTarget, 3,
/*514*/         OPC_MorphNodeTo, TARGET_VAL(PPC::DSTST), 0|OPFL_Chain,
                    0/*#VTs*/, 4/*#Ops*/, 4, 5, 1, 2, 
                // Src: (intrinsic_void 1319:iPTR, GPRC:i32:$rA, GPRC:i32:$rB, (imm:i32):$STRM) - Complexity = 11
                // Dst: (DSTST 0:i32, (imm:i32):$STRM, GPRC:i32:$rA, GPRC:i32:$rB)
/*524*/       /*Scope*/ 26, /*->551*/
/*525*/         OPC_CheckChild2Type, MVT::i64,
/*527*/         OPC_RecordChild3, // #2 = $rB
/*528*/         OPC_RecordChild4, // #3 = $STRM
/*529*/         OPC_MoveChild, 4,
/*531*/         OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/*534*/         OPC_MoveParent,
/*535*/         OPC_EmitMergeInputChains1_0,
/*536*/         OPC_EmitInteger, MVT::i32, 0, 
/*539*/         OPC_EmitConvertToTarget, 3,
/*541*/         OPC_MorphNodeTo, TARGET_VAL(PPC::DSTST64), 0|OPFL_Chain,
                    0/*#VTs*/, 4/*#Ops*/, 4, 5, 1, 2, 
                // Src: (intrinsic_void 1319:iPTR, G8RC:i64:$rA, GPRC:i32:$rB, (imm:i32):$STRM) - Complexity = 11
                // Dst: (DSTST64 0:i32, (imm:i32):$STRM, G8RC:i64:$rA, GPRC:i32:$rB)
/*551*/       0, /*End of Scope*/
/*552*/     /*Scope*/ 61, /*->614*/
/*553*/       OPC_CheckInteger, 40|128,10/*1320*/, 
/*556*/       OPC_MoveParent,
/*557*/       OPC_RecordChild2, // #1 = $rA
/*558*/       OPC_Scope, 26, /*->586*/ // 2 children in Scope
/*560*/         OPC_CheckChild2Type, MVT::i32,
/*562*/         OPC_RecordChild3, // #2 = $rB
/*563*/         OPC_RecordChild4, // #3 = $STRM
/*564*/         OPC_MoveChild, 4,
/*566*/         OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/*569*/         OPC_MoveParent,
/*570*/         OPC_EmitMergeInputChains1_0,
/*571*/         OPC_EmitInteger, MVT::i32, 1, 
/*574*/         OPC_EmitConvertToTarget, 3,
/*576*/         OPC_MorphNodeTo, TARGET_VAL(PPC::DSTSTT), 0|OPFL_Chain,
                    0/*#VTs*/, 4/*#Ops*/, 4, 5, 1, 2, 
                // Src: (intrinsic_void 1320:iPTR, GPRC:i32:$rA, GPRC:i32:$rB, (imm:i32):$STRM) - Complexity = 11
                // Dst: (DSTSTT 1:i32, (imm:i32):$STRM, GPRC:i32:$rA, GPRC:i32:$rB)
/*586*/       /*Scope*/ 26, /*->613*/
/*587*/         OPC_CheckChild2Type, MVT::i64,
/*589*/         OPC_RecordChild3, // #2 = $rB
/*590*/         OPC_RecordChild4, // #3 = $STRM
/*591*/         OPC_MoveChild, 4,
/*593*/         OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/*596*/         OPC_MoveParent,
/*597*/         OPC_EmitMergeInputChains1_0,
/*598*/         OPC_EmitInteger, MVT::i32, 1, 
/*601*/         OPC_EmitConvertToTarget, 3,
/*603*/         OPC_MorphNodeTo, TARGET_VAL(PPC::DSTSTT64), 0|OPFL_Chain,
                    0/*#VTs*/, 4/*#Ops*/, 4, 5, 1, 2, 
                // Src: (intrinsic_void 1320:iPTR, G8RC:i64:$rA, GPRC:i32:$rB, (imm:i32):$STRM) - Complexity = 11
                // Dst: (DSTSTT64 1:i32, (imm:i32):$STRM, G8RC:i64:$rA, GPRC:i32:$rB)
/*613*/       0, /*End of Scope*/
/*614*/     /*Scope*/ 11, /*->626*/
/*615*/       OPC_CheckInteger, 63|128,11/*1471*/, 
/*618*/       OPC_MoveParent,
/*619*/       OPC_EmitMergeInputChains1_0,
/*620*/       OPC_MorphNodeTo, TARGET_VAL(PPC::SYNC), 0|OPFL_Chain,
                  0/*#VTs*/, 0/*#Ops*/, 
              // Src: (intrinsic_void 1471:iPTR) - Complexity = 8
              // Dst: (SYNC)
/*626*/     /*Scope*/ 13, /*->640*/
/*627*/       OPC_CheckInteger, 50|128,10/*1330*/, 
/*630*/       OPC_MoveParent,
/*631*/       OPC_RecordChild2, // #1 = $vB
/*632*/       OPC_EmitMergeInputChains1_0,
/*633*/       OPC_MorphNodeTo, TARGET_VAL(PPC::MTVSCR), 0|OPFL_Chain,
                  0/*#VTs*/, 1/*#Ops*/, 1, 
              // Src: (intrinsic_void 1330:iPTR, VRRC:v4i32:$vB) - Complexity = 8
              // Dst: (MTVSCR VRRC:v4i32:$vB)
/*640*/     /*Scope*/ 27, /*->668*/
/*641*/       OPC_CheckInteger, 37|128,10/*1317*/, 
/*644*/       OPC_MoveParent,
/*645*/       OPC_EmitMergeInputChains1_0,
/*646*/       OPC_EmitInteger, MVT::i32, 1, 
/*649*/       OPC_EmitInteger, MVT::i32, 0, 
/*652*/       OPC_EmitInteger, MVT::i32, 0, 
/*655*/       OPC_EmitInteger, MVT::i32, 0, 
/*658*/       OPC_MorphNodeTo, TARGET_VAL(PPC::DSSALL), 0|OPFL_Chain,
                  0/*#VTs*/, 4/*#Ops*/, 1, 2, 3, 4, 
              // Src: (intrinsic_void 1317:iPTR) - Complexity = 8
              // Dst: (DSSALL 1:i32, 0:i32, 0:i32, 0:i32)
/*668*/     0, /*End of Scope*/
          /*SwitchOpcode*/ 59|128,4/*571*/,  TARGET_VAL(ISD::ADD),// ->1244
/*673*/     OPC_Scope, 49|128,1/*177*/, /*->853*/ // 3 children in Scope
/*676*/       OPC_RecordChild0, // #0 = $rA
/*677*/       OPC_MoveChild, 1,
/*679*/       OPC_SwitchOpcode /*2 cases */, 24,  TARGET_VAL(PPCISD::Lo),// ->707
/*683*/         OPC_RecordChild0, // #1 = $sym
/*684*/         OPC_MoveChild, 0,
/*686*/         OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/*689*/         OPC_MoveParent,
/*690*/         OPC_MoveChild, 1,
/*692*/         OPC_CheckInteger, 0, 
/*694*/         OPC_MoveParent,
/*695*/         OPC_MoveParent,
/*696*/         OPC_CheckType, MVT::i32,
/*698*/         OPC_MorphNodeTo, TARGET_VAL(PPC::LA), 0,
                    1/*#VTs*/, MVT::i32, 2/*#Ops*/, 0, 1, 
                // Src: (add:i32 GPRC:i32:$rA, (PPClo:i32 (tglobaladdr:i32):$sym, 0:i32)) - Complexity = 14
                // Dst: (LA:i32 GPRC:i32:$rA, (tglobaladdr:i32):$sym)
              /*SwitchOpcode*/ 13|128,1/*141*/,  TARGET_VAL(PPCISD::Hi),// ->852
/*711*/         OPC_RecordChild0, // #1 = $g
/*712*/         OPC_MoveChild, 0,
/*714*/         OPC_SwitchOpcode /*4 cases */, 31,  TARGET_VAL(ISD::TargetGlobalAddress),// ->749
/*718*/           OPC_MoveParent,
/*719*/           OPC_MoveChild, 1,
/*721*/           OPC_CheckInteger, 0, 
/*723*/           OPC_MoveParent,
/*724*/           OPC_MoveParent,
/*725*/           OPC_SwitchType /*2 cases */, 9,  MVT::i32,// ->737
/*728*/             OPC_MorphNodeTo, TARGET_VAL(PPC::ADDIS), 0,
                        1/*#VTs*/, MVT::i32, 2/*#Ops*/, 0, 1, 
                    // Src: (add:i32 GPRC:i32:$in, (PPChi:i32 (tglobaladdr:i32):$g, 0:i32)) - Complexity = 14
                    // Dst: (ADDIS:i32 GPRC:i32:$in, (tglobaladdr:i32):$g)
                  /*SwitchType*/ 9,  MVT::i64,// ->748
/*739*/             OPC_MorphNodeTo, TARGET_VAL(PPC::ADDIS8), 0,
                        1/*#VTs*/, MVT::i64, 2/*#Ops*/, 0, 1, 
                    // Src: (add:i64 G8RC:i64:$in, (PPChi:i64 (tglobaladdr:i64):$g, 0:i64)) - Complexity = 14
                    // Dst: (ADDIS8:i64 G8RC:i64:$in, (tglobaladdr:i64):$g)
                  0, // EndSwitchType
                /*SwitchOpcode*/ 31,  TARGET_VAL(ISD::TargetConstantPool),// ->783
/*752*/           OPC_MoveParent,
/*753*/           OPC_MoveChild, 1,
/*755*/           OPC_CheckInteger, 0, 
/*757*/           OPC_MoveParent,
/*758*/           OPC_MoveParent,
/*759*/           OPC_SwitchType /*2 cases */, 9,  MVT::i32,// ->771
/*762*/             OPC_MorphNodeTo, TARGET_VAL(PPC::ADDIS), 0,
                        1/*#VTs*/, MVT::i32, 2/*#Ops*/, 0, 1, 
                    // Src: (add:i32 GPRC:i32:$in, (PPChi:i32 (tconstpool:i32):$g, 0:i32)) - Complexity = 14
                    // Dst: (ADDIS:i32 GPRC:i32:$in, (tconstpool:i32):$g)
                  /*SwitchType*/ 9,  MVT::i64,// ->782
/*773*/             OPC_MorphNodeTo, TARGET_VAL(PPC::ADDIS8), 0,
                        1/*#VTs*/, MVT::i64, 2/*#Ops*/, 0, 1, 
                    // Src: (add:i64 G8RC:i64:$in, (PPChi:i64 (tconstpool:i64):$g, 0:i64)) - Complexity = 14
                    // Dst: (ADDIS8:i64 G8RC:i64:$in, (tconstpool:i64):$g)
                  0, // EndSwitchType
                /*SwitchOpcode*/ 31,  TARGET_VAL(ISD::TargetJumpTable),// ->817
/*786*/           OPC_MoveParent,
/*787*/           OPC_MoveChild, 1,
/*789*/           OPC_CheckInteger, 0, 
/*791*/           OPC_MoveParent,
/*792*/           OPC_MoveParent,
/*793*/           OPC_SwitchType /*2 cases */, 9,  MVT::i32,// ->805
/*796*/             OPC_MorphNodeTo, TARGET_VAL(PPC::ADDIS), 0,
                        1/*#VTs*/, MVT::i32, 2/*#Ops*/, 0, 1, 
                    // Src: (add:i32 GPRC:i32:$in, (PPChi:i32 (tjumptable:i32):$g, 0:i32)) - Complexity = 14
                    // Dst: (ADDIS:i32 GPRC:i32:$in, (tjumptable:i32):$g)
                  /*SwitchType*/ 9,  MVT::i64,// ->816
/*807*/             OPC_MorphNodeTo, TARGET_VAL(PPC::ADDIS8), 0,
                        1/*#VTs*/, MVT::i64, 2/*#Ops*/, 0, 1, 
                    // Src: (add:i64 G8RC:i64:$in, (PPChi:i64 (tjumptable:i64):$g, 0:i64)) - Complexity = 14
                    // Dst: (ADDIS8:i64 G8RC:i64:$in, (tjumptable:i64):$g)
                  0, // EndSwitchType
                /*SwitchOpcode*/ 31,  TARGET_VAL(ISD::TargetBlockAddress),// ->851
/*820*/           OPC_MoveParent,
/*821*/           OPC_MoveChild, 1,
/*823*/           OPC_CheckInteger, 0, 
/*825*/           OPC_MoveParent,
/*826*/           OPC_MoveParent,
/*827*/           OPC_SwitchType /*2 cases */, 9,  MVT::i32,// ->839
/*830*/             OPC_MorphNodeTo, TARGET_VAL(PPC::ADDIS), 0,
                        1/*#VTs*/, MVT::i32, 2/*#Ops*/, 0, 1, 
                    // Src: (add:i32 GPRC:i32:$in, (PPChi:i32 (tblockaddress:i32):$g, 0:i32)) - Complexity = 14
                    // Dst: (ADDIS:i32 GPRC:i32:$in, (tblockaddress:i32):$g)
                  /*SwitchType*/ 9,  MVT::i64,// ->850
/*841*/             OPC_MorphNodeTo, TARGET_VAL(PPC::ADDIS8), 0,
                        1/*#VTs*/, MVT::i64, 2/*#Ops*/, 0, 1, 
                    // Src: (add:i64 G8RC:i64:$in, (PPChi:i64 (tblockaddress:i64):$g, 0:i64)) - Complexity = 14
                    // Dst: (ADDIS8:i64 G8RC:i64:$in, (tblockaddress:i64):$g)
                  0, // EndSwitchType
                0, // EndSwitchOpcode
              0, // EndSwitchOpcode
/*853*/     /*Scope*/ 53|128,1/*181*/, /*->1036*/
/*855*/       OPC_MoveChild, 0,
/*857*/       OPC_SwitchOpcode /*2 cases */, 25,  TARGET_VAL(PPCISD::Lo),// ->886
/*861*/         OPC_RecordChild0, // #0 = $sym
/*862*/         OPC_MoveChild, 0,
/*864*/         OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/*867*/         OPC_MoveParent,
/*868*/         OPC_MoveChild, 1,
/*870*/         OPC_CheckInteger, 0, 
/*872*/         OPC_MoveParent,
/*873*/         OPC_MoveParent,
/*874*/         OPC_RecordChild1, // #1 = $rA
/*875*/         OPC_CheckType, MVT::i32,
/*877*/         OPC_MorphNodeTo, TARGET_VAL(PPC::LA), 0,
                    1/*#VTs*/, MVT::i32, 2/*#Ops*/, 1, 0, 
                // Src: (add:i32 (PPClo:i32 (tglobaladdr:i32):$sym, 0:i32), GPRC:i32:$rA) - Complexity = 14
                // Dst: (LA:i32 GPRC:i32:$rA, (tglobaladdr:i32):$sym)
              /*SwitchOpcode*/ 17|128,1/*145*/,  TARGET_VAL(PPCISD::Hi),// ->1035
/*890*/         OPC_RecordChild0, // #0 = $g
/*891*/         OPC_MoveChild, 0,
/*893*/         OPC_SwitchOpcode /*4 cases */, 32,  TARGET_VAL(ISD::TargetGlobalAddress),// ->929
/*897*/           OPC_MoveParent,
/*898*/           OPC_MoveChild, 1,
/*900*/           OPC_CheckInteger, 0, 
/*902*/           OPC_MoveParent,
/*903*/           OPC_MoveParent,
/*904*/           OPC_RecordChild1, // #1 = $in
/*905*/           OPC_SwitchType /*2 cases */, 9,  MVT::i64,// ->917
/*908*/             OPC_MorphNodeTo, TARGET_VAL(PPC::ADDIS8), 0,
                        1/*#VTs*/, MVT::i64, 2/*#Ops*/, 1, 0, 
                    // Src: (add:i64 (PPChi:i64 (tglobaladdr:i64):$g, 0:i64), G8RC:i64:$in) - Complexity = 14
                    // Dst: (ADDIS8:i64 G8RC:i64:$in, (tglobaladdr:i64):$g)
                  /*SwitchType*/ 9,  MVT::i32,// ->928
/*919*/             OPC_MorphNodeTo, TARGET_VAL(PPC::ADDIS), 0,
                        1/*#VTs*/, MVT::i32, 2/*#Ops*/, 1, 0, 
                    // Src: (add:i32 (PPChi:i32 (tglobaladdr:i32):$g, 0:i32), GPRC:i32:$in) - Complexity = 14
                    // Dst: (ADDIS:i32 GPRC:i32:$in, (tglobaladdr:i32):$g)
                  0, // EndSwitchType
                /*SwitchOpcode*/ 32,  TARGET_VAL(ISD::TargetConstantPool),// ->964
/*932*/           OPC_MoveParent,
/*933*/           OPC_MoveChild, 1,
/*935*/           OPC_CheckInteger, 0, 
/*937*/           OPC_MoveParent,
/*938*/           OPC_MoveParent,
/*939*/           OPC_RecordChild1, // #1 = $in
/*940*/           OPC_SwitchType /*2 cases */, 9,  MVT::i64,// ->952
/*943*/             OPC_MorphNodeTo, TARGET_VAL(PPC::ADDIS8), 0,
                        1/*#VTs*/, MVT::i64, 2/*#Ops*/, 1, 0, 
                    // Src: (add:i64 (PPChi:i64 (tconstpool:i64):$g, 0:i64), G8RC:i64:$in) - Complexity = 14
                    // Dst: (ADDIS8:i64 G8RC:i64:$in, (tconstpool:i64):$g)
                  /*SwitchType*/ 9,  MVT::i32,// ->963
/*954*/             OPC_MorphNodeTo, TARGET_VAL(PPC::ADDIS), 0,
                        1/*#VTs*/, MVT::i32, 2/*#Ops*/, 1, 0, 
                    // Src: (add:i32 (PPChi:i32 (tconstpool:i32):$g, 0:i32), GPRC:i32:$in) - Complexity = 14
                    // Dst: (ADDIS:i32 GPRC:i32:$in, (tconstpool:i32):$g)
                  0, // EndSwitchType
                /*SwitchOpcode*/ 32,  TARGET_VAL(ISD::TargetJumpTable),// ->999
/*967*/           OPC_MoveParent,
/*968*/           OPC_MoveChild, 1,
/*970*/           OPC_CheckInteger, 0, 
/*972*/           OPC_MoveParent,
/*973*/           OPC_MoveParent,
/*974*/           OPC_RecordChild1, // #1 = $in
/*975*/           OPC_SwitchType /*2 cases */, 9,  MVT::i64,// ->987
/*978*/             OPC_MorphNodeTo, TARGET_VAL(PPC::ADDIS8), 0,
                        1/*#VTs*/, MVT::i64, 2/*#Ops*/, 1, 0, 
                    // Src: (add:i64 (PPChi:i64 (tjumptable:i64):$g, 0:i64), G8RC:i64:$in) - Complexity = 14
                    // Dst: (ADDIS8:i64 G8RC:i64:$in, (tjumptable:i64):$g)
                  /*SwitchType*/ 9,  MVT::i32,// ->998
/*989*/             OPC_MorphNodeTo, TARGET_VAL(PPC::ADDIS), 0,
                        1/*#VTs*/, MVT::i32, 2/*#Ops*/, 1, 0, 
                    // Src: (add:i32 (PPChi:i32 (tjumptable:i32):$g, 0:i32), GPRC:i32:$in) - Complexity = 14
                    // Dst: (ADDIS:i32 GPRC:i32:$in, (tjumptable:i32):$g)
                  0, // EndSwitchType
                /*SwitchOpcode*/ 32,  TARGET_VAL(ISD::TargetBlockAddress),// ->1034
/*1002*/          OPC_MoveParent,
/*1003*/          OPC_MoveChild, 1,
/*1005*/          OPC_CheckInteger, 0, 
/*1007*/          OPC_MoveParent,
/*1008*/          OPC_MoveParent,
/*1009*/          OPC_RecordChild1, // #1 = $in
/*1010*/          OPC_SwitchType /*2 cases */, 9,  MVT::i64,// ->1022
/*1013*/            OPC_MorphNodeTo, TARGET_VAL(PPC::ADDIS8), 0,
                        1/*#VTs*/, MVT::i64, 2/*#Ops*/, 1, 0, 
                    // Src: (add:i64 (PPChi:i64 (tblockaddress:i64):$g, 0:i64), G8RC:i64:$in) - Complexity = 14
                    // Dst: (ADDIS8:i64 G8RC:i64:$in, (tblockaddress:i64):$g)
                  /*SwitchType*/ 9,  MVT::i32,// ->1033
/*1024*/            OPC_MorphNodeTo, TARGET_VAL(PPC::ADDIS), 0,
                        1/*#VTs*/, MVT::i32, 2/*#Ops*/, 1, 0, 
                    // Src: (add:i32 (PPChi:i32 (tblockaddress:i32):$g, 0:i32), GPRC:i32:$in) - Complexity = 14
                    // Dst: (ADDIS:i32 GPRC:i32:$in, (tblockaddress:i32):$g)
                  0, // EndSwitchType
                0, // EndSwitchOpcode
              0, // EndSwitchOpcode
/*1036*/    /*Scope*/ 77|128,1/*205*/, /*->1243*/
/*1038*/      OPC_RecordChild0, // #0 = $rA
/*1039*/      OPC_RecordChild1, // #1 = $imm
/*1040*/      OPC_Scope, 11|128,1/*139*/, /*->1182*/ // 6 children in Scope
/*1043*/        OPC_MoveChild, 1,
/*1045*/        OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/*1048*/        OPC_Scope, 29, /*->1079*/ // 5 children in Scope
/*1050*/          OPC_CheckPredicate, 0, // Predicate_immSExt16
/*1052*/          OPC_MoveParent,
/*1053*/          OPC_CheckType, MVT::i32,
/*1055*/          OPC_EmitConvertToTarget, 1,
/*1057*/          OPC_Scope, 9, /*->1068*/ // 2 children in Scope
/*1059*/            OPC_MorphNodeTo, TARGET_VAL(PPC::ADDI), 0,
                        1/*#VTs*/, MVT::i32, 2/*#Ops*/, 0, 2, 
                    // Src: (add:i32 GPRC:i32:$rA, (imm:i32)<<P:Predicate_immSExt16>>:$imm) - Complexity = 7
                    // Dst: (ADDI:i32 GPRC:i32:$rA, (imm:i32):$imm)
/*1068*/          /*Scope*/ 9, /*->1078*/
/*1069*/            OPC_MorphNodeTo, TARGET_VAL(PPC::ADDIL), 0,
                        1/*#VTs*/, MVT::i32, 2/*#Ops*/, 0, 2, 
                    // Src: (add:i32 GPRC:i32:$rA, (imm:i32)<<P:Predicate_immSExt16>>:$imm) - Complexity = 7
                    // Dst: (ADDIL:i32 GPRC:i32:$rA, (imm:i32):$imm)
/*1078*/          0, /*End of Scope*/
/*1079*/        /*Scope*/ 19, /*->1099*/
/*1080*/          OPC_CheckPredicate, 1, // Predicate_imm16ShiftedSExt
/*1082*/          OPC_MoveParent,
/*1083*/          OPC_CheckType, MVT::i32,
/*1085*/          OPC_EmitConvertToTarget, 1,
/*1087*/          OPC_EmitNodeXForm, 0, 2, // HI16
/*1090*/          OPC_MorphNodeTo, TARGET_VAL(PPC::ADDIS), 0,
                      1/*#VTs*/, MVT::i32, 2/*#Ops*/, 0, 3, 
                  // Src: (add:i32 GPRC:i32:$rA, (imm:i32)<<P:Predicate_imm16ShiftedSExt>><<X:HI16>>:$imm) - Complexity = 7
                  // Dst: (ADDIS:i32 GPRC:i32:$rA, (HI16:i32 (imm:i32):$imm))
/*1099*/        /*Scope*/ 29, /*->1129*/
/*1100*/          OPC_CheckPredicate, 0, // Predicate_immSExt16
/*1102*/          OPC_MoveParent,
/*1103*/          OPC_CheckType, MVT::i64,
/*1105*/          OPC_EmitConvertToTarget, 1,
/*1107*/          OPC_Scope, 9, /*->1118*/ // 2 children in Scope
/*1109*/            OPC_MorphNodeTo, TARGET_VAL(PPC::ADDI8), 0,
                        1/*#VTs*/, MVT::i64, 2/*#Ops*/, 0, 2, 
                    // Src: (add:i64 G8RC:i64:$rA, (imm:i64)<<P:Predicate_immSExt16>>:$imm) - Complexity = 7
                    // Dst: (ADDI8:i64 G8RC:i64:$rA, (imm:i64):$imm)
/*1118*/          /*Scope*/ 9, /*->1128*/
/*1119*/            OPC_MorphNodeTo, TARGET_VAL(PPC::ADDI8L), 0,
                        1/*#VTs*/, MVT::i64, 2/*#Ops*/, 0, 2, 
                    // Src: (add:i64 G8RC:i64:$rA, (imm:i64)<<P:Predicate_immSExt16>>:$imm) - Complexity = 7
                    // Dst: (ADDI8L:i64 G8RC:i64:$rA, (imm:i64):$imm)
/*1128*/          0, /*End of Scope*/
/*1129*/        /*Scope*/ 19, /*->1149*/
/*1130*/          OPC_CheckPredicate, 1, // Predicate_imm16ShiftedSExt
/*1132*/          OPC_MoveParent,
/*1133*/          OPC_CheckType, MVT::i64,
/*1135*/          OPC_EmitConvertToTarget, 1,
/*1137*/          OPC_EmitNodeXForm, 0, 2, // HI16
/*1140*/          OPC_MorphNodeTo, TARGET_VAL(PPC::ADDIS8), 0,
                      1/*#VTs*/, MVT::i64, 2/*#Ops*/, 0, 3, 
                  // Src: (add:i64 G8RC:i64:$rA, (imm:i64)<<P:Predicate_imm16ShiftedSExt>><<X:HI16>>:$imm) - Complexity = 7
                  // Dst: (ADDIS8:i64 G8RC:i64:$rA, (HI16:i64 (imm:i64):$imm))
/*1149*/        /*Scope*/ 31, /*->1181*/
/*1150*/          OPC_MoveParent,
/*1151*/          OPC_CheckType, MVT::i32,
/*1153*/          OPC_EmitConvertToTarget, 1,
/*1155*/          OPC_EmitNodeXForm, 1, 2, // LO16
/*1158*/          OPC_EmitNode, TARGET_VAL(PPC::ADDI), 0,
                      1/*#VTs*/, MVT::i32, 2/*#Ops*/, 0, 3,  // Results = #4 
/*1167*/          OPC_EmitConvertToTarget, 1,
/*1169*/          OPC_EmitNodeXForm, 2, 5, // HA16
/*1172*/          OPC_MorphNodeTo, TARGET_VAL(PPC::ADDIS), 0,
                      1/*#VTs*/, MVT::i32, 2/*#Ops*/, 4, 6, 
                  // Src: (add:i32 GPRC:i32:$in, (imm:i32):$imm) - Complexity = 6
                  // Dst: (ADDIS:i32 (ADDI:i32 GPRC:i32:$in, (LO16:i32 (imm:i32):$imm)), (HA16:i32 (imm:i32):$imm))
/*1181*/        0, /*End of Scope*/
/*1182*/      /*Scope*/ 11, /*->1194*/
/*1183*/        OPC_CheckType, MVT::i32,
/*1185*/        OPC_MorphNodeTo, TARGET_VAL(PPC::ADD4), 0,
                    1/*#VTs*/, MVT::i32, 2/*#Ops*/, 0, 1, 
                // Src: (add:i32 GPRC:i32:$rA, GPRC:i32:$rB) - Complexity = 3
                // Dst: (ADD4:i32 GPRC:i32:$rA, GPRC:i32:$rB)
/*1194*/      /*Scope*/ 11, /*->1206*/
/*1195*/        OPC_CheckType, MVT::i64,
/*1197*/        OPC_MorphNodeTo, TARGET_VAL(PPC::ADD8), 0,
                    1/*#VTs*/, MVT::i64, 2/*#Ops*/, 0, 1, 
                // Src: (add:i64 G8RC:i64:$rA, G8RC:i64:$rB) - Complexity = 3
                // Dst: (ADD8:i64 G8RC:i64:$rA, G8RC:i64:$rB)
/*1206*/      /*Scope*/ 11, /*->1218*/
/*1207*/        OPC_CheckType, MVT::v16i8,
/*1209*/        OPC_MorphNodeTo, TARGET_VAL(PPC::VADDUBM), 0,
                    1/*#VTs*/, MVT::v16i8, 2/*#Ops*/, 0, 1, 
                // Src: (add:v16i8 VRRC:v16i8:$vA, VRRC:v16i8:$vB) - Complexity = 3
                // Dst: (VADDUBM:v16i8 VRRC:v16i8:$vA, VRRC:v16i8:$vB)
/*1218*/      /*Scope*/ 11, /*->1230*/
/*1219*/        OPC_CheckType, MVT::v8i16,
/*1221*/        OPC_MorphNodeTo, TARGET_VAL(PPC::VADDUHM), 0,
                    1/*#VTs*/, MVT::v8i16, 2/*#Ops*/, 0, 1, 
                // Src: (add:v8i16 VRRC:v8i16:$vA, VRRC:v8i16:$vB) - Complexity = 3
                // Dst: (VADDUHM:v8i16 VRRC:v8i16:$vA, VRRC:v8i16:$vB)
/*1230*/      /*Scope*/ 11, /*->1242*/
/*1231*/        OPC_CheckType, MVT::v4i32,
/*1233*/        OPC_MorphNodeTo, TARGET_VAL(PPC::VADDUWM), 0,
                    1/*#VTs*/, MVT::v4i32, 2/*#Ops*/, 0, 1, 
                // Src: (add:v4i32 VRRC:v4i32:$vA, VRRC:v4i32:$vB) - Complexity = 3
                // Dst: (VADDUWM:v4i32 VRRC:v4i32:$vA, VRRC:v4i32:$vB)
/*1242*/      0, /*End of Scope*/
/*1243*/    0, /*End of Scope*/
          /*SwitchOpcode*/ 72|128,6/*840*/,  TARGET_VAL(ISD::LOAD),// ->2088
/*1248*/    OPC_RecordMemRef,
/*1249*/    OPC_RecordNode,   // #0 = 'ld' chained node
/*1250*/    OPC_RecordChild1, // #1 = $src
/*1251*/    OPC_CheckPredicate, 2, // Predicate_unindexedload
/*1253*/    OPC_Scope, 19, /*->1274*/ // 18 children in Scope
/*1255*/      OPC_CheckPredicate, 3, // Predicate_zextload
/*1257*/      OPC_CheckPredicate, 4, // Predicate_zextloadi8
/*1259*/      OPC_CheckType, MVT::i32,
/*1261*/      OPC_CheckComplexPat, /*CP*/1, /*#*/1, // SelectAddrImm:$src #2 #3
/*1264*/      OPC_EmitMergeInputChains1_0,
/*1265*/      OPC_MorphNodeTo, TARGET_VAL(PPC::LBZ), 0|OPFL_Chain|OPFL_MemRefs,
                  1/*#VTs*/, MVT::i32, 2/*#Ops*/, 2, 3, 
              // Src: (ld:i32 iaddr:iPTR:$src)<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>> - Complexity = 13
              // Dst: (LBZ:i32 iaddr:iPTR:$src)
/*1274*/    /*Scope*/ 19, /*->1294*/
/*1275*/      OPC_CheckPredicate, 5, // Predicate_sextload
/*1277*/      OPC_CheckPredicate, 6, // Predicate_sextloadi16
/*1279*/      OPC_CheckType, MVT::i32,
/*1281*/      OPC_CheckComplexPat, /*CP*/1, /*#*/1, // SelectAddrImm:$src #2 #3
/*1284*/      OPC_EmitMergeInputChains1_0,
/*1285*/      OPC_MorphNodeTo, TARGET_VAL(PPC::LHA), 0|OPFL_Chain|OPFL_MemRefs,
                  1/*#VTs*/, MVT::i32, 2/*#Ops*/, 2, 3, 
              // Src: (ld:i32 iaddr:iPTR:$src)<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>> - Complexity = 13
              // Dst: (LHA:i32 iaddr:iPTR:$src)
/*1294*/    /*Scope*/ 19, /*->1314*/
/*1295*/      OPC_CheckPredicate, 3, // Predicate_zextload
/*1297*/      OPC_CheckPredicate, 7, // Predicate_zextloadi16
/*1299*/      OPC_CheckType, MVT::i32,
/*1301*/      OPC_CheckComplexPat, /*CP*/1, /*#*/1, // SelectAddrImm:$src #2 #3
/*1304*/      OPC_EmitMergeInputChains1_0,
/*1305*/      OPC_MorphNodeTo, TARGET_VAL(PPC::LHZ), 0|OPFL_Chain|OPFL_MemRefs,
                  1/*#VTs*/, MVT::i32, 2/*#Ops*/, 2, 3, 
              // Src: (ld:i32 iaddr:iPTR:$src)<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>> - Complexity = 13
              // Dst: (LHZ:i32 iaddr:iPTR:$src)
/*1314*/    /*Scope*/ 17, /*->1332*/
/*1315*/      OPC_CheckPredicate, 8, // Predicate_load
/*1317*/      OPC_CheckType, MVT::i32,
/*1319*/      OPC_CheckComplexPat, /*CP*/1, /*#*/1, // SelectAddrImm:$src #2 #3
/*1322*/      OPC_EmitMergeInputChains1_0,
/*1323*/      OPC_MorphNodeTo, TARGET_VAL(PPC::LWZ), 0|OPFL_Chain|OPFL_MemRefs,
                  1/*#VTs*/, MVT::i32, 2/*#Ops*/, 2, 3, 
              // Src: (ld:i32 iaddr:iPTR:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 13
              // Dst: (LWZ:i32 iaddr:iPTR:$src)
/*1332*/    /*Scope*/ 19, /*->1352*/
/*1333*/      OPC_CheckPredicate, 3, // Predicate_zextload
/*1335*/      OPC_CheckPredicate, 4, // Predicate_zextloadi8
/*1337*/      OPC_CheckType, MVT::i32,
/*1339*/      OPC_CheckComplexPat, /*CP*/2, /*#*/1, // SelectAddrIdx:$src #2 #3
/*1342*/      OPC_EmitMergeInputChains1_0,
/*1343*/      OPC_MorphNodeTo, TARGET_VAL(PPC::LBZX), 0|OPFL_Chain|OPFL_MemRefs,
                  1/*#VTs*/, MVT::i32, 2/*#Ops*/, 2, 3, 
              // Src: (ld:i32 xaddr:iPTR:$src)<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>> - Complexity = 13
              // Dst: (LBZX:i32 xaddr:iPTR:$src)
/*1352*/    /*Scope*/ 19, /*->1372*/
/*1353*/      OPC_CheckPredicate, 5, // Predicate_sextload
/*1355*/      OPC_CheckPredicate, 6, // Predicate_sextloadi16
/*1357*/      OPC_CheckType, MVT::i32,
/*1359*/      OPC_CheckComplexPat, /*CP*/2, /*#*/1, // SelectAddrIdx:$src #2 #3
/*1362*/      OPC_EmitMergeInputChains1_0,
/*1363*/      OPC_MorphNodeTo, TARGET_VAL(PPC::LHAX), 0|OPFL_Chain|OPFL_MemRefs,
                  1/*#VTs*/, MVT::i32, 2/*#Ops*/, 2, 3, 
              // Src: (ld:i32 xaddr:iPTR:$src)<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>> - Complexity = 13
              // Dst: (LHAX:i32 xaddr:iPTR:$src)
/*1372*/    /*Scope*/ 19, /*->1392*/
/*1373*/      OPC_CheckPredicate, 3, // Predicate_zextload
/*1375*/      OPC_CheckPredicate, 7, // Predicate_zextloadi16
/*1377*/      OPC_CheckType, MVT::i32,
/*1379*/      OPC_CheckComplexPat, /*CP*/2, /*#*/1, // SelectAddrIdx:$src #2 #3
/*1382*/      OPC_EmitMergeInputChains1_0,
/*1383*/      OPC_MorphNodeTo, TARGET_VAL(PPC::LHZX), 0|OPFL_Chain|OPFL_MemRefs,
                  1/*#VTs*/, MVT::i32, 2/*#Ops*/, 2, 3, 
              // Src: (ld:i32 xaddr:iPTR:$src)<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>> - Complexity = 13
              // Dst: (LHZX:i32 xaddr:iPTR:$src)
/*1392*/    /*Scope*/ 17, /*->1410*/
/*1393*/      OPC_CheckPredicate, 8, // Predicate_load
/*1395*/      OPC_CheckType, MVT::i32,
/*1397*/      OPC_CheckComplexPat, /*CP*/2, /*#*/1, // SelectAddrIdx:$src #2 #3
/*1400*/      OPC_EmitMergeInputChains1_0,
/*1401*/      OPC_MorphNodeTo, TARGET_VAL(PPC::LWZX), 0|OPFL_Chain|OPFL_MemRefs,
                  1/*#VTs*/, MVT::i32, 2/*#Ops*/, 2, 3, 
              // Src: (ld:i32 xaddr:iPTR:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 13
              // Dst: (LWZX:i32 xaddr:iPTR:$src)
/*1410*/    /*Scope*/ 36, /*->1447*/
/*1411*/      OPC_CheckPredicate, 3, // Predicate_zextload
/*1413*/      OPC_CheckPredicate, 9, // Predicate_zextloadi1
/*1415*/      OPC_CheckType, MVT::i32,
/*1417*/      OPC_Scope, 13, /*->1432*/ // 2 children in Scope
/*1419*/        OPC_CheckComplexPat, /*CP*/1, /*#*/1, // SelectAddrImm:$src #2 #3
/*1422*/        OPC_EmitMergeInputChains1_0,
/*1423*/        OPC_MorphNodeTo, TARGET_VAL(PPC::LBZ), 0|OPFL_Chain|OPFL_MemRefs,
                    1/*#VTs*/, MVT::i32, 2/*#Ops*/, 2, 3, 
                // Src: (ld:i32 iaddr:iPTR:$src)<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi1>> - Complexity = 13
                // Dst: (LBZ:i32 iaddr:iPTR:$src)
/*1432*/      /*Scope*/ 13, /*->1446*/
/*1433*/        OPC_CheckComplexPat, /*CP*/2, /*#*/1, // SelectAddrIdx:$src #2 #3
/*1436*/        OPC_EmitMergeInputChains1_0,
/*1437*/        OPC_MorphNodeTo, TARGET_VAL(PPC::LBZX), 0|OPFL_Chain|OPFL_MemRefs,
                    1/*#VTs*/, MVT::i32, 2/*#Ops*/, 2, 3, 
                // Src: (ld:i32 xaddr:iPTR:$src)<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi1>> - Complexity = 13
                // Dst: (LBZX:i32 xaddr:iPTR:$src)
/*1446*/      0, /*End of Scope*/
/*1447*/    /*Scope*/ 105, /*->1553*/
/*1448*/      OPC_CheckPredicate, 10, // Predicate_extload
/*1450*/      OPC_CheckType, MVT::i32,
/*1452*/      OPC_Scope, 32, /*->1486*/ // 3 children in Scope
/*1454*/        OPC_CheckPredicate, 11, // Predicate_extloadi1
/*1456*/        OPC_Scope, 13, /*->1471*/ // 2 children in Scope
/*1458*/          OPC_CheckComplexPat, /*CP*/1, /*#*/1, // SelectAddrImm:$src #2 #3
/*1461*/          OPC_EmitMergeInputChains1_0,
/*1462*/          OPC_MorphNodeTo, TARGET_VAL(PPC::LBZ), 0|OPFL_Chain|OPFL_MemRefs,
                      1/*#VTs*/, MVT::i32, 2/*#Ops*/, 2, 3, 
                  // Src: (ld:i32 iaddr:iPTR:$src)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi1>> - Complexity = 13
                  // Dst: (LBZ:i32 iaddr:iPTR:$src)
/*1471*/        /*Scope*/ 13, /*->1485*/
/*1472*/          OPC_CheckComplexPat, /*CP*/2, /*#*/1, // SelectAddrIdx:$src #2 #3
/*1475*/          OPC_EmitMergeInputChains1_0,
/*1476*/          OPC_MorphNodeTo, TARGET_VAL(PPC::LBZX), 0|OPFL_Chain|OPFL_MemRefs,
                      1/*#VTs*/, MVT::i32, 2/*#Ops*/, 2, 3, 
                  // Src: (ld:i32 xaddr:iPTR:$src)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi1>> - Complexity = 13
                  // Dst: (LBZX:i32 xaddr:iPTR:$src)
/*1485*/        0, /*End of Scope*/
/*1486*/      /*Scope*/ 32, /*->1519*/
/*1487*/        OPC_CheckPredicate, 12, // Predicate_extloadi8
/*1489*/        OPC_Scope, 13, /*->1504*/ // 2 children in Scope
/*1491*/          OPC_CheckComplexPat, /*CP*/1, /*#*/1, // SelectAddrImm:$src #2 #3
/*1494*/          OPC_EmitMergeInputChains1_0,
/*1495*/          OPC_MorphNodeTo, TARGET_VAL(PPC::LBZ), 0|OPFL_Chain|OPFL_MemRefs,
                      1/*#VTs*/, MVT::i32, 2/*#Ops*/, 2, 3, 
                  // Src: (ld:i32 iaddr:iPTR:$src)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>> - Complexity = 13
                  // Dst: (LBZ:i32 iaddr:iPTR:$src)
/*1504*/        /*Scope*/ 13, /*->1518*/
/*1505*/          OPC_CheckComplexPat, /*CP*/2, /*#*/1, // SelectAddrIdx:$src #2 #3
/*1508*/          OPC_EmitMergeInputChains1_0,
/*1509*/          OPC_MorphNodeTo, TARGET_VAL(PPC::LBZX), 0|OPFL_Chain|OPFL_MemRefs,
                      1/*#VTs*/, MVT::i32, 2/*#Ops*/, 2, 3, 
                  // Src: (ld:i32 xaddr:iPTR:$src)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>> - Complexity = 13
                  // Dst: (LBZX:i32 xaddr:iPTR:$src)
/*1518*/        0, /*End of Scope*/
/*1519*/      /*Scope*/ 32, /*->1552*/
/*1520*/        OPC_CheckPredicate, 13, // Predicate_extloadi16
/*1522*/        OPC_Scope, 13, /*->1537*/ // 2 children in Scope
/*1524*/          OPC_CheckComplexPat, /*CP*/1, /*#*/1, // SelectAddrImm:$src #2 #3
/*1527*/          OPC_EmitMergeInputChains1_0,
/*1528*/          OPC_MorphNodeTo, TARGET_VAL(PPC::LHZ), 0|OPFL_Chain|OPFL_MemRefs,
                      1/*#VTs*/, MVT::i32, 2/*#Ops*/, 2, 3, 
                  // Src: (ld:i32 iaddr:iPTR:$src)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>> - Complexity = 13
                  // Dst: (LHZ:i32 iaddr:iPTR:$src)
/*1537*/        /*Scope*/ 13, /*->1551*/
/*1538*/          OPC_CheckComplexPat, /*CP*/2, /*#*/1, // SelectAddrIdx:$src #2 #3
/*1541*/          OPC_EmitMergeInputChains1_0,
/*1542*/          OPC_MorphNodeTo, TARGET_VAL(PPC::LHZX), 0|OPFL_Chain|OPFL_MemRefs,
                      1/*#VTs*/, MVT::i32, 2/*#Ops*/, 2, 3, 
                  // Src: (ld:i32 xaddr:iPTR:$src)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>> - Complexity = 13
                  // Dst: (LHZX:i32 xaddr:iPTR:$src)
/*1551*/        0, /*End of Scope*/
/*1552*/      0, /*End of Scope*/
/*1553*/    /*Scope*/ 70, /*->1624*/
/*1554*/      OPC_CheckPredicate, 5, // Predicate_sextload
/*1556*/      OPC_CheckType, MVT::i64,
/*1558*/      OPC_Scope, 15, /*->1575*/ // 4 children in Scope
/*1560*/        OPC_CheckPredicate, 6, // Predicate_sextloadi16
/*1562*/        OPC_CheckComplexPat, /*CP*/1, /*#*/1, // SelectAddrImm:$src #2 #3
/*1565*/        OPC_EmitMergeInputChains1_0,
/*1566*/        OPC_MorphNodeTo, TARGET_VAL(PPC::LHA8), 0|OPFL_Chain|OPFL_MemRefs,
                    1/*#VTs*/, MVT::i64, 2/*#Ops*/, 2, 3, 
                // Src: (ld:i64 iaddr:iPTR:$src)<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>> - Complexity = 13
                // Dst: (LHA8:i64 iaddr:iPTR:$src)
/*1575*/      /*Scope*/ 15, /*->1591*/
/*1576*/        OPC_CheckPredicate, 14, // Predicate_sextloadi32
/*1578*/        OPC_CheckComplexPat, /*CP*/3, /*#*/1, // SelectAddrImmShift:$src #2 #3
/*1581*/        OPC_EmitMergeInputChains1_0,
/*1582*/        OPC_MorphNodeTo, TARGET_VAL(PPC::LWA), 0|OPFL_Chain|OPFL_MemRefs,
                    1/*#VTs*/, MVT::i64, 2/*#Ops*/, 2, 3, 
                // Src: (ld:i64 ixaddr:iPTR:$src)<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi32>> - Complexity = 13
                // Dst: (LWA:i64 ixaddr:iPTR:$src)
/*1591*/      /*Scope*/ 15, /*->1607*/
/*1592*/        OPC_CheckPredicate, 6, // Predicate_sextloadi16
/*1594*/        OPC_CheckComplexPat, /*CP*/2, /*#*/1, // SelectAddrIdx:$src #2 #3
/*1597*/        OPC_EmitMergeInputChains1_0,
/*1598*/        OPC_MorphNodeTo, TARGET_VAL(PPC::LHAX8), 0|OPFL_Chain|OPFL_MemRefs,
                    1/*#VTs*/, MVT::i64, 2/*#Ops*/, 2, 3, 
                // Src: (ld:i64 xaddr:iPTR:$src)<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>> - Complexity = 13
                // Dst: (LHAX8:i64 xaddr:iPTR:$src)
/*1607*/      /*Scope*/ 15, /*->1623*/
/*1608*/        OPC_CheckPredicate, 14, // Predicate_sextloadi32
/*1610*/        OPC_CheckComplexPat, /*CP*/2, /*#*/1, // SelectAddrIdx:$src #2 #3
/*1613*/        OPC_EmitMergeInputChains1_0,
/*1614*/        OPC_MorphNodeTo, TARGET_VAL(PPC::LWAX), 0|OPFL_Chain|OPFL_MemRefs,
                    1/*#VTs*/, MVT::i64, 2/*#Ops*/, 2, 3, 
                // Src: (ld:i64 xaddr:iPTR:$src)<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi32>> - Complexity = 13
                // Dst: (LWAX:i64 xaddr:iPTR:$src)
/*1623*/      0, /*End of Scope*/
/*1624*/    /*Scope*/ 102, /*->1727*/
/*1625*/      OPC_CheckPredicate, 3, // Predicate_zextload
/*1627*/      OPC_CheckType, MVT::i64,
/*1629*/      OPC_Scope, 15, /*->1646*/ // 6 children in Scope
/*1631*/        OPC_CheckPredicate, 4, // Predicate_zextloadi8
/*1633*/        OPC_CheckComplexPat, /*CP*/1, /*#*/1, // SelectAddrImm:$src #2 #3
/*1636*/        OPC_EmitMergeInputChains1_0,
/*1637*/        OPC_MorphNodeTo, TARGET_VAL(PPC::LBZ8), 0|OPFL_Chain|OPFL_MemRefs,
                    1/*#VTs*/, MVT::i64, 2/*#Ops*/, 2, 3, 
                // Src: (ld:i64 iaddr:iPTR:$src)<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>> - Complexity = 13
                // Dst: (LBZ8:i64 iaddr:iPTR:$src)
/*1646*/      /*Scope*/ 15, /*->1662*/
/*1647*/        OPC_CheckPredicate, 7, // Predicate_zextloadi16
/*1649*/        OPC_CheckComplexPat, /*CP*/1, /*#*/1, // SelectAddrImm:$src #2 #3
/*1652*/        OPC_EmitMergeInputChains1_0,
/*1653*/        OPC_MorphNodeTo, TARGET_VAL(PPC::LHZ8), 0|OPFL_Chain|OPFL_MemRefs,
                    1/*#VTs*/, MVT::i64, 2/*#Ops*/, 2, 3, 
                // Src: (ld:i64 iaddr:iPTR:$src)<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>> - Complexity = 13
                // Dst: (LHZ8:i64 iaddr:iPTR:$src)
/*1662*/      /*Scope*/ 15, /*->1678*/
/*1663*/        OPC_CheckPredicate, 15, // Predicate_zextloadi32
/*1665*/        OPC_CheckComplexPat, /*CP*/1, /*#*/1, // SelectAddrImm:$src #2 #3
/*1668*/        OPC_EmitMergeInputChains1_0,
/*1669*/        OPC_MorphNodeTo, TARGET_VAL(PPC::LWZ8), 0|OPFL_Chain|OPFL_MemRefs,
                    1/*#VTs*/, MVT::i64, 2/*#Ops*/, 2, 3, 
                // Src: (ld:i64 iaddr:iPTR:$src)<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi32>> - Complexity = 13
                // Dst: (LWZ8:i64 iaddr:iPTR:$src)
/*1678*/      /*Scope*/ 15, /*->1694*/
/*1679*/        OPC_CheckPredicate, 4, // Predicate_zextloadi8
/*1681*/        OPC_CheckComplexPat, /*CP*/2, /*#*/1, // SelectAddrIdx:$src #2 #3
/*1684*/        OPC_EmitMergeInputChains1_0,
/*1685*/        OPC_MorphNodeTo, TARGET_VAL(PPC::LBZX8), 0|OPFL_Chain|OPFL_MemRefs,
                    1/*#VTs*/, MVT::i64, 2/*#Ops*/, 2, 3, 
                // Src: (ld:i64 xaddr:iPTR:$src)<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>> - Complexity = 13
                // Dst: (LBZX8:i64 xaddr:iPTR:$src)
/*1694*/      /*Scope*/ 15, /*->1710*/
/*1695*/        OPC_CheckPredicate, 7, // Predicate_zextloadi16
/*1697*/        OPC_CheckComplexPat, /*CP*/2, /*#*/1, // SelectAddrIdx:$src #2 #3
/*1700*/        OPC_EmitMergeInputChains1_0,
/*1701*/        OPC_MorphNodeTo, TARGET_VAL(PPC::LHZX8), 0|OPFL_Chain|OPFL_MemRefs,
                    1/*#VTs*/, MVT::i64, 2/*#Ops*/, 2, 3, 
                // Src: (ld:i64 xaddr:iPTR:$src)<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>> - Complexity = 13
                // Dst: (LHZX8:i64 xaddr:iPTR:$src)
/*1710*/      /*Scope*/ 15, /*->1726*/
/*1711*/        OPC_CheckPredicate, 15, // Predicate_zextloadi32
/*1713*/        OPC_CheckComplexPat, /*CP*/2, /*#*/1, // SelectAddrIdx:$src #2 #3
/*1716*/        OPC_EmitMergeInputChains1_0,
/*1717*/        OPC_MorphNodeTo, TARGET_VAL(PPC::LWZX8), 0|OPFL_Chain|OPFL_MemRefs,
                    1/*#VTs*/, MVT::i64, 2/*#Ops*/, 2, 3, 
                // Src: (ld:i64 xaddr:iPTR:$src)<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi32>> - Complexity = 13
                // Dst: (LWZX8:i64 xaddr:iPTR:$src)
/*1726*/      0, /*End of Scope*/
/*1727*/    /*Scope*/ 34, /*->1762*/
/*1728*/      OPC_CheckPredicate, 8, // Predicate_load
/*1730*/      OPC_CheckType, MVT::i64,
/*1732*/      OPC_Scope, 13, /*->1747*/ // 2 children in Scope
/*1734*/        OPC_CheckComplexPat, /*CP*/3, /*#*/1, // SelectAddrImmShift:$src #2 #3
/*1737*/        OPC_EmitMergeInputChains1_0,
/*1738*/        OPC_MorphNodeTo, TARGET_VAL(PPC::LD), 0|OPFL_Chain|OPFL_MemRefs,
                    1/*#VTs*/, MVT::i64, 2/*#Ops*/, 2, 3, 
                // Src: (ld:i64 ixaddr:iPTR:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 13
                // Dst: (LD:i64 ixaddr:iPTR:$src)
/*1747*/      /*Scope*/ 13, /*->1761*/
/*1748*/        OPC_CheckComplexPat, /*CP*/2, /*#*/1, // SelectAddrIdx:$src #2 #3
/*1751*/        OPC_EmitMergeInputChains1_0,
/*1752*/        OPC_MorphNodeTo, TARGET_VAL(PPC::LDX), 0|OPFL_Chain|OPFL_MemRefs,
                    1/*#VTs*/, MVT::i64, 2/*#Ops*/, 2, 3, 
                // Src: (ld:i64 xaddr:iPTR:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 13
                // Dst: (LDX:i64 xaddr:iPTR:$src)
/*1761*/      0, /*End of Scope*/
/*1762*/    /*Scope*/ 36, /*->1799*/
/*1763*/      OPC_CheckPredicate, 3, // Predicate_zextload
/*1765*/      OPC_CheckPredicate, 9, // Predicate_zextloadi1
/*1767*/      OPC_CheckType, MVT::i64,
/*1769*/      OPC_Scope, 13, /*->1784*/ // 2 children in Scope
/*1771*/        OPC_CheckComplexPat, /*CP*/1, /*#*/1, // SelectAddrImm:$src #2 #3
/*1774*/        OPC_EmitMergeInputChains1_0,
/*1775*/        OPC_MorphNodeTo, TARGET_VAL(PPC::LBZ8), 0|OPFL_Chain|OPFL_MemRefs,
                    1/*#VTs*/, MVT::i64, 2/*#Ops*/, 2, 3, 
                // Src: (ld:i64 iaddr:iPTR:$src)<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi1>> - Complexity = 13
                // Dst: (LBZ8:i64 iaddr:iPTR:$src)
/*1784*/      /*Scope*/ 13, /*->1798*/
/*1785*/        OPC_CheckComplexPat, /*CP*/2, /*#*/1, // SelectAddrIdx:$src #2 #3
/*1788*/        OPC_EmitMergeInputChains1_0,
/*1789*/        OPC_MorphNodeTo, TARGET_VAL(PPC::LBZX8), 0|OPFL_Chain|OPFL_MemRefs,
                    1/*#VTs*/, MVT::i64, 2/*#Ops*/, 2, 3, 
                // Src: (ld:i64 xaddr:iPTR:$src)<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi1>> - Complexity = 13
                // Dst: (LBZX8:i64 xaddr:iPTR:$src)
/*1798*/      0, /*End of Scope*/
/*1799*/    /*Scope*/ 10|128,1/*138*/, /*->1939*/
/*1801*/      OPC_CheckPredicate, 10, // Predicate_extload
/*1803*/      OPC_CheckType, MVT::i64,
/*1805*/      OPC_Scope, 32, /*->1839*/ // 4 children in Scope
/*1807*/        OPC_CheckPredicate, 11, // Predicate_extloadi1
/*1809*/        OPC_Scope, 13, /*->1824*/ // 2 children in Scope
/*1811*/          OPC_CheckComplexPat, /*CP*/1, /*#*/1, // SelectAddrImm:$src #2 #3
/*1814*/          OPC_EmitMergeInputChains1_0,
/*1815*/          OPC_MorphNodeTo, TARGET_VAL(PPC::LBZ8), 0|OPFL_Chain|OPFL_MemRefs,
                      1/*#VTs*/, MVT::i64, 2/*#Ops*/, 2, 3, 
                  // Src: (ld:i64 iaddr:iPTR:$src)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi1>> - Complexity = 13
                  // Dst: (LBZ8:i64 iaddr:iPTR:$src)
/*1824*/        /*Scope*/ 13, /*->1838*/
/*1825*/          OPC_CheckComplexPat, /*CP*/2, /*#*/1, // SelectAddrIdx:$src #2 #3
/*1828*/          OPC_EmitMergeInputChains1_0,
/*1829*/          OPC_MorphNodeTo, TARGET_VAL(PPC::LBZX8), 0|OPFL_Chain|OPFL_MemRefs,
                      1/*#VTs*/, MVT::i64, 2/*#Ops*/, 2, 3, 
                  // Src: (ld:i64 xaddr:iPTR:$src)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi1>> - Complexity = 13
                  // Dst: (LBZX8:i64 xaddr:iPTR:$src)
/*1838*/        0, /*End of Scope*/
/*1839*/      /*Scope*/ 32, /*->1872*/
/*1840*/        OPC_CheckPredicate, 12, // Predicate_extloadi8
/*1842*/        OPC_Scope, 13, /*->1857*/ // 2 children in Scope
/*1844*/          OPC_CheckComplexPat, /*CP*/1, /*#*/1, // SelectAddrImm:$src #2 #3
/*1847*/          OPC_EmitMergeInputChains1_0,
/*1848*/          OPC_MorphNodeTo, TARGET_VAL(PPC::LBZ8), 0|OPFL_Chain|OPFL_MemRefs,
                      1/*#VTs*/, MVT::i64, 2/*#Ops*/, 2, 3, 
                  // Src: (ld:i64 iaddr:iPTR:$src)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>> - Complexity = 13
                  // Dst: (LBZ8:i64 iaddr:iPTR:$src)
/*1857*/        /*Scope*/ 13, /*->1871*/
/*1858*/          OPC_CheckComplexPat, /*CP*/2, /*#*/1, // SelectAddrIdx:$src #2 #3
/*1861*/          OPC_EmitMergeInputChains1_0,
/*1862*/          OPC_MorphNodeTo, TARGET_VAL(PPC::LBZX8), 0|OPFL_Chain|OPFL_MemRefs,
                      1/*#VTs*/, MVT::i64, 2/*#Ops*/, 2, 3, 
                  // Src: (ld:i64 xaddr:iPTR:$src)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>> - Complexity = 13
                  // Dst: (LBZX8:i64 xaddr:iPTR:$src)
/*1871*/        0, /*End of Scope*/
/*1872*/      /*Scope*/ 32, /*->1905*/
/*1873*/        OPC_CheckPredicate, 13, // Predicate_extloadi16
/*1875*/        OPC_Scope, 13, /*->1890*/ // 2 children in Scope
/*1877*/          OPC_CheckComplexPat, /*CP*/1, /*#*/1, // SelectAddrImm:$src #2 #3
/*1880*/          OPC_EmitMergeInputChains1_0,
/*1881*/          OPC_MorphNodeTo, TARGET_VAL(PPC::LHZ8), 0|OPFL_Chain|OPFL_MemRefs,
                      1/*#VTs*/, MVT::i64, 2/*#Ops*/, 2, 3, 
                  // Src: (ld:i64 iaddr:iPTR:$src)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>> - Complexity = 13
                  // Dst: (LHZ8:i64 iaddr:iPTR:$src)
/*1890*/        /*Scope*/ 13, /*->1904*/
/*1891*/          OPC_CheckComplexPat, /*CP*/2, /*#*/1, // SelectAddrIdx:$src #2 #3
/*1894*/          OPC_EmitMergeInputChains1_0,
/*1895*/          OPC_MorphNodeTo, TARGET_VAL(PPC::LHZX8), 0|OPFL_Chain|OPFL_MemRefs,
                      1/*#VTs*/, MVT::i64, 2/*#Ops*/, 2, 3, 
                  // Src: (ld:i64 xaddr:iPTR:$src)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>> - Complexity = 13
                  // Dst: (LHZX8:i64 xaddr:iPTR:$src)
/*1904*/        0, /*End of Scope*/
/*1905*/      /*Scope*/ 32, /*->1938*/
/*1906*/        OPC_CheckPredicate, 16, // Predicate_extloadi32
/*1908*/        OPC_Scope, 13, /*->1923*/ // 2 children in Scope
/*1910*/          OPC_CheckComplexPat, /*CP*/1, /*#*/1, // SelectAddrImm:$src #2 #3
/*1913*/          OPC_EmitMergeInputChains1_0,
/*1914*/          OPC_MorphNodeTo, TARGET_VAL(PPC::LWZ8), 0|OPFL_Chain|OPFL_MemRefs,
                      1/*#VTs*/, MVT::i64, 2/*#Ops*/, 2, 3, 
                  // Src: (ld:i64 iaddr:iPTR:$src)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi32>> - Complexity = 13
                  // Dst: (LWZ8:i64 iaddr:iPTR:$src)
/*1923*/        /*Scope*/ 13, /*->1937*/
/*1924*/          OPC_CheckComplexPat, /*CP*/2, /*#*/1, // SelectAddrIdx:$src #2 #3
/*1927*/          OPC_EmitMergeInputChains1_0,
/*1928*/          OPC_MorphNodeTo, TARGET_VAL(PPC::LWZX8), 0|OPFL_Chain|OPFL_MemRefs,
                      1/*#VTs*/, MVT::i64, 2/*#Ops*/, 2, 3, 
                  // Src: (ld:i64 xaddr:iPTR:$src)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi32>> - Complexity = 13
                  // Dst: (LWZX8:i64 xaddr:iPTR:$src)
/*1937*/        0, /*End of Scope*/
/*1938*/      0, /*End of Scope*/
/*1939*/    /*Scope*/ 68, /*->2008*/
/*1940*/      OPC_CheckPredicate, 8, // Predicate_load
/*1942*/      OPC_SwitchType /*2 cases */, 30,  MVT::f32,// ->1975
/*1945*/        OPC_Scope, 13, /*->1960*/ // 2 children in Scope
/*1947*/          OPC_CheckComplexPat, /*CP*/1, /*#*/1, // SelectAddrImm:$src #2 #3
/*1950*/          OPC_EmitMergeInputChains1_0,
/*1951*/          OPC_MorphNodeTo, TARGET_VAL(PPC::LFS), 0|OPFL_Chain|OPFL_MemRefs,
                      1/*#VTs*/, MVT::f32, 2/*#Ops*/, 2, 3, 
                  // Src: (ld:f32 iaddr:iPTR:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 13
                  // Dst: (LFS:f32 iaddr:iPTR:$src)
/*1960*/        /*Scope*/ 13, /*->1974*/
/*1961*/          OPC_CheckComplexPat, /*CP*/2, /*#*/1, // SelectAddrIdx:$src #2 #3
/*1964*/          OPC_EmitMergeInputChains1_0,
/*1965*/          OPC_MorphNodeTo, TARGET_VAL(PPC::LFSX), 0|OPFL_Chain|OPFL_MemRefs,
                      1/*#VTs*/, MVT::f32, 2/*#Ops*/, 2, 3, 
                  // Src: (ld:f32 xaddr:iPTR:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 13
                  // Dst: (LFSX:f32 xaddr:iPTR:$src)
/*1974*/        0, /*End of Scope*/
              /*SwitchType*/ 30,  MVT::f64,// ->2007
/*1977*/        OPC_Scope, 13, /*->1992*/ // 2 children in Scope
/*1979*/          OPC_CheckComplexPat, /*CP*/1, /*#*/1, // SelectAddrImm:$src #2 #3
/*1982*/          OPC_EmitMergeInputChains1_0,
/*1983*/          OPC_MorphNodeTo, TARGET_VAL(PPC::LFD), 0|OPFL_Chain|OPFL_MemRefs,
                      1/*#VTs*/, MVT::f64, 2/*#Ops*/, 2, 3, 
                  // Src: (ld:f64 iaddr:iPTR:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 13
                  // Dst: (LFD:f64 iaddr:iPTR:$src)
/*1992*/        /*Scope*/ 13, /*->2006*/
/*1993*/          OPC_CheckComplexPat, /*CP*/2, /*#*/1, // SelectAddrIdx:$src #2 #3
/*1996*/          OPC_EmitMergeInputChains1_0,
/*1997*/          OPC_MorphNodeTo, TARGET_VAL(PPC::LFDX), 0|OPFL_Chain|OPFL_MemRefs,
                      1/*#VTs*/, MVT::f64, 2/*#Ops*/, 2, 3, 
                  // Src: (ld:f64 xaddr:iPTR:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 13
                  // Dst: (LFDX:f64 xaddr:iPTR:$src)
/*2006*/        0, /*End of Scope*/
              0, // EndSwitchType
/*2008*/    /*Scope*/ 60, /*->2069*/
/*2009*/      OPC_CheckPredicate, 10, // Predicate_extload
/*2011*/      OPC_CheckPredicate, 17, // Predicate_extloadf32
/*2013*/      OPC_CheckType, MVT::f64,
/*2015*/      OPC_Scope, 25, /*->2042*/ // 2 children in Scope
/*2017*/        OPC_CheckComplexPat, /*CP*/1, /*#*/1, // SelectAddrImm:$src #2 #3
/*2020*/        OPC_EmitMergeInputChains1_0,
/*2021*/        OPC_EmitNode, TARGET_VAL(PPC::LFS), 0|OPFL_Chain|OPFL_MemRefs,
                    1/*#VTs*/, MVT::f32, 2/*#Ops*/, 2, 3,  // Results = #4 
/*2030*/        OPC_EmitInteger, MVT::i32, PPC::F8RCRegClassID,
/*2033*/        OPC_MorphNodeTo, TARGET_VAL(TargetOpcode::COPY_TO_REGCLASS), 0|OPFL_Chain,
                    1/*#VTs*/, MVT::f64, 2/*#Ops*/, 4, 5, 
                // Src: (ld:f64 iaddr:iPTR:$src)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadf32>> - Complexity = 13
                // Dst: (COPY_TO_REGCLASS:f64 (LFS:f32 iaddr:iPTR:$src), F8RC:f64)
/*2042*/      /*Scope*/ 25, /*->2068*/
/*2043*/        OPC_CheckComplexPat, /*CP*/2, /*#*/1, // SelectAddrIdx:$src #2 #3
/*2046*/        OPC_EmitMergeInputChains1_0,
/*2047*/        OPC_EmitNode, TARGET_VAL(PPC::LFSX), 0|OPFL_Chain|OPFL_MemRefs,
                    1/*#VTs*/, MVT::f32, 2/*#Ops*/, 2, 3,  // Results = #4 
/*2056*/        OPC_EmitInteger, MVT::i32, PPC::F8RCRegClassID,
/*2059*/        OPC_MorphNodeTo, TARGET_VAL(TargetOpcode::COPY_TO_REGCLASS), 0|OPFL_Chain,
                    1/*#VTs*/, MVT::f64, 2/*#Ops*/, 4, 5, 
                // Src: (ld:f64 xaddr:iPTR:$src)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadf32>> - Complexity = 13
                // Dst: (COPY_TO_REGCLASS:f64 (LFSX:f32 xaddr:iPTR:$src), F8RC:f64)
/*2068*/      0, /*End of Scope*/
/*2069*/    /*Scope*/ 17, /*->2087*/
/*2070*/      OPC_CheckPredicate, 8, // Predicate_load
/*2072*/      OPC_CheckType, MVT::v4i32,
/*2074*/      OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrIdxOnly:$src #2 #3
/*2077*/      OPC_EmitMergeInputChains1_0,
/*2078*/      OPC_MorphNodeTo, TARGET_VAL(PPC::LVX), 0|OPFL_Chain|OPFL_MemRefs,
                  1/*#VTs*/, MVT::v4i32, 2/*#Ops*/, 2, 3, 
              // Src: (ld:v4i32 xoaddr:iPTR:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 13
              // Dst: (LVX:v4i32 xoaddr:iPTR:$src)
/*2087*/    0, /*End of Scope*/
          /*SwitchOpcode*/ 46|128,4/*558*/,  TARGET_VAL(ISD::STORE),// ->2650
/*2092*/    OPC_RecordMemRef,
/*2093*/    OPC_RecordNode,   // #0 = 'st' chained node
/*2094*/    OPC_RecordChild1, // #1 = $rS
/*2095*/    OPC_Scope, 52|128,1/*180*/, /*->2278*/ // 5 children in Scope
/*2098*/      OPC_CheckChild1Type, MVT::i32,
/*2100*/      OPC_RecordChild2, // #2 = $src
/*2101*/      OPC_Scope, 110, /*->2213*/ // 2 children in Scope
/*2103*/        OPC_CheckPredicate, 18, // Predicate_unindexedstore
/*2105*/        OPC_Scope, 36, /*->2143*/ // 4 children in Scope
/*2107*/          OPC_CheckPredicate, 19, // Predicate_truncstore
/*2109*/          OPC_Scope, 15, /*->2126*/ // 2 children in Scope
/*2111*/            OPC_CheckPredicate, 20, // Predicate_truncstorei8
/*2113*/            OPC_CheckComplexPat, /*CP*/1, /*#*/2, // SelectAddrImm:$src #3 #4
/*2116*/            OPC_EmitMergeInputChains1_0,
/*2117*/            OPC_MorphNodeTo, TARGET_VAL(PPC::STB), 0|OPFL_Chain|OPFL_MemRefs,
                        0/*#VTs*/, 3/*#Ops*/, 1, 3, 4, 
                    // Src: (st GPRC:i32:$rS, iaddr:iPTR:$src)<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>> - Complexity = 13
                    // Dst: (STB GPRC:i32:$rS, iaddr:iPTR:$src)
/*2126*/          /*Scope*/ 15, /*->2142*/
/*2127*/            OPC_CheckPredicate, 21, // Predicate_truncstorei16
/*2129*/            OPC_CheckComplexPat, /*CP*/1, /*#*/2, // SelectAddrImm:$src #3 #4
/*2132*/            OPC_EmitMergeInputChains1_0,
/*2133*/            OPC_MorphNodeTo, TARGET_VAL(PPC::STH), 0|OPFL_Chain|OPFL_MemRefs,
                        0/*#VTs*/, 3/*#Ops*/, 1, 3, 4, 
                    // Src: (st GPRC:i32:$rS, iaddr:iPTR:$src)<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>> - Complexity = 13
                    // Dst: (STH GPRC:i32:$rS, iaddr:iPTR:$src)
/*2142*/          0, /*End of Scope*/
/*2143*/        /*Scope*/ 15, /*->2159*/
/*2144*/          OPC_CheckPredicate, 22, // Predicate_store
/*2146*/          OPC_CheckComplexPat, /*CP*/1, /*#*/2, // SelectAddrImm:$src #3 #4
/*2149*/          OPC_EmitMergeInputChains1_0,
/*2150*/          OPC_MorphNodeTo, TARGET_VAL(PPC::STW), 0|OPFL_Chain|OPFL_MemRefs,
                      0/*#VTs*/, 3/*#Ops*/, 1, 3, 4, 
                  // Src: (st GPRC:i32:$rS, iaddr:iPTR:$src)<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 13
                  // Dst: (STW GPRC:i32:$rS, iaddr:iPTR:$src)
/*2159*/        /*Scope*/ 36, /*->2196*/
/*2160*/          OPC_CheckPredicate, 19, // Predicate_truncstore
/*2162*/          OPC_Scope, 15, /*->2179*/ // 2 children in Scope
/*2164*/            OPC_CheckPredicate, 20, // Predicate_truncstorei8
/*2166*/            OPC_CheckComplexPat, /*CP*/2, /*#*/2, // SelectAddrIdx:$dst #3 #4
/*2169*/            OPC_EmitMergeInputChains1_0,
/*2170*/            OPC_MorphNodeTo, TARGET_VAL(PPC::STBX), 0|OPFL_Chain|OPFL_MemRefs,
                        0/*#VTs*/, 3/*#Ops*/, 1, 3, 4, 
                    // Src: (st GPRC:i32:$rS, xaddr:iPTR:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>> - Complexity = 13
                    // Dst: (STBX GPRC:i32:$rS, xaddr:iPTR:$dst)
/*2179*/          /*Scope*/ 15, /*->2195*/
/*2180*/            OPC_CheckPredicate, 21, // Predicate_truncstorei16
/*2182*/            OPC_CheckComplexPat, /*CP*/2, /*#*/2, // SelectAddrIdx:$dst #3 #4
/*2185*/            OPC_EmitMergeInputChains1_0,
/*2186*/            OPC_MorphNodeTo, TARGET_VAL(PPC::STHX), 0|OPFL_Chain|OPFL_MemRefs,
                        0/*#VTs*/, 3/*#Ops*/, 1, 3, 4, 
                    // Src: (st GPRC:i32:$rS, xaddr:iPTR:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>> - Complexity = 13
                    // Dst: (STHX GPRC:i32:$rS, xaddr:iPTR:$dst)
/*2195*/          0, /*End of Scope*/
/*2196*/        /*Scope*/ 15, /*->2212*/
/*2197*/          OPC_CheckPredicate, 22, // Predicate_store
/*2199*/          OPC_CheckComplexPat, /*CP*/2, /*#*/2, // SelectAddrIdx:$dst #3 #4
/*2202*/          OPC_EmitMergeInputChains1_0,
/*2203*/          OPC_MorphNodeTo, TARGET_VAL(PPC::STWX), 0|OPFL_Chain|OPFL_MemRefs,
                      0/*#VTs*/, 3/*#Ops*/, 1, 3, 4, 
                  // Src: (st GPRC:i32:$rS, xaddr:iPTR:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 13
                  // Dst: (STWX GPRC:i32:$rS, xaddr:iPTR:$dst)
/*2212*/        0, /*End of Scope*/
/*2213*/      /*Scope*/ 63, /*->2277*/
/*2214*/        OPC_RecordChild3, // #3 = $ptroff
/*2215*/        OPC_Scope, 40, /*->2257*/ // 2 children in Scope
/*2217*/          OPC_CheckPredicate, 23, // Predicate_itruncstore
/*2219*/          OPC_CheckPredicate, 24, // Predicate_pre_truncst
/*2221*/          OPC_Scope, 16, /*->2239*/ // 2 children in Scope
/*2223*/            OPC_CheckPredicate, 25, // Predicate_pre_truncsti8
/*2225*/            OPC_CheckComplexPat, /*CP*/4, /*#*/3, // SelectAddrImmOffs:$ptroff #4
/*2228*/            OPC_EmitMergeInputChains1_0,
/*2229*/            OPC_MorphNodeTo, TARGET_VAL(PPC::STBU), 0|OPFL_Chain|OPFL_MemRefs,
                        1/*#VTs*/, MVT::iPTR, 3/*#Ops*/, 1, 4, 2, 
                    // Src: (ist:iPTR GPRC:i32:$rS, ptr_rc:iPTR:$ptrreg, iaddroff:iPTR:$ptroff)<<P:Predicate_itruncstore>><<P:Predicate_pre_truncst>><<P:Predicate_pre_truncsti8>> - Complexity = 10
                    // Dst: (STBU:iPTR GPRC:i32:$rS, iaddroff:i32:$ptroff, ptr_rc:iPTR:$ptrreg)
/*2239*/          /*Scope*/ 16, /*->2256*/
/*2240*/            OPC_CheckPredicate, 26, // Predicate_pre_truncsti16
/*2242*/            OPC_CheckComplexPat, /*CP*/4, /*#*/3, // SelectAddrImmOffs:$ptroff #4
/*2245*/            OPC_EmitMergeInputChains1_0,
/*2246*/            OPC_MorphNodeTo, TARGET_VAL(PPC::STHU), 0|OPFL_Chain|OPFL_MemRefs,
                        1/*#VTs*/, MVT::iPTR, 3/*#Ops*/, 1, 4, 2, 
                    // Src: (ist:iPTR GPRC:i32:$rS, ptr_rc:iPTR:$ptrreg, iaddroff:iPTR:$ptroff)<<P:Predicate_itruncstore>><<P:Predicate_pre_truncst>><<P:Predicate_pre_truncsti16>> - Complexity = 10
                    // Dst: (STHU:iPTR GPRC:i32:$rS, iaddroff:i32:$ptroff, ptr_rc:iPTR:$ptrreg)
/*2256*/          0, /*End of Scope*/
/*2257*/        /*Scope*/ 18, /*->2276*/
/*2258*/          OPC_CheckPredicate, 27, // Predicate_istore
/*2260*/          OPC_CheckPredicate, 28, // Predicate_pre_store
/*2262*/          OPC_CheckComplexPat, /*CP*/4, /*#*/3, // SelectAddrImmOffs:$ptroff #4
/*2265*/          OPC_EmitMergeInputChains1_0,
/*2266*/          OPC_MorphNodeTo, TARGET_VAL(PPC::STWU), 0|OPFL_Chain|OPFL_MemRefs,
                      1/*#VTs*/, MVT::iPTR, 3/*#Ops*/, 1, 4, 2, 
                  // Src: (ist:iPTR GPRC:i32:$rS, ptr_rc:iPTR:$ptrreg, iaddroff:iPTR:$ptroff)<<P:Predicate_istore>><<P:Predicate_pre_store>> - Complexity = 10
                  // Dst: (STWU:iPTR GPRC:i32:$rS, iaddroff:i32:$ptroff, ptr_rc:iPTR:$ptrreg)
/*2276*/        0, /*End of Scope*/
/*2277*/      0, /*End of Scope*/
/*2278*/    /*Scope*/ 60, /*->2339*/
/*2279*/      OPC_CheckChild1Type, MVT::f32,
/*2281*/      OPC_RecordChild2, // #2 = $dst
/*2282*/      OPC_Scope, 34, /*->2318*/ // 2 children in Scope
/*2284*/        OPC_CheckPredicate, 18, // Predicate_unindexedstore
/*2286*/        OPC_CheckPredicate, 22, // Predicate_store
/*2288*/        OPC_Scope, 13, /*->2303*/ // 2 children in Scope
/*2290*/          OPC_CheckComplexPat, /*CP*/1, /*#*/2, // SelectAddrImm:$dst #3 #4
/*2293*/          OPC_EmitMergeInputChains1_0,
/*2294*/          OPC_MorphNodeTo, TARGET_VAL(PPC::STFS), 0|OPFL_Chain|OPFL_MemRefs,
                      0/*#VTs*/, 3/*#Ops*/, 1, 3, 4, 
                  // Src: (st F4RC:f32:$rS, iaddr:iPTR:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 13
                  // Dst: (STFS F4RC:f32:$rS, iaddr:iPTR:$dst)
/*2303*/        /*Scope*/ 13, /*->2317*/
/*2304*/          OPC_CheckComplexPat, /*CP*/2, /*#*/2, // SelectAddrIdx:$dst #3 #4
/*2307*/          OPC_EmitMergeInputChains1_0,
/*2308*/          OPC_MorphNodeTo, TARGET_VAL(PPC::STFSX), 0|OPFL_Chain|OPFL_MemRefs,
                      0/*#VTs*/, 3/*#Ops*/, 1, 3, 4, 
                  // Src: (st F4RC:f32:$frS, xaddr:iPTR:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 13
                  // Dst: (STFSX F4RC:f32:$frS, xaddr:iPTR:$dst)
/*2317*/        0, /*End of Scope*/
/*2318*/      /*Scope*/ 19, /*->2338*/
/*2319*/        OPC_RecordChild3, // #3 = $ptroff
/*2320*/        OPC_CheckPredicate, 27, // Predicate_istore
/*2322*/        OPC_CheckPredicate, 28, // Predicate_pre_store
/*2324*/        OPC_CheckComplexPat, /*CP*/4, /*#*/3, // SelectAddrImmOffs:$ptroff #4
/*2327*/        OPC_EmitMergeInputChains1_0,
/*2328*/        OPC_MorphNodeTo, TARGET_VAL(PPC::STFSU), 0|OPFL_Chain|OPFL_MemRefs,
                    1/*#VTs*/, MVT::iPTR, 3/*#Ops*/, 1, 4, 2, 
                // Src: (ist:iPTR F4RC:f32:$rS, ptr_rc:iPTR:$ptrreg, iaddroff:iPTR:$ptroff)<<P:Predicate_istore>><<P:Predicate_pre_store>> - Complexity = 10
                // Dst: (STFSU:iPTR F4RC:f32:$rS, iaddroff:i32:$ptroff, ptr_rc:iPTR:$ptrreg)
/*2338*/      0, /*End of Scope*/
/*2339*/    /*Scope*/ 60, /*->2400*/
/*2340*/      OPC_CheckChild1Type, MVT::f64,
/*2342*/      OPC_RecordChild2, // #2 = $dst
/*2343*/      OPC_Scope, 34, /*->2379*/ // 2 children in Scope
/*2345*/        OPC_CheckPredicate, 18, // Predicate_unindexedstore
/*2347*/        OPC_CheckPredicate, 22, // Predicate_store
/*2349*/        OPC_Scope, 13, /*->2364*/ // 2 children in Scope
/*2351*/          OPC_CheckComplexPat, /*CP*/1, /*#*/2, // SelectAddrImm:$dst #3 #4
/*2354*/          OPC_EmitMergeInputChains1_0,
/*2355*/          OPC_MorphNodeTo, TARGET_VAL(PPC::STFD), 0|OPFL_Chain|OPFL_MemRefs,
                      0/*#VTs*/, 3/*#Ops*/, 1, 3, 4, 
                  // Src: (st F8RC:f64:$rS, iaddr:iPTR:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 13
                  // Dst: (STFD F8RC:f64:$rS, iaddr:iPTR:$dst)
/*2364*/        /*Scope*/ 13, /*->2378*/
/*2365*/          OPC_CheckComplexPat, /*CP*/2, /*#*/2, // SelectAddrIdx:$dst #3 #4
/*2368*/          OPC_EmitMergeInputChains1_0,
/*2369*/          OPC_MorphNodeTo, TARGET_VAL(PPC::STFDX), 0|OPFL_Chain|OPFL_MemRefs,
                      0/*#VTs*/, 3/*#Ops*/, 1, 3, 4, 
                  // Src: (st F8RC:f64:$frS, xaddr:iPTR:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 13
                  // Dst: (STFDX F8RC:f64:$frS, xaddr:iPTR:$dst)
/*2378*/        0, /*End of Scope*/
/*2379*/      /*Scope*/ 19, /*->2399*/
/*2380*/        OPC_RecordChild3, // #3 = $ptroff
/*2381*/        OPC_CheckPredicate, 27, // Predicate_istore
/*2383*/        OPC_CheckPredicate, 28, // Predicate_pre_store
/*2385*/        OPC_CheckComplexPat, /*CP*/4, /*#*/3, // SelectAddrImmOffs:$ptroff #4
/*2388*/        OPC_EmitMergeInputChains1_0,
/*2389*/        OPC_MorphNodeTo, TARGET_VAL(PPC::STFDU), 0|OPFL_Chain|OPFL_MemRefs,
                    1/*#VTs*/, MVT::iPTR, 3/*#Ops*/, 1, 4, 2, 
                // Src: (ist:iPTR F8RC:f64:$rS, ptr_rc:iPTR:$ptrreg, iaddroff:iPTR:$ptroff)<<P:Predicate_istore>><<P:Predicate_pre_store>> - Complexity = 10
                // Dst: (STFDU:iPTR F8RC:f64:$rS, iaddroff:i32:$ptroff, ptr_rc:iPTR:$ptrreg)
/*2399*/      0, /*End of Scope*/
/*2400*/    /*Scope*/ 20, /*->2421*/
/*2401*/      OPC_CheckChild1Type, MVT::v4i32,
/*2403*/      OPC_RecordChild2, // #2 = $dst
/*2404*/      OPC_CheckPredicate, 18, // Predicate_unindexedstore
/*2406*/      OPC_CheckPredicate, 22, // Predicate_store
/*2408*/      OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddrIdxOnly:$dst #3 #4
/*2411*/      OPC_EmitMergeInputChains1_0,
/*2412*/      OPC_MorphNodeTo, TARGET_VAL(PPC::STVX), 0|OPFL_Chain|OPFL_MemRefs,
                  0/*#VTs*/, 3/*#Ops*/, 1, 3, 4, 
              // Src: (st VRRC:v4i32:$rS, xoaddr:iPTR:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 13
              // Dst: (STVX VRRC:v4i32:$rS, xoaddr:iPTR:$dst)
/*2421*/    /*Scope*/ 98|128,1/*226*/, /*->2649*/
/*2423*/      OPC_CheckChild1Type, MVT::i64,
/*2425*/      OPC_RecordChild2, // #2 = $src
/*2426*/      OPC_Scope, 10|128,1/*138*/, /*->2567*/ // 2 children in Scope
/*2429*/        OPC_CheckPredicate, 18, // Predicate_unindexedstore
/*2431*/        OPC_Scope, 100, /*->2533*/ // 2 children in Scope
/*2433*/          OPC_CheckPredicate, 19, // Predicate_truncstore
/*2435*/          OPC_Scope, 15, /*->2452*/ // 6 children in Scope
/*2437*/            OPC_CheckPredicate, 20, // Predicate_truncstorei8
/*2439*/            OPC_CheckComplexPat, /*CP*/1, /*#*/2, // SelectAddrImm:$src #3 #4
/*2442*/            OPC_EmitMergeInputChains1_0,
/*2443*/            OPC_MorphNodeTo, TARGET_VAL(PPC::STB8), 0|OPFL_Chain|OPFL_MemRefs,
                        0/*#VTs*/, 3/*#Ops*/, 1, 3, 4, 
                    // Src: (st G8RC:i64:$rS, iaddr:iPTR:$src)<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>> - Complexity = 13
                    // Dst: (STB8 G8RC:i64:$rS, iaddr:iPTR:$src)
/*2452*/          /*Scope*/ 15, /*->2468*/
/*2453*/            OPC_CheckPredicate, 21, // Predicate_truncstorei16
/*2455*/            OPC_CheckComplexPat, /*CP*/1, /*#*/2, // SelectAddrImm:$src #3 #4
/*2458*/            OPC_EmitMergeInputChains1_0,
/*2459*/            OPC_MorphNodeTo, TARGET_VAL(PPC::STH8), 0|OPFL_Chain|OPFL_MemRefs,
                        0/*#VTs*/, 3/*#Ops*/, 1, 3, 4, 
                    // Src: (st G8RC:i64:$rS, iaddr:iPTR:$src)<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>> - Complexity = 13
                    // Dst: (STH8 G8RC:i64:$rS, iaddr:iPTR:$src)
/*2468*/          /*Scope*/ 15, /*->2484*/
/*2469*/            OPC_CheckPredicate, 29, // Predicate_truncstorei32
/*2471*/            OPC_CheckComplexPat, /*CP*/1, /*#*/2, // SelectAddrImm:$src #3 #4
/*2474*/            OPC_EmitMergeInputChains1_0,
/*2475*/            OPC_MorphNodeTo, TARGET_VAL(PPC::STW8), 0|OPFL_Chain|OPFL_MemRefs,
                        0/*#VTs*/, 3/*#Ops*/, 1, 3, 4, 
                    // Src: (st G8RC:i64:$rS, iaddr:iPTR:$src)<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei32>> - Complexity = 13
                    // Dst: (STW8 G8RC:i64:$rS, iaddr:iPTR:$src)
/*2484*/          /*Scope*/ 15, /*->2500*/
/*2485*/            OPC_CheckPredicate, 20, // Predicate_truncstorei8
/*2487*/            OPC_CheckComplexPat, /*CP*/2, /*#*/2, // SelectAddrIdx:$dst #3 #4
/*2490*/            OPC_EmitMergeInputChains1_0,
/*2491*/            OPC_MorphNodeTo, TARGET_VAL(PPC::STBX8), 0|OPFL_Chain|OPFL_MemRefs,
                        0/*#VTs*/, 3/*#Ops*/, 1, 3, 4, 
                    // Src: (st G8RC:i64:$rS, xaddr:iPTR:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>> - Complexity = 13
                    // Dst: (STBX8 G8RC:i64:$rS, xaddr:iPTR:$dst)
/*2500*/          /*Scope*/ 15, /*->2516*/
/*2501*/            OPC_CheckPredicate, 21, // Predicate_truncstorei16
/*2503*/            OPC_CheckComplexPat, /*CP*/2, /*#*/2, // SelectAddrIdx:$dst #3 #4
/*2506*/            OPC_EmitMergeInputChains1_0,
/*2507*/            OPC_MorphNodeTo, TARGET_VAL(PPC::STHX8), 0|OPFL_Chain|OPFL_MemRefs,
                        0/*#VTs*/, 3/*#Ops*/, 1, 3, 4, 
                    // Src: (st G8RC:i64:$rS, xaddr:iPTR:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>> - Complexity = 13
                    // Dst: (STHX8 G8RC:i64:$rS, xaddr:iPTR:$dst)
/*2516*/          /*Scope*/ 15, /*->2532*/
/*2517*/            OPC_CheckPredicate, 29, // Predicate_truncstorei32
/*2519*/            OPC_CheckComplexPat, /*CP*/2, /*#*/2, // SelectAddrIdx:$dst #3 #4
/*2522*/            OPC_EmitMergeInputChains1_0,
/*2523*/            OPC_MorphNodeTo, TARGET_VAL(PPC::STWX8), 0|OPFL_Chain|OPFL_MemRefs,
                        0/*#VTs*/, 3/*#Ops*/, 1, 3, 4, 
                    // Src: (st G8RC:i64:$rS, xaddr:iPTR:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei32>> - Complexity = 13
                    // Dst: (STWX8 G8RC:i64:$rS, xaddr:iPTR:$dst)
/*2532*/          0, /*End of Scope*/
/*2533*/        /*Scope*/ 32, /*->2566*/
/*2534*/          OPC_CheckPredicate, 22, // Predicate_store
/*2536*/          OPC_Scope, 13, /*->2551*/ // 2 children in Scope
/*2538*/            OPC_CheckComplexPat, /*CP*/3, /*#*/2, // SelectAddrImmShift:$dst #3 #4
/*2541*/            OPC_EmitMergeInputChains1_0,
/*2542*/            OPC_MorphNodeTo, TARGET_VAL(PPC::STD), 0|OPFL_Chain|OPFL_MemRefs,
                        0/*#VTs*/, 3/*#Ops*/, 1, 3, 4, 
                    // Src: (st G8RC:i64:$rS, ixaddr:iPTR:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 13
                    // Dst: (STD G8RC:i64:$rS, ixaddr:iPTR:$dst)
/*2551*/          /*Scope*/ 13, /*->2565*/
/*2552*/            OPC_CheckComplexPat, /*CP*/2, /*#*/2, // SelectAddrIdx:$dst #3 #4
/*2555*/            OPC_EmitMergeInputChains1_0,
/*2556*/            OPC_MorphNodeTo, TARGET_VAL(PPC::STDX), 0|OPFL_Chain|OPFL_MemRefs,
                        0/*#VTs*/, 3/*#Ops*/, 1, 3, 4, 
                    // Src: (st G8RC:i64:$rS, xaddr:iPTR:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 13
                    // Dst: (STDX G8RC:i64:$rS, xaddr:iPTR:$dst)
/*2565*/          0, /*End of Scope*/
/*2566*/        0, /*End of Scope*/
/*2567*/      /*Scope*/ 80, /*->2648*/
/*2568*/        OPC_RecordChild3, // #3 = $ptroff
/*2569*/        OPC_Scope, 57, /*->2628*/ // 2 children in Scope
/*2571*/          OPC_CheckPredicate, 23, // Predicate_itruncstore
/*2573*/          OPC_CheckPredicate, 24, // Predicate_pre_truncst
/*2575*/          OPC_Scope, 16, /*->2593*/ // 3 children in Scope
/*2577*/            OPC_CheckPredicate, 25, // Predicate_pre_truncsti8
/*2579*/            OPC_CheckComplexPat, /*CP*/4, /*#*/3, // SelectAddrImmOffs:$ptroff #4
/*2582*/            OPC_EmitMergeInputChains1_0,
/*2583*/            OPC_MorphNodeTo, TARGET_VAL(PPC::STBU8), 0|OPFL_Chain|OPFL_MemRefs,
                        1/*#VTs*/, MVT::iPTR, 3/*#Ops*/, 1, 4, 2, 
                    // Src: (ist:iPTR G8RC:i64:$rS, ptr_rc:iPTR:$ptrreg, iaddroff:iPTR:$ptroff)<<P:Predicate_itruncstore>><<P:Predicate_pre_truncst>><<P:Predicate_pre_truncsti8>> - Complexity = 10
                    // Dst: (STBU8:iPTR G8RC:i64:$rS, iaddroff:i32:$ptroff, ptr_rc:iPTR:$ptrreg)
/*2593*/          /*Scope*/ 16, /*->2610*/
/*2594*/            OPC_CheckPredicate, 26, // Predicate_pre_truncsti16
/*2596*/            OPC_CheckComplexPat, /*CP*/4, /*#*/3, // SelectAddrImmOffs:$ptroff #4
/*2599*/            OPC_EmitMergeInputChains1_0,
/*2600*/            OPC_MorphNodeTo, TARGET_VAL(PPC::STHU8), 0|OPFL_Chain|OPFL_MemRefs,
                        1/*#VTs*/, MVT::iPTR, 3/*#Ops*/, 1, 4, 2, 
                    // Src: (ist:iPTR G8RC:i64:$rS, ptr_rc:iPTR:$ptrreg, iaddroff:iPTR:$ptroff)<<P:Predicate_itruncstore>><<P:Predicate_pre_truncst>><<P:Predicate_pre_truncsti16>> - Complexity = 10
                    // Dst: (STHU8:iPTR G8RC:i64:$rS, iaddroff:i32:$ptroff, ptr_rc:iPTR:$ptrreg)
/*2610*/          /*Scope*/ 16, /*->2627*/
/*2611*/            OPC_CheckPredicate, 30, // Predicate_pre_truncsti32
/*2613*/            OPC_CheckComplexPat, /*CP*/4, /*#*/3, // SelectAddrImmOffs:$ptroff #4
/*2616*/            OPC_EmitMergeInputChains1_0,
/*2617*/            OPC_MorphNodeTo, TARGET_VAL(PPC::STWU8), 0|OPFL_Chain|OPFL_MemRefs,
                        1/*#VTs*/, MVT::iPTR, 3/*#Ops*/, 1, 4, 2, 
                    // Src: (ist:iPTR G8RC:i64:$rS, ptr_rc:iPTR:$ptrreg, iaddroff:iPTR:$ptroff)<<P:Predicate_itruncstore>><<P:Predicate_pre_truncst>><<P:Predicate_pre_truncsti32>> - Complexity = 10
                    // Dst: (STWU8:iPTR G8RC:i64:$rS, iaddroff:i32:$ptroff, ptr_rc:iPTR:$ptrreg)
/*2627*/          0, /*End of Scope*/
/*2628*/        /*Scope*/ 18, /*->2647*/
/*2629*/          OPC_CheckPredicate, 27, // Predicate_istore
/*2631*/          OPC_CheckPredicate, 28, // Predicate_pre_store
/*2633*/          OPC_CheckComplexPat, /*CP*/4, /*#*/3, // SelectAddrImmOffs:$ptroff #4
/*2636*/          OPC_EmitMergeInputChains1_0,
/*2637*/          OPC_MorphNodeTo, TARGET_VAL(PPC::STDU), 0|OPFL_Chain|OPFL_MemRefs,
                      1/*#VTs*/, MVT::iPTR, 3/*#Ops*/, 1, 4, 2, 
                  // Src: (ist:iPTR G8RC:i64:$rS, ptr_rc:iPTR:$ptrreg, iaddroff:iPTR:$ptroff)<<P:Predicate_istore>><<P:Predicate_pre_store>> - Complexity = 10
                  // Dst: (STDU:iPTR G8RC:i64:$rS, iaddroff:i32:$ptroff, ptr_rc:iPTR:$ptrreg)
/*2647*/        0, /*End of Scope*/
/*2648*/      0, /*End of Scope*/
/*2649*/    0, /*End of Scope*/
          /*SwitchOpcode*/ 83,  TARGET_VAL(ISD::ATOMIC_LOAD_ADD),// ->2736
/*2653*/    OPC_RecordMemRef,
/*2654*/    OPC_RecordNode,   // #0 = 'atomic_load_add' chained node
/*2655*/    OPC_RecordChild1, // #1 = $ptr
/*2656*/    OPC_RecordChild2, // #2 = $incr
/*2657*/    OPC_SwitchType /*2 cases */, 56,  MVT::i32,// ->2716
/*2660*/      OPC_Scope, 17, /*->2679*/ // 3 children in Scope
/*2662*/        OPC_CheckPredicate, 31, // Predicate_atomic_load_add_8
/*2664*/        OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrIdxOnly:$ptr #3 #4
/*2667*/        OPC_EmitMergeInputChains1_0,
/*2668*/        OPC_MorphNodeTo, TARGET_VAL(PPC::ATOMIC_LOAD_ADD_I8), 0|OPFL_Chain|OPFL_MemRefs,
                    2/*#VTs*/, MVT::i32, MVT::i32, 3/*#Ops*/, 3, 4, 2, 
                // Src: (atomic_load_add:i32 xoaddr:iPTR:$ptr, GPRC:i32:$incr)<<P:Predicate_atomic_load_add_8>> - Complexity = 13
                // Dst: (ATOMIC_LOAD_ADD_I8:i32:i32 xoaddr:iPTR:$ptr, GPRC:i32:$incr)
/*2679*/      /*Scope*/ 17, /*->2697*/
/*2680*/        OPC_CheckPredicate, 32, // Predicate_atomic_load_add_16
/*2682*/        OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrIdxOnly:$ptr #3 #4
/*2685*/        OPC_EmitMergeInputChains1_0,
/*2686*/        OPC_MorphNodeTo, TARGET_VAL(PPC::ATOMIC_LOAD_ADD_I16), 0|OPFL_Chain|OPFL_MemRefs,
                    2/*#VTs*/, MVT::i32, MVT::i32, 3/*#Ops*/, 3, 4, 2, 
                // Src: (atomic_load_add:i32 xoaddr:iPTR:$ptr, GPRC:i32:$incr)<<P:Predicate_atomic_load_add_16>> - Complexity = 13
                // Dst: (ATOMIC_LOAD_ADD_I16:i32:i32 xoaddr:iPTR:$ptr, GPRC:i32:$incr)
/*2697*/      /*Scope*/ 17, /*->2715*/
/*2698*/        OPC_CheckPredicate, 33, // Predicate_atomic_load_add_32
/*2700*/        OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrIdxOnly:$ptr #3 #4
/*2703*/        OPC_EmitMergeInputChains1_0,
/*2704*/        OPC_MorphNodeTo, TARGET_VAL(PPC::ATOMIC_LOAD_ADD_I32), 0|OPFL_Chain|OPFL_MemRefs,
                    2/*#VTs*/, MVT::i32, MVT::i32, 3/*#Ops*/, 3, 4, 2, 
                // Src: (atomic_load_add:i32 xoaddr:iPTR:$ptr, GPRC:i32:$incr)<<P:Predicate_atomic_load_add_32>> - Complexity = 13
                // Dst: (ATOMIC_LOAD_ADD_I32:i32:i32 xoaddr:iPTR:$ptr, GPRC:i32:$incr)
/*2715*/      0, /*End of Scope*/
            /*SwitchType*/ 17,  MVT::i64,// ->2735
/*2718*/      OPC_CheckPredicate, 34, // Predicate_atomic_load_add_64
/*2720*/      OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrIdxOnly:$ptr #3 #4
/*2723*/      OPC_EmitMergeInputChains1_0,
/*2724*/      OPC_MorphNodeTo, TARGET_VAL(PPC::ATOMIC_LOAD_ADD_I64), 0|OPFL_Chain|OPFL_MemRefs,
                  2/*#VTs*/, MVT::i64, MVT::i32, 3/*#Ops*/, 3, 4, 2, 
              // Src: (atomic_load_add:i64 xoaddr:iPTR:$ptr, G8RC:i64:$incr)<<P:Predicate_atomic_load_add_64>> - Complexity = 13
              // Dst: (ATOMIC_LOAD_ADD_I64:i64:i32 xoaddr:iPTR:$ptr, G8RC:i64:$incr)
            0, // EndSwitchType
          /*SwitchOpcode*/ 83,  TARGET_VAL(ISD::ATOMIC_LOAD_SUB),// ->2822
/*2739*/    OPC_RecordMemRef,
/*2740*/    OPC_RecordNode,   // #0 = 'atomic_load_sub' chained node
/*2741*/    OPC_RecordChild1, // #1 = $ptr
/*2742*/    OPC_RecordChild2, // #2 = $incr
/*2743*/    OPC_SwitchType /*2 cases */, 56,  MVT::i32,// ->2802
/*2746*/      OPC_Scope, 17, /*->2765*/ // 3 children in Scope
/*2748*/        OPC_CheckPredicate, 35, // Predicate_atomic_load_sub_8
/*2750*/        OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrIdxOnly:$ptr #3 #4
/*2753*/        OPC_EmitMergeInputChains1_0,
/*2754*/        OPC_MorphNodeTo, TARGET_VAL(PPC::ATOMIC_LOAD_SUB_I8), 0|OPFL_Chain|OPFL_MemRefs,
                    2/*#VTs*/, MVT::i32, MVT::i32, 3/*#Ops*/, 3, 4, 2, 
                // Src: (atomic_load_sub:i32 xoaddr:iPTR:$ptr, GPRC:i32:$incr)<<P:Predicate_atomic_load_sub_8>> - Complexity = 13
                // Dst: (ATOMIC_LOAD_SUB_I8:i32:i32 xoaddr:iPTR:$ptr, GPRC:i32:$incr)
/*2765*/      /*Scope*/ 17, /*->2783*/
/*2766*/        OPC_CheckPredicate, 36, // Predicate_atomic_load_sub_16
/*2768*/        OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrIdxOnly:$ptr #3 #4
/*2771*/        OPC_EmitMergeInputChains1_0,
/*2772*/        OPC_MorphNodeTo, TARGET_VAL(PPC::ATOMIC_LOAD_SUB_I16), 0|OPFL_Chain|OPFL_MemRefs,
                    2/*#VTs*/, MVT::i32, MVT::i32, 3/*#Ops*/, 3, 4, 2, 
                // Src: (atomic_load_sub:i32 xoaddr:iPTR:$ptr, GPRC:i32:$incr)<<P:Predicate_atomic_load_sub_16>> - Complexity = 13
                // Dst: (ATOMIC_LOAD_SUB_I16:i32:i32 xoaddr:iPTR:$ptr, GPRC:i32:$incr)
/*2783*/      /*Scope*/ 17, /*->2801*/
/*2784*/        OPC_CheckPredicate, 37, // Predicate_atomic_load_sub_32
/*2786*/        OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrIdxOnly:$ptr #3 #4
/*2789*/        OPC_EmitMergeInputChains1_0,
/*2790*/        OPC_MorphNodeTo, TARGET_VAL(PPC::ATOMIC_LOAD_SUB_I32), 0|OPFL_Chain|OPFL_MemRefs,
                    2/*#VTs*/, MVT::i32, MVT::i32, 3/*#Ops*/, 3, 4, 2, 
                // Src: (atomic_load_sub:i32 xoaddr:iPTR:$ptr, GPRC:i32:$incr)<<P:Predicate_atomic_load_sub_32>> - Complexity = 13
                // Dst: (ATOMIC_LOAD_SUB_I32:i32:i32 xoaddr:iPTR:$ptr, GPRC:i32:$incr)
/*2801*/      0, /*End of Scope*/
            /*SwitchType*/ 17,  MVT::i64,// ->2821
/*2804*/      OPC_CheckPredicate, 38, // Predicate_atomic_load_sub_64
/*2806*/      OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrIdxOnly:$ptr #3 #4
/*2809*/      OPC_EmitMergeInputChains1_0,
/*2810*/      OPC_MorphNodeTo, TARGET_VAL(PPC::ATOMIC_LOAD_SUB_I64), 0|OPFL_Chain|OPFL_MemRefs,
                  2/*#VTs*/, MVT::i64, MVT::i32, 3/*#Ops*/, 3, 4, 2, 
              // Src: (atomic_load_sub:i64 xoaddr:iPTR:$ptr, G8RC:i64:$incr)<<P:Predicate_atomic_load_sub_64>> - Complexity = 13
              // Dst: (ATOMIC_LOAD_SUB_I64:i64:i32 xoaddr:iPTR:$ptr, G8RC:i64:$incr)
            0, // EndSwitchType
          /*SwitchOpcode*/ 83,  TARGET_VAL(ISD::ATOMIC_LOAD_AND),// ->2908
/*2825*/    OPC_RecordMemRef,
/*2826*/    OPC_RecordNode,   // #0 = 'atomic_load_and' chained node
/*2827*/    OPC_RecordChild1, // #1 = $ptr
/*2828*/    OPC_RecordChild2, // #2 = $incr
/*2829*/    OPC_SwitchType /*2 cases */, 56,  MVT::i32,// ->2888
/*2832*/      OPC_Scope, 17, /*->2851*/ // 3 children in Scope
/*2834*/        OPC_CheckPredicate, 39, // Predicate_atomic_load_and_8
/*2836*/        OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrIdxOnly:$ptr #3 #4
/*2839*/        OPC_EmitMergeInputChains1_0,
/*2840*/        OPC_MorphNodeTo, TARGET_VAL(PPC::ATOMIC_LOAD_AND_I8), 0|OPFL_Chain|OPFL_MemRefs,
                    2/*#VTs*/, MVT::i32, MVT::i32, 3/*#Ops*/, 3, 4, 2, 
                // Src: (atomic_load_and:i32 xoaddr:iPTR:$ptr, GPRC:i32:$incr)<<P:Predicate_atomic_load_and_8>> - Complexity = 13
                // Dst: (ATOMIC_LOAD_AND_I8:i32:i32 xoaddr:iPTR:$ptr, GPRC:i32:$incr)
/*2851*/      /*Scope*/ 17, /*->2869*/
/*2852*/        OPC_CheckPredicate, 40, // Predicate_atomic_load_and_16
/*2854*/        OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrIdxOnly:$ptr #3 #4
/*2857*/        OPC_EmitMergeInputChains1_0,
/*2858*/        OPC_MorphNodeTo, TARGET_VAL(PPC::ATOMIC_LOAD_AND_I16), 0|OPFL_Chain|OPFL_MemRefs,
                    2/*#VTs*/, MVT::i32, MVT::i32, 3/*#Ops*/, 3, 4, 2, 
                // Src: (atomic_load_and:i32 xoaddr:iPTR:$ptr, GPRC:i32:$incr)<<P:Predicate_atomic_load_and_16>> - Complexity = 13
                // Dst: (ATOMIC_LOAD_AND_I16:i32:i32 xoaddr:iPTR:$ptr, GPRC:i32:$incr)
/*2869*/      /*Scope*/ 17, /*->2887*/
/*2870*/        OPC_CheckPredicate, 41, // Predicate_atomic_load_and_32
/*2872*/        OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrIdxOnly:$ptr #3 #4
/*2875*/        OPC_EmitMergeInputChains1_0,
/*2876*/        OPC_MorphNodeTo, TARGET_VAL(PPC::ATOMIC_LOAD_AND_I32), 0|OPFL_Chain|OPFL_MemRefs,
                    2/*#VTs*/, MVT::i32, MVT::i32, 3/*#Ops*/, 3, 4, 2, 
                // Src: (atomic_load_and:i32 xoaddr:iPTR:$ptr, GPRC:i32:$incr)<<P:Predicate_atomic_load_and_32>> - Complexity = 13
                // Dst: (ATOMIC_LOAD_AND_I32:i32:i32 xoaddr:iPTR:$ptr, GPRC:i32:$incr)
/*2887*/      0, /*End of Scope*/
            /*SwitchType*/ 17,  MVT::i64,// ->2907
/*2890*/      OPC_CheckPredicate, 42, // Predicate_atomic_load_and_64
/*2892*/      OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrIdxOnly:$ptr #3 #4
/*2895*/      OPC_EmitMergeInputChains1_0,
/*2896*/      OPC_MorphNodeTo, TARGET_VAL(PPC::ATOMIC_LOAD_AND_I64), 0|OPFL_Chain|OPFL_MemRefs,
                  2/*#VTs*/, MVT::i64, MVT::i32, 3/*#Ops*/, 3, 4, 2, 
              // Src: (atomic_load_and:i64 xoaddr:iPTR:$ptr, G8RC:i64:$incr)<<P:Predicate_atomic_load_and_64>> - Complexity = 13
              // Dst: (ATOMIC_LOAD_AND_I64:i64:i32 xoaddr:iPTR:$ptr, G8RC:i64:$incr)
            0, // EndSwitchType
          /*SwitchOpcode*/ 83,  TARGET_VAL(ISD::ATOMIC_LOAD_OR),// ->2994
/*2911*/    OPC_RecordMemRef,
/*2912*/    OPC_RecordNode,   // #0 = 'atomic_load_or' chained node
/*2913*/    OPC_RecordChild1, // #1 = $ptr
/*2914*/    OPC_RecordChild2, // #2 = $incr
/*2915*/    OPC_SwitchType /*2 cases */, 56,  MVT::i32,// ->2974
/*2918*/      OPC_Scope, 17, /*->2937*/ // 3 children in Scope
/*2920*/        OPC_CheckPredicate, 43, // Predicate_atomic_load_or_8
/*2922*/        OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrIdxOnly:$ptr #3 #4
/*2925*/        OPC_EmitMergeInputChains1_0,
/*2926*/        OPC_MorphNodeTo, TARGET_VAL(PPC::ATOMIC_LOAD_OR_I8), 0|OPFL_Chain|OPFL_MemRefs,
                    2/*#VTs*/, MVT::i32, MVT::i32, 3/*#Ops*/, 3, 4, 2, 
                // Src: (atomic_load_or:i32 xoaddr:iPTR:$ptr, GPRC:i32:$incr)<<P:Predicate_atomic_load_or_8>> - Complexity = 13
                // Dst: (ATOMIC_LOAD_OR_I8:i32:i32 xoaddr:iPTR:$ptr, GPRC:i32:$incr)
/*2937*/      /*Scope*/ 17, /*->2955*/
/*2938*/        OPC_CheckPredicate, 44, // Predicate_atomic_load_or_16
/*2940*/        OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrIdxOnly:$ptr #3 #4
/*2943*/        OPC_EmitMergeInputChains1_0,
/*2944*/        OPC_MorphNodeTo, TARGET_VAL(PPC::ATOMIC_LOAD_OR_I16), 0|OPFL_Chain|OPFL_MemRefs,
                    2/*#VTs*/, MVT::i32, MVT::i32, 3/*#Ops*/, 3, 4, 2, 
                // Src: (atomic_load_or:i32 xoaddr:iPTR:$ptr, GPRC:i32:$incr)<<P:Predicate_atomic_load_or_16>> - Complexity = 13
                // Dst: (ATOMIC_LOAD_OR_I16:i32:i32 xoaddr:iPTR:$ptr, GPRC:i32:$incr)
/*2955*/      /*Scope*/ 17, /*->2973*/
/*2956*/        OPC_CheckPredicate, 45, // Predicate_atomic_load_or_32
/*2958*/        OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrIdxOnly:$ptr #3 #4
/*2961*/        OPC_EmitMergeInputChains1_0,
/*2962*/        OPC_MorphNodeTo, TARGET_VAL(PPC::ATOMIC_LOAD_OR_I32), 0|OPFL_Chain|OPFL_MemRefs,
                    2/*#VTs*/, MVT::i32, MVT::i32, 3/*#Ops*/, 3, 4, 2, 
                // Src: (atomic_load_or:i32 xoaddr:iPTR:$ptr, GPRC:i32:$incr)<<P:Predicate_atomic_load_or_32>> - Complexity = 13
                // Dst: (ATOMIC_LOAD_OR_I32:i32:i32 xoaddr:iPTR:$ptr, GPRC:i32:$incr)
/*2973*/      0, /*End of Scope*/
            /*SwitchType*/ 17,  MVT::i64,// ->2993
/*2976*/      OPC_CheckPredicate, 46, // Predicate_atomic_load_or_64
/*2978*/      OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrIdxOnly:$ptr #3 #4
/*2981*/      OPC_EmitMergeInputChains1_0,
/*2982*/      OPC_MorphNodeTo, TARGET_VAL(PPC::ATOMIC_LOAD_OR_I64), 0|OPFL_Chain|OPFL_MemRefs,
                  2/*#VTs*/, MVT::i64, MVT::i32, 3/*#Ops*/, 3, 4, 2, 
              // Src: (atomic_load_or:i64 xoaddr:iPTR:$ptr, G8RC:i64:$incr)<<P:Predicate_atomic_load_or_64>> - Complexity = 13
              // Dst: (ATOMIC_LOAD_OR_I64:i64:i32 xoaddr:iPTR:$ptr, G8RC:i64:$incr)
            0, // EndSwitchType
          /*SwitchOpcode*/ 83,  TARGET_VAL(ISD::ATOMIC_LOAD_XOR),// ->3080
/*2997*/    OPC_RecordMemRef,
/*2998*/    OPC_RecordNode,   // #0 = 'atomic_load_xor' chained node
/*2999*/    OPC_RecordChild1, // #1 = $ptr
/*3000*/    OPC_RecordChild2, // #2 = $incr
/*3001*/    OPC_SwitchType /*2 cases */, 56,  MVT::i32,// ->3060
/*3004*/      OPC_Scope, 17, /*->3023*/ // 3 children in Scope
/*3006*/        OPC_CheckPredicate, 47, // Predicate_atomic_load_xor_8
/*3008*/        OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrIdxOnly:$ptr #3 #4
/*3011*/        OPC_EmitMergeInputChains1_0,
/*3012*/        OPC_MorphNodeTo, TARGET_VAL(PPC::ATOMIC_LOAD_XOR_I8), 0|OPFL_Chain|OPFL_MemRefs,
                    2/*#VTs*/, MVT::i32, MVT::i32, 3/*#Ops*/, 3, 4, 2, 
                // Src: (atomic_load_xor:i32 xoaddr:iPTR:$ptr, GPRC:i32:$incr)<<P:Predicate_atomic_load_xor_8>> - Complexity = 13
                // Dst: (ATOMIC_LOAD_XOR_I8:i32:i32 xoaddr:iPTR:$ptr, GPRC:i32:$incr)
/*3023*/      /*Scope*/ 17, /*->3041*/
/*3024*/        OPC_CheckPredicate, 48, // Predicate_atomic_load_xor_16
/*3026*/        OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrIdxOnly:$ptr #3 #4
/*3029*/        OPC_EmitMergeInputChains1_0,
/*3030*/        OPC_MorphNodeTo, TARGET_VAL(PPC::ATOMIC_LOAD_XOR_I16), 0|OPFL_Chain|OPFL_MemRefs,
                    2/*#VTs*/, MVT::i32, MVT::i32, 3/*#Ops*/, 3, 4, 2, 
                // Src: (atomic_load_xor:i32 xoaddr:iPTR:$ptr, GPRC:i32:$incr)<<P:Predicate_atomic_load_xor_16>> - Complexity = 13
                // Dst: (ATOMIC_LOAD_XOR_I16:i32:i32 xoaddr:iPTR:$ptr, GPRC:i32:$incr)
/*3041*/      /*Scope*/ 17, /*->3059*/
/*3042*/        OPC_CheckPredicate, 49, // Predicate_atomic_load_xor_32
/*3044*/        OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrIdxOnly:$ptr #3 #4
/*3047*/        OPC_EmitMergeInputChains1_0,
/*3048*/        OPC_MorphNodeTo, TARGET_VAL(PPC::ATOMIC_LOAD_XOR_I32), 0|OPFL_Chain|OPFL_MemRefs,
                    2/*#VTs*/, MVT::i32, MVT::i32, 3/*#Ops*/, 3, 4, 2, 
                // Src: (atomic_load_xor:i32 xoaddr:iPTR:$ptr, GPRC:i32:$incr)<<P:Predicate_atomic_load_xor_32>> - Complexity = 13
                // Dst: (ATOMIC_LOAD_XOR_I32:i32:i32 xoaddr:iPTR:$ptr, GPRC:i32:$incr)
/*3059*/      0, /*End of Scope*/
            /*SwitchType*/ 17,  MVT::i64,// ->3079
/*3062*/      OPC_CheckPredicate, 50, // Predicate_atomic_load_xor_64
/*3064*/      OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrIdxOnly:$ptr #3 #4
/*3067*/      OPC_EmitMergeInputChains1_0,
/*3068*/      OPC_MorphNodeTo, TARGET_VAL(PPC::ATOMIC_LOAD_XOR_I64), 0|OPFL_Chain|OPFL_MemRefs,
                  2/*#VTs*/, MVT::i64, MVT::i32, 3/*#Ops*/, 3, 4, 2, 
              // Src: (atomic_load_xor:i64 xoaddr:iPTR:$ptr, G8RC:i64:$incr)<<P:Predicate_atomic_load_xor_64>> - Complexity = 13
              // Dst: (ATOMIC_LOAD_XOR_I64:i64:i32 xoaddr:iPTR:$ptr, G8RC:i64:$incr)
            0, // EndSwitchType
          /*SwitchOpcode*/ 83,  TARGET_VAL(ISD::ATOMIC_LOAD_NAND),// ->3166
/*3083*/    OPC_RecordMemRef,
/*3084*/    OPC_RecordNode,   // #0 = 'atomic_load_nand' chained node
/*3085*/    OPC_RecordChild1, // #1 = $ptr
/*3086*/    OPC_RecordChild2, // #2 = $incr
/*3087*/    OPC_SwitchType /*2 cases */, 56,  MVT::i32,// ->3146
/*3090*/      OPC_Scope, 17, /*->3109*/ // 3 children in Scope
/*3092*/        OPC_CheckPredicate, 51, // Predicate_atomic_load_nand_8
/*3094*/        OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrIdxOnly:$ptr #3 #4
/*3097*/        OPC_EmitMergeInputChains1_0,
/*3098*/        OPC_MorphNodeTo, TARGET_VAL(PPC::ATOMIC_LOAD_NAND_I8), 0|OPFL_Chain|OPFL_MemRefs,
                    2/*#VTs*/, MVT::i32, MVT::i32, 3/*#Ops*/, 3, 4, 2, 
                // Src: (atomic_load_nand:i32 xoaddr:iPTR:$ptr, GPRC:i32:$incr)<<P:Predicate_atomic_load_nand_8>> - Complexity = 13
                // Dst: (ATOMIC_LOAD_NAND_I8:i32:i32 xoaddr:iPTR:$ptr, GPRC:i32:$incr)
/*3109*/      /*Scope*/ 17, /*->3127*/
/*3110*/        OPC_CheckPredicate, 52, // Predicate_atomic_load_nand_16
/*3112*/        OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrIdxOnly:$ptr #3 #4
/*3115*/        OPC_EmitMergeInputChains1_0,
/*3116*/        OPC_MorphNodeTo, TARGET_VAL(PPC::ATOMIC_LOAD_NAND_I16), 0|OPFL_Chain|OPFL_MemRefs,
                    2/*#VTs*/, MVT::i32, MVT::i32, 3/*#Ops*/, 3, 4, 2, 
                // Src: (atomic_load_nand:i32 xoaddr:iPTR:$ptr, GPRC:i32:$incr)<<P:Predicate_atomic_load_nand_16>> - Complexity = 13
                // Dst: (ATOMIC_LOAD_NAND_I16:i32:i32 xoaddr:iPTR:$ptr, GPRC:i32:$incr)
/*3127*/      /*Scope*/ 17, /*->3145*/
/*3128*/        OPC_CheckPredicate, 53, // Predicate_atomic_load_nand_32
/*3130*/        OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrIdxOnly:$ptr #3 #4
/*3133*/        OPC_EmitMergeInputChains1_0,
/*3134*/        OPC_MorphNodeTo, TARGET_VAL(PPC::ATOMIC_LOAD_NAND_I32), 0|OPFL_Chain|OPFL_MemRefs,
                    2/*#VTs*/, MVT::i32, MVT::i32, 3/*#Ops*/, 3, 4, 2, 
                // Src: (atomic_load_nand:i32 xoaddr:iPTR:$ptr, GPRC:i32:$incr)<<P:Predicate_atomic_load_nand_32>> - Complexity = 13
                // Dst: (ATOMIC_LOAD_NAND_I32:i32:i32 xoaddr:iPTR:$ptr, GPRC:i32:$incr)
/*3145*/      0, /*End of Scope*/
            /*SwitchType*/ 17,  MVT::i64,// ->3165
/*3148*/      OPC_CheckPredicate, 54, // Predicate_atomic_load_nand_64
/*3150*/      OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrIdxOnly:$ptr #3 #4
/*3153*/      OPC_EmitMergeInputChains1_0,
/*3154*/      OPC_MorphNodeTo, TARGET_VAL(PPC::ATOMIC_LOAD_NAND_I64), 0|OPFL_Chain|OPFL_MemRefs,
                  2/*#VTs*/, MVT::i64, MVT::i32, 3/*#Ops*/, 3, 4, 2, 
              // Src: (atomic_load_nand:i64 xoaddr:iPTR:$ptr, G8RC:i64:$incr)<<P:Predicate_atomic_load_nand_64>> - Complexity = 13
              // Dst: (ATOMIC_LOAD_NAND_I64:i64:i32 xoaddr:iPTR:$ptr, G8RC:i64:$incr)
            0, // EndSwitchType
          /*SwitchOpcode*/ 88,  TARGET_VAL(ISD::ATOMIC_CMP_SWAP),// ->3257
/*3169*/    OPC_RecordMemRef,
/*3170*/    OPC_RecordNode,   // #0 = 'atomic_cmp_swap' chained node
/*3171*/    OPC_RecordChild1, // #1 = $ptr
/*3172*/    OPC_RecordChild2, // #2 = $old
/*3173*/    OPC_RecordChild3, // #3 = $new
/*3174*/    OPC_SwitchType /*2 cases */, 59,  MVT::i32,// ->3236
/*3177*/      OPC_Scope, 18, /*->3197*/ // 3 children in Scope
/*3179*/        OPC_CheckPredicate, 55, // Predicate_atomic_cmp_swap_8
/*3181*/        OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrIdxOnly:$ptr #4 #5
/*3184*/        OPC_EmitMergeInputChains1_0,
/*3185*/        OPC_MorphNodeTo, TARGET_VAL(PPC::ATOMIC_CMP_SWAP_I8), 0|OPFL_Chain|OPFL_MemRefs,
                    2/*#VTs*/, MVT::i32, MVT::i32, 4/*#Ops*/, 4, 5, 2, 3, 
                // Src: (atomic_cmp_swap:i32 xoaddr:iPTR:$ptr, GPRC:i32:$old, GPRC:i32:$new)<<P:Predicate_atomic_cmp_swap_8>> - Complexity = 13
                // Dst: (ATOMIC_CMP_SWAP_I8:i32:i32 xoaddr:iPTR:$ptr, GPRC:i32:$old, GPRC:i32:$new)
/*3197*/      /*Scope*/ 18, /*->3216*/
/*3198*/        OPC_CheckPredicate, 56, // Predicate_atomic_cmp_swap_16
/*3200*/        OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrIdxOnly:$ptr #4 #5
/*3203*/        OPC_EmitMergeInputChains1_0,
/*3204*/        OPC_MorphNodeTo, TARGET_VAL(PPC::ATOMIC_CMP_SWAP_I16), 0|OPFL_Chain|OPFL_MemRefs,
                    2/*#VTs*/, MVT::i32, MVT::i32, 4/*#Ops*/, 4, 5, 2, 3, 
                // Src: (atomic_cmp_swap:i32 xoaddr:iPTR:$ptr, GPRC:i32:$old, GPRC:i32:$new)<<P:Predicate_atomic_cmp_swap_16>> - Complexity = 13
                // Dst: (ATOMIC_CMP_SWAP_I16:i32:i32 xoaddr:iPTR:$ptr, GPRC:i32:$old, GPRC:i32:$new)
/*3216*/      /*Scope*/ 18, /*->3235*/
/*3217*/        OPC_CheckPredicate, 57, // Predicate_atomic_cmp_swap_32
/*3219*/        OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrIdxOnly:$ptr #4 #5
/*3222*/        OPC_EmitMergeInputChains1_0,
/*3223*/        OPC_MorphNodeTo, TARGET_VAL(PPC::ATOMIC_CMP_SWAP_I32), 0|OPFL_Chain|OPFL_MemRefs,
                    2/*#VTs*/, MVT::i32, MVT::i32, 4/*#Ops*/, 4, 5, 2, 3, 
                // Src: (atomic_cmp_swap:i32 xoaddr:iPTR:$ptr, GPRC:i32:$old, GPRC:i32:$new)<<P:Predicate_atomic_cmp_swap_32>> - Complexity = 13
                // Dst: (ATOMIC_CMP_SWAP_I32:i32:i32 xoaddr:iPTR:$ptr, GPRC:i32:$old, GPRC:i32:$new)
/*3235*/      0, /*End of Scope*/
            /*SwitchType*/ 18,  MVT::i64,// ->3256
/*3238*/      OPC_CheckPredicate, 58, // Predicate_atomic_cmp_swap_64
/*3240*/      OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrIdxOnly:$ptr #4 #5
/*3243*/      OPC_EmitMergeInputChains1_0,
/*3244*/      OPC_MorphNodeTo, TARGET_VAL(PPC::ATOMIC_CMP_SWAP_I64), 0|OPFL_Chain|OPFL_MemRefs,
                  2/*#VTs*/, MVT::i64, MVT::i32, 4/*#Ops*/, 4, 5, 2, 3, 
              // Src: (atomic_cmp_swap:i64 xoaddr:iPTR:$ptr, G8RC:i64:$old, G8RC:i64:$new)<<P:Predicate_atomic_cmp_swap_64>> - Complexity = 13
              // Dst: (ATOMIC_CMP_SWAP_I64:i64:i32 xoaddr:iPTR:$ptr, G8RC:i64:$old, G8RC:i64:$new)
            0, // EndSwitchType
          /*SwitchOpcode*/ 83,  TARGET_VAL(ISD::ATOMIC_SWAP),// ->3343
/*3260*/    OPC_RecordMemRef,
/*3261*/    OPC_RecordNode,   // #0 = 'atomic_swap' chained node
/*3262*/    OPC_RecordChild1, // #1 = $ptr
/*3263*/    OPC_RecordChild2, // #2 = $new
/*3264*/    OPC_SwitchType /*2 cases */, 56,  MVT::i32,// ->3323
/*3267*/      OPC_Scope, 17, /*->3286*/ // 3 children in Scope
/*3269*/        OPC_CheckPredicate, 59, // Predicate_atomic_swap_8
/*3271*/        OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrIdxOnly:$ptr #3 #4
/*3274*/        OPC_EmitMergeInputChains1_0,
/*3275*/        OPC_MorphNodeTo, TARGET_VAL(PPC::ATOMIC_SWAP_I8), 0|OPFL_Chain|OPFL_MemRefs,
                    2/*#VTs*/, MVT::i32, MVT::i32, 3/*#Ops*/, 3, 4, 2, 
                // Src: (atomic_swap:i32 xoaddr:iPTR:$ptr, GPRC:i32:$new)<<P:Predicate_atomic_swap_8>> - Complexity = 13
                // Dst: (ATOMIC_SWAP_I8:i32:i32 xoaddr:iPTR:$ptr, GPRC:i32:$new)
/*3286*/      /*Scope*/ 17, /*->3304*/
/*3287*/        OPC_CheckPredicate, 60, // Predicate_atomic_swap_16
/*3289*/        OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrIdxOnly:$ptr #3 #4
/*3292*/        OPC_EmitMergeInputChains1_0,
/*3293*/        OPC_MorphNodeTo, TARGET_VAL(PPC::ATOMIC_SWAP_I16), 0|OPFL_Chain|OPFL_MemRefs,
                    2/*#VTs*/, MVT::i32, MVT::i32, 3/*#Ops*/, 3, 4, 2, 
                // Src: (atomic_swap:i32 xoaddr:iPTR:$ptr, GPRC:i32:$new)<<P:Predicate_atomic_swap_16>> - Complexity = 13
                // Dst: (ATOMIC_SWAP_I16:i32:i32 xoaddr:iPTR:$ptr, GPRC:i32:$new)
/*3304*/      /*Scope*/ 17, /*->3322*/
/*3305*/        OPC_CheckPredicate, 61, // Predicate_atomic_swap_32
/*3307*/        OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrIdxOnly:$ptr #3 #4
/*3310*/        OPC_EmitMergeInputChains1_0,
/*3311*/        OPC_MorphNodeTo, TARGET_VAL(PPC::ATOMIC_SWAP_I32), 0|OPFL_Chain|OPFL_MemRefs,
                    2/*#VTs*/, MVT::i32, MVT::i32, 3/*#Ops*/, 3, 4, 2, 
                // Src: (atomic_swap:i32 xoaddr:iPTR:$ptr, GPRC:i32:$new)<<P:Predicate_atomic_swap_32>> - Complexity = 13
                // Dst: (ATOMIC_SWAP_I32:i32:i32 xoaddr:iPTR:$ptr, GPRC:i32:$new)
/*3322*/      0, /*End of Scope*/
            /*SwitchType*/ 17,  MVT::i64,// ->3342
/*3325*/      OPC_CheckPredicate, 62, // Predicate_atomic_swap_64
/*3327*/      OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrIdxOnly:$ptr #3 #4
/*3330*/      OPC_EmitMergeInputChains1_0,
/*3331*/      OPC_MorphNodeTo, TARGET_VAL(PPC::ATOMIC_SWAP_I64), 0|OPFL_Chain|OPFL_MemRefs,
                  2/*#VTs*/, MVT::i64, MVT::i32, 3/*#Ops*/, 3, 4, 2, 
              // Src: (atomic_swap:i64 xoaddr:iPTR:$ptr, G8RC:i64:$new)<<P:Predicate_atomic_swap_64>> - Complexity = 13
              // Dst: (ATOMIC_SWAP_I64:i64:i32 xoaddr:iPTR:$ptr, G8RC:i64:$new)
            0, // EndSwitchType
          /*SwitchOpcode*/ 48,  TARGET_VAL(PPCISD::DYNALLOC),// ->3394
/*3346*/    OPC_RecordNode,   // #0 = 'PPCdynalloc' chained node
/*3347*/    OPC_RecordChild1, // #1 = $negsize
/*3348*/    OPC_SwitchType /*2 cases */, 20,  MVT::i32,// ->3371
/*3351*/      OPC_CheckChild1Type, MVT::i32,
/*3353*/      OPC_RecordChild2, // #2 = $fpsi
/*3354*/      OPC_CheckChild2Type, MVT::iPTR,
/*3356*/      OPC_CheckComplexPat, /*CP*/1, /*#*/2, // SelectAddrImm:$fpsi #3 #4
/*3359*/      OPC_EmitMergeInputChains1_0,
/*3360*/      OPC_MorphNodeTo, TARGET_VAL(PPC::DYNALLOC), 0|OPFL_Chain,
                  2/*#VTs*/, MVT::i32, MVT::i32, 3/*#Ops*/, 1, 3, 4, 
              // Src: (PPCdynalloc:i32 GPRC:i32:$negsize, iaddr:iPTR:$fpsi) - Complexity = 12
              // Dst: (DYNALLOC:i32:i32 GPRC:i32:$negsize, iaddr:iPTR:$fpsi)
            /*SwitchType*/ 20,  MVT::i64,// ->3393
/*3373*/      OPC_CheckChild1Type, MVT::i64,
/*3375*/      OPC_RecordChild2, // #2 = $fpsi
/*3376*/      OPC_CheckChild2Type, MVT::iPTR,
/*3378*/      OPC_CheckComplexPat, /*CP*/1, /*#*/2, // SelectAddrImm:$fpsi #3 #4
/*3381*/      OPC_EmitMergeInputChains1_0,
/*3382*/      OPC_MorphNodeTo, TARGET_VAL(PPC::DYNALLOC8), 0|OPFL_Chain,
                  2/*#VTs*/, MVT::i64, MVT::i64, 3/*#Ops*/, 1, 3, 4, 
              // Src: (PPCdynalloc:i64 G8RC:i64:$negsize, iaddr:iPTR:$fpsi) - Complexity = 12
              // Dst: (DYNALLOC8:i64:i64 G8RC:i64:$negsize, iaddr:iPTR:$fpsi)
            0, // EndSwitchType
          /*SwitchOpcode*/ 34,  TARGET_VAL(PPCISD::LARX),// ->3431
/*3397*/    OPC_RecordNode,   // #0 = 'PPClarx' chained node
/*3398*/    OPC_RecordChild1, // #1 = $src
/*3399*/    OPC_SwitchType /*2 cases */, 13,  MVT::i32,// ->3415
/*3402*/      OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrIdxOnly:$src #2 #3
/*3405*/      OPC_EmitMergeInputChains1_0,
/*3406*/      OPC_MorphNodeTo, TARGET_VAL(PPC::LWARX), 0|OPFL_Chain,
                  1/*#VTs*/, MVT::i32, 2/*#Ops*/, 2, 3, 
              // Src: (PPClarx:i32 xoaddr:iPTR:$src) - Complexity = 12
              // Dst: (LWARX:i32 xoaddr:iPTR:$src)
            /*SwitchType*/ 13,  MVT::i64,// ->3430
/*3417*/      OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrIdxOnly:$ptr #2 #3
/*3420*/      OPC_EmitMergeInputChains1_0,
/*3421*/      OPC_MorphNodeTo, TARGET_VAL(PPC::LDARX), 0|OPFL_Chain,
                  1/*#VTs*/, MVT::i64, 2/*#Ops*/, 2, 3, 
              // Src: (PPClarx:i64 xoaddr:iPTR:$ptr) - Complexity = 12
              // Dst: (LDARX:i64 xoaddr:iPTR:$ptr)
            0, // EndSwitchType
          /*SwitchOpcode*/ 40,  TARGET_VAL(PPCISD::STCX),// ->3474
/*3434*/    OPC_RecordNode,   // #0 = 'PPCstcx' chained node
/*3435*/    OPC_RecordChild1, // #1 = $rS
/*3436*/    OPC_Scope, 17, /*->3455*/ // 2 children in Scope
/*3438*/      OPC_CheckChild1Type, MVT::i32,
/*3440*/      OPC_RecordChild2, // #2 = $dst
/*3441*/      OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddrIdxOnly:$dst #3 #4
/*3444*/      OPC_EmitMergeInputChains1_0,
/*3445*/      OPC_MorphNodeTo, TARGET_VAL(PPC::STWCX), 0|OPFL_Chain,
                  1/*#VTs*/, MVT::i32, 3/*#Ops*/, 1, 3, 4, 
              // Src: (PPCstcx GPRC:i32:$rS, xoaddr:iPTR:$dst) - Complexity = 12
              // Dst: (STWCX:i32 GPRC:i32:$rS, xoaddr:iPTR:$dst)
/*3455*/    /*Scope*/ 17, /*->3473*/
/*3456*/      OPC_CheckChild1Type, MVT::i64,
/*3458*/      OPC_RecordChild2, // #2 = $dst
/*3459*/      OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddrIdxOnly:$dst #3 #4
/*3462*/      OPC_EmitMergeInputChains1_0,
/*3463*/      OPC_MorphNodeTo, TARGET_VAL(PPC::STDCX), 0|OPFL_Chain,
                  1/*#VTs*/, MVT::i32, 3/*#Ops*/, 1, 3, 4, 
              // Src: (PPCstcx G8RC:i64:$rS, xoaddr:iPTR:$dst) - Complexity = 12
              // Dst: (STDCX:i32 G8RC:i64:$rS, xoaddr:iPTR:$dst)
/*3473*/    0, /*End of Scope*/
          /*SwitchOpcode*/ 40,  TARGET_VAL(PPCISD::LBRX),// ->3517
/*3477*/    OPC_RecordNode,   // #0 = 'PPClbrx' chained node
/*3478*/    OPC_RecordChild1, // #1 = $src
/*3479*/    OPC_MoveChild, 2,
/*3481*/    OPC_Scope, 16, /*->3499*/ // 2 children in Scope
/*3483*/      OPC_CheckValueType, MVT::i16,
/*3485*/      OPC_MoveParent,
/*3486*/      OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrIdxOnly:$src #2 #3
/*3489*/      OPC_EmitMergeInputChains1_0,
/*3490*/      OPC_MorphNodeTo, TARGET_VAL(PPC::LHBRX), 0|OPFL_Chain,
                  1/*#VTs*/, MVT::i32, 2/*#Ops*/, 2, 3, 
              // Src: (PPClbrx:i32 xoaddr:iPTR:$src, i16:Other) - Complexity = 12
              // Dst: (LHBRX:i32 xoaddr:iPTR:$src)
/*3499*/    /*Scope*/ 16, /*->3516*/
/*3500*/      OPC_CheckValueType, MVT::i32,
/*3502*/      OPC_MoveParent,
/*3503*/      OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrIdxOnly:$src #2 #3
/*3506*/      OPC_EmitMergeInputChains1_0,
/*3507*/      OPC_MorphNodeTo, TARGET_VAL(PPC::LWBRX), 0|OPFL_Chain,
                  1/*#VTs*/, MVT::i32, 2/*#Ops*/, 2, 3, 
              // Src: (PPClbrx:i32 xoaddr:iPTR:$src, i32:Other) - Complexity = 12
              // Dst: (LWBRX:i32 xoaddr:iPTR:$src)
/*3516*/    0, /*End of Scope*/
          /*SwitchOpcode*/ 41,  TARGET_VAL(PPCISD::STBRX),// ->3561
/*3520*/    OPC_RecordNode,   // #0 = 'PPCstbrx' chained node
/*3521*/    OPC_RecordChild1, // #1 = $rS
/*3522*/    OPC_RecordChild2, // #2 = $dst
/*3523*/    OPC_MoveChild, 3,
/*3525*/    OPC_Scope, 16, /*->3543*/ // 2 children in Scope
/*3527*/      OPC_CheckValueType, MVT::i16,
/*3529*/      OPC_MoveParent,
/*3530*/      OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddrIdxOnly:$dst #3 #4
/*3533*/      OPC_EmitMergeInputChains1_0,
/*3534*/      OPC_MorphNodeTo, TARGET_VAL(PPC::STHBRX), 0|OPFL_Chain,
                  0/*#VTs*/, 3/*#Ops*/, 1, 3, 4, 
              // Src: (PPCstbrx GPRC:i32:$rS, xoaddr:iPTR:$dst, i16:Other) - Complexity = 12
              // Dst: (STHBRX GPRC:i32:$rS, xoaddr:iPTR:$dst)
/*3543*/    /*Scope*/ 16, /*->3560*/
/*3544*/      OPC_CheckValueType, MVT::i32,
/*3546*/      OPC_MoveParent,
/*3547*/      OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddrIdxOnly:$dst #3 #4
/*3550*/      OPC_EmitMergeInputChains1_0,
/*3551*/      OPC_MorphNodeTo, TARGET_VAL(PPC::STWBRX), 0|OPFL_Chain,
                  0/*#VTs*/, 3/*#Ops*/, 1, 3, 4, 
              // Src: (PPCstbrx GPRC:i32:$rS, xoaddr:iPTR:$dst, i32:Other) - Complexity = 12
              // Dst: (STWBRX GPRC:i32:$rS, xoaddr:iPTR:$dst)
/*3560*/    0, /*End of Scope*/
          /*SwitchOpcode*/ 16,  TARGET_VAL(PPCISD::STFIWX),// ->3580
/*3564*/    OPC_RecordNode,   // #0 = 'PPCstfiwx' chained node
/*3565*/    OPC_RecordChild1, // #1 = $frS
/*3566*/    OPC_RecordChild2, // #2 = $dst
/*3567*/    OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddrIdxOnly:$dst #3 #4
/*3570*/    OPC_EmitMergeInputChains1_0,
/*3571*/    OPC_MorphNodeTo, TARGET_VAL(PPC::STFIWX), 0|OPFL_Chain,
                0/*#VTs*/, 3/*#Ops*/, 1, 3, 4, 
            // Src: (PPCstfiwx F8RC:f64:$frS, xoaddr:iPTR:$dst) - Complexity = 12
            // Dst: (STFIWX F8RC:f64:$frS, xoaddr:iPTR:$dst)
          /*SwitchOpcode*/ 37,  TARGET_VAL(PPCISD::LOAD),// ->3620
/*3583*/    OPC_RecordNode,   // #0 = 'PPCload' chained node
/*3584*/    OPC_CaptureGlueInput,
/*3585*/    OPC_RecordChild1, // #1 = $src
/*3586*/    OPC_CheckChild1Type, MVT::iPTR,
/*3588*/    OPC_CheckType, MVT::i64,
/*3590*/    OPC_Scope, 13, /*->3605*/ // 2 children in Scope
/*3592*/      OPC_CheckComplexPat, /*CP*/3, /*#*/1, // SelectAddrImmShift:$src #2 #3
/*3595*/      OPC_EmitMergeInputChains1_0,
/*3596*/      OPC_MorphNodeTo, TARGET_VAL(PPC::LD), 0|OPFL_Chain|OPFL_GlueInput|OPFL_GlueOutput,
                  1/*#VTs*/, MVT::i64, 2/*#Ops*/, 2, 3, 
              // Src: (PPCload:i64 ixaddr:iPTR:$src) - Complexity = 12
              // Dst: (LD:i64 ixaddr:iPTR:$src)
/*3605*/    /*Scope*/ 13, /*->3619*/
/*3606*/      OPC_CheckComplexPat, /*CP*/2, /*#*/1, // SelectAddrIdx:$src #2 #3
/*3609*/      OPC_EmitMergeInputChains1_0,
/*3610*/      OPC_MorphNodeTo, TARGET_VAL(PPC::LDX), 0|OPFL_Chain|OPFL_GlueInput|OPFL_GlueOutput,
                  1/*#VTs*/, MVT::i64, 2/*#Ops*/, 2, 3, 
              // Src: (PPCload:i64 xaddr:iPTR:$src) - Complexity = 12
              // Dst: (LDX:i64 xaddr:iPTR:$src)
/*3619*/    0, /*End of Scope*/
          /*SwitchOpcode*/ 35,  TARGET_VAL(PPCISD::STD_32),// ->3658
/*3623*/    OPC_RecordNode,   // #0 = 'PPCstd_32' chained node
/*3624*/    OPC_RecordChild1, // #1 = $rT
/*3625*/    OPC_CheckChild1Type, MVT::i32,
/*3627*/    OPC_RecordChild2, // #2 = $dst
/*3628*/    OPC_Scope, 13, /*->3643*/ // 2 children in Scope
/*3630*/      OPC_CheckComplexPat, /*CP*/3, /*#*/2, // SelectAddrImmShift:$dst #3 #4
/*3633*/      OPC_EmitMergeInputChains1_0,
/*3634*/      OPC_MorphNodeTo, TARGET_VAL(PPC::STD_32), 0|OPFL_Chain,
                  0/*#VTs*/, 3/*#Ops*/, 1, 3, 4, 
              // Src: (PPCstd_32 GPRC:i32:$rT, ixaddr:iPTR:$dst) - Complexity = 12
              // Dst: (STD_32 GPRC:i32:$rT, ixaddr:iPTR:$dst)
/*3643*/    /*Scope*/ 13, /*->3657*/
/*3644*/      OPC_CheckComplexPat, /*CP*/2, /*#*/2, // SelectAddrIdx:$dst #3 #4
/*3647*/      OPC_EmitMergeInputChains1_0,
/*3648*/      OPC_MorphNodeTo, TARGET_VAL(PPC::STDX_32), 0|OPFL_Chain,
                  0/*#VTs*/, 3/*#Ops*/, 1, 3, 4, 
              // Src: (PPCstd_32 GPRC:i32:$rT, xaddr:iPTR:$dst) - Complexity = 12
              // Dst: (STDX_32 GPRC:i32:$rT, xaddr:iPTR:$dst)
/*3657*/    0, /*End of Scope*/
          /*SwitchOpcode*/ 84|128,4/*596*/,  TARGET_VAL(ISD::XOR),// ->4258
/*3662*/    OPC_Scope, 39|128,1/*167*/, /*->3832*/ // 8 children in Scope
/*3665*/      OPC_MoveChild, 0,
/*3667*/      OPC_SwitchOpcode /*3 cases */, 41,  TARGET_VAL(ISD::AND),// ->3712
/*3671*/        OPC_RecordChild0, // #0 = $rS
/*3672*/        OPC_RecordChild1, // #1 = $rB
/*3673*/        OPC_MoveParent,
/*3674*/        OPC_MoveChild, 1,
/*3676*/        OPC_CheckInteger, 127|128,127|128,127|128,127|128,127|128,127|128,127|128,127|128,127|128,1/*18446744073709551615*/, 
/*3687*/        OPC_MoveParent,
/*3688*/        OPC_SwitchType /*2 cases */, 9,  MVT::i32,// ->3700
/*3691*/          OPC_MorphNodeTo, TARGET_VAL(PPC::NAND), 0,
                      1/*#VTs*/, MVT::i32, 2/*#Ops*/, 0, 1, 
                  // Src: (xor:i32 (and:i32 GPRC:i32:$rS, GPRC:i32:$rB), -1:i32) - Complexity = 11
                  // Dst: (NAND:i32 GPRC:i32:$rS, GPRC:i32:$rB)
                /*SwitchType*/ 9,  MVT::i64,// ->3711
/*3702*/          OPC_MorphNodeTo, TARGET_VAL(PPC::NAND8), 0,
                      1/*#VTs*/, MVT::i64, 2/*#Ops*/, 0, 1, 
                  // Src: (xor:i64 (and:i64 G8RC:i64:$rS, G8RC:i64:$rB), -1:i64) - Complexity = 11
                  // Dst: (NAND8:i64 G8RC:i64:$rS, G8RC:i64:$rB)
                0, // EndSwitchType
              /*SwitchOpcode*/ 41,  TARGET_VAL(ISD::OR),// ->3756
/*3715*/        OPC_RecordChild0, // #0 = $rS
/*3716*/        OPC_RecordChild1, // #1 = $rB
/*3717*/        OPC_MoveParent,
/*3718*/        OPC_MoveChild, 1,
/*3720*/        OPC_CheckInteger, 127|128,127|128,127|128,127|128,127|128,127|128,127|128,127|128,127|128,1/*18446744073709551615*/, 
/*3731*/        OPC_MoveParent,
/*3732*/        OPC_SwitchType /*2 cases */, 9,  MVT::i32,// ->3744
/*3735*/          OPC_MorphNodeTo, TARGET_VAL(PPC::NOR), 0,
                      1/*#VTs*/, MVT::i32, 2/*#Ops*/, 0, 1, 
                  // Src: (xor:i32 (or:i32 GPRC:i32:$rS, GPRC:i32:$rB), -1:i32) - Complexity = 11
                  // Dst: (NOR:i32 GPRC:i32:$rS, GPRC:i32:$rB)
                /*SwitchType*/ 9,  MVT::i64,// ->3755
/*3746*/          OPC_MorphNodeTo, TARGET_VAL(PPC::NOR8), 0,
                      1/*#VTs*/, MVT::i64, 2/*#Ops*/, 0, 1, 
                  // Src: (xor:i64 (or:i64 G8RC:i64:$rS, G8RC:i64:$rB), -1:i64) - Complexity = 11
                  // Dst: (NOR8:i64 G8RC:i64:$rS, G8RC:i64:$rB)
                0, // EndSwitchType
              /*SwitchOpcode*/ 72,  TARGET_VAL(ISD::XOR),// ->3831
/*3759*/        OPC_RecordChild0, // #0 = $rS
/*3760*/        OPC_Scope, 40, /*->3802*/ // 2 children in Scope
/*3762*/          OPC_RecordChild1, // #1 = $rB
/*3763*/          OPC_MoveParent,
/*3764*/          OPC_MoveChild, 1,
/*3766*/          OPC_CheckInteger, 127|128,127|128,127|128,127|128,127|128,127|128,127|128,127|128,127|128,1/*18446744073709551615*/, 
/*3777*/          OPC_MoveParent,
/*3778*/          OPC_SwitchType /*2 cases */, 9,  MVT::i32,// ->3790
/*3781*/            OPC_MorphNodeTo, TARGET_VAL(PPC::EQV), 0,
                        1/*#VTs*/, MVT::i32, 2/*#Ops*/, 0, 1, 
                    // Src: (xor:i32 (xor:i32 GPRC:i32:$rS, GPRC:i32:$rB), -1:i32) - Complexity = 11
                    // Dst: (EQV:i32 GPRC:i32:$rS, GPRC:i32:$rB)
                  /*SwitchType*/ 9,  MVT::i64,// ->3801
/*3792*/            OPC_MorphNodeTo, TARGET_VAL(PPC::EQV8), 0,
                        1/*#VTs*/, MVT::i64, 2/*#Ops*/, 0, 1, 
                    // Src: (xor:i64 (xor:i64 G8RC:i64:$rS, G8RC:i64:$rB), -1:i64) - Complexity = 11
                    // Dst: (EQV8:i64 G8RC:i64:$rS, G8RC:i64:$rB)
                  0, // EndSwitchType
/*3802*/        /*Scope*/ 27, /*->3830*/
/*3803*/          OPC_MoveChild, 1,
/*3805*/          OPC_CheckInteger, 127|128,127|128,127|128,127|128,127|128,127|128,127|128,127|128,127|128,1/*18446744073709551615*/, 
/*3816*/          OPC_MoveParent,
/*3817*/          OPC_MoveParent,
/*3818*/          OPC_RecordChild1, // #1 = $rB
/*3819*/          OPC_CheckType, MVT::i32,
/*3821*/          OPC_MorphNodeTo, TARGET_VAL(PPC::EQV), 0,
                      1/*#VTs*/, MVT::i32, 2/*#Ops*/, 0, 1, 
                  // Src: (xor:i32 (xor:i32 GPRC:i32:$rS, -1:i32), GPRC:i32:$rB) - Complexity = 11
                  // Dst: (EQV:i32 GPRC:i32:$rS, GPRC:i32:$rB)
/*3830*/        0, /*End of Scope*/
              0, // EndSwitchOpcode
/*3832*/    /*Scope*/ 33, /*->3866*/
/*3833*/      OPC_RecordChild0, // #0 = $rB
/*3834*/      OPC_MoveChild, 1,
/*3836*/      OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/*3839*/      OPC_RecordChild0, // #1 = $rS
/*3840*/      OPC_MoveChild, 1,
/*3842*/      OPC_CheckInteger, 127|128,127|128,127|128,127|128,127|128,127|128,127|128,127|128,127|128,1/*18446744073709551615*/, 
/*3853*/      OPC_MoveParent,
/*3854*/      OPC_MoveParent,
/*3855*/      OPC_CheckType, MVT::i32,
/*3857*/      OPC_MorphNodeTo, TARGET_VAL(PPC::EQV), 0,
                  1/*#VTs*/, MVT::i32, 2/*#Ops*/, 1, 0, 
              // Src: (xor:i32 GPRC:i32:$rB, (xor:i32 GPRC:i32:$rS, -1:i32)) - Complexity = 11
              // Dst: (EQV:i32 GPRC:i32:$rS, GPRC:i32:$rB)
/*3866*/    /*Scope*/ 33, /*->3900*/
/*3867*/      OPC_MoveChild, 0,
/*3869*/      OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/*3872*/      OPC_RecordChild0, // #0 = $rS
/*3873*/      OPC_MoveChild, 1,
/*3875*/      OPC_CheckInteger, 127|128,127|128,127|128,127|128,127|128,127|128,127|128,127|128,127|128,1/*18446744073709551615*/, 
/*3886*/      OPC_MoveParent,
/*3887*/      OPC_MoveParent,
/*3888*/      OPC_RecordChild1, // #1 = $rB
/*3889*/      OPC_CheckType, MVT::i64,
/*3891*/      OPC_MorphNodeTo, TARGET_VAL(PPC::EQV8), 0,
                  1/*#VTs*/, MVT::i64, 2/*#Ops*/, 0, 1, 
              // Src: (xor:i64 (xor:i64 G8RC:i64:$rS, -1:i64), G8RC:i64:$rB) - Complexity = 11
              // Dst: (EQV8:i64 G8RC:i64:$rS, G8RC:i64:$rB)
/*3900*/    /*Scope*/ 84|128,1/*212*/, /*->4114*/
/*3902*/      OPC_RecordChild0, // #0 = $rB
/*3903*/      OPC_Scope, 59, /*->3964*/ // 2 children in Scope
/*3905*/        OPC_MoveChild, 1,
/*3907*/        OPC_Scope, 30, /*->3939*/ // 2 children in Scope
/*3909*/          OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/*3912*/          OPC_RecordChild0, // #1 = $rS
/*3913*/          OPC_MoveChild, 1,
/*3915*/          OPC_CheckInteger, 127|128,127|128,127|128,127|128,127|128,127|128,127|128,127|128,127|128,1/*18446744073709551615*/, 
/*3926*/          OPC_MoveParent,
/*3927*/          OPC_MoveParent,
/*3928*/          OPC_CheckType, MVT::i64,
/*3930*/          OPC_MorphNodeTo, TARGET_VAL(PPC::EQV8), 0,
                      1/*#VTs*/, MVT::i64, 2/*#Ops*/, 1, 0, 
                  // Src: (xor:i64 G8RC:i64:$rB, (xor:i64 G8RC:i64:$rS, -1:i64)) - Complexity = 11
                  // Dst: (EQV8:i64 G8RC:i64:$rS, G8RC:i64:$rB)
/*3939*/        /*Scope*/ 23, /*->3963*/
/*3940*/          OPC_CheckInteger, 127|128,127|128,127|128,127|128,127|128,127|128,127|128,127|128,127|128,1/*18446744073709551615*/, 
/*3951*/          OPC_MoveParent,
/*3952*/          OPC_CheckType, MVT::i32,
/*3954*/          OPC_MorphNodeTo, TARGET_VAL(PPC::NOR), 0,
                      1/*#VTs*/, MVT::i32, 2/*#Ops*/, 0, 0, 
                  // Src: (xor:i32 GPRC:i32:$in, -1:i32) - Complexity = 8
                  // Dst: (NOR:i32 GPRC:i32:$in, GPRC:i32:$in)
/*3963*/        0, /*End of Scope*/
/*3964*/      /*Scope*/ 19|128,1/*147*/, /*->4113*/
/*3966*/        OPC_RecordChild1, // #1 = $src2
/*3967*/        OPC_Scope, 119, /*->4088*/ // 3 children in Scope
/*3969*/          OPC_MoveChild, 1,
/*3971*/          OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/*3974*/          OPC_Scope, 19, /*->3995*/ // 5 children in Scope
/*3976*/            OPC_CheckPredicate, 63, // Predicate_immZExt16
/*3978*/            OPC_MoveParent,
/*3979*/            OPC_CheckType, MVT::i32,
/*3981*/            OPC_EmitConvertToTarget, 1,
/*3983*/            OPC_EmitNodeXForm, 1, 2, // LO16
/*3986*/            OPC_MorphNodeTo, TARGET_VAL(PPC::XORI), 0,
                        1/*#VTs*/, MVT::i32, 2/*#Ops*/, 0, 3, 
                    // Src: (xor:i32 GPRC:i32:$src1, (imm:i32)<<P:Predicate_immZExt16>><<X:LO16>>:$src2) - Complexity = 7
                    // Dst: (XORI:i32 GPRC:i32:$src1, (LO16:i32 (imm:i32):$src2))
/*3995*/          /*Scope*/ 19, /*->4015*/
/*3996*/            OPC_CheckPredicate, 64, // Predicate_imm16ShiftedZExt
/*3998*/            OPC_MoveParent,
/*3999*/            OPC_CheckType, MVT::i32,
/*4001*/            OPC_EmitConvertToTarget, 1,
/*4003*/            OPC_EmitNodeXForm, 0, 2, // HI16
/*4006*/            OPC_MorphNodeTo, TARGET_VAL(PPC::XORIS), 0,
                        1/*#VTs*/, MVT::i32, 2/*#Ops*/, 0, 3, 
                    // Src: (xor:i32 GPRC:i32:$src1, (imm:i32)<<P:Predicate_imm16ShiftedZExt>><<X:HI16>>:$src2) - Complexity = 7
                    // Dst: (XORIS:i32 GPRC:i32:$src1, (HI16:i32 (imm:i32):$src2))
/*4015*/          /*Scope*/ 19, /*->4035*/
/*4016*/            OPC_CheckPredicate, 63, // Predicate_immZExt16
/*4018*/            OPC_MoveParent,
/*4019*/            OPC_CheckType, MVT::i64,
/*4021*/            OPC_EmitConvertToTarget, 1,
/*4023*/            OPC_EmitNodeXForm, 1, 2, // LO16
/*4026*/            OPC_MorphNodeTo, TARGET_VAL(PPC::XORI8), 0,
                        1/*#VTs*/, MVT::i64, 2/*#Ops*/, 0, 3, 
                    // Src: (xor:i64 G8RC:i64:$src1, (imm:i64)<<P:Predicate_immZExt16>><<X:LO16>>:$src2) - Complexity = 7
                    // Dst: (XORI8:i64 G8RC:i64:$src1, (LO16:i32 (imm:i64):$src2))
/*4035*/          /*Scope*/ 19, /*->4055*/
/*4036*/            OPC_CheckPredicate, 64, // Predicate_imm16ShiftedZExt
/*4038*/            OPC_MoveParent,
/*4039*/            OPC_CheckType, MVT::i64,
/*4041*/            OPC_EmitConvertToTarget, 1,
/*4043*/            OPC_EmitNodeXForm, 0, 2, // HI16
/*4046*/            OPC_MorphNodeTo, TARGET_VAL(PPC::XORIS8), 0,
                        1/*#VTs*/, MVT::i64, 2/*#Ops*/, 0, 3, 
                    // Src: (xor:i64 G8RC:i64:$src1, (imm:i64)<<P:Predicate_imm16ShiftedZExt>><<X:HI16>>:$src2) - Complexity = 7
                    // Dst: (XORIS8:i64 G8RC:i64:$src1, (HI16:i32 (imm:i64):$src2))
/*4055*/          /*Scope*/ 31, /*->4087*/
/*4056*/            OPC_MoveParent,
/*4057*/            OPC_CheckType, MVT::i32,
/*4059*/            OPC_EmitConvertToTarget, 1,
/*4061*/            OPC_EmitNodeXForm, 1, 2, // LO16
/*4064*/            OPC_EmitNode, TARGET_VAL(PPC::XORI), 0,
                        1/*#VTs*/, MVT::i32, 2/*#Ops*/, 0, 3,  // Results = #4 
/*4073*/            OPC_EmitConvertToTarget, 1,
/*4075*/            OPC_EmitNodeXForm, 0, 5, // HI16
/*4078*/            OPC_MorphNodeTo, TARGET_VAL(PPC::XORIS), 0,
                        1/*#VTs*/, MVT::i32, 2/*#Ops*/, 4, 6, 
                    // Src: (xor:i32 GPRC:i32:$in, (imm:i32):$imm) - Complexity = 6
                    // Dst: (XORIS:i32 (XORI:i32 GPRC:i32:$in, (LO16:i32 (imm:i32):$imm)), (HI16:i32 (imm:i32):$imm))
/*4087*/          0, /*End of Scope*/
/*4088*/        /*Scope*/ 11, /*->4100*/
/*4089*/          OPC_CheckType, MVT::i32,
/*4091*/          OPC_MorphNodeTo, TARGET_VAL(PPC::XOR), 0,
                      1/*#VTs*/, MVT::i32, 2/*#Ops*/, 0, 1, 
                  // Src: (xor:i32 GPRC:i32:$rS, GPRC:i32:$rB) - Complexity = 3
                  // Dst: (XOR:i32 GPRC:i32:$rS, GPRC:i32:$rB)
/*4100*/        /*Scope*/ 11, /*->4112*/
/*4101*/          OPC_CheckType, MVT::i64,
/*4103*/          OPC_MorphNodeTo, TARGET_VAL(PPC::XOR8), 0,
                      1/*#VTs*/, MVT::i64, 2/*#Ops*/, 0, 1, 
                  // Src: (xor:i64 G8RC:i64:$rS, G8RC:i64:$rB) - Complexity = 3
                  // Dst: (XOR8:i64 G8RC:i64:$rS, G8RC:i64:$rB)
/*4112*/        0, /*End of Scope*/
/*4113*/      0, /*End of Scope*/
/*4114*/    /*Scope*/ 70, /*->4185*/
/*4115*/      OPC_MoveChild, 0,
/*4117*/      OPC_SwitchOpcode /*2 cases */, 30,  TARGET_VAL(ISD::OR),// ->4151
/*4121*/        OPC_RecordChild0, // #0 = $vA
/*4122*/        OPC_RecordChild1, // #1 = $vB
/*4123*/        OPC_MoveParent,
/*4124*/        OPC_MoveChild, 1,
/*4126*/        OPC_CheckOpcode, TARGET_VAL(ISD::BITCAST),
/*4129*/        OPC_MoveChild, 0,
/*4131*/        OPC_CheckOpcode, TARGET_VAL(ISD::BUILD_VECTOR),
/*4134*/        OPC_CheckPredicate, 65, // Predicate_immAllOnesV
/*4136*/        OPC_CheckType, MVT::v16i8,
/*4138*/        OPC_MoveParent,
/*4139*/        OPC_MoveParent,
/*4140*/        OPC_CheckType, MVT::v4i32,
/*4142*/        OPC_MorphNodeTo, TARGET_VAL(PPC::VNOR), 0,
                    1/*#VTs*/, MVT::v4i32, 2/*#Ops*/, 0, 1, 
                // Src: (xor:v4i32 (or:v4i32 VRRC:v4i32:$vA, VRRC:v4i32:$vB), (bitconvert:v4i32 (build_vector:v16i8)<<P:Predicate_immAllOnesV>>)) - Complexity = 13
                // Dst: (VNOR:v4i32 VRRC:v4i32:$vA, VRRC:v4i32:$vB)
              /*SwitchOpcode*/ 30,  TARGET_VAL(ISD::BITCAST),// ->4184
/*4154*/        OPC_MoveChild, 0,
/*4156*/        OPC_CheckOpcode, TARGET_VAL(ISD::BUILD_VECTOR),
/*4159*/        OPC_CheckPredicate, 65, // Predicate_immAllOnesV
/*4161*/        OPC_CheckType, MVT::v16i8,
/*4163*/        OPC_MoveParent,
/*4164*/        OPC_MoveParent,
/*4165*/        OPC_MoveChild, 1,
/*4167*/        OPC_CheckOpcode, TARGET_VAL(ISD::OR),
/*4170*/        OPC_RecordChild0, // #0 = $vA
/*4171*/        OPC_RecordChild1, // #1 = $vB
/*4172*/        OPC_MoveParent,
/*4173*/        OPC_CheckType, MVT::v4i32,
/*4175*/        OPC_MorphNodeTo, TARGET_VAL(PPC::VNOR), 0,
                    1/*#VTs*/, MVT::v4i32, 2/*#Ops*/, 0, 1, 
                // Src: (xor:v4i32 (bitconvert:v4i32 (build_vector:v16i8)<<P:Predicate_immAllOnesV>>), (or:v4i32 VRRC:v4i32:$vA, VRRC:v4i32:$vB)) - Complexity = 13
                // Dst: (VNOR:v4i32 VRRC:v4i32:$vA, VRRC:v4i32:$vB)
              0, // EndSwitchOpcode
/*4185*/    /*Scope*/ 28, /*->4214*/
/*4186*/      OPC_RecordChild0, // #0 = $vA
/*4187*/      OPC_MoveChild, 1,
/*4189*/      OPC_CheckOpcode, TARGET_VAL(ISD::BITCAST),
/*4192*/      OPC_MoveChild, 0,
/*4194*/      OPC_CheckOpcode, TARGET_VAL(ISD::BUILD_VECTOR),
/*4197*/      OPC_CheckPredicate, 65, // Predicate_immAllOnesV
/*4199*/      OPC_CheckType, MVT::v16i8,
/*4201*/      OPC_MoveParent,
/*4202*/      OPC_MoveParent,
/*4203*/      OPC_CheckType, MVT::v4i32,
/*4205*/      OPC_MorphNodeTo, TARGET_VAL(PPC::VNOR), 0,
                  1/*#VTs*/, MVT::v4i32, 2/*#Ops*/, 0, 0, 
              // Src: (xor:v4i32 VRRC:v4i32:$vA, (bitconvert:v4i32 (build_vector:v16i8)<<P:Predicate_immAllOnesV>>)) - Complexity = 10
              // Dst: (VNOR:v4i32 VRRC:v4i32:$vA, VRRC:v4i32:$vA)
/*4214*/    /*Scope*/ 28, /*->4243*/
/*4215*/      OPC_MoveChild, 0,
/*4217*/      OPC_CheckOpcode, TARGET_VAL(ISD::BITCAST),
/*4220*/      OPC_MoveChild, 0,
/*4222*/      OPC_CheckOpcode, TARGET_VAL(ISD::BUILD_VECTOR),
/*4225*/      OPC_CheckPredicate, 65, // Predicate_immAllOnesV
/*4227*/      OPC_CheckType, MVT::v16i8,
/*4229*/      OPC_MoveParent,
/*4230*/      OPC_MoveParent,
/*4231*/      OPC_RecordChild1, // #0 = $vA
/*4232*/      OPC_CheckType, MVT::v4i32,
/*4234*/      OPC_MorphNodeTo, TARGET_VAL(PPC::VNOR), 0,
                  1/*#VTs*/, MVT::v4i32, 2/*#Ops*/, 0, 0, 
              // Src: (xor:v4i32 (bitconvert:v4i32 (build_vector:v16i8)<<P:Predicate_immAllOnesV>>), VRRC:v4i32:$vA) - Complexity = 10
              // Dst: (VNOR:v4i32 VRRC:v4i32:$vA, VRRC:v4i32:$vA)
/*4243*/    /*Scope*/ 13, /*->4257*/
/*4244*/      OPC_RecordChild0, // #0 = $vA
/*4245*/      OPC_RecordChild1, // #1 = $vB
/*4246*/      OPC_CheckType, MVT::v4i32,
/*4248*/      OPC_MorphNodeTo, TARGET_VAL(PPC::VXOR), 0,
                  1/*#VTs*/, MVT::v4i32, 2/*#Ops*/, 0, 1, 
              // Src: (xor:v4i32 VRRC:v4i32:$vA, VRRC:v4i32:$vB) - Complexity = 3
              // Dst: (VXOR:v4i32 VRRC:v4i32:$vA, VRRC:v4i32:$vB)
/*4257*/    0, /*End of Scope*/
          /*SwitchOpcode*/ 31|128,3/*415*/,  TARGET_VAL(ISD::AND),// ->4677
/*4262*/    OPC_Scope, 46, /*->4310*/ // 5 children in Scope
/*4264*/      OPC_RecordChild0, // #0 = $rS
/*4265*/      OPC_MoveChild, 1,
/*4267*/      OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/*4270*/      OPC_RecordChild0, // #1 = $rB
/*4271*/      OPC_MoveChild, 1,
/*4273*/      OPC_CheckInteger, 127|128,127|128,127|128,127|128,127|128,127|128,127|128,127|128,127|128,1/*18446744073709551615*/, 
/*4284*/      OPC_MoveParent,
/*4285*/      OPC_MoveParent,
/*4286*/      OPC_SwitchType /*2 cases */, 9,  MVT::i32,// ->4298
/*4289*/        OPC_MorphNodeTo, TARGET_VAL(PPC::ANDC), 0,
                    1/*#VTs*/, MVT::i32, 2/*#Ops*/, 0, 1, 
                // Src: (and:i32 GPRC:i32:$rS, (xor:i32 GPRC:i32:$rB, -1:i32)) - Complexity = 11
                // Dst: (ANDC:i32 GPRC:i32:$rS, GPRC:i32:$rB)
              /*SwitchType*/ 9,  MVT::i64,// ->4309
/*4300*/        OPC_MorphNodeTo, TARGET_VAL(PPC::ANDC8), 0,
                    1/*#VTs*/, MVT::i64, 2/*#Ops*/, 0, 1, 
                // Src: (and:i64 G8RC:i64:$rS, (xor:i64 G8RC:i64:$rB, -1:i64)) - Complexity = 11
                // Dst: (ANDC8:i64 G8RC:i64:$rS, G8RC:i64:$rB)
              0, // EndSwitchType
/*4310*/    /*Scope*/ 88, /*->4399*/
/*4311*/      OPC_MoveChild, 0,
/*4313*/      OPC_SwitchOpcode /*2 cases */, 41,  TARGET_VAL(ISD::XOR),// ->4358
/*4317*/        OPC_RecordChild0, // #0 = $rB
/*4318*/        OPC_MoveChild, 1,
/*4320*/        OPC_CheckInteger, 127|128,127|128,127|128,127|128,127|128,127|128,127|128,127|128,127|128,1/*18446744073709551615*/, 
/*4331*/        OPC_MoveParent,
/*4332*/        OPC_MoveParent,
/*4333*/        OPC_RecordChild1, // #1 = $rS
/*4334*/        OPC_SwitchType /*2 cases */, 9,  MVT::i32,// ->4346
/*4337*/          OPC_MorphNodeTo, TARGET_VAL(PPC::ANDC), 0,
                      1/*#VTs*/, MVT::i32, 2/*#Ops*/, 1, 0, 
                  // Src: (and:i32 (xor:i32 GPRC:i32:$rB, -1:i32), GPRC:i32:$rS) - Complexity = 11
                  // Dst: (ANDC:i32 GPRC:i32:$rS, GPRC:i32:$rB)
                /*SwitchType*/ 9,  MVT::i64,// ->4357
/*4348*/          OPC_MorphNodeTo, TARGET_VAL(PPC::ANDC8), 0,
                      1/*#VTs*/, MVT::i64, 2/*#Ops*/, 1, 0, 
                  // Src: (and:i64 (xor:i64 G8RC:i64:$rB, -1:i64), G8RC:i64:$rS) - Complexity = 11
                  // Dst: (ANDC8:i64 G8RC:i64:$rS, G8RC:i64:$rB)
                0, // EndSwitchType
              /*SwitchOpcode*/ 37,  TARGET_VAL(ISD::ROTL),// ->4398
/*4361*/        OPC_RecordChild0, // #0 = $in
/*4362*/        OPC_RecordChild1, // #1 = $sh
/*4363*/        OPC_CheckChild1Type, MVT::i32,
/*4365*/        OPC_MoveParent,
/*4366*/        OPC_RecordChild1, // #2 = $imm
/*4367*/        OPC_MoveChild, 1,
/*4369*/        OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/*4372*/        OPC_CheckPredicate, 66, // Predicate_maskimm32
/*4374*/        OPC_MoveParent,
/*4375*/        OPC_CheckType, MVT::i32,
/*4377*/        OPC_EmitConvertToTarget, 2,
/*4379*/        OPC_EmitNodeXForm, 3, 3, // MB
/*4382*/        OPC_EmitConvertToTarget, 2,
/*4384*/        OPC_EmitNodeXForm, 4, 5, // ME
/*4387*/        OPC_MorphNodeTo, TARGET_VAL(PPC::RLWNM), 0,
                    1/*#VTs*/, MVT::i32, 4/*#Ops*/, 0, 1, 4, 6, 
                // Src: (and:i32 (rotl:i32 GPRC:i32:$in, GPRC:i32:$sh), (imm:i32)<<P:Predicate_maskimm32>>:$imm) - Complexity = 10
                // Dst: (RLWNM:i32 GPRC:i32:$in, GPRC:i32:$sh, (MB:i32 (imm:i32)<<P:Predicate_maskimm32>>:$imm), (ME:i32 (imm:i32)<<P:Predicate_maskimm32>>:$imm))
              0, // EndSwitchOpcode
/*4399*/    /*Scope*/ 63|128,1/*191*/, /*->4592*/
/*4401*/      OPC_RecordChild0, // #0 = $src1
/*4402*/      OPC_Scope, 119, /*->4523*/ // 2 children in Scope
/*4404*/        OPC_RecordChild1, // #1 = $src2
/*4405*/        OPC_Scope, 91, /*->4498*/ // 3 children in Scope
/*4407*/          OPC_MoveChild, 1,
/*4409*/          OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/*4412*/          OPC_Scope, 20, /*->4434*/ // 4 children in Scope
/*4414*/            OPC_CheckPredicate, 63, // Predicate_immZExt16
/*4416*/            OPC_MoveParent,
/*4417*/            OPC_CheckType, MVT::i32,
/*4419*/            OPC_EmitConvertToTarget, 1,
/*4421*/            OPC_EmitNodeXForm, 1, 2, // LO16
/*4424*/            OPC_MorphNodeTo, TARGET_VAL(PPC::ANDIo), 0,
                        2/*#VTs*/, MVT::i32, MVT::i32, 2/*#Ops*/, 0, 3, 
                    // Src: (and:i32 GPRC:i32:$src1, (imm:i32)<<P:Predicate_immZExt16>><<X:LO16>>:$src2) - Complexity = 7
                    // Dst: (ANDIo:i32:i32 GPRC:i32:$src1, (LO16:i32 (imm:i32):$src2))
/*4434*/          /*Scope*/ 20, /*->4455*/
/*4435*/            OPC_CheckPredicate, 64, // Predicate_imm16ShiftedZExt
/*4437*/            OPC_MoveParent,
/*4438*/            OPC_CheckType, MVT::i32,
/*4440*/            OPC_EmitConvertToTarget, 1,
/*4442*/            OPC_EmitNodeXForm, 0, 2, // HI16
/*4445*/            OPC_MorphNodeTo, TARGET_VAL(PPC::ANDISo), 0,
                        2/*#VTs*/, MVT::i32, MVT::i32, 2/*#Ops*/, 0, 3, 
                    // Src: (and:i32 GPRC:i32:$src1, (imm:i32)<<P:Predicate_imm16ShiftedZExt>><<X:HI16>>:$src2) - Complexity = 7
                    // Dst: (ANDISo:i32:i32 GPRC:i32:$src1, (HI16:i32 (imm:i32):$src2))
/*4455*/          /*Scope*/ 20, /*->4476*/
/*4456*/            OPC_CheckPredicate, 63, // Predicate_immZExt16
/*4458*/            OPC_MoveParent,
/*4459*/            OPC_CheckType, MVT::i64,
/*4461*/            OPC_EmitConvertToTarget, 1,
/*4463*/            OPC_EmitNodeXForm, 1, 2, // LO16
/*4466*/            OPC_MorphNodeTo, TARGET_VAL(PPC::ANDIo8), 0,
                        2/*#VTs*/, MVT::i64, MVT::i32, 2/*#Ops*/, 0, 3, 
                    // Src: (and:i64 G8RC:i64:$src1, (imm:i64)<<P:Predicate_immZExt16>><<X:LO16>>:$src2) - Complexity = 7
                    // Dst: (ANDIo8:i64:i32 G8RC:i64:$src1, (LO16:i32 (imm:i64):$src2))
/*4476*/          /*Scope*/ 20, /*->4497*/
/*4477*/            OPC_CheckPredicate, 64, // Predicate_imm16ShiftedZExt
/*4479*/            OPC_MoveParent,
/*4480*/            OPC_CheckType, MVT::i64,
/*4482*/            OPC_EmitConvertToTarget, 1,
/*4484*/            OPC_EmitNodeXForm, 0, 2, // HI16
/*4487*/            OPC_MorphNodeTo, TARGET_VAL(PPC::ANDISo8), 0,
                        2/*#VTs*/, MVT::i64, MVT::i32, 2/*#Ops*/, 0, 3, 
                    // Src: (and:i64 G8RC:i64:$src1, (imm:i64)<<P:Predicate_imm16ShiftedZExt>><<X:HI16>>:$src2) - Complexity = 7
                    // Dst: (ANDISo8:i64:i32 G8RC:i64:$src1, (HI16:i32 (imm:i64):$src2))
/*4497*/          0, /*End of Scope*/
/*4498*/        /*Scope*/ 11, /*->4510*/
/*4499*/          OPC_CheckType, MVT::i32,
/*4501*/          OPC_MorphNodeTo, TARGET_VAL(PPC::AND), 0,
                      1/*#VTs*/, MVT::i32, 2/*#Ops*/, 0, 1, 
                  // Src: (and:i32 GPRC:i32:$rS, GPRC:i32:$rB) - Complexity = 3
                  // Dst: (AND:i32 GPRC:i32:$rS, GPRC:i32:$rB)
/*4510*/        /*Scope*/ 11, /*->4522*/
/*4511*/          OPC_CheckType, MVT::i64,
/*4513*/          OPC_MorphNodeTo, TARGET_VAL(PPC::AND8), 0,
                      1/*#VTs*/, MVT::i64, 2/*#Ops*/, 0, 1, 
                  // Src: (and:i64 G8RC:i64:$rS, G8RC:i64:$rB) - Complexity = 3
                  // Dst: (AND8:i64 G8RC:i64:$rS, G8RC:i64:$rB)
/*4522*/        0, /*End of Scope*/
/*4523*/      /*Scope*/ 67, /*->4591*/
/*4524*/        OPC_MoveChild, 1,
/*4526*/        OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/*4529*/        OPC_Scope, 29, /*->4560*/ // 2 children in Scope
/*4531*/          OPC_RecordChild0, // #1 = $vB
/*4532*/          OPC_MoveChild, 1,
/*4534*/          OPC_CheckOpcode, TARGET_VAL(ISD::BITCAST),
/*4537*/          OPC_MoveChild, 0,
/*4539*/          OPC_CheckOpcode, TARGET_VAL(ISD::BUILD_VECTOR),
/*4542*/          OPC_CheckPredicate, 65, // Predicate_immAllOnesV
/*4544*/          OPC_CheckType, MVT::v16i8,
/*4546*/          OPC_MoveParent,
/*4547*/          OPC_MoveParent,
/*4548*/          OPC_MoveParent,
/*4549*/          OPC_CheckType, MVT::v4i32,
/*4551*/          OPC_MorphNodeTo, TARGET_VAL(PPC::VANDC), 0,
                      1/*#VTs*/, MVT::v4i32, 2/*#Ops*/, 0, 1, 
                  // Src: (and:v4i32 VRRC:v4i32:$vA, (xor:v4i32 VRRC:v4i32:$vB, (bitconvert:v4i32 (build_vector:v16i8)<<P:Predicate_immAllOnesV>>))) - Complexity = 13
                  // Dst: (VANDC:v4i32 VRRC:v4i32:$vA, VRRC:v4i32:$vB)
/*4560*/        /*Scope*/ 29, /*->4590*/
/*4561*/          OPC_MoveChild, 0,
/*4563*/          OPC_CheckOpcode, TARGET_VAL(ISD::BITCAST),
/*4566*/          OPC_MoveChild, 0,
/*4568*/          OPC_CheckOpcode, TARGET_VAL(ISD::BUILD_VECTOR),
/*4571*/          OPC_CheckPredicate, 65, // Predicate_immAllOnesV
/*4573*/          OPC_CheckType, MVT::v16i8,
/*4575*/          OPC_MoveParent,
/*4576*/          OPC_MoveParent,
/*4577*/          OPC_RecordChild1, // #1 = $vB
/*4578*/          OPC_MoveParent,
/*4579*/          OPC_CheckType, MVT::v4i32,
/*4581*/          OPC_MorphNodeTo, TARGET_VAL(PPC::VANDC), 0,
                      1/*#VTs*/, MVT::v4i32, 2/*#Ops*/, 0, 1, 
                  // Src: (and:v4i32 VRRC:v4i32:$vA, (xor:v4i32 (bitconvert:v4i32 (build_vector:v16i8)<<P:Predicate_immAllOnesV>>), VRRC:v4i32:$vB)) - Complexity = 13
                  // Dst: (VANDC:v4i32 VRRC:v4i32:$vA, VRRC:v4i32:$vB)
/*4590*/        0, /*End of Scope*/
/*4591*/      0, /*End of Scope*/
/*4592*/    /*Scope*/ 69, /*->4662*/
/*4593*/      OPC_MoveChild, 0,
/*4595*/      OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/*4598*/      OPC_Scope, 30, /*->4630*/ // 2 children in Scope
/*4600*/        OPC_RecordChild0, // #0 = $vB
/*4601*/        OPC_MoveChild, 1,
/*4603*/        OPC_CheckOpcode, TARGET_VAL(ISD::BITCAST),
/*4606*/        OPC_MoveChild, 0,
/*4608*/        OPC_CheckOpcode, TARGET_VAL(ISD::BUILD_VECTOR),
/*4611*/        OPC_CheckPredicate, 65, // Predicate_immAllOnesV
/*4613*/        OPC_CheckType, MVT::v16i8,
/*4615*/        OPC_MoveParent,
/*4616*/        OPC_MoveParent,
/*4617*/        OPC_MoveParent,
/*4618*/        OPC_RecordChild1, // #1 = $vA
/*4619*/        OPC_CheckType, MVT::v4i32,
/*4621*/        OPC_MorphNodeTo, TARGET_VAL(PPC::VANDC), 0,
                    1/*#VTs*/, MVT::v4i32, 2/*#Ops*/, 1, 0, 
                // Src: (and:v4i32 (xor:v4i32 VRRC:v4i32:$vB, (bitconvert:v4i32 (build_vector:v16i8)<<P:Predicate_immAllOnesV>>)), VRRC:v4i32:$vA) - Complexity = 13
                // Dst: (VANDC:v4i32 VRRC:v4i32:$vA, VRRC:v4i32:$vB)
/*4630*/      /*Scope*/ 30, /*->4661*/
/*4631*/        OPC_MoveChild, 0,
/*4633*/        OPC_CheckOpcode, TARGET_VAL(ISD::BITCAST),
/*4636*/        OPC_MoveChild, 0,
/*4638*/        OPC_CheckOpcode, TARGET_VAL(ISD::BUILD_VECTOR),
/*4641*/        OPC_CheckPredicate, 65, // Predicate_immAllOnesV
/*4643*/        OPC_CheckType, MVT::v16i8,
/*4645*/        OPC_MoveParent,
/*4646*/        OPC_MoveParent,
/*4647*/        OPC_RecordChild1, // #0 = $vB
/*4648*/        OPC_MoveParent,
/*4649*/        OPC_RecordChild1, // #1 = $vA
/*4650*/        OPC_CheckType, MVT::v4i32,
/*4652*/        OPC_MorphNodeTo, TARGET_VAL(PPC::VANDC), 0,
                    1/*#VTs*/, MVT::v4i32, 2/*#Ops*/, 1, 0, 
                // Src: (and:v4i32 (xor:v4i32 (bitconvert:v4i32 (build_vector:v16i8)<<P:Predicate_immAllOnesV>>), VRRC:v4i32:$vB), VRRC:v4i32:$vA) - Complexity = 13
                // Dst: (VANDC:v4i32 VRRC:v4i32:$vA, VRRC:v4i32:$vB)
/*4661*/      0, /*End of Scope*/
/*4662*/    /*Scope*/ 13, /*->4676*/
/*4663*/      OPC_RecordChild0, // #0 = $vA
/*4664*/      OPC_RecordChild1, // #1 = $vB
/*4665*/      OPC_CheckType, MVT::v4i32,
/*4667*/      OPC_MorphNodeTo, TARGET_VAL(PPC::VAND), 0,
                  1/*#VTs*/, MVT::v4i32, 2/*#Ops*/, 0, 1, 
              // Src: (and:v4i32 VRRC:v4i32:$vA, VRRC:v4i32:$vB) - Complexity = 3
              // Dst: (VAND:v4i32 VRRC:v4i32:$vA, VRRC:v4i32:$vB)
/*4676*/    0, /*End of Scope*/
          /*SwitchOpcode*/ 2|128,2/*258*/,  TARGET_VAL(ISD::OR),// ->4939
/*4681*/    OPC_Scope, 46, /*->4729*/ // 3 children in Scope
/*4683*/      OPC_RecordChild0, // #0 = $rS
/*4684*/      OPC_MoveChild, 1,
/*4686*/      OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/*4689*/      OPC_RecordChild0, // #1 = $rB
/*4690*/      OPC_MoveChild, 1,
/*4692*/      OPC_CheckInteger, 127|128,127|128,127|128,127|128,127|128,127|128,127|128,127|128,127|128,1/*18446744073709551615*/, 
/*4703*/      OPC_MoveParent,
/*4704*/      OPC_MoveParent,
/*4705*/      OPC_SwitchType /*2 cases */, 9,  MVT::i32,// ->4717
/*4708*/        OPC_MorphNodeTo, TARGET_VAL(PPC::ORC), 0,
                    1/*#VTs*/, MVT::i32, 2/*#Ops*/, 0, 1, 
                // Src: (or:i32 GPRC:i32:$rS, (xor:i32 GPRC:i32:$rB, -1:i32)) - Complexity = 11
                // Dst: (ORC:i32 GPRC:i32:$rS, GPRC:i32:$rB)
              /*SwitchType*/ 9,  MVT::i64,// ->4728
/*4719*/        OPC_MorphNodeTo, TARGET_VAL(PPC::ORC8), 0,
                    1/*#VTs*/, MVT::i64, 2/*#Ops*/, 0, 1, 
                // Src: (or:i64 G8RC:i64:$rS, (xor:i64 G8RC:i64:$rB, -1:i64)) - Complexity = 11
                // Dst: (ORC8:i64 G8RC:i64:$rS, G8RC:i64:$rB)
              0, // EndSwitchType
/*4729*/    /*Scope*/ 46, /*->4776*/
/*4730*/      OPC_MoveChild, 0,
/*4732*/      OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/*4735*/      OPC_RecordChild0, // #0 = $rB
/*4736*/      OPC_MoveChild, 1,
/*4738*/      OPC_CheckInteger, 127|128,127|128,127|128,127|128,127|128,127|128,127|128,127|128,127|128,1/*18446744073709551615*/, 
/*4749*/      OPC_MoveParent,
/*4750*/      OPC_MoveParent,
/*4751*/      OPC_RecordChild1, // #1 = $rS
/*4752*/      OPC_SwitchType /*2 cases */, 9,  MVT::i32,// ->4764
/*4755*/        OPC_MorphNodeTo, TARGET_VAL(PPC::ORC), 0,
                    1/*#VTs*/, MVT::i32, 2/*#Ops*/, 1, 0, 
                // Src: (or:i32 (xor:i32 GPRC:i32:$rB, -1:i32), GPRC:i32:$rS) - Complexity = 11
                // Dst: (ORC:i32 GPRC:i32:$rS, GPRC:i32:$rB)
              /*SwitchType*/ 9,  MVT::i64,// ->4775
/*4766*/        OPC_MorphNodeTo, TARGET_VAL(PPC::ORC8), 0,
                    1/*#VTs*/, MVT::i64, 2/*#Ops*/, 1, 0, 
                // Src: (or:i64 (xor:i64 G8RC:i64:$rB, -1:i64), G8RC:i64:$rS) - Complexity = 11
                // Dst: (ORC8:i64 G8RC:i64:$rS, G8RC:i64:$rB)
              0, // EndSwitchType
/*4776*/    /*Scope*/ 32|128,1/*160*/, /*->4938*/
/*4778*/      OPC_RecordChild0, // #0 = $src1
/*4779*/      OPC_RecordChild1, // #1 = $src2
/*4780*/      OPC_Scope, 119, /*->4901*/ // 4 children in Scope
/*4782*/        OPC_MoveChild, 1,
/*4784*/        OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/*4787*/        OPC_Scope, 19, /*->4808*/ // 5 children in Scope
/*4789*/          OPC_CheckPredicate, 63, // Predicate_immZExt16
/*4791*/          OPC_MoveParent,
/*4792*/          OPC_CheckType, MVT::i32,
/*4794*/          OPC_EmitConvertToTarget, 1,
/*4796*/          OPC_EmitNodeXForm, 1, 2, // LO16
/*4799*/          OPC_MorphNodeTo, TARGET_VAL(PPC::ORI), 0,
                      1/*#VTs*/, MVT::i32, 2/*#Ops*/, 0, 3, 
                  // Src: (or:i32 GPRC:i32:$src1, (imm:i32)<<P:Predicate_immZExt16>><<X:LO16>>:$src2) - Complexity = 7
                  // Dst: (ORI:i32 GPRC:i32:$src1, (LO16:i32 (imm:i32):$src2))
/*4808*/        /*Scope*/ 19, /*->4828*/
/*4809*/          OPC_CheckPredicate, 64, // Predicate_imm16ShiftedZExt
/*4811*/          OPC_MoveParent,
/*4812*/          OPC_CheckType, MVT::i32,
/*4814*/          OPC_EmitConvertToTarget, 1,
/*4816*/          OPC_EmitNodeXForm, 0, 2, // HI16
/*4819*/          OPC_MorphNodeTo, TARGET_VAL(PPC::ORIS), 0,
                      1/*#VTs*/, MVT::i32, 2/*#Ops*/, 0, 3, 
                  // Src: (or:i32 GPRC:i32:$src1, (imm:i32)<<P:Predicate_imm16ShiftedZExt>><<X:HI16>>:$src2) - Complexity = 7
                  // Dst: (ORIS:i32 GPRC:i32:$src1, (HI16:i32 (imm:i32):$src2))
/*4828*/        /*Scope*/ 19, /*->4848*/
/*4829*/          OPC_CheckPredicate, 63, // Predicate_immZExt16
/*4831*/          OPC_MoveParent,
/*4832*/          OPC_CheckType, MVT::i64,
/*4834*/          OPC_EmitConvertToTarget, 1,
/*4836*/          OPC_EmitNodeXForm, 1, 2, // LO16
/*4839*/          OPC_MorphNodeTo, TARGET_VAL(PPC::ORI8), 0,
                      1/*#VTs*/, MVT::i64, 2/*#Ops*/, 0, 3, 
                  // Src: (or:i64 G8RC:i64:$src1, (imm:i64)<<P:Predicate_immZExt16>><<X:LO16>>:$src2) - Complexity = 7
                  // Dst: (ORI8:i64 G8RC:i64:$src1, (LO16:i32 (imm:i64):$src2))
/*4848*/        /*Scope*/ 19, /*->4868*/
/*4849*/          OPC_CheckPredicate, 64, // Predicate_imm16ShiftedZExt
/*4851*/          OPC_MoveParent,
/*4852*/          OPC_CheckType, MVT::i64,
/*4854*/          OPC_EmitConvertToTarget, 1,
/*4856*/          OPC_EmitNodeXForm, 0, 2, // HI16
/*4859*/          OPC_MorphNodeTo, TARGET_VAL(PPC::ORIS8), 0,
                      1/*#VTs*/, MVT::i64, 2/*#Ops*/, 0, 3, 
                  // Src: (or:i64 G8RC:i64:$src1, (imm:i64)<<P:Predicate_imm16ShiftedZExt>><<X:HI16>>:$src2) - Complexity = 7
                  // Dst: (ORIS8:i64 G8RC:i64:$src1, (HI16:i32 (imm:i64):$src2))
/*4868*/        /*Scope*/ 31, /*->4900*/
/*4869*/          OPC_MoveParent,
/*4870*/          OPC_CheckType, MVT::i32,
/*4872*/          OPC_EmitConvertToTarget, 1,
/*4874*/          OPC_EmitNodeXForm, 1, 2, // LO16
/*4877*/          OPC_EmitNode, TARGET_VAL(PPC::ORI), 0,
                      1/*#VTs*/, MVT::i32, 2/*#Ops*/, 0, 3,  // Results = #4 
/*4886*/          OPC_EmitConvertToTarget, 1,
/*4888*/          OPC_EmitNodeXForm, 0, 5, // HI16
/*4891*/          OPC_MorphNodeTo, TARGET_VAL(PPC::ORIS), 0,
                      1/*#VTs*/, MVT::i32, 2/*#Ops*/, 4, 6, 
                  // Src: (or:i32 GPRC:i32:$in, (imm:i32):$imm) - Complexity = 6
                  // Dst: (ORIS:i32 (ORI:i32 GPRC:i32:$in, (LO16:i32 (imm:i32):$imm)), (HI16:i32 (imm:i32):$imm))
/*4900*/        0, /*End of Scope*/
/*4901*/      /*Scope*/ 11, /*->4913*/
/*4902*/        OPC_CheckType, MVT::i32,
/*4904*/        OPC_MorphNodeTo, TARGET_VAL(PPC::OR), 0,
                    1/*#VTs*/, MVT::i32, 2/*#Ops*/, 0, 1, 
                // Src: (or:i32 GPRC:i32:$rS, GPRC:i32:$rB) - Complexity = 3
                // Dst: (OR:i32 GPRC:i32:$rS, GPRC:i32:$rB)
/*4913*/      /*Scope*/ 11, /*->4925*/
/*4914*/        OPC_CheckType, MVT::i64,
/*4916*/        OPC_MorphNodeTo, TARGET_VAL(PPC::OR8), 0,
                    1/*#VTs*/, MVT::i64, 2/*#Ops*/, 0, 1, 
                // Src: (or:i64 G8RC:i64:$rS, G8RC:i64:$rB) - Complexity = 3
                // Dst: (OR8:i64 G8RC:i64:$rS, G8RC:i64:$rB)
/*4925*/      /*Scope*/ 11, /*->4937*/
/*4926*/        OPC_CheckType, MVT::v4i32,
/*4928*/        OPC_MorphNodeTo, TARGET_VAL(PPC::VOR), 0,
                    1/*#VTs*/, MVT::v4i32, 2/*#Ops*/, 0, 1, 
                // Src: (or:v4i32 VRRC:v4i32:$vA, VRRC:v4i32:$vB) - Complexity = 3
                // Dst: (VOR:v4i32 VRRC:v4i32:$vA, VRRC:v4i32:$vB)
/*4937*/      0, /*End of Scope*/
/*4938*/    0, /*End of Scope*/
          /*SwitchOpcode*/ 30|128,1/*158*/,  TARGET_VAL(PPCISD::Hi),// ->5101
/*4943*/    OPC_RecordChild0, // #0 = $in
/*4944*/    OPC_MoveChild, 0,
/*4946*/    OPC_SwitchOpcode /*5 cases */, 28,  TARGET_VAL(ISD::TargetGlobalAddress),// ->4978
/*4950*/      OPC_MoveParent,
/*4951*/      OPC_MoveChild, 1,
/*4953*/      OPC_CheckInteger, 0, 
/*4955*/      OPC_MoveParent,
/*4956*/      OPC_SwitchType /*2 cases */, 8,  MVT::i32,// ->4967
/*4959*/        OPC_MorphNodeTo, TARGET_VAL(PPC::LIS), 0,
                    1/*#VTs*/, MVT::i32, 1/*#Ops*/, 0, 
                // Src: (PPChi:i32 (tglobaladdr:i32):$in, 0:i32) - Complexity = 11
                // Dst: (LIS:i32 (tglobaladdr:i32):$in)
              /*SwitchType*/ 8,  MVT::i64,// ->4977
/*4969*/        OPC_MorphNodeTo, TARGET_VAL(PPC::LIS8), 0,
                    1/*#VTs*/, MVT::i64, 1/*#Ops*/, 0, 
                // Src: (PPChi:i64 (tglobaladdr:i64):$in, 0:i64) - Complexity = 11
                // Dst: (LIS8:i64 (tglobaladdr:i64):$in)
              0, // EndSwitchType
            /*SwitchOpcode*/ 28,  TARGET_VAL(ISD::TargetConstantPool),// ->5009
/*4981*/      OPC_MoveParent,
/*4982*/      OPC_MoveChild, 1,
/*4984*/      OPC_CheckInteger, 0, 
/*4986*/      OPC_MoveParent,
/*4987*/      OPC_SwitchType /*2 cases */, 8,  MVT::i32,// ->4998
/*4990*/        OPC_MorphNodeTo, TARGET_VAL(PPC::LIS), 0,
                    1/*#VTs*/, MVT::i32, 1/*#Ops*/, 0, 
                // Src: (PPChi:i32 (tconstpool:i32):$in, 0:i32) - Complexity = 11
                // Dst: (LIS:i32 (tconstpool:i32):$in)
              /*SwitchType*/ 8,  MVT::i64,// ->5008
/*5000*/        OPC_MorphNodeTo, TARGET_VAL(PPC::LIS8), 0,
                    1/*#VTs*/, MVT::i64, 1/*#Ops*/, 0, 
                // Src: (PPChi:i64 (tconstpool:i64):$in, 0:i64) - Complexity = 11
                // Dst: (LIS8:i64 (tconstpool:i64):$in)
              0, // EndSwitchType
            /*SwitchOpcode*/ 28,  TARGET_VAL(ISD::TargetJumpTable),// ->5040
/*5012*/      OPC_MoveParent,
/*5013*/      OPC_MoveChild, 1,
/*5015*/      OPC_CheckInteger, 0, 
/*5017*/      OPC_MoveParent,
/*5018*/      OPC_SwitchType /*2 cases */, 8,  MVT::i32,// ->5029
/*5021*/        OPC_MorphNodeTo, TARGET_VAL(PPC::LIS), 0,
                    1/*#VTs*/, MVT::i32, 1/*#Ops*/, 0, 
                // Src: (PPChi:i32 (tjumptable:i32):$in, 0:i32) - Complexity = 11
                // Dst: (LIS:i32 (tjumptable:i32):$in)
              /*SwitchType*/ 8,  MVT::i64,// ->5039
/*5031*/        OPC_MorphNodeTo, TARGET_VAL(PPC::LIS8), 0,
                    1/*#VTs*/, MVT::i64, 1/*#Ops*/, 0, 
                // Src: (PPChi:i64 (tjumptable:i64):$in, 0:i64) - Complexity = 11
                // Dst: (LIS8:i64 (tjumptable:i64):$in)
              0, // EndSwitchType
            /*SwitchOpcode*/ 28,  TARGET_VAL(ISD::TargetBlockAddress),// ->5071
/*5043*/      OPC_MoveParent,
/*5044*/      OPC_MoveChild, 1,
/*5046*/      OPC_CheckInteger, 0, 
/*5048*/      OPC_MoveParent,
/*5049*/      OPC_SwitchType /*2 cases */, 8,  MVT::i32,// ->5060
/*5052*/        OPC_MorphNodeTo, TARGET_VAL(PPC::LIS), 0,
                    1/*#VTs*/, MVT::i32, 1/*#Ops*/, 0, 
                // Src: (PPChi:i32 (tblockaddress:i32):$in, 0:i32) - Complexity = 11
                // Dst: (LIS:i32 (tblockaddress:i32):$in)
              /*SwitchType*/ 8,  MVT::i64,// ->5070
/*5062*/        OPC_MorphNodeTo, TARGET_VAL(PPC::LIS8), 0,
                    1/*#VTs*/, MVT::i64, 1/*#Ops*/, 0, 
                // Src: (PPChi:i64 (tblockaddress:i64):$in, 0:i64) - Complexity = 11
                // Dst: (LIS8:i64 (tblockaddress:i64):$in)
              0, // EndSwitchType
            /*SwitchOpcode*/ 26,  TARGET_VAL(ISD::TargetGlobalTLSAddress),// ->5100
/*5074*/      OPC_MoveParent,
/*5075*/      OPC_RecordChild1, // #1 = $in
/*5076*/      OPC_SwitchType /*2 cases */, 9,  MVT::i32,// ->5088
/*5079*/        OPC_MorphNodeTo, TARGET_VAL(PPC::ADDIS), 0,
                    1/*#VTs*/, MVT::i32, 2/*#Ops*/, 1, 0, 
                // Src: (PPChi:i32 (tglobaltlsaddr:i32):$g, GPRC:i32:$in) - Complexity = 6
                // Dst: (ADDIS:i32 GPRC:i32:$in, (tglobaltlsaddr:i32):$g)
              /*SwitchType*/ 9,  MVT::i64,// ->5099
/*5090*/        OPC_MorphNodeTo, TARGET_VAL(PPC::ADDIS8), 0,
                    1/*#VTs*/, MVT::i64, 2/*#Ops*/, 1, 0, 
                // Src: (PPChi:i64 (tglobaltlsaddr:i64):$g, G8RC:i64:$in) - Complexity = 6
                // Dst: (ADDIS8:i64 G8RC:i64:$in, (tglobaltlsaddr:i64):$g)
              0, // EndSwitchType
            0, // EndSwitchOpcode
          /*SwitchOpcode*/ 30|128,1/*158*/,  TARGET_VAL(PPCISD::Lo),// ->5263
/*5105*/    OPC_RecordChild0, // #0 = $in
/*5106*/    OPC_MoveChild, 0,
/*5108*/    OPC_SwitchOpcode /*5 cases */, 28,  TARGET_VAL(ISD::TargetGlobalAddress),// ->5140
/*5112*/      OPC_MoveParent,
/*5113*/      OPC_MoveChild, 1,
/*5115*/      OPC_CheckInteger, 0, 
/*5117*/      OPC_MoveParent,
/*5118*/      OPC_SwitchType /*2 cases */, 8,  MVT::i32,// ->5129
/*5121*/        OPC_MorphNodeTo, TARGET_VAL(PPC::LI), 0,
                    1/*#VTs*/, MVT::i32, 1/*#Ops*/, 0, 
                // Src: (PPClo:i32 (tglobaladdr:i32):$in, 0:i32) - Complexity = 11
                // Dst: (LI:i32 (tglobaladdr:i32):$in)
              /*SwitchType*/ 8,  MVT::i64,// ->5139
/*5131*/        OPC_MorphNodeTo, TARGET_VAL(PPC::LI8), 0,
                    1/*#VTs*/, MVT::i64, 1/*#Ops*/, 0, 
                // Src: (PPClo:i64 (tglobaladdr:i64):$in, 0:i64) - Complexity = 11
                // Dst: (LI8:i64 (tglobaladdr:i64):$in)
              0, // EndSwitchType
            /*SwitchOpcode*/ 28,  TARGET_VAL(ISD::TargetConstantPool),// ->5171
/*5143*/      OPC_MoveParent,
/*5144*/      OPC_MoveChild, 1,
/*5146*/      OPC_CheckInteger, 0, 
/*5148*/      OPC_MoveParent,
/*5149*/      OPC_SwitchType /*2 cases */, 8,  MVT::i32,// ->5160
/*5152*/        OPC_MorphNodeTo, TARGET_VAL(PPC::LI), 0,
                    1/*#VTs*/, MVT::i32, 1/*#Ops*/, 0, 
                // Src: (PPClo:i32 (tconstpool:i32):$in, 0:i32) - Complexity = 11
                // Dst: (LI:i32 (tconstpool:i32):$in)
              /*SwitchType*/ 8,  MVT::i64,// ->5170
/*5162*/        OPC_MorphNodeTo, TARGET_VAL(PPC::LI8), 0,
                    1/*#VTs*/, MVT::i64, 1/*#Ops*/, 0, 
                // Src: (PPClo:i64 (tconstpool:i64):$in, 0:i64) - Complexity = 11
                // Dst: (LI8:i64 (tconstpool:i64):$in)
              0, // EndSwitchType
            /*SwitchOpcode*/ 28,  TARGET_VAL(ISD::TargetJumpTable),// ->5202
/*5174*/      OPC_MoveParent,
/*5175*/      OPC_MoveChild, 1,
/*5177*/      OPC_CheckInteger, 0, 
/*5179*/      OPC_MoveParent,
/*5180*/      OPC_SwitchType /*2 cases */, 8,  MVT::i32,// ->5191
/*5183*/        OPC_MorphNodeTo, TARGET_VAL(PPC::LI), 0,
                    1/*#VTs*/, MVT::i32, 1/*#Ops*/, 0, 
                // Src: (PPClo:i32 (tjumptable:i32):$in, 0:i32) - Complexity = 11
                // Dst: (LI:i32 (tjumptable:i32):$in)
              /*SwitchType*/ 8,  MVT::i64,// ->5201
/*5193*/        OPC_MorphNodeTo, TARGET_VAL(PPC::LI8), 0,
                    1/*#VTs*/, MVT::i64, 1/*#Ops*/, 0, 
                // Src: (PPClo:i64 (tjumptable:i64):$in, 0:i64) - Complexity = 11
                // Dst: (LI8:i64 (tjumptable:i64):$in)
              0, // EndSwitchType
            /*SwitchOpcode*/ 28,  TARGET_VAL(ISD::TargetBlockAddress),// ->5233
/*5205*/      OPC_MoveParent,
/*5206*/      OPC_MoveChild, 1,
/*5208*/      OPC_CheckInteger, 0, 
/*5210*/      OPC_MoveParent,
/*5211*/      OPC_SwitchType /*2 cases */, 8,  MVT::i32,// ->5222
/*5214*/        OPC_MorphNodeTo, TARGET_VAL(PPC::LI), 0,
                    1/*#VTs*/, MVT::i32, 1/*#Ops*/, 0, 
                // Src: (PPClo:i32 (tblockaddress:i32):$in, 0:i32) - Complexity = 11
                // Dst: (LI:i32 (tblockaddress:i32):$in)
              /*SwitchType*/ 8,  MVT::i64,// ->5232
/*5224*/        OPC_MorphNodeTo, TARGET_VAL(PPC::LI8), 0,
                    1/*#VTs*/, MVT::i64, 1/*#Ops*/, 0, 
                // Src: (PPClo:i64 (tblockaddress:i64):$in, 0:i64) - Complexity = 11
                // Dst: (LI8:i64 (tblockaddress:i64):$in)
              0, // EndSwitchType
            /*SwitchOpcode*/ 26,  TARGET_VAL(ISD::TargetGlobalTLSAddress),// ->5262
/*5236*/      OPC_MoveParent,
/*5237*/      OPC_RecordChild1, // #1 = $in
/*5238*/      OPC_SwitchType /*2 cases */, 9,  MVT::i32,// ->5250
/*5241*/        OPC_MorphNodeTo, TARGET_VAL(PPC::ADDIL), 0,
                    1/*#VTs*/, MVT::i32, 2/*#Ops*/, 1, 0, 
                // Src: (PPClo:i32 (tglobaltlsaddr:i32):$g, GPRC:i32:$in) - Complexity = 6
                // Dst: (ADDIL:i32 GPRC:i32:$in, (tglobaltlsaddr:i32):$g)
              /*SwitchType*/ 9,  MVT::i64,// ->5261
/*5252*/        OPC_MorphNodeTo, TARGET_VAL(PPC::ADDI8L), 0,
                    1/*#VTs*/, MVT::i64, 2/*#Ops*/, 1, 0, 
                // Src: (PPClo:i64 (tglobaltlsaddr:i64):$g, G8RC:i64:$in) - Complexity = 6
                // Dst: (ADDI8L:i64 G8RC:i64:$in, (tglobaltlsaddr:i64):$g)
              0, // EndSwitchType
            0, // EndSwitchOpcode
          /*SwitchOpcode*/ 26,  TARGET_VAL(ISD::CALLSEQ_END),// ->5292
/*5266*/    OPC_RecordNode,   // #0 = 'callseq_end' chained node
/*5267*/    OPC_CaptureGlueInput,
/*5268*/    OPC_RecordChild1, // #1 = $amt1
/*5269*/    OPC_MoveChild, 1,
/*5271*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/*5274*/    OPC_MoveParent,
/*5275*/    OPC_RecordChild2, // #2 = $amt2
/*5276*/    OPC_MoveChild, 2,
/*5278*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/*5281*/    OPC_MoveParent,
/*5282*/    OPC_EmitMergeInputChains1_0,
/*5283*/    OPC_MorphNodeTo, TARGET_VAL(PPC::ADJCALLSTACKUP), 0|OPFL_Chain|OPFL_GlueInput|OPFL_GlueOutput,
                1/*#VTs*/, MVT::i32, 2/*#Ops*/, 1, 2, 
            // Src: (callseq_end (timm:i32):$amt1, (timm:i32):$amt2) - Complexity = 9
            // Dst: (ADJCALLSTACKUP:i32 (timm:i32):$amt1, (timm:i32):$amt2)
          /*SwitchOpcode*/ 70|128,1/*198*/,  TARGET_VAL(PPCISD::TC_RETURN),// ->5494
/*5296*/    OPC_RecordNode,   // #0 = 'PPCtc_return' chained node
/*5297*/    OPC_CaptureGlueInput,
/*5298*/    OPC_RecordChild1, // #1 = $func
/*5299*/    OPC_Scope, 21|128,1/*149*/, /*->5451*/ // 3 children in Scope
/*5302*/      OPC_MoveChild, 1,
/*5304*/      OPC_SwitchOpcode /*3 cases */, 48,  TARGET_VAL(ISD::Constant),// ->5356
/*5308*/        OPC_SwitchType /*2 cases */, 21,  MVT::i32,// ->5332
/*5311*/          OPC_MoveParent,
/*5312*/          OPC_RecordChild2, // #2 = $offset
/*5313*/          OPC_MoveChild, 2,
/*5315*/          OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/*5318*/          OPC_MoveParent,
/*5319*/          OPC_EmitMergeInputChains1_0,
/*5320*/          OPC_EmitConvertToTarget, 1,
/*5322*/          OPC_EmitConvertToTarget, 2,
/*5324*/          OPC_MorphNodeTo, TARGET_VAL(PPC::TCRETURNai), 0|OPFL_Chain|OPFL_GlueInput|OPFL_Variadic2,
                      0/*#VTs*/, 2/*#Ops*/, 3, 4, 
                  // Src: (PPCtc_return (imm:i32):$func, (imm:i32):$offset) - Complexity = 9
                  // Dst: (TCRETURNai (imm:i32):$func, (imm:i32):$offset)
                /*SwitchType*/ 21,  MVT::i64,// ->5355
/*5334*/          OPC_MoveParent,
/*5335*/          OPC_RecordChild2, // #2 = $offset
/*5336*/          OPC_MoveChild, 2,
/*5338*/          OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/*5341*/          OPC_MoveParent,
/*5342*/          OPC_EmitMergeInputChains1_0,
/*5343*/          OPC_EmitConvertToTarget, 1,
/*5345*/          OPC_EmitConvertToTarget, 2,
/*5347*/          OPC_MorphNodeTo, TARGET_VAL(PPC::TCRETURNai8), 0|OPFL_Chain|OPFL_GlueInput|OPFL_Variadic2,
                      0/*#VTs*/, 2/*#Ops*/, 3, 4, 
                  // Src: (PPCtc_return (imm:i64):$func, (imm:i32):$offset) - Complexity = 9
                  // Dst: (TCRETURNai8 (imm:i64):$func, (imm:i32):$offset)
                0, // EndSwitchType
              /*SwitchOpcode*/ 44,  TARGET_VAL(ISD::TargetGlobalAddress),// ->5403
/*5359*/        OPC_SwitchType /*2 cases */, 19,  MVT::i32,// ->5381
/*5362*/          OPC_MoveParent,
/*5363*/          OPC_RecordChild2, // #2 = $imm
/*5364*/          OPC_MoveChild, 2,
/*5366*/          OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/*5369*/          OPC_MoveParent,
/*5370*/          OPC_EmitMergeInputChains1_0,
/*5371*/          OPC_EmitConvertToTarget, 2,
/*5373*/          OPC_MorphNodeTo, TARGET_VAL(PPC::TCRETURNdi), 0|OPFL_Chain|OPFL_GlueInput|OPFL_Variadic2,
                      0/*#VTs*/, 2/*#Ops*/, 1, 3, 
                  // Src: (PPCtc_return (tglobaladdr:i32):$dst, (imm:i32):$imm) - Complexity = 9
                  // Dst: (TCRETURNdi (tglobaladdr:i32):$dst, (imm:i32):$imm)
                /*SwitchType*/ 19,  MVT::i64,// ->5402
/*5383*/          OPC_MoveParent,
/*5384*/          OPC_RecordChild2, // #2 = $imm
/*5385*/          OPC_MoveChild, 2,
/*5387*/          OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/*5390*/          OPC_MoveParent,
/*5391*/          OPC_EmitMergeInputChains1_0,
/*5392*/          OPC_EmitConvertToTarget, 2,
/*5394*/          OPC_MorphNodeTo, TARGET_VAL(PPC::TCRETURNdi8), 0|OPFL_Chain|OPFL_GlueInput|OPFL_Variadic2,
                      0/*#VTs*/, 2/*#Ops*/, 1, 3, 
                  // Src: (PPCtc_return (tglobaladdr:i64):$dst, (imm:i32):$imm) - Complexity = 9
                  // Dst: (TCRETURNdi8 (tglobaladdr:i64):$dst, (imm:i32):$imm)
                0, // EndSwitchType
              /*SwitchOpcode*/ 44,  TARGET_VAL(ISD::TargetExternalSymbol),// ->5450
/*5406*/        OPC_SwitchType /*2 cases */, 19,  MVT::i32,// ->5428
/*5409*/          OPC_MoveParent,
/*5410*/          OPC_RecordChild2, // #2 = $imm
/*5411*/          OPC_MoveChild, 2,
/*5413*/          OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/*5416*/          OPC_MoveParent,
/*5417*/          OPC_EmitMergeInputChains1_0,
/*5418*/          OPC_EmitConvertToTarget, 2,
/*5420*/          OPC_MorphNodeTo, TARGET_VAL(PPC::TCRETURNdi), 0|OPFL_Chain|OPFL_GlueInput|OPFL_Variadic2,
                      0/*#VTs*/, 2/*#Ops*/, 1, 3, 
                  // Src: (PPCtc_return (texternalsym:i32):$dst, (imm:i32):$imm) - Complexity = 9
                  // Dst: (TCRETURNdi (texternalsym:i32):$dst, (imm:i32):$imm)
                /*SwitchType*/ 19,  MVT::i64,// ->5449
/*5430*/          OPC_MoveParent,
/*5431*/          OPC_RecordChild2, // #2 = $imm
/*5432*/          OPC_MoveChild, 2,
/*5434*/          OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/*5437*/          OPC_MoveParent,
/*5438*/          OPC_EmitMergeInputChains1_0,
/*5439*/          OPC_EmitConvertToTarget, 2,
/*5441*/          OPC_MorphNodeTo, TARGET_VAL(PPC::TCRETURNdi8), 0|OPFL_Chain|OPFL_GlueInput|OPFL_Variadic2,
                      0/*#VTs*/, 2/*#Ops*/, 1, 3, 
                  // Src: (PPCtc_return (texternalsym:i64):$dst, (imm:i32):$imm) - Complexity = 9
                  // Dst: (TCRETURNdi8 (texternalsym:i64):$dst, (imm:i32):$imm)
                0, // EndSwitchType
              0, // EndSwitchOpcode
/*5451*/    /*Scope*/ 20, /*->5472*/
/*5452*/      OPC_CheckChild1Type, MVT::i32,
/*5454*/      OPC_RecordChild2, // #2 = $imm
/*5455*/      OPC_MoveChild, 2,
/*5457*/      OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/*5460*/      OPC_MoveParent,
/*5461*/      OPC_EmitMergeInputChains1_0,
/*5462*/      OPC_EmitConvertToTarget, 2,
/*5464*/      OPC_MorphNodeTo, TARGET_VAL(PPC::TCRETURNri), 0|OPFL_Chain|OPFL_GlueInput|OPFL_Variadic2,
                  0/*#VTs*/, 2/*#Ops*/, 1, 3, 
              // Src: (PPCtc_return CTRRC:i32:$dst, (imm:i32):$imm) - Complexity = 6
              // Dst: (TCRETURNri CTRRC:i32:$dst, (imm:i32):$imm)
/*5472*/    /*Scope*/ 20, /*->5493*/
/*5473*/      OPC_CheckChild1Type, MVT::i64,
/*5475*/      OPC_RecordChild2, // #2 = $imm
/*5476*/      OPC_MoveChild, 2,
/*5478*/      OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/*5481*/      OPC_MoveParent,
/*5482*/      OPC_EmitMergeInputChains1_0,
/*5483*/      OPC_EmitConvertToTarget, 2,
/*5485*/      OPC_MorphNodeTo, TARGET_VAL(PPC::TCRETURNri8), 0|OPFL_Chain|OPFL_GlueInput|OPFL_Variadic2,
                  0/*#VTs*/, 2/*#Ops*/, 1, 3, 
              // Src: (PPCtc_return CTRRC8:i64:$dst, (imm:i32):$imm) - Complexity = 6
              // Dst: (TCRETURNri8 CTRRC8:i64:$dst, (imm:i32):$imm)
/*5493*/    0, /*End of Scope*/
          /*SwitchOpcode*/ 20,  TARGET_VAL(ISD::ATOMIC_FENCE),// ->5517
/*5497*/    OPC_RecordNode,   // #0 = 'atomic_fence' chained node
/*5498*/    OPC_MoveChild, 1,
/*5500*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/*5503*/    OPC_MoveParent,
/*5504*/    OPC_MoveChild, 2,
/*5506*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/*5509*/    OPC_MoveParent,
/*5510*/    OPC_EmitMergeInputChains1_0,
/*5511*/    OPC_MorphNodeTo, TARGET_VAL(PPC::SYNC), 0|OPFL_Chain,
                0/*#VTs*/, 0/*#Ops*/, 
            // Src: (atomic_fence (imm:iPTR), (imm:iPTR)) - Complexity = 9
            // Dst: (SYNC)
          /*SwitchOpcode*/ 118,  TARGET_VAL(ISD::SUB),// ->5638
/*5520*/    OPC_Scope, 28, /*->5550*/ // 2 children in Scope
/*5522*/      OPC_MoveChild, 0,
/*5524*/      OPC_CheckInteger, 0, 
/*5526*/      OPC_MoveParent,
/*5527*/      OPC_RecordChild1, // #0 = $rA
/*5528*/      OPC_SwitchType /*2 cases */, 8,  MVT::i32,// ->5539
/*5531*/        OPC_MorphNodeTo, TARGET_VAL(PPC::NEG), 0,
                    1/*#VTs*/, MVT::i32, 1/*#Ops*/, 0, 
                // Src: (sub:i32 0:i32, GPRC:i32:$rA) - Complexity = 8
                // Dst: (NEG:i32 GPRC:i32:$rA)
              /*SwitchType*/ 8,  MVT::i64,// ->5549
/*5541*/        OPC_MorphNodeTo, TARGET_VAL(PPC::NEG8), 0,
                    1/*#VTs*/, MVT::i64, 1/*#Ops*/, 0, 
                // Src: (sub:i64 0:i64, G8RC:i64:$rA) - Complexity = 8
                // Dst: (NEG8:i64 G8RC:i64:$rA)
              0, // EndSwitchType
/*5550*/    /*Scope*/ 86, /*->5637*/
/*5551*/      OPC_RecordChild0, // #0 = $imm
/*5552*/      OPC_Scope, 23, /*->5577*/ // 2 children in Scope
/*5554*/        OPC_MoveChild, 0,
/*5556*/        OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/*5559*/        OPC_CheckPredicate, 0, // Predicate_immSExt16
/*5561*/        OPC_MoveParent,
/*5562*/        OPC_RecordChild1, // #1 = $in
/*5563*/        OPC_CheckType, MVT::i32,
/*5565*/        OPC_EmitConvertToTarget, 0,
/*5567*/        OPC_MorphNodeTo, TARGET_VAL(PPC::SUBFIC), 0,
                    2/*#VTs*/, MVT::i32, MVT::i32, 2/*#Ops*/, 1, 2, 
                // Src: (sub:i32 (imm:i32)<<P:Predicate_immSExt16>>:$imm, GPRC:i32:$in) - Complexity = 7
                // Dst: (SUBFIC:i32:i32 GPRC:i32:$in, (imm:i32):$imm)
/*5577*/      /*Scope*/ 58, /*->5636*/
/*5578*/        OPC_RecordChild1, // #1 = $rA
/*5579*/        OPC_SwitchType /*5 cases */, 9,  MVT::i32,// ->5591
/*5582*/          OPC_MorphNodeTo, TARGET_VAL(PPC::SUBF), 0,
                      1/*#VTs*/, MVT::i32, 2/*#Ops*/, 1, 0, 
                  // Src: (sub:i32 GPRC:i32:$rB, GPRC:i32:$rA) - Complexity = 3
                  // Dst: (SUBF:i32 GPRC:i32:$rA, GPRC:i32:$rB)
                /*SwitchType*/ 9,  MVT::i64,// ->5602
/*5593*/          OPC_MorphNodeTo, TARGET_VAL(PPC::SUBF8), 0,
                      1/*#VTs*/, MVT::i64, 2/*#Ops*/, 1, 0, 
                  // Src: (sub:i64 G8RC:i64:$rB, G8RC:i64:$rA) - Complexity = 3
                  // Dst: (SUBF8:i64 G8RC:i64:$rA, G8RC:i64:$rB)
                /*SwitchType*/ 9,  MVT::v16i8,// ->5613
/*5604*/          OPC_MorphNodeTo, TARGET_VAL(PPC::VSUBUBM), 0,
                      1/*#VTs*/, MVT::v16i8, 2/*#Ops*/, 0, 1, 
                  // Src: (sub:v16i8 VRRC:v16i8:$vA, VRRC:v16i8:$vB) - Complexity = 3
                  // Dst: (VSUBUBM:v16i8 VRRC:v16i8:$vA, VRRC:v16i8:$vB)
                /*SwitchType*/ 9,  MVT::v8i16,// ->5624
/*5615*/          OPC_MorphNodeTo, TARGET_VAL(PPC::VSUBUHM), 0,
                      1/*#VTs*/, MVT::v8i16, 2/*#Ops*/, 0, 1, 
                  // Src: (sub:v8i16 VRRC:v8i16:$vA, VRRC:v8i16:$vB) - Complexity = 3
                  // Dst: (VSUBUHM:v8i16 VRRC:v8i16:$vA, VRRC:v8i16:$vB)
                /*SwitchType*/ 9,  MVT::v4i32,// ->5635
/*5626*/          OPC_MorphNodeTo, TARGET_VAL(PPC::VSUBUWM), 0,
                      1/*#VTs*/, MVT::v4i32, 2/*#Ops*/, 0, 1, 
                  // Src: (sub:v4i32 VRRC:v4i32:$vA, VRRC:v4i32:$vB) - Complexity = 3
                  // Dst: (VSUBUWM:v4i32 VRRC:v4i32:$vA, VRRC:v4i32:$vB)
                0, // EndSwitchType
/*5636*/      0, /*End of Scope*/
/*5637*/    0, /*End of Scope*/
          /*SwitchOpcode*/ 102,  TARGET_VAL(ISD::ADDE),// ->5743
/*5641*/    OPC_CaptureGlueInput,
/*5642*/    OPC_RecordChild0, // #0 = $rA
/*5643*/    OPC_Scope, 69, /*->5714*/ // 2 children in Scope
/*5645*/      OPC_MoveChild, 1,
/*5647*/      OPC_Scope, 36, /*->5685*/ // 2 children in Scope
/*5649*/        OPC_CheckInteger, 127|128,127|128,127|128,127|128,127|128,127|128,127|128,127|128,127|128,1/*18446744073709551615*/, 
/*5660*/        OPC_MoveParent,
/*5661*/        OPC_SwitchType /*2 cases */, 9,  MVT::i32,// ->5673
/*5664*/          OPC_MorphNodeTo, TARGET_VAL(PPC::ADDME), 0|OPFL_GlueInput|OPFL_GlueOutput,
                      2/*#VTs*/, MVT::i32, MVT::i32, 1/*#Ops*/, 0, 
                  // Src: (adde:i32 GPRC:i32:$rA, -1:i32) - Complexity = 8
                  // Dst: (ADDME:i32:i32 GPRC:i32:$rA)
                /*SwitchType*/ 9,  MVT::i64,// ->5684
/*5675*/          OPC_MorphNodeTo, TARGET_VAL(PPC::ADDME8), 0|OPFL_GlueInput|OPFL_GlueOutput,
                      2/*#VTs*/, MVT::i64, MVT::i32, 1/*#Ops*/, 0, 
                  // Src: (adde:i64 G8RC:i64:$rA, -1:i64) - Complexity = 8
                  // Dst: (ADDME8:i64:i32 G8RC:i64:$rA)
                0, // EndSwitchType
/*5685*/      /*Scope*/ 27, /*->5713*/
/*5686*/        OPC_CheckInteger, 0, 
/*5688*/        OPC_MoveParent,
/*5689*/        OPC_SwitchType /*2 cases */, 9,  MVT::i32,// ->5701
/*5692*/          OPC_MorphNodeTo, TARGET_VAL(PPC::ADDZE), 0|OPFL_GlueInput|OPFL_GlueOutput,
                      2/*#VTs*/, MVT::i32, MVT::i32, 1/*#Ops*/, 0, 
                  // Src: (adde:i32 GPRC:i32:$rA, 0:i32) - Complexity = 8
                  // Dst: (ADDZE:i32:i32 GPRC:i32:$rA)
                /*SwitchType*/ 9,  MVT::i64,// ->5712
/*5703*/          OPC_MorphNodeTo, TARGET_VAL(PPC::ADDZE8), 0|OPFL_GlueInput|OPFL_GlueOutput,
                      2/*#VTs*/, MVT::i64, MVT::i32, 1/*#Ops*/, 0, 
                  // Src: (adde:i64 G8RC:i64:$rA, 0:i64) - Complexity = 8
                  // Dst: (ADDZE8:i64:i32 G8RC:i64:$rA)
                0, // EndSwitchType
/*5713*/      0, /*End of Scope*/
/*5714*/    /*Scope*/ 27, /*->5742*/
/*5715*/      OPC_RecordChild1, // #1 = $rB
/*5716*/      OPC_SwitchType /*2 cases */, 10,  MVT::i32,// ->5729
/*5719*/        OPC_MorphNodeTo, TARGET_VAL(PPC::ADDE), 0|OPFL_GlueInput|OPFL_GlueOutput,
                    2/*#VTs*/, MVT::i32, MVT::i32, 2/*#Ops*/, 0, 1, 
                // Src: (adde:i32 GPRC:i32:$rA, GPRC:i32:$rB) - Complexity = 3
                // Dst: (ADDE:i32:i32 GPRC:i32:$rA, GPRC:i32:$rB)
              /*SwitchType*/ 10,  MVT::i64,// ->5741
/*5731*/        OPC_MorphNodeTo, TARGET_VAL(PPC::ADDE8), 0|OPFL_GlueInput|OPFL_GlueOutput,
                    2/*#VTs*/, MVT::i64, MVT::i32, 2/*#Ops*/, 0, 1, 
                // Src: (adde:i64 G8RC:i64:$rA, G8RC:i64:$rB) - Complexity = 3
                // Dst: (ADDE8:i64:i32 G8RC:i64:$rA, G8RC:i64:$rB)
              0, // EndSwitchType
/*5742*/    0, /*End of Scope*/
          /*SwitchOpcode*/ 104,  TARGET_VAL(ISD::SUBE),// ->5850
/*5746*/    OPC_CaptureGlueInput,
/*5747*/    OPC_Scope, 71, /*->5820*/ // 2 children in Scope
/*5749*/      OPC_MoveChild, 0,
/*5751*/      OPC_Scope, 37, /*->5790*/ // 2 children in Scope
/*5753*/        OPC_CheckInteger, 127|128,127|128,127|128,127|128,127|128,127|128,127|128,127|128,127|128,1/*18446744073709551615*/, 
/*5764*/        OPC_MoveParent,
/*5765*/        OPC_RecordChild1, // #0 = $rA
/*5766*/        OPC_SwitchType /*2 cases */, 9,  MVT::i32,// ->5778
/*5769*/          OPC_MorphNodeTo, TARGET_VAL(PPC::SUBFME), 0|OPFL_GlueInput|OPFL_GlueOutput,
                      2/*#VTs*/, MVT::i32, MVT::i32, 1/*#Ops*/, 0, 
                  // Src: (sube:i32 -1:i32, GPRC:i32:$rA) - Complexity = 8
                  // Dst: (SUBFME:i32:i32 GPRC:i32:$rA)
                /*SwitchType*/ 9,  MVT::i64,// ->5789
/*5780*/          OPC_MorphNodeTo, TARGET_VAL(PPC::SUBFME8), 0|OPFL_GlueInput|OPFL_GlueOutput,
                      2/*#VTs*/, MVT::i64, MVT::i32, 1/*#Ops*/, 0, 
                  // Src: (sube:i64 -1:i64, G8RC:i64:$rA) - Complexity = 8
                  // Dst: (SUBFME8:i64:i32 G8RC:i64:$rA)
                0, // EndSwitchType
/*5790*/      /*Scope*/ 28, /*->5819*/
/*5791*/        OPC_CheckInteger, 0, 
/*5793*/        OPC_MoveParent,
/*5794*/        OPC_RecordChild1, // #0 = $rA
/*5795*/        OPC_SwitchType /*2 cases */, 9,  MVT::i32,// ->5807
/*5798*/          OPC_MorphNodeTo, TARGET_VAL(PPC::SUBFZE), 0|OPFL_GlueInput|OPFL_GlueOutput,
                      2/*#VTs*/, MVT::i32, MVT::i32, 1/*#Ops*/, 0, 
                  // Src: (sube:i32 0:i32, GPRC:i32:$rA) - Complexity = 8
                  // Dst: (SUBFZE:i32:i32 GPRC:i32:$rA)
                /*SwitchType*/ 9,  MVT::i64,// ->5818
/*5809*/          OPC_MorphNodeTo, TARGET_VAL(PPC::SUBFZE8), 0|OPFL_GlueInput|OPFL_GlueOutput,
                      2/*#VTs*/, MVT::i64, MVT::i32, 1/*#Ops*/, 0, 
                  // Src: (sube:i64 0:i64, G8RC:i64:$rA) - Complexity = 8
                  // Dst: (SUBFZE8:i64:i32 G8RC:i64:$rA)
                0, // EndSwitchType
/*5819*/      0, /*End of Scope*/
/*5820*/    /*Scope*/ 28, /*->5849*/
/*5821*/      OPC_RecordChild0, // #0 = $rB
/*5822*/      OPC_RecordChild1, // #1 = $rA
/*5823*/      OPC_SwitchType /*2 cases */, 10,  MVT::i32,// ->5836
/*5826*/        OPC_MorphNodeTo, TARGET_VAL(PPC::SUBFE), 0|OPFL_GlueInput|OPFL_GlueOutput,
                    2/*#VTs*/, MVT::i32, MVT::i32, 2/*#Ops*/, 1, 0, 
                // Src: (sube:i32 GPRC:i32:$rB, GPRC:i32:$rA) - Complexity = 3
                // Dst: (SUBFE:i32:i32 GPRC:i32:$rA, GPRC:i32:$rB)
              /*SwitchType*/ 10,  MVT::i64,// ->5848
/*5838*/        OPC_MorphNodeTo, TARGET_VAL(PPC::SUBFE8), 0|OPFL_GlueInput|OPFL_GlueOutput,
                    2/*#VTs*/, MVT::i64, MVT::i32, 2/*#Ops*/, 1, 0, 
                // Src: (sube:i64 G8RC:i64:$rB, G8RC:i64:$rA) - Complexity = 3
                // Dst: (SUBFE8:i64:i32 G8RC:i64:$rA, G8RC:i64:$rB)
              0, // EndSwitchType
/*5849*/    0, /*End of Scope*/
          /*SwitchOpcode*/ 69,  TARGET_VAL(ISD::ADDC),// ->5922
/*5853*/    OPC_RecordChild0, // #0 = $rA
/*5854*/    OPC_RecordChild1, // #1 = $imm
/*5855*/    OPC_Scope, 38, /*->5895*/ // 3 children in Scope
/*5857*/      OPC_MoveChild, 1,
/*5859*/      OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/*5862*/      OPC_CheckPredicate, 0, // Predicate_immSExt16
/*5864*/      OPC_MoveParent,
/*5865*/      OPC_SwitchType /*2 cases */, 12,  MVT::i32,// ->5880
/*5868*/        OPC_EmitConvertToTarget, 1,
/*5870*/        OPC_MorphNodeTo, TARGET_VAL(PPC::ADDIC), 0|OPFL_GlueOutput,
                    2/*#VTs*/, MVT::i32, MVT::i32, 2/*#Ops*/, 0, 2, 
                // Src: (addc:i32 GPRC:i32:$rA, (imm:i32)<<P:Predicate_immSExt16>>:$imm) - Complexity = 7
                // Dst: (ADDIC:i32:i32 GPRC:i32:$rA, (imm:i32):$imm)
              /*SwitchType*/ 12,  MVT::i64,// ->5894
/*5882*/        OPC_EmitConvertToTarget, 1,
/*5884*/        OPC_MorphNodeTo, TARGET_VAL(PPC::ADDIC8), 0|OPFL_GlueOutput,
                    2/*#VTs*/, MVT::i64, MVT::i32, 2/*#Ops*/, 0, 2, 
                // Src: (addc:i64 G8RC:i64:$rA, (imm:i64)<<P:Predicate_immSExt16>>:$imm) - Complexity = 7
                // Dst: (ADDIC8:i64:i32 G8RC:i64:$rA, (imm:i64):$imm)
              0, // EndSwitchType
/*5895*/    /*Scope*/ 12, /*->5908*/
/*5896*/      OPC_CheckType, MVT::i32,
/*5898*/      OPC_MorphNodeTo, TARGET_VAL(PPC::ADDC), 0|OPFL_GlueOutput,
                  2/*#VTs*/, MVT::i32, MVT::i32, 2/*#Ops*/, 0, 1, 
              // Src: (addc:i32 GPRC:i32:$rA, GPRC:i32:$rB) - Complexity = 3
              // Dst: (ADDC:i32:i32 GPRC:i32:$rA, GPRC:i32:$rB)
/*5908*/    /*Scope*/ 12, /*->5921*/
/*5909*/      OPC_CheckType, MVT::i64,
/*5911*/      OPC_MorphNodeTo, TARGET_VAL(PPC::ADDC8), 0|OPFL_GlueOutput,
                  2/*#VTs*/, MVT::i64, MVT::i32, 2/*#Ops*/, 0, 1, 
              // Src: (addc:i64 G8RC:i64:$rA, G8RC:i64:$rB) - Complexity = 3
              // Dst: (ADDC8:i64:i32 G8RC:i64:$rA, G8RC:i64:$rB)
/*5921*/    0, /*End of Scope*/
          /*SwitchOpcode*/ 50,  TARGET_VAL(ISD::MUL),// ->5975
/*5925*/    OPC_RecordChild0, // #0 = $rA
/*5926*/    OPC_RecordChild1, // #1 = $imm
/*5927*/    OPC_Scope, 21, /*->5950*/ // 3 children in Scope
/*5929*/      OPC_MoveChild, 1,
/*5931*/      OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/*5934*/      OPC_CheckPredicate, 0, // Predicate_immSExt16
/*5936*/      OPC_MoveParent,
/*5937*/      OPC_CheckType, MVT::i32,
/*5939*/      OPC_EmitConvertToTarget, 1,
/*5941*/      OPC_MorphNodeTo, TARGET_VAL(PPC::MULLI), 0,
                  1/*#VTs*/, MVT::i32, 2/*#Ops*/, 0, 2, 
              // Src: (mul:i32 GPRC:i32:$rA, (imm:i32)<<P:Predicate_immSExt16>>:$imm) - Complexity = 7
              // Dst: (MULLI:i32 GPRC:i32:$rA, (imm:i32):$imm)
/*5950*/    /*Scope*/ 11, /*->5962*/
/*5951*/      OPC_CheckType, MVT::i32,
/*5953*/      OPC_MorphNodeTo, TARGET_VAL(PPC::MULLW), 0,
                  1/*#VTs*/, MVT::i32, 2/*#Ops*/, 0, 1, 
              // Src: (mul:i32 GPRC:i32:$rA, GPRC:i32:$rB) - Complexity = 3
              // Dst: (MULLW:i32 GPRC:i32:$rA, GPRC:i32:$rB)
/*5962*/    /*Scope*/ 11, /*->5974*/
/*5963*/      OPC_CheckType, MVT::i64,
/*5965*/      OPC_MorphNodeTo, TARGET_VAL(PPC::MULLD), 0,
                  1/*#VTs*/, MVT::i64, 2/*#Ops*/, 0, 1, 
              // Src: (mul:i64 G8RC:i64:$rA, G8RC:i64:$rB) - Complexity = 3
              // Dst: (MULLD:i64 G8RC:i64:$rA, G8RC:i64:$rB)
/*5974*/    0, /*End of Scope*/
          /*SwitchOpcode*/ 71,  TARGET_VAL(ISD::SUBC),// ->6049
/*5978*/    OPC_RecordChild0, // #0 = $imm
/*5979*/    OPC_Scope, 39, /*->6020*/ // 2 children in Scope
/*5981*/      OPC_MoveChild, 0,
/*5983*/      OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/*5986*/      OPC_CheckPredicate, 0, // Predicate_immSExt16
/*5988*/      OPC_MoveParent,
/*5989*/      OPC_RecordChild1, // #1 = $rA
/*5990*/      OPC_SwitchType /*2 cases */, 12,  MVT::i32,// ->6005
/*5993*/        OPC_EmitConvertToTarget, 0,
/*5995*/        OPC_MorphNodeTo, TARGET_VAL(PPC::SUBFIC), 0|OPFL_GlueOutput,
                    2/*#VTs*/, MVT::i32, MVT::i32, 2/*#Ops*/, 1, 2, 
                // Src: (subc:i32 (imm:i32)<<P:Predicate_immSExt16>>:$imm, GPRC:i32:$rA) - Complexity = 7
                // Dst: (SUBFIC:i32:i32 GPRC:i32:$rA, (imm:i32):$imm)
              /*SwitchType*/ 12,  MVT::i64,// ->6019
/*6007*/        OPC_EmitConvertToTarget, 0,
/*6009*/        OPC_MorphNodeTo, TARGET_VAL(PPC::SUBFIC8), 0|OPFL_GlueOutput,
                    2/*#VTs*/, MVT::i64, MVT::i32, 2/*#Ops*/, 1, 2, 
                // Src: (subc:i64 (imm:i64)<<P:Predicate_immSExt16>>:$imm, G8RC:i64:$rA) - Complexity = 7
                // Dst: (SUBFIC8:i64:i32 G8RC:i64:$rA, (imm:i64):$imm)
              0, // EndSwitchType
/*6020*/    /*Scope*/ 27, /*->6048*/
/*6021*/      OPC_RecordChild1, // #1 = $rA
/*6022*/      OPC_SwitchType /*2 cases */, 10,  MVT::i32,// ->6035
/*6025*/        OPC_MorphNodeTo, TARGET_VAL(PPC::SUBFC), 0|OPFL_GlueOutput,
                    2/*#VTs*/, MVT::i32, MVT::i32, 2/*#Ops*/, 1, 0, 
                // Src: (subc:i32 GPRC:i32:$rB, GPRC:i32:$rA) - Complexity = 3
                // Dst: (SUBFC:i32:i32 GPRC:i32:$rA, GPRC:i32:$rB)
              /*SwitchType*/ 10,  MVT::i64,// ->6047
/*6037*/        OPC_MorphNodeTo, TARGET_VAL(PPC::SUBFC8), 0|OPFL_GlueOutput,
                    2/*#VTs*/, MVT::i64, MVT::i32, 2/*#Ops*/, 1, 0, 
                // Src: (subc:i64 G8RC:i64:$rB, G8RC:i64:$rA) - Complexity = 3
                // Dst: (SUBFC8:i64:i32 G8RC:i64:$rA, G8RC:i64:$rB)
              0, // EndSwitchType
/*6048*/    0, /*End of Scope*/
          /*SwitchOpcode*/ 114,  TARGET_VAL(ISD::SRA),// ->6166
/*6052*/    OPC_RecordChild0, // #0 = $rS
/*6053*/    OPC_RecordChild1, // #1 = $SH
/*6054*/    OPC_Scope, 38, /*->6094*/ // 5 children in Scope
/*6056*/      OPC_MoveChild, 1,
/*6058*/      OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/*6061*/      OPC_CheckType, MVT::i32,
/*6063*/      OPC_MoveParent,
/*6064*/      OPC_SwitchType /*2 cases */, 12,  MVT::i32,// ->6079
/*6067*/        OPC_EmitConvertToTarget, 1,
/*6069*/        OPC_MorphNodeTo, TARGET_VAL(PPC::SRAWI), 0,
                    2/*#VTs*/, MVT::i32, MVT::i32, 2/*#Ops*/, 0, 2, 
                // Src: (sra:i32 GPRC:i32:$rS, (imm:i32):$SH) - Complexity = 6
                // Dst: (SRAWI:i32:i32 GPRC:i32:$rS, (imm:i32):$SH)
              /*SwitchType*/ 12,  MVT::i64,// ->6093
/*6081*/        OPC_EmitConvertToTarget, 1,
/*6083*/        OPC_MorphNodeTo, TARGET_VAL(PPC::SRADI), 0,
                    2/*#VTs*/, MVT::i64, MVT::i32, 2/*#Ops*/, 0, 2, 
                // Src: (sra:i64 G8RC:i64:$rS, (imm:i32):$SH) - Complexity = 6
                // Dst: (SRADI:i64:i32 G8RC:i64:$rS, (imm:i32):$SH)
              0, // EndSwitchType
/*6094*/    /*Scope*/ 28, /*->6123*/
/*6095*/      OPC_CheckChild1Type, MVT::i32,
/*6097*/      OPC_SwitchType /*2 cases */, 10,  MVT::i32,// ->6110
/*6100*/        OPC_MorphNodeTo, TARGET_VAL(PPC::SRAW), 0,
                    2/*#VTs*/, MVT::i32, MVT::i32, 2/*#Ops*/, 0, 1, 
                // Src: (sra:i32 GPRC:i32:$rS, GPRC:i32:$rB) - Complexity = 3
                // Dst: (SRAW:i32:i32 GPRC:i32:$rS, GPRC:i32:$rB)
              /*SwitchType*/ 10,  MVT::i64,// ->6122
/*6112*/        OPC_MorphNodeTo, TARGET_VAL(PPC::SRAD), 0,
                    2/*#VTs*/, MVT::i64, MVT::i32, 2/*#Ops*/, 0, 1, 
                // Src: (sra:i64 G8RC:i64:$rS, GPRC:i32:$rB) - Complexity = 3
                // Dst: (SRAD:i64:i32 G8RC:i64:$rS, GPRC:i32:$rB)
              0, // EndSwitchType
/*6123*/    /*Scope*/ 13, /*->6137*/
/*6124*/      OPC_CheckChild1Type, MVT::v16i8,
/*6126*/      OPC_CheckType, MVT::v16i8,
/*6128*/      OPC_MorphNodeTo, TARGET_VAL(PPC::VSRAB), 0,
                  1/*#VTs*/, MVT::v16i8, 2/*#Ops*/, 0, 1, 
              // Src: (sra:v16i8 VRRC:v16i8:$vA, VRRC:v16i8:$vB) - Complexity = 3
              // Dst: (VSRAB:v16i8 VRRC:v16i8:$vA, VRRC:v16i8:$vB)
/*6137*/    /*Scope*/ 13, /*->6151*/
/*6138*/      OPC_CheckChild1Type, MVT::v8i16,
/*6140*/      OPC_CheckType, MVT::v8i16,
/*6142*/      OPC_MorphNodeTo, TARGET_VAL(PPC::VSRAH), 0,
                  1/*#VTs*/, MVT::v8i16, 2/*#Ops*/, 0, 1, 
              // Src: (sra:v8i16 VRRC:v8i16:$vA, VRRC:v8i16:$vB) - Complexity = 3
              // Dst: (VSRAH:v8i16 VRRC:v8i16:$vA, VRRC:v8i16:$vB)
/*6151*/    /*Scope*/ 13, /*->6165*/
/*6152*/      OPC_CheckChild1Type, MVT::v4i32,
/*6154*/      OPC_CheckType, MVT::v4i32,
/*6156*/      OPC_MorphNodeTo, TARGET_VAL(PPC::VSRAW), 0,
                  1/*#VTs*/, MVT::v4i32, 2/*#Ops*/, 0, 1, 
              // Src: (sra:v4i32 VRRC:v4i32:$vA, VRRC:v4i32:$vB) - Complexity = 3
              // Dst: (VSRAW:v4i32 VRRC:v4i32:$vA, VRRC:v4i32:$vB)
/*6165*/    0, /*End of Scope*/
          /*SwitchOpcode*/ 126,  TARGET_VAL(ISD::SHL),// ->6295
/*6169*/    OPC_RecordChild0, // #0 = $in
/*6170*/    OPC_RecordChild1, // #1 = $imm
/*6171*/    OPC_Scope, 52, /*->6225*/ // 5 children in Scope
/*6173*/      OPC_MoveChild, 1,
/*6175*/      OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/*6178*/      OPC_CheckType, MVT::i32,
/*6180*/      OPC_MoveParent,
/*6181*/      OPC_SwitchType /*2 cases */, 21,  MVT::i32,// ->6205
/*6184*/        OPC_EmitConvertToTarget, 1,
/*6186*/        OPC_EmitInteger, MVT::i32, 0, 
/*6189*/        OPC_EmitConvertToTarget, 1,
/*6191*/        OPC_EmitNodeXForm, 5, 4, // SHL32
/*6194*/        OPC_MorphNodeTo, TARGET_VAL(PPC::RLWINM), 0,
                    1/*#VTs*/, MVT::i32, 4/*#Ops*/, 0, 2, 3, 5, 
                // Src: (shl:i32 GPRC:i32:$in, (imm:i32):$imm) - Complexity = 6
                // Dst: (RLWINM:i32 GPRC:i32:$in, (imm:i32):$imm, 0:i32, (SHL32:i32 (imm:i32):$imm))
              /*SwitchType*/ 17,  MVT::i64,// ->6224
/*6207*/        OPC_EmitConvertToTarget, 1,
/*6209*/        OPC_EmitConvertToTarget, 1,
/*6211*/        OPC_EmitNodeXForm, 6, 3, // SHL64
/*6214*/        OPC_MorphNodeTo, TARGET_VAL(PPC::RLDICR), 0,
                    1/*#VTs*/, MVT::i64, 3/*#Ops*/, 0, 2, 4, 
                // Src: (shl:i64 G8RC:i64:$in, (imm:i32):$imm) - Complexity = 6
                // Dst: (RLDICR:i64 G8RC:i64:$in, (imm:i32):$imm, (SHL64:i32 (imm:i32):$imm))
              0, // EndSwitchType
/*6225*/    /*Scope*/ 26, /*->6252*/
/*6226*/      OPC_CheckChild1Type, MVT::i32,
/*6228*/      OPC_SwitchType /*2 cases */, 9,  MVT::i32,// ->6240
/*6231*/        OPC_MorphNodeTo, TARGET_VAL(PPC::SLW), 0,
                    1/*#VTs*/, MVT::i32, 2/*#Ops*/, 0, 1, 
                // Src: (shl:i32 GPRC:i32:$rS, GPRC:i32:$rB) - Complexity = 3
                // Dst: (SLW:i32 GPRC:i32:$rS, GPRC:i32:$rB)
              /*SwitchType*/ 9,  MVT::i64,// ->6251
/*6242*/        OPC_MorphNodeTo, TARGET_VAL(PPC::SLD), 0,
                    1/*#VTs*/, MVT::i64, 2/*#Ops*/, 0, 1, 
                // Src: (shl:i64 G8RC:i64:$rS, GPRC:i32:$rB) - Complexity = 3
                // Dst: (SLD:i64 G8RC:i64:$rS, GPRC:i32:$rB)
              0, // EndSwitchType
/*6252*/    /*Scope*/ 13, /*->6266*/
/*6253*/      OPC_CheckChild1Type, MVT::v16i8,
/*6255*/      OPC_CheckType, MVT::v16i8,
/*6257*/      OPC_MorphNodeTo, TARGET_VAL(PPC::VSLB), 0,
                  1/*#VTs*/, MVT::v16i8, 2/*#Ops*/, 0, 1, 
              // Src: (shl:v16i8 VRRC:v16i8:$vA, VRRC:v16i8:$vB) - Complexity = 3
              // Dst: (VSLB:v16i8 VRRC:v16i8:$vA, VRRC:v16i8:$vB)
/*6266*/    /*Scope*/ 13, /*->6280*/
/*6267*/      OPC_CheckChild1Type, MVT::v8i16,
/*6269*/      OPC_CheckType, MVT::v8i16,
/*6271*/      OPC_MorphNodeTo, TARGET_VAL(PPC::VSLH), 0,
                  1/*#VTs*/, MVT::v8i16, 2/*#Ops*/, 0, 1, 
              // Src: (shl:v8i16 VRRC:v8i16:$vA, VRRC:v8i16:$vB) - Complexity = 3
              // Dst: (VSLH:v8i16 VRRC:v8i16:$vA, VRRC:v8i16:$vB)
/*6280*/    /*Scope*/ 13, /*->6294*/
/*6281*/      OPC_CheckChild1Type, MVT::v4i32,
/*6283*/      OPC_CheckType, MVT::v4i32,
/*6285*/      OPC_MorphNodeTo, TARGET_VAL(PPC::VSLW), 0,
                  1/*#VTs*/, MVT::v4i32, 2/*#Ops*/, 0, 1, 
              // Src: (shl:v4i32 VRRC:v4i32:$vA, VRRC:v4i32:$vB) - Complexity = 3
              // Dst: (VSLW:v4i32 VRRC:v4i32:$vA, VRRC:v4i32:$vB)
/*6294*/    0, /*End of Scope*/
          /*SwitchOpcode*/ 126,  TARGET_VAL(ISD::SRL),// ->6424
/*6298*/    OPC_RecordChild0, // #0 = $in
/*6299*/    OPC_RecordChild1, // #1 = $imm
/*6300*/    OPC_Scope, 52, /*->6354*/ // 5 children in Scope
/*6302*/      OPC_MoveChild, 1,
/*6304*/      OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/*6307*/      OPC_CheckType, MVT::i32,
/*6309*/      OPC_MoveParent,
/*6310*/      OPC_SwitchType /*2 cases */, 21,  MVT::i32,// ->6334
/*6313*/        OPC_EmitConvertToTarget, 1,
/*6315*/        OPC_EmitNodeXForm, 7, 2, // SRL32
/*6318*/        OPC_EmitConvertToTarget, 1,
/*6320*/        OPC_EmitInteger, MVT::i32, 31, 
/*6323*/        OPC_MorphNodeTo, TARGET_VAL(PPC::RLWINM), 0,
                    1/*#VTs*/, MVT::i32, 4/*#Ops*/, 0, 3, 4, 5, 
                // Src: (srl:i32 GPRC:i32:$in, (imm:i32):$imm) - Complexity = 6
                // Dst: (RLWINM:i32 GPRC:i32:$in, (SRL32:i32 (imm:i32):$imm), (imm:i32):$imm, 31:i32)
              /*SwitchType*/ 17,  MVT::i64,// ->6353
/*6336*/        OPC_EmitConvertToTarget, 1,
/*6338*/        OPC_EmitNodeXForm, 8, 2, // SRL64
/*6341*/        OPC_EmitConvertToTarget, 1,
/*6343*/        OPC_MorphNodeTo, TARGET_VAL(PPC::RLDICL), 0,
                    1/*#VTs*/, MVT::i64, 3/*#Ops*/, 0, 3, 4, 
                // Src: (srl:i64 G8RC:i64:$in, (imm:i32):$imm) - Complexity = 6
                // Dst: (RLDICL:i64 G8RC:i64:$in, (SRL64:i32 (imm:i32):$imm), (imm:i32):$imm)
              0, // EndSwitchType
/*6354*/    /*Scope*/ 26, /*->6381*/
/*6355*/      OPC_CheckChild1Type, MVT::i32,
/*6357*/      OPC_SwitchType /*2 cases */, 9,  MVT::i32,// ->6369
/*6360*/        OPC_MorphNodeTo, TARGET_VAL(PPC::SRW), 0,
                    1/*#VTs*/, MVT::i32, 2/*#Ops*/, 0, 1, 
                // Src: (srl:i32 GPRC:i32:$rS, GPRC:i32:$rB) - Complexity = 3
                // Dst: (SRW:i32 GPRC:i32:$rS, GPRC:i32:$rB)
              /*SwitchType*/ 9,  MVT::i64,// ->6380
/*6371*/        OPC_MorphNodeTo, TARGET_VAL(PPC::SRD), 0,
                    1/*#VTs*/, MVT::i64, 2/*#Ops*/, 0, 1, 
                // Src: (srl:i64 G8RC:i64:$rS, GPRC:i32:$rB) - Complexity = 3
                // Dst: (SRD:i64 G8RC:i64:$rS, GPRC:i32:$rB)
              0, // EndSwitchType
/*6381*/    /*Scope*/ 13, /*->6395*/
/*6382*/      OPC_CheckChild1Type, MVT::v16i8,
/*6384*/      OPC_CheckType, MVT::v16i8,
/*6386*/      OPC_MorphNodeTo, TARGET_VAL(PPC::VSRB), 0,
                  1/*#VTs*/, MVT::v16i8, 2/*#Ops*/, 0, 1, 
              // Src: (srl:v16i8 VRRC:v16i8:$vA, VRRC:v16i8:$vB) - Complexity = 3
              // Dst: (VSRB:v16i8 VRRC:v16i8:$vA, VRRC:v16i8:$vB)
/*6395*/    /*Scope*/ 13, /*->6409*/
/*6396*/      OPC_CheckChild1Type, MVT::v8i16,
/*6398*/      OPC_CheckType, MVT::v8i16,
/*6400*/      OPC_MorphNodeTo, TARGET_VAL(PPC::VSRH), 0,
                  1/*#VTs*/, MVT::v8i16, 2/*#Ops*/, 0, 1, 
              // Src: (srl:v8i16 VRRC:v8i16:$vA, VRRC:v8i16:$vB) - Complexity = 3
              // Dst: (VSRH:v8i16 VRRC:v8i16:$vA, VRRC:v8i16:$vB)
/*6409*/    /*Scope*/ 13, /*->6423*/
/*6410*/      OPC_CheckChild1Type, MVT::v4i32,
/*6412*/      OPC_CheckType, MVT::v4i32,
/*6414*/      OPC_MorphNodeTo, TARGET_VAL(PPC::VSRW), 0,
                  1/*#VTs*/, MVT::v4i32, 2/*#Ops*/, 0, 1, 
              // Src: (srl:v4i32 VRRC:v4i32:$vA, VRRC:v4i32:$vB) - Complexity = 3
              // Dst: (VSRW:v4i32 VRRC:v4i32:$vA, VRRC:v4i32:$vB)
/*6423*/    0, /*End of Scope*/
          /*SwitchOpcode*/ 92,  TARGET_VAL(ISD::ROTL),// ->6519
/*6427*/    OPC_RecordChild0, // #0 = $in
/*6428*/    OPC_RecordChild1, // #1 = $imm
/*6429*/    OPC_Scope, 48, /*->6479*/ // 2 children in Scope
/*6431*/      OPC_MoveChild, 1,
/*6433*/      OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/*6436*/      OPC_CheckType, MVT::i32,
/*6438*/      OPC_MoveParent,
/*6439*/      OPC_SwitchType /*2 cases */, 19,  MVT::i32,// ->6461
/*6442*/        OPC_EmitConvertToTarget, 1,
/*6444*/        OPC_EmitInteger, MVT::i32, 0, 
/*6447*/        OPC_EmitInteger, MVT::i32, 31, 
/*6450*/        OPC_MorphNodeTo, TARGET_VAL(PPC::RLWINM), 0,
                    1/*#VTs*/, MVT::i32, 4/*#Ops*/, 0, 2, 3, 4, 
                // Src: (rotl:i32 GPRC:i32:$in, (imm:i32):$imm) - Complexity = 6
                // Dst: (RLWINM:i32 GPRC:i32:$in, (imm:i32):$imm, 0:i32, 31:i32)
              /*SwitchType*/ 15,  MVT::i64,// ->6478
/*6463*/        OPC_EmitConvertToTarget, 1,
/*6465*/        OPC_EmitInteger, MVT::i32, 0, 
/*6468*/        OPC_MorphNodeTo, TARGET_VAL(PPC::RLDICL), 0,
                    1/*#VTs*/, MVT::i64, 3/*#Ops*/, 0, 2, 3, 
                // Src: (rotl:i64 G8RC:i64:$in, (imm:i32):$imm) - Complexity = 6
                // Dst: (RLDICL:i64 G8RC:i64:$in, (imm:i32):$imm, 0:i32)
              0, // EndSwitchType
/*6479*/    /*Scope*/ 38, /*->6518*/
/*6480*/      OPC_CheckChild1Type, MVT::i32,
/*6482*/      OPC_SwitchType /*2 cases */, 17,  MVT::i32,// ->6502
/*6485*/        OPC_EmitInteger, MVT::i32, 0, 
/*6488*/        OPC_EmitInteger, MVT::i32, 31, 
/*6491*/        OPC_MorphNodeTo, TARGET_VAL(PPC::RLWNM), 0,
                    1/*#VTs*/, MVT::i32, 4/*#Ops*/, 0, 1, 2, 3, 
                // Src: (rotl:i32 GPRC:i32:$in, GPRC:i32:$sh) - Complexity = 3
                // Dst: (RLWNM:i32 GPRC:i32:$in, GPRC:i32:$sh, 0:i32, 31:i32)
              /*SwitchType*/ 13,  MVT::i64,// ->6517
/*6504*/        OPC_EmitInteger, MVT::i32, 0, 
/*6507*/        OPC_MorphNodeTo, TARGET_VAL(PPC::RLDCL), 0,
                    1/*#VTs*/, MVT::i64, 3/*#Ops*/, 0, 1, 2, 
                // Src: (rotl:i64 G8RC:i64:$in, GPRC:i32:$sh) - Complexity = 3
                // Dst: (RLDCL:i64 G8RC:i64:$in, GPRC:i32:$sh, 0:i32)
              0, // EndSwitchType
/*6518*/    0, /*End of Scope*/
          /*SwitchOpcode*/ 19,  TARGET_VAL(PPCISD::TOC_ENTRY),// ->6541
/*6522*/    OPC_RecordChild0, // #0 = $disp
/*6523*/    OPC_MoveChild, 0,
/*6525*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/*6528*/    OPC_MoveParent,
/*6529*/    OPC_RecordChild1, // #1 = $reg
/*6530*/    OPC_CheckType, MVT::i64,
/*6532*/    OPC_MorphNodeTo, TARGET_VAL(PPC::LDtoc), 0,
                1/*#VTs*/, MVT::i64, 2/*#Ops*/, 0, 1, 
            // Src: (PPCtoc_entry:i64 (tglobaladdr:i64):$disp, G8RC:i64:$reg) - Complexity = 6
            // Dst: (LDtoc:i64 (tglobaladdr:i64):$disp, G8RC:i64:$reg)
          /*SwitchOpcode*/ 97,  TARGET_VAL(ISD::Constant),// ->6641
/*6544*/    OPC_RecordNode,   // #0 = $imm
/*6545*/    OPC_SwitchType /*2 cases */, 59,  MVT::i32,// ->6607
/*6548*/      OPC_Scope, 12, /*->6562*/ // 3 children in Scope
/*6550*/        OPC_CheckPredicate, 0, // Predicate_immSExt16
/*6552*/        OPC_EmitConvertToTarget, 0,
/*6554*/        OPC_MorphNodeTo, TARGET_VAL(PPC::LI), 0,
                    1/*#VTs*/, MVT::i32, 1/*#Ops*/, 1, 
                // Src: (imm:i32)<<P:Predicate_immSExt16>>:$imm - Complexity = 4
                // Dst: (LI:i32 (imm:i32):$imm)
/*6562*/      /*Scope*/ 15, /*->6578*/
/*6563*/        OPC_CheckPredicate, 1, // Predicate_imm16ShiftedSExt
/*6565*/        OPC_EmitConvertToTarget, 0,
/*6567*/        OPC_EmitNodeXForm, 0, 1, // HI16
/*6570*/        OPC_MorphNodeTo, TARGET_VAL(PPC::LIS), 0,
                    1/*#VTs*/, MVT::i32, 1/*#Ops*/, 2, 
                // Src: (imm:i32)<<P:Predicate_imm16ShiftedSExt>><<X:HI16>>:$imm - Complexity = 4
                // Dst: (LIS:i32 (HI16:i32 (imm:i32):$imm))
/*6578*/      /*Scope*/ 27, /*->6606*/
/*6579*/        OPC_EmitConvertToTarget, 0,
/*6581*/        OPC_EmitNodeXForm, 0, 1, // HI16
/*6584*/        OPC_EmitNode, TARGET_VAL(PPC::LIS), 0,
                    1/*#VTs*/, MVT::i32, 1/*#Ops*/, 2,  // Results = #3 
/*6592*/        OPC_EmitConvertToTarget, 0,
/*6594*/        OPC_EmitNodeXForm, 1, 4, // LO16
/*6597*/        OPC_MorphNodeTo, TARGET_VAL(PPC::ORI), 0,
                    1/*#VTs*/, MVT::i32, 2/*#Ops*/, 3, 5, 
                // Src: (imm:i32):$imm - Complexity = 3
                // Dst: (ORI:i32 (LIS:i32 (HI16:i32 (imm:i32):$imm)), (LO16:i32 (imm:i32):$imm))
/*6606*/      0, /*End of Scope*/
            /*SwitchType*/ 31,  MVT::i64,// ->6640
/*6609*/      OPC_Scope, 12, /*->6623*/ // 2 children in Scope
/*6611*/        OPC_CheckPredicate, 0, // Predicate_immSExt16
/*6613*/        OPC_EmitConvertToTarget, 0,
/*6615*/        OPC_MorphNodeTo, TARGET_VAL(PPC::LI8), 0,
                    1/*#VTs*/, MVT::i64, 1/*#Ops*/, 1, 
                // Src: (imm:i64)<<P:Predicate_immSExt16>>:$imm - Complexity = 4
                // Dst: (LI8:i64 (imm:i64):$imm)
/*6623*/      /*Scope*/ 15, /*->6639*/
/*6624*/        OPC_CheckPredicate, 1, // Predicate_imm16ShiftedSExt
/*6626*/        OPC_EmitConvertToTarget, 0,
/*6628*/        OPC_EmitNodeXForm, 0, 1, // HI16
/*6631*/        OPC_MorphNodeTo, TARGET_VAL(PPC::LIS8), 0,
                    1/*#VTs*/, MVT::i64, 1/*#Ops*/, 2, 
                // Src: (imm:i64)<<P:Predicate_imm16ShiftedSExt>><<X:HI16>>:$imm - Complexity = 4
                // Dst: (LIS8:i64 (HI16:i64 (imm:i64):$imm))
/*6639*/      0, /*End of Scope*/
            0, // EndSwitchType
          /*SwitchOpcode*/ 28,  TARGET_VAL(PPCISD::SHL),// ->6672
/*6644*/    OPC_RecordChild0, // #0 = $rS
/*6645*/    OPC_RecordChild1, // #1 = $rB
/*6646*/    OPC_CheckChild1Type, MVT::i32,
/*6648*/    OPC_SwitchType /*2 cases */, 9,  MVT::i32,// ->6660
/*6651*/      OPC_MorphNodeTo, TARGET_VAL(PPC::SLW), 0,
                  1/*#VTs*/, MVT::i32, 2/*#Ops*/, 0, 1, 
              // Src: (PPCshl:i32 GPRC:i32:$rS, GPRC:i32:$rB) - Complexity = 3
              // Dst: (SLW:i32 GPRC:i32:$rS, GPRC:i32:$rB)
            /*SwitchType*/ 9,  MVT::i64,// ->6671
/*6662*/      OPC_MorphNodeTo, TARGET_VAL(PPC::SLD), 0,
                  1/*#VTs*/, MVT::i64, 2/*#Ops*/, 0, 1, 
              // Src: (PPCshl:i64 G8RC:i64:$rS, GPRC:i32:$rB) - Complexity = 3
              // Dst: (SLD:i64 G8RC:i64:$rS, GPRC:i32:$rB)
            0, // EndSwitchType
          /*SwitchOpcode*/ 28,  TARGET_VAL(PPCISD::SRL),// ->6703
/*6675*/    OPC_RecordChild0, // #0 = $rS
/*6676*/    OPC_RecordChild1, // #1 = $rB
/*6677*/    OPC_CheckChild1Type, MVT::i32,
/*6679*/    OPC_SwitchType /*2 cases */, 9,  MVT::i32,// ->6691
/*6682*/      OPC_MorphNodeTo, TARGET_VAL(PPC::SRW), 0,
                  1/*#VTs*/, MVT::i32, 2/*#Ops*/, 0, 1, 
              // Src: (PPCsrl:i32 GPRC:i32:$rS, GPRC:i32:$rB) - Complexity = 3
              // Dst: (SRW:i32 GPRC:i32:$rS, GPRC:i32:$rB)
            /*SwitchType*/ 9,  MVT::i64,// ->6702
/*6693*/      OPC_MorphNodeTo, TARGET_VAL(PPC::SRD), 0,
                  1/*#VTs*/, MVT::i64, 2/*#Ops*/, 0, 1, 
              // Src: (PPCsrl:i64 G8RC:i64:$rS, GPRC:i32:$rB) - Complexity = 3
              // Dst: (SRD:i64 G8RC:i64:$rS, GPRC:i32:$rB)
            0, // EndSwitchType
          /*SwitchOpcode*/ 30,  TARGET_VAL(PPCISD::SRA),// ->6736
/*6706*/    OPC_RecordChild0, // #0 = $rS
/*6707*/    OPC_RecordChild1, // #1 = $rB
/*6708*/    OPC_CheckChild1Type, MVT::i32,
/*6710*/    OPC_SwitchType /*2 cases */, 10,  MVT::i32,// ->6723
/*6713*/      OPC_MorphNodeTo, TARGET_VAL(PPC::SRAW), 0,
                  2/*#VTs*/, MVT::i32, MVT::i32, 2/*#Ops*/, 0, 1, 
              // Src: (PPCsra:i32 GPRC:i32:$rS, GPRC:i32:$rB) - Complexity = 3
              // Dst: (SRAW:i32:i32 GPRC:i32:$rS, GPRC:i32:$rB)
            /*SwitchType*/ 10,  MVT::i64,// ->6735
/*6725*/      OPC_MorphNodeTo, TARGET_VAL(PPC::SRAD), 0,
                  2/*#VTs*/, MVT::i64, MVT::i32, 2/*#Ops*/, 0, 1, 
              // Src: (PPCsra:i64 G8RC:i64:$rS, GPRC:i32:$rB) - Complexity = 3
              // Dst: (SRAD:i64:i32 G8RC:i64:$rS, GPRC:i32:$rB)
            0, // EndSwitchType
          /*SwitchOpcode*/ 23,  TARGET_VAL(ISD::CTLZ),// ->6762
/*6739*/    OPC_RecordChild0, // #0 = $rS
/*6740*/    OPC_SwitchType /*2 cases */, 8,  MVT::i32,// ->6751
/*6743*/      OPC_MorphNodeTo, TARGET_VAL(PPC::CNTLZW), 0,
                  1/*#VTs*/, MVT::i32, 1/*#Ops*/, 0, 
              // Src: (ctlz:i32 GPRC:i32:$rS) - Complexity = 3
              // Dst: (CNTLZW:i32 GPRC:i32:$rS)
            /*SwitchType*/ 8,  MVT::i64,// ->6761
/*6753*/      OPC_MorphNodeTo, TARGET_VAL(PPC::CNTLZD), 0,
                  1/*#VTs*/, MVT::i64, 1/*#Ops*/, 0, 
              // Src: (ctlz:i64 G8RC:i64:$rS) - Complexity = 3
              // Dst: (CNTLZD:i64 G8RC:i64:$rS)
            0, // EndSwitchType
          /*SwitchOpcode*/ 69,  TARGET_VAL(ISD::SIGN_EXTEND_INREG),// ->6834
/*6765*/    OPC_RecordChild0, // #0 = $rS
/*6766*/    OPC_MoveChild, 1,
/*6768*/    OPC_Scope, 25, /*->6795*/ // 3 children in Scope
/*6770*/      OPC_CheckValueType, MVT::i8,
/*6772*/      OPC_MoveParent,
/*6773*/      OPC_SwitchType /*2 cases */, 8,  MVT::i32,// ->6784
/*6776*/        OPC_MorphNodeTo, TARGET_VAL(PPC::EXTSB), 0,
                    1/*#VTs*/, MVT::i32, 1/*#Ops*/, 0, 
                // Src: (sext_inreg:i32 GPRC:i32:$rS, i8:Other) - Complexity = 3
                // Dst: (EXTSB:i32 GPRC:i32:$rS)
              /*SwitchType*/ 8,  MVT::i64,// ->6794
/*6786*/        OPC_MorphNodeTo, TARGET_VAL(PPC::EXTSB8), 0,
                    1/*#VTs*/, MVT::i64, 1/*#Ops*/, 0, 
                // Src: (sext_inreg:i64 G8RC:i64:$rS, i8:Other) - Complexity = 3
                // Dst: (EXTSB8:i64 G8RC:i64:$rS)
              0, // EndSwitchType
/*6795*/    /*Scope*/ 25, /*->6821*/
/*6796*/      OPC_CheckValueType, MVT::i16,
/*6798*/      OPC_MoveParent,
/*6799*/      OPC_SwitchType /*2 cases */, 8,  MVT::i32,// ->6810
/*6802*/        OPC_MorphNodeTo, TARGET_VAL(PPC::EXTSH), 0,
                    1/*#VTs*/, MVT::i32, 1/*#Ops*/, 0, 
                // Src: (sext_inreg:i32 GPRC:i32:$rS, i16:Other) - Complexity = 3
                // Dst: (EXTSH:i32 GPRC:i32:$rS)
              /*SwitchType*/ 8,  MVT::i64,// ->6820
/*6812*/        OPC_MorphNodeTo, TARGET_VAL(PPC::EXTSH8), 0,
                    1/*#VTs*/, MVT::i64, 1/*#Ops*/, 0, 
                // Src: (sext_inreg:i64 G8RC:i64:$rS, i16:Other) - Complexity = 3
                // Dst: (EXTSH8:i64 G8RC:i64:$rS)
              0, // EndSwitchType
/*6821*/    /*Scope*/ 11, /*->6833*/
/*6822*/      OPC_CheckValueType, MVT::i32,
/*6824*/      OPC_MoveParent,
/*6825*/      OPC_MorphNodeTo, TARGET_VAL(PPC::EXTSW), 0,
                  1/*#VTs*/, MVT::i64, 1/*#Ops*/, 0, 
              // Src: (sext_inreg:i64 G8RC:i64:$rS, i32:Other) - Complexity = 3
              // Dst: (EXTSW:i64 G8RC:i64:$rS)
/*6833*/    0, /*End of Scope*/
          /*SwitchOpcode*/ 26,  TARGET_VAL(ISD::SDIV),// ->6863
/*6837*/    OPC_RecordChild0, // #0 = $rA
/*6838*/    OPC_RecordChild1, // #1 = $rB
/*6839*/    OPC_SwitchType /*2 cases */, 9,  MVT::i32,// ->6851
/*6842*/      OPC_MorphNodeTo, TARGET_VAL(PPC::DIVW), 0,
                  1/*#VTs*/, MVT::i32, 2/*#Ops*/, 0, 1, 
              // Src: (sdiv:i32 GPRC:i32:$rA, GPRC:i32:$rB) - Complexity = 3
              // Dst: (DIVW:i32 GPRC:i32:$rA, GPRC:i32:$rB)
            /*SwitchType*/ 9,  MVT::i64,// ->6862
/*6853*/      OPC_MorphNodeTo, TARGET_VAL(PPC::DIVD), 0,
                  1/*#VTs*/, MVT::i64, 2/*#Ops*/, 0, 1, 
              // Src: (sdiv:i64 G8RC:i64:$rA, G8RC:i64:$rB) - Complexity = 3
              // Dst: (DIVD:i64 G8RC:i64:$rA, G8RC:i64:$rB)
            0, // EndSwitchType
          /*SwitchOpcode*/ 26,  TARGET_VAL(ISD::UDIV),// ->6892
/*6866*/    OPC_RecordChild0, // #0 = $rA
/*6867*/    OPC_RecordChild1, // #1 = $rB
/*6868*/    OPC_SwitchType /*2 cases */, 9,  MVT::i32,// ->6880
/*6871*/      OPC_MorphNodeTo, TARGET_VAL(PPC::DIVWU), 0,
                  1/*#VTs*/, MVT::i32, 2/*#Ops*/, 0, 1, 
              // Src: (udiv:i32 GPRC:i32:$rA, GPRC:i32:$rB) - Complexity = 3
              // Dst: (DIVWU:i32 GPRC:i32:$rA, GPRC:i32:$rB)
            /*SwitchType*/ 9,  MVT::i64,// ->6891
/*6882*/      OPC_MorphNodeTo, TARGET_VAL(PPC::DIVDU), 0,
                  1/*#VTs*/, MVT::i64, 2/*#Ops*/, 0, 1, 
              // Src: (udiv:i64 G8RC:i64:$rA, G8RC:i64:$rB) - Complexity = 3
              // Dst: (DIVDU:i64 G8RC:i64:$rA, G8RC:i64:$rB)
            0, // EndSwitchType
          /*SwitchOpcode*/ 26,  TARGET_VAL(ISD::MULHS),// ->6921
/*6895*/    OPC_RecordChild0, // #0 = $rA
/*6896*/    OPC_RecordChild1, // #1 = $rB
/*6897*/    OPC_SwitchType /*2 cases */, 9,  MVT::i32,// ->6909
/*6900*/      OPC_MorphNodeTo, TARGET_VAL(PPC::MULHW), 0,
                  1/*#VTs*/, MVT::i32, 2/*#Ops*/, 0, 1, 
              // Src: (mulhs:i32 GPRC:i32:$rA, GPRC:i32:$rB) - Complexity = 3
              // Dst: (MULHW:i32 GPRC:i32:$rA, GPRC:i32:$rB)
            /*SwitchType*/ 9,  MVT::i64,// ->6920
/*6911*/      OPC_MorphNodeTo, TARGET_VAL(PPC::MULHD), 0,
                  1/*#VTs*/, MVT::i64, 2/*#Ops*/, 0, 1, 
              // Src: (mulhs:i64 G8RC:i64:$rA, G8RC:i64:$rB) - Complexity = 3
              // Dst: (MULHD:i64 G8RC:i64:$rA, G8RC:i64:$rB)
            0, // EndSwitchType
          /*SwitchOpcode*/ 26,  TARGET_VAL(ISD::MULHU),// ->6950
/*6924*/    OPC_RecordChild0, // #0 = $rA
/*6925*/    OPC_RecordChild1, // #1 = $rB
/*6926*/    OPC_SwitchType /*2 cases */, 9,  MVT::i32,// ->6938
/*6929*/      OPC_MorphNodeTo, TARGET_VAL(PPC::MULHWU), 0,
                  1/*#VTs*/, MVT::i32, 2/*#Ops*/, 0, 1, 
              // Src: (mulhu:i32 GPRC:i32:$rA, GPRC:i32:$rB) - Complexity = 3
              // Dst: (MULHWU:i32 GPRC:i32:$rA, GPRC:i32:$rB)
            /*SwitchType*/ 9,  MVT::i64,// ->6949
/*6940*/      OPC_MorphNodeTo, TARGET_VAL(PPC::MULHDU), 0,
                  1/*#VTs*/, MVT::i64, 2/*#Ops*/, 0, 1, 
              // Src: (mulhu:i64 G8RC:i64:$rA, G8RC:i64:$rB) - Complexity = 3
              // Dst: (MULHDU:i64 G8RC:i64:$rA, G8RC:i64:$rB)
            0, // EndSwitchType
          /*SwitchOpcode*/ 11,  TARGET_VAL(PPCISD::EXTSW_32),// ->6964
/*6953*/    OPC_RecordChild0, // #0 = $rS
/*6954*/    OPC_CheckType, MVT::i32,
/*6956*/    OPC_MorphNodeTo, TARGET_VAL(PPC::EXTSW_32), 0,
                1/*#VTs*/, MVT::i32, 1/*#Ops*/, 0, 
            // Src: (PPCextsw_32:i32 GPRC:i32:$rS) - Complexity = 3
            // Dst: (EXTSW_32:i32 GPRC:i32:$rS)
          /*SwitchOpcode*/ 13,  TARGET_VAL(ISD::SIGN_EXTEND),// ->6980
/*6967*/    OPC_RecordChild0, // #0 = $rS
/*6968*/    OPC_CheckChild0Type, MVT::i32,
/*6970*/    OPC_CheckType, MVT::i64,
/*6972*/    OPC_MorphNodeTo, TARGET_VAL(PPC::EXTSW_32_64), 0,
                1/*#VTs*/, MVT::i64, 1/*#Ops*/, 0, 
            // Src: (sext:i64 GPRC:i32:$rS) - Complexity = 3
            // Dst: (EXTSW_32_64:i64 GPRC:i32:$rS)
          /*SwitchOpcode*/ 15,  TARGET_VAL(ISD::TRUNCATE),// ->6998
/*6983*/    OPC_RecordChild0, // #0 = $in
/*6984*/    OPC_CheckType, MVT::i32,
/*6986*/    OPC_EmitInteger, MVT::i32, PPC::sub_32,
/*6989*/    OPC_MorphNodeTo, TARGET_VAL(TargetOpcode::EXTRACT_SUBREG), 0,
                1/*#VTs*/, MVT::i32, 2/*#Ops*/, 0, 1, 
            // Src: (trunc:i32 G8RC:i64:$in) - Complexity = 3
            // Dst: (EXTRACT_SUBREG:i32 G8RC:i64:$in, sub_32:i32)
          /*SwitchOpcode*/ 25,  TARGET_VAL(ISD::ANY_EXTEND),// ->7026
/*7001*/    OPC_RecordChild0, // #0 = $in
/*7002*/    OPC_CheckChild0Type, MVT::i32,
/*7004*/    OPC_CheckType, MVT::i64,
/*7006*/    OPC_EmitNode, TARGET_VAL(TargetOpcode::IMPLICIT_DEF), 0,
                1/*#VTs*/, MVT::i64, 0/*#Ops*/,  // Results = #1 
/*7013*/    OPC_EmitInteger, MVT::i32, PPC::sub_32,
/*7016*/    OPC_MorphNodeTo, TARGET_VAL(TargetOpcode::INSERT_SUBREG), 0,
                1/*#VTs*/, MVT::i64, 3/*#Ops*/, 1, 0, 2, 
            // Src: (anyext:i64 GPRC:i32:$in) - Complexity = 3
            // Dst: (INSERT_SUBREG:i64 (IMPLICIT_DEF:i64), GPRC:i32:$in, sub_32:i32)
          /*SwitchOpcode*/ 41,  TARGET_VAL(ISD::ZERO_EXTEND),// ->7070
/*7029*/    OPC_RecordChild0, // #0 = $in
/*7030*/    OPC_CheckChild0Type, MVT::i32,
/*7032*/    OPC_CheckType, MVT::i64,
/*7034*/    OPC_EmitNode, TARGET_VAL(TargetOpcode::IMPLICIT_DEF), 0,
                1/*#VTs*/, MVT::i64, 0/*#Ops*/,  // Results = #1 
/*7041*/    OPC_EmitInteger, MVT::i32, PPC::sub_32,
/*7044*/    OPC_EmitNode, TARGET_VAL(TargetOpcode::INSERT_SUBREG), 0,
                1/*#VTs*/, MVT::i64, 3/*#Ops*/, 1, 0, 2,  // Results = #3 
/*7054*/    OPC_EmitInteger, MVT::i32, 0, 
/*7057*/    OPC_EmitInteger, MVT::i32, 32, 
/*7060*/    OPC_MorphNodeTo, TARGET_VAL(PPC::RLDICL), 0,
                1/*#VTs*/, MVT::i64, 3/*#Ops*/, 3, 4, 5, 
            // Src: (zext:i64 GPRC:i32:$in) - Complexity = 3
            // Dst: (RLDICL:i64 (INSERT_SUBREG:i64 (IMPLICIT_DEF:i64), GPRC:i32:$in, sub_32:i32), 0:i32, 32:i32)
          /*SwitchOpcode*/ 61|128,1/*189*/,  TARGET_VAL(ISD::FNEG),// ->7263
/*7074*/    OPC_Scope, 33|128,1/*161*/, /*->7238*/ // 2 children in Scope
/*7077*/      OPC_MoveChild, 0,
/*7079*/      OPC_SwitchOpcode /*3 cases */, 84,  TARGET_VAL(ISD::FADD),// ->7167
/*7083*/        OPC_Scope, 40, /*->7125*/ // 2 children in Scope
/*7085*/          OPC_MoveChild, 0,
/*7087*/          OPC_CheckOpcode, TARGET_VAL(ISD::FMUL),
/*7090*/          OPC_RecordChild0, // #0 = $FRA
/*7091*/          OPC_RecordChild1, // #1 = $FRC
/*7092*/          OPC_MoveParent,
/*7093*/          OPC_RecordChild1, // #2 = $FRB
/*7094*/          OPC_MoveParent,
/*7095*/          OPC_SwitchType /*2 cases */, 12,  MVT::f64,// ->7110
/*7098*/            OPC_CheckPatternPredicate, 0, // (!TM.Options.NoExcessFPPrecision)
/*7100*/            OPC_MorphNodeTo, TARGET_VAL(PPC::FNMADD), 0,
                        1/*#VTs*/, MVT::f64, 3/*#Ops*/, 0, 1, 2, 
                    // Src: (fneg:f64 (fadd:f64 (fmul:f64 F8RC:f64:$FRA, F8RC:f64:$FRC), F8RC:f64:$FRB)) - Complexity = 9
                    // Dst: (FNMADD:f64 F8RC:f64:$FRA, F8RC:f64:$FRC, F8RC:f64:$FRB)
                  /*SwitchType*/ 12,  MVT::f32,// ->7124
/*7112*/            OPC_CheckPatternPredicate, 0, // (!TM.Options.NoExcessFPPrecision)
/*7114*/            OPC_MorphNodeTo, TARGET_VAL(PPC::FNMADDS), 0,
                        1/*#VTs*/, MVT::f32, 3/*#Ops*/, 0, 1, 2, 
                    // Src: (fneg:f32 (fadd:f32 (fmul:f32 F4RC:f32:$FRA, F4RC:f32:$FRC), F4RC:f32:$FRB)) - Complexity = 9
                    // Dst: (FNMADDS:f32 F4RC:f32:$FRA, F4RC:f32:$FRC, F4RC:f32:$FRB)
                  0, // EndSwitchType
/*7125*/        /*Scope*/ 40, /*->7166*/
/*7126*/          OPC_RecordChild0, // #0 = $FRB
/*7127*/          OPC_MoveChild, 1,
/*7129*/          OPC_CheckOpcode, TARGET_VAL(ISD::FMUL),
/*7132*/          OPC_RecordChild0, // #1 = $FRA
/*7133*/          OPC_RecordChild1, // #2 = $FRC
/*7134*/          OPC_MoveParent,
/*7135*/          OPC_MoveParent,
/*7136*/          OPC_SwitchType /*2 cases */, 12,  MVT::f64,// ->7151
/*7139*/            OPC_CheckPatternPredicate, 0, // (!TM.Options.NoExcessFPPrecision)
/*7141*/            OPC_MorphNodeTo, TARGET_VAL(PPC::FNMADD), 0,
                        1/*#VTs*/, MVT::f64, 3/*#Ops*/, 1, 2, 0, 
                    // Src: (fneg:f64 (fadd:f64 F8RC:f64:$FRB, (fmul:f64 F8RC:f64:$FRA, F8RC:f64:$FRC))) - Complexity = 9
                    // Dst: (FNMADD:f64 F8RC:f64:$FRA, F8RC:f64:$FRC, F8RC:f64:$FRB)
                  /*SwitchType*/ 12,  MVT::f32,// ->7165
/*7153*/            OPC_CheckPatternPredicate, 0, // (!TM.Options.NoExcessFPPrecision)
/*7155*/            OPC_MorphNodeTo, TARGET_VAL(PPC::FNMADDS), 0,
                        1/*#VTs*/, MVT::f32, 3/*#Ops*/, 1, 2, 0, 
                    // Src: (fneg:f32 (fadd:f32 F4RC:f32:$FRB, (fmul:f32 F4RC:f32:$FRA, F4RC:f32:$FRC))) - Complexity = 9
                    // Dst: (FNMADDS:f32 F4RC:f32:$FRA, F4RC:f32:$FRC, F4RC:f32:$FRB)
                  0, // EndSwitchType
/*7166*/        0, /*End of Scope*/
              /*SwitchOpcode*/ 40,  TARGET_VAL(ISD::FSUB),// ->7210
/*7170*/        OPC_MoveChild, 0,
/*7172*/        OPC_CheckOpcode, TARGET_VAL(ISD::FMUL),
/*7175*/        OPC_RecordChild0, // #0 = $FRA
/*7176*/        OPC_RecordChild1, // #1 = $FRC
/*7177*/        OPC_MoveParent,
/*7178*/        OPC_RecordChild1, // #2 = $FRB
/*7179*/        OPC_MoveParent,
/*7180*/        OPC_SwitchType /*2 cases */, 12,  MVT::f64,// ->7195
/*7183*/          OPC_CheckPatternPredicate, 0, // (!TM.Options.NoExcessFPPrecision)
/*7185*/          OPC_MorphNodeTo, TARGET_VAL(PPC::FNMSUB), 0,
                      1/*#VTs*/, MVT::f64, 3/*#Ops*/, 0, 1, 2, 
                  // Src: (fneg:f64 (fsub:f64 (fmul:f64 F8RC:f64:$FRA, F8RC:f64:$FRC), F8RC:f64:$FRB)) - Complexity = 9
                  // Dst: (FNMSUB:f64 F8RC:f64:$FRA, F8RC:f64:$FRC, F8RC:f64:$FRB)
                /*SwitchType*/ 12,  MVT::f32,// ->7209
/*7197*/          OPC_CheckPatternPredicate, 0, // (!TM.Options.NoExcessFPPrecision)
/*7199*/          OPC_MorphNodeTo, TARGET_VAL(PPC::FNMSUBS), 0,
                      1/*#VTs*/, MVT::f32, 3/*#Ops*/, 0, 1, 2, 
                  // Src: (fneg:f32 (fsub:f32 (fmul:f32 F4RC:f32:$FRA, F4RC:f32:$FRC), F4RC:f32:$FRB)) - Complexity = 9
                  // Dst: (FNMSUBS:f32 F4RC:f32:$FRA, F4RC:f32:$FRC, F4RC:f32:$FRB)
                0, // EndSwitchType
              /*SwitchOpcode*/ 24,  TARGET_VAL(ISD::FABS),// ->7237
/*7213*/        OPC_RecordChild0, // #0 = $frB
/*7214*/        OPC_MoveParent,
/*7215*/        OPC_SwitchType /*2 cases */, 8,  MVT::f32,// ->7226
/*7218*/          OPC_MorphNodeTo, TARGET_VAL(PPC::FNABSS), 0,
                      1/*#VTs*/, MVT::f32, 1/*#Ops*/, 0, 
                  // Src: (fneg:f32 (fabs:f32 F4RC:f32:$frB)) - Complexity = 6
                  // Dst: (FNABSS:f32 F4RC:f32:$frB)
                /*SwitchType*/ 8,  MVT::f64,// ->7236
/*7228*/          OPC_MorphNodeTo, TARGET_VAL(PPC::FNABSD), 0,
                      1/*#VTs*/, MVT::f64, 1/*#Ops*/, 0, 
                  // Src: (fneg:f64 (fabs:f64 F8RC:f64:$frB)) - Complexity = 6
                  // Dst: (FNABSD:f64 F8RC:f64:$frB)
                0, // EndSwitchType
              0, // EndSwitchOpcode
/*7238*/    /*Scope*/ 23, /*->7262*/
/*7239*/      OPC_RecordChild0, // #0 = $frB
/*7240*/      OPC_SwitchType /*2 cases */, 8,  MVT::f32,// ->7251
/*7243*/        OPC_MorphNodeTo, TARGET_VAL(PPC::FNEGS), 0,
                    1/*#VTs*/, MVT::f32, 1/*#Ops*/, 0, 
                // Src: (fneg:f32 F4RC:f32:$frB) - Complexity = 3
                // Dst: (FNEGS:f32 F4RC:f32:$frB)
              /*SwitchType*/ 8,  MVT::f64,// ->7261
/*7253*/        OPC_MorphNodeTo, TARGET_VAL(PPC::FNEGD), 0,
                    1/*#VTs*/, MVT::f64, 1/*#Ops*/, 0, 
                // Src: (fneg:f64 F8RC:f64:$frB) - Complexity = 3
                // Dst: (FNEGD:f64 F8RC:f64:$frB)
              0, // EndSwitchType
/*7262*/    0, /*End of Scope*/
          /*SwitchOpcode*/ 24,  TARGET_VAL(PPCISD::MTFSF),// ->7290
/*7266*/    OPC_CaptureGlueInput,
/*7267*/    OPC_RecordChild0, // #0 = $FM
/*7268*/    OPC_MoveChild, 0,
/*7270*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/*7273*/    OPC_CheckType, MVT::i32,
/*7275*/    OPC_MoveParent,
/*7276*/    OPC_RecordChild1, // #1 = $rT
/*7277*/    OPC_RecordChild2, // #2 = $FRB
/*7278*/    OPC_EmitConvertToTarget, 0,
/*7280*/    OPC_MorphNodeTo, TARGET_VAL(PPC::MTFSF), 0|OPFL_GlueInput,
                1/*#VTs*/, MVT::f64, 3/*#Ops*/, 3, 1, 2, 
            // Src: (PPCmtfsf:f64 (imm:i32):$FM, F8RC:f64:$rT, F8RC:f64:$FRB) - Complexity = 6
            // Dst: (MTFSF:f64 (imm:i32):$FM, F8RC:f64:$rT, F8RC:f64:$FRB)
          /*SwitchOpcode*/ 47|128,1/*175*/,  TARGET_VAL(ISD::FADD),// ->7469
/*7294*/    OPC_Scope, 39, /*->7335*/ // 4 children in Scope
/*7296*/      OPC_MoveChild, 0,
/*7298*/      OPC_CheckOpcode, TARGET_VAL(ISD::FMUL),
/*7301*/      OPC_RecordChild0, // #0 = $FRA
/*7302*/      OPC_RecordChild1, // #1 = $FRC
/*7303*/      OPC_MoveParent,
/*7304*/      OPC_RecordChild1, // #2 = $FRB
/*7305*/      OPC_SwitchType /*2 cases */, 12,  MVT::f64,// ->7320
/*7308*/        OPC_CheckPatternPredicate, 0, // (!TM.Options.NoExcessFPPrecision)
/*7310*/        OPC_MorphNodeTo, TARGET_VAL(PPC::FMADD), 0,
                    1/*#VTs*/, MVT::f64, 3/*#Ops*/, 0, 1, 2, 
                // Src: (fadd:f64 (fmul:f64 F8RC:f64:$FRA, F8RC:f64:$FRC), F8RC:f64:$FRB) - Complexity = 6
                // Dst: (FMADD:f64 F8RC:f64:$FRA, F8RC:f64:$FRC, F8RC:f64:$FRB)
              /*SwitchType*/ 12,  MVT::f32,// ->7334
/*7322*/        OPC_CheckPatternPredicate, 0, // (!TM.Options.NoExcessFPPrecision)
/*7324*/        OPC_MorphNodeTo, TARGET_VAL(PPC::FMADDS), 0,
                    1/*#VTs*/, MVT::f32, 3/*#Ops*/, 0, 1, 2, 
                // Src: (fadd:f32 (fmul:f32 F4RC:f32:$FRA, F4RC:f32:$FRC), F4RC:f32:$FRB) - Complexity = 6
                // Dst: (FMADDS:f32 F4RC:f32:$FRA, F4RC:f32:$FRC, F4RC:f32:$FRB)
              0, // EndSwitchType
/*7335*/    /*Scope*/ 68, /*->7404*/
/*7336*/      OPC_RecordChild0, // #0 = $FRB
/*7337*/      OPC_Scope, 38, /*->7377*/ // 2 children in Scope
/*7339*/        OPC_MoveChild, 1,
/*7341*/        OPC_CheckOpcode, TARGET_VAL(ISD::FMUL),
/*7344*/        OPC_RecordChild0, // #1 = $FRA
/*7345*/        OPC_RecordChild1, // #2 = $FRC
/*7346*/        OPC_MoveParent,
/*7347*/        OPC_SwitchType /*2 cases */, 12,  MVT::f64,// ->7362
/*7350*/          OPC_CheckPatternPredicate, 0, // (!TM.Options.NoExcessFPPrecision)
/*7352*/          OPC_MorphNodeTo, TARGET_VAL(PPC::FMADD), 0,
                      1/*#VTs*/, MVT::f64, 3/*#Ops*/, 1, 2, 0, 
                  // Src: (fadd:f64 F8RC:f64:$FRB, (fmul:f64 F8RC:f64:$FRA, F8RC:f64:$FRC)) - Complexity = 6
                  // Dst: (FMADD:f64 F8RC:f64:$FRA, F8RC:f64:$FRC, F8RC:f64:$FRB)
                /*SwitchType*/ 12,  MVT::f32,// ->7376
/*7364*/          OPC_CheckPatternPredicate, 0, // (!TM.Options.NoExcessFPPrecision)
/*7366*/          OPC_MorphNodeTo, TARGET_VAL(PPC::FMADDS), 0,
                      1/*#VTs*/, MVT::f32, 3/*#Ops*/, 1, 2, 0, 
                  // Src: (fadd:f32 F4RC:f32:$FRB, (fmul:f32 F4RC:f32:$FRA, F4RC:f32:$FRC)) - Complexity = 6
                  // Dst: (FMADDS:f32 F4RC:f32:$FRA, F4RC:f32:$FRC, F4RC:f32:$FRB)
                0, // EndSwitchType
/*7377*/      /*Scope*/ 25, /*->7403*/
/*7378*/        OPC_RecordChild1, // #1 = $FRB
/*7379*/        OPC_SwitchType /*2 cases */, 9,  MVT::f64,// ->7391
/*7382*/          OPC_MorphNodeTo, TARGET_VAL(PPC::FADD), 0,
                      1/*#VTs*/, MVT::f64, 2/*#Ops*/, 0, 1, 
                  // Src: (fadd:f64 F8RC:f64:$FRA, F8RC:f64:$FRB) - Complexity = 3
                  // Dst: (FADD:f64 F8RC:f64:$FRA, F8RC:f64:$FRB)
                /*SwitchType*/ 9,  MVT::f32,// ->7402
/*7393*/          OPC_MorphNodeTo, TARGET_VAL(PPC::FADDS), 0,
                      1/*#VTs*/, MVT::f32, 2/*#Ops*/, 0, 1, 
                  // Src: (fadd:f32 F4RC:f32:$FRA, F4RC:f32:$FRB) - Complexity = 3
                  // Dst: (FADDS:f32 F4RC:f32:$FRA, F4RC:f32:$FRB)
                0, // EndSwitchType
/*7403*/      0, /*End of Scope*/
/*7404*/    /*Scope*/ 23, /*->7428*/
/*7405*/      OPC_MoveChild, 0,
/*7407*/      OPC_CheckOpcode, TARGET_VAL(ISD::FMUL),
/*7410*/      OPC_RecordChild0, // #0 = $vA
/*7411*/      OPC_RecordChild1, // #1 = $vC
/*7412*/      OPC_MoveParent,
/*7413*/      OPC_RecordChild1, // #2 = $vB
/*7414*/      OPC_CheckType, MVT::v4f32,
/*7416*/      OPC_CheckPatternPredicate, 0, // (!TM.Options.NoExcessFPPrecision)
/*7418*/      OPC_MorphNodeTo, TARGET_VAL(PPC::VMADDFP), 0,
                  1/*#VTs*/, MVT::v4f32, 3/*#Ops*/, 0, 1, 2, 
              // Src: (fadd:v4f32 (fmul:v4f32 VRRC:v4f32:$vA, VRRC:v4f32:$vC), VRRC:v4f32:$vB) - Complexity = 6
              // Dst: (VMADDFP:v4f32 VRRC:v4f32:$vA, VRRC:v4f32:$vC, VRRC:v4f32:$vB)
/*7428*/    /*Scope*/ 39, /*->7468*/
/*7429*/      OPC_RecordChild0, // #0 = $vB
/*7430*/      OPC_Scope, 22, /*->7454*/ // 2 children in Scope
/*7432*/        OPC_MoveChild, 1,
/*7434*/        OPC_CheckOpcode, TARGET_VAL(ISD::FMUL),
/*7437*/        OPC_RecordChild0, // #1 = $vA
/*7438*/        OPC_RecordChild1, // #2 = $vC
/*7439*/        OPC_MoveParent,
/*7440*/        OPC_CheckType, MVT::v4f32,
/*7442*/        OPC_CheckPatternPredicate, 0, // (!TM.Options.NoExcessFPPrecision)
/*7444*/        OPC_MorphNodeTo, TARGET_VAL(PPC::VMADDFP), 0,
                    1/*#VTs*/, MVT::v4f32, 3/*#Ops*/, 1, 2, 0, 
                // Src: (fadd:v4f32 VRRC:v4f32:$vB, (fmul:v4f32 VRRC:v4f32:$vA, VRRC:v4f32:$vC)) - Complexity = 6
                // Dst: (VMADDFP:v4f32 VRRC:v4f32:$vA, VRRC:v4f32:$vC, VRRC:v4f32:$vB)
/*7454*/      /*Scope*/ 12, /*->7467*/
/*7455*/        OPC_RecordChild1, // #1 = $vB
/*7456*/        OPC_CheckType, MVT::v4f32,
/*7458*/        OPC_MorphNodeTo, TARGET_VAL(PPC::VADDFP), 0,
                    1/*#VTs*/, MVT::v4f32, 2/*#Ops*/, 0, 1, 
                // Src: (fadd:v4f32 VRRC:v4f32:$vA, VRRC:v4f32:$vB) - Complexity = 3
                // Dst: (VADDFP:v4f32 VRRC:v4f32:$vA, VRRC:v4f32:$vB)
/*7467*/      0, /*End of Scope*/
/*7468*/    0, /*End of Scope*/
          /*SwitchOpcode*/ 35|128,1/*163*/,  TARGET_VAL(ISD::FSUB),// ->7636
/*7473*/    OPC_Scope, 39, /*->7514*/ // 4 children in Scope
/*7475*/      OPC_MoveChild, 0,
/*7477*/      OPC_CheckOpcode, TARGET_VAL(ISD::FMUL),
/*7480*/      OPC_RecordChild0, // #0 = $FRA
/*7481*/      OPC_RecordChild1, // #1 = $FRC
/*7482*/      OPC_MoveParent,
/*7483*/      OPC_RecordChild1, // #2 = $FRB
/*7484*/      OPC_SwitchType /*2 cases */, 12,  MVT::f64,// ->7499
/*7487*/        OPC_CheckPatternPredicate, 0, // (!TM.Options.NoExcessFPPrecision)
/*7489*/        OPC_MorphNodeTo, TARGET_VAL(PPC::FMSUB), 0,
                    1/*#VTs*/, MVT::f64, 3/*#Ops*/, 0, 1, 2, 
                // Src: (fsub:f64 (fmul:f64 F8RC:f64:$FRA, F8RC:f64:$FRC), F8RC:f64:$FRB) - Complexity = 6
                // Dst: (FMSUB:f64 F8RC:f64:$FRA, F8RC:f64:$FRC, F8RC:f64:$FRB)
              /*SwitchType*/ 12,  MVT::f32,// ->7513
/*7501*/        OPC_CheckPatternPredicate, 0, // (!TM.Options.NoExcessFPPrecision)
/*7503*/        OPC_MorphNodeTo, TARGET_VAL(PPC::FMSUBS), 0,
                    1/*#VTs*/, MVT::f32, 3/*#Ops*/, 0, 1, 2, 
                // Src: (fsub:f32 (fmul:f32 F4RC:f32:$FRA, F4RC:f32:$FRC), F4RC:f32:$FRB) - Complexity = 6
                // Dst: (FMSUBS:f32 F4RC:f32:$FRA, F4RC:f32:$FRC, F4RC:f32:$FRB)
              0, // EndSwitchType
/*7514*/    /*Scope*/ 68, /*->7583*/
/*7515*/      OPC_RecordChild0, // #0 = $B
/*7516*/      OPC_Scope, 38, /*->7556*/ // 2 children in Scope
/*7518*/        OPC_MoveChild, 1,
/*7520*/        OPC_CheckOpcode, TARGET_VAL(ISD::FMUL),
/*7523*/        OPC_RecordChild0, // #1 = $A
/*7524*/        OPC_RecordChild1, // #2 = $C
/*7525*/        OPC_MoveParent,
/*7526*/        OPC_SwitchType /*2 cases */, 12,  MVT::f64,// ->7541
/*7529*/          OPC_CheckPatternPredicate, 0, // (!TM.Options.NoExcessFPPrecision)
/*7531*/          OPC_MorphNodeTo, TARGET_VAL(PPC::FNMSUB), 0,
                      1/*#VTs*/, MVT::f64, 3/*#Ops*/, 1, 2, 0, 
                  // Src: (fsub:f64 F8RC:f64:$B, (fmul:f64 F8RC:f64:$A, F8RC:f64:$C)) - Complexity = 6
                  // Dst: (FNMSUB:f64 F8RC:f64:$A, F8RC:f64:$C, F8RC:f64:$B)
                /*SwitchType*/ 12,  MVT::f32,// ->7555
/*7543*/          OPC_CheckPatternPredicate, 0, // (!TM.Options.NoExcessFPPrecision)
/*7545*/          OPC_MorphNodeTo, TARGET_VAL(PPC::FNMSUBS), 0,
                      1/*#VTs*/, MVT::f32, 3/*#Ops*/, 1, 2, 0, 
                  // Src: (fsub:f32 F4RC:f32:$B, (fmul:f32 F4RC:f32:$A, F4RC:f32:$C)) - Complexity = 6
                  // Dst: (FNMSUBS:f32 F4RC:f32:$A, F4RC:f32:$C, F4RC:f32:$B)
                0, // EndSwitchType
/*7556*/      /*Scope*/ 25, /*->7582*/
/*7557*/        OPC_RecordChild1, // #1 = $FRB
/*7558*/        OPC_SwitchType /*2 cases */, 9,  MVT::f64,// ->7570
/*7561*/          OPC_MorphNodeTo, TARGET_VAL(PPC::FSUB), 0,
                      1/*#VTs*/, MVT::f64, 2/*#Ops*/, 0, 1, 
                  // Src: (fsub:f64 F8RC:f64:$FRA, F8RC:f64:$FRB) - Complexity = 3
                  // Dst: (FSUB:f64 F8RC:f64:$FRA, F8RC:f64:$FRB)
                /*SwitchType*/ 9,  MVT::f32,// ->7581
/*7572*/          OPC_MorphNodeTo, TARGET_VAL(PPC::FSUBS), 0,
                      1/*#VTs*/, MVT::f32, 2/*#Ops*/, 0, 1, 
                  // Src: (fsub:f32 F4RC:f32:$FRA, F4RC:f32:$FRB) - Complexity = 3
                  // Dst: (FSUBS:f32 F4RC:f32:$FRA, F4RC:f32:$FRB)
                0, // EndSwitchType
/*7582*/      0, /*End of Scope*/
/*7583*/    /*Scope*/ 37, /*->7621*/
/*7584*/      OPC_MoveChild, 0,
/*7586*/      OPC_CheckOpcode, TARGET_VAL(ISD::BUILD_VECTOR),
/*7589*/      OPC_CheckPredicate, 67, // Predicate_V_immneg0
/*7591*/      OPC_MoveParent,
/*7592*/      OPC_MoveChild, 1,
/*7594*/      OPC_CheckOpcode, TARGET_VAL(ISD::FSUB),
/*7597*/      OPC_MoveChild, 0,
/*7599*/      OPC_CheckOpcode, TARGET_VAL(ISD::FMUL),
/*7602*/      OPC_RecordChild0, // #0 = $vA
/*7603*/      OPC_RecordChild1, // #1 = $vC
/*7604*/      OPC_MoveParent,
/*7605*/      OPC_RecordChild1, // #2 = $vB
/*7606*/      OPC_MoveParent,
/*7607*/      OPC_CheckType, MVT::v4f32,
/*7609*/      OPC_CheckPatternPredicate, 0, // (!TM.Options.NoExcessFPPrecision)
/*7611*/      OPC_MorphNodeTo, TARGET_VAL(PPC::VNMSUBFP), 0,
                  1/*#VTs*/, MVT::v4f32, 3/*#Ops*/, 0, 1, 2, 
              // Src: (fsub:v4f32 (build_vector:v4f32)<<P:Predicate_V_immneg0>>, (fsub:v4f32 (fmul:v4f32 VRRC:v4f32:$vA, VRRC:v4f32:$vC), VRRC:v4f32:$vB)) - Complexity = 13
              // Dst: (VNMSUBFP:v4f32 VRRC:v4f32:$vA, VRRC:v4f32:$vC, VRRC:v4f32:$vB)
/*7621*/    /*Scope*/ 13, /*->7635*/
/*7622*/      OPC_RecordChild0, // #0 = $vA
/*7623*/      OPC_RecordChild1, // #1 = $vB
/*7624*/      OPC_CheckType, MVT::v4f32,
/*7626*/      OPC_MorphNodeTo, TARGET_VAL(PPC::VSUBFP), 0,
                  1/*#VTs*/, MVT::v4f32, 2/*#Ops*/, 0, 1, 
              // Src: (fsub:v4f32 VRRC:v4f32:$vA, VRRC:v4f32:$vB) - Complexity = 3
              // Dst: (VSUBFP:v4f32 VRRC:v4f32:$vA, VRRC:v4f32:$vB)
/*7635*/    0, /*End of Scope*/
          /*SwitchOpcode*/ 11,  TARGET_VAL(PPCISD::FCTIWZ),// ->7650
/*7639*/    OPC_RecordChild0, // #0 = $frB
/*7640*/    OPC_CheckType, MVT::f64,
/*7642*/    OPC_MorphNodeTo, TARGET_VAL(PPC::FCTIWZ), 0,
                1/*#VTs*/, MVT::f64, 1/*#Ops*/, 0, 
            // Src: (PPCfctiwz:f64 F8RC:f64:$frB) - Complexity = 3
            // Dst: (FCTIWZ:f64 F8RC:f64:$frB)
          /*SwitchOpcode*/ 9,  TARGET_VAL(ISD::FP_ROUND),// ->7662
/*7653*/    OPC_RecordChild0, // #0 = $frB
/*7654*/    OPC_MorphNodeTo, TARGET_VAL(PPC::FRSP), 0,
                1/*#VTs*/, MVT::f32, 1/*#Ops*/, 0, 
            // Src: (fround:f32 F8RC:f64:$frB) - Complexity = 3
            // Dst: (FRSP:f32 F8RC:f64:$frB)
          /*SwitchOpcode*/ 23,  TARGET_VAL(ISD::FSQRT),// ->7688
/*7665*/    OPC_RecordChild0, // #0 = $frB
/*7666*/    OPC_SwitchType /*2 cases */, 8,  MVT::f64,// ->7677
/*7669*/      OPC_MorphNodeTo, TARGET_VAL(PPC::FSQRT), 0,
                  1/*#VTs*/, MVT::f64, 1/*#Ops*/, 0, 
              // Src: (fsqrt:f64 F8RC:f64:$frB) - Complexity = 3
              // Dst: (FSQRT:f64 F8RC:f64:$frB)
            /*SwitchType*/ 8,  MVT::f32,// ->7687
/*7679*/      OPC_MorphNodeTo, TARGET_VAL(PPC::FSQRTS), 0,
                  1/*#VTs*/, MVT::f32, 1/*#Ops*/, 0, 
              // Src: (fsqrt:f32 F4RC:f32:$frB) - Complexity = 3
              // Dst: (FSQRTS:f32 F4RC:f32:$frB)
            0, // EndSwitchType
          /*SwitchOpcode*/ 23,  TARGET_VAL(ISD::FABS),// ->7714
/*7691*/    OPC_RecordChild0, // #0 = $frB
/*7692*/    OPC_SwitchType /*2 cases */, 8,  MVT::f32,// ->7703
/*7695*/      OPC_MorphNodeTo, TARGET_VAL(PPC::FABSS), 0,
                  1/*#VTs*/, MVT::f32, 1/*#Ops*/, 0, 
              // Src: (fabs:f32 F4RC:f32:$frB) - Complexity = 3
              // Dst: (FABSS:f32 F4RC:f32:$frB)
            /*SwitchType*/ 8,  MVT::f64,// ->7713
/*7705*/      OPC_MorphNodeTo, TARGET_VAL(PPC::FABSD), 0,
                  1/*#VTs*/, MVT::f64, 1/*#Ops*/, 0, 
              // Src: (fabs:f64 F8RC:f64:$frB) - Complexity = 3
              // Dst: (FABSD:f64 F8RC:f64:$frB)
            0, // EndSwitchType
          /*SwitchOpcode*/ 7,  TARGET_VAL(PPCISD::MFFS),// ->7724
/*7717*/    OPC_MorphNodeTo, TARGET_VAL(PPC::MFFS), 0|OPFL_GlueOutput,
                1/*#VTs*/, MVT::f64, 0/*#Ops*/, 
            // Src: (PPCmffs:f64) - Complexity = 3
            // Dst: (MFFS:f64)
          /*SwitchOpcode*/ 14,  TARGET_VAL(PPCISD::FADDRTZ),// ->7741
/*7727*/    OPC_CaptureGlueInput,
/*7728*/    OPC_RecordChild0, // #0 = $FRA
/*7729*/    OPC_RecordChild1, // #1 = $FRB
/*7730*/    OPC_CheckType, MVT::f64,
/*7732*/    OPC_MorphNodeTo, TARGET_VAL(PPC::FADDrtz), 0|OPFL_GlueInput|OPFL_GlueOutput,
                1/*#VTs*/, MVT::f64, 2/*#Ops*/, 0, 1, 
            // Src: (PPCfaddrtz:f64 F8RC:f64:$FRA, F8RC:f64:$FRB) - Complexity = 3
            // Dst: (FADDrtz:f64 F8RC:f64:$FRA, F8RC:f64:$FRB)
          /*SwitchOpcode*/ 29,  TARGET_VAL(PPCISD::FSEL),// ->7773
/*7744*/    OPC_RecordChild0, // #0 = $FRA
/*7745*/    OPC_RecordChild1, // #1 = $FRC
/*7746*/    OPC_RecordChild2, // #2 = $FRB
/*7747*/    OPC_SwitchType /*2 cases */, 10,  MVT::f64,// ->7760
/*7750*/      OPC_MorphNodeTo, TARGET_VAL(PPC::FSELD), 0,
                  1/*#VTs*/, MVT::f64, 3/*#Ops*/, 0, 1, 2, 
              // Src: (PPCfsel:f64 F8RC:f64:$FRA, F8RC:f64:$FRC, F8RC:f64:$FRB) - Complexity = 3
              // Dst: (FSELD:f64 F8RC:f64:$FRA, F8RC:f64:$FRC, F8RC:f64:$FRB)
            /*SwitchType*/ 10,  MVT::f32,// ->7772
/*7762*/      OPC_MorphNodeTo, TARGET_VAL(PPC::FSELS), 0,
                  1/*#VTs*/, MVT::f32, 3/*#Ops*/, 0, 1, 2, 
              // Src: (PPCfsel:f32 F8RC:f64:$FRA, F4RC:f32:$FRC, F4RC:f32:$FRB) - Complexity = 3
              // Dst: (FSELS:f32 F8RC:f64:$FRA, F4RC:f32:$FRC, F4RC:f32:$FRB)
            0, // EndSwitchType
          /*SwitchOpcode*/ 26,  TARGET_VAL(ISD::FDIV),// ->7802
/*7776*/    OPC_RecordChild0, // #0 = $FRA
/*7777*/    OPC_RecordChild1, // #1 = $FRB
/*7778*/    OPC_SwitchType /*2 cases */, 9,  MVT::f64,// ->7790
/*7781*/      OPC_MorphNodeTo, TARGET_VAL(PPC::FDIV), 0,
                  1/*#VTs*/, MVT::f64, 2/*#Ops*/, 0, 1, 
              // Src: (fdiv:f64 F8RC:f64:$FRA, F8RC:f64:$FRB) - Complexity = 3
              // Dst: (FDIV:f64 F8RC:f64:$FRA, F8RC:f64:$FRB)
            /*SwitchType*/ 9,  MVT::f32,// ->7801
/*7792*/      OPC_MorphNodeTo, TARGET_VAL(PPC::FDIVS), 0,
                  1/*#VTs*/, MVT::f32, 2/*#Ops*/, 0, 1, 
              // Src: (fdiv:f32 F4RC:f32:$FRA, F4RC:f32:$FRB) - Complexity = 3
              // Dst: (FDIVS:f32 F4RC:f32:$FRA, F4RC:f32:$FRB)
            0, // EndSwitchType
          /*SwitchOpcode*/ 45,  TARGET_VAL(ISD::FMUL),// ->7850
/*7805*/    OPC_RecordChild0, // #0 = $FRA
/*7806*/    OPC_RecordChild1, // #1 = $FRB
/*7807*/    OPC_SwitchType /*3 cases */, 9,  MVT::f64,// ->7819
/*7810*/      OPC_MorphNodeTo, TARGET_VAL(PPC::FMUL), 0,
                  1/*#VTs*/, MVT::f64, 2/*#Ops*/, 0, 1, 
              // Src: (fmul:f64 F8RC:f64:$FRA, F8RC:f64:$FRB) - Complexity = 3
              // Dst: (FMUL:f64 F8RC:f64:$FRA, F8RC:f64:$FRB)
            /*SwitchType*/ 9,  MVT::f32,// ->7830
/*7821*/      OPC_MorphNodeTo, TARGET_VAL(PPC::FMULS), 0,
                  1/*#VTs*/, MVT::f32, 2/*#Ops*/, 0, 1, 
              // Src: (fmul:f32 F4RC:f32:$FRA, F4RC:f32:$FRB) - Complexity = 3
              // Dst: (FMULS:f32 F4RC:f32:$FRA, F4RC:f32:$FRB)
            /*SwitchType*/ 17,  MVT::v4f32,// ->7849
/*7832*/      OPC_EmitNode, TARGET_VAL(PPC::V_SET0), 0,
                  1/*#VTs*/, MVT::v4i32, 0/*#Ops*/,  // Results = #2 
/*7839*/      OPC_MorphNodeTo, TARGET_VAL(PPC::VMADDFP), 0,
                  1/*#VTs*/, MVT::v4f32, 3/*#Ops*/, 0, 1, 2, 
              // Src: (fmul:v4f32 VRRC:v4f32:$vA, VRRC:v4f32:$vB) - Complexity = 3
              // Dst: (VMADDFP:v4f32 VRRC:v4f32:$vA, VRRC:v4f32:$vB, (V_SET0:v4i32))
            0, // EndSwitchType
          /*SwitchOpcode*/ 13,  TARGET_VAL(ISD::FP_EXTEND),// ->7866
/*7853*/    OPC_RecordChild0, // #0 = $src
/*7854*/    OPC_EmitInteger, MVT::i32, PPC::F8RCRegClassID,
/*7857*/    OPC_MorphNodeTo, TARGET_VAL(TargetOpcode::COPY_TO_REGCLASS), 0,
                1/*#VTs*/, MVT::f64, 2/*#Ops*/, 0, 1, 
            // Src: (fextend:f64 F4RC:f32:$src) - Complexity = 3
            // Dst: (COPY_TO_REGCLASS:f64 F4RC:f32:$src, F8RC:f64)
          /*SwitchOpcode*/ 11,  TARGET_VAL(PPCISD::FCFID),// ->7880
/*7869*/    OPC_RecordChild0, // #0 = $frB
/*7870*/    OPC_CheckType, MVT::f64,
/*7872*/    OPC_MorphNodeTo, TARGET_VAL(PPC::FCFID), 0,
                1/*#VTs*/, MVT::f64, 1/*#Ops*/, 0, 
            // Src: (PPCfcfid:f64 F8RC:f64:$frB) - Complexity = 3
            // Dst: (FCFID:f64 F8RC:f64:$frB)
          /*SwitchOpcode*/ 11,  TARGET_VAL(PPCISD::FCTIDZ),// ->7894
/*7883*/    OPC_RecordChild0, // #0 = $frB
/*7884*/    OPC_CheckType, MVT::f64,
/*7886*/    OPC_MorphNodeTo, TARGET_VAL(PPC::FCTIDZ), 0,
                1/*#VTs*/, MVT::f64, 1/*#Ops*/, 0, 
            // Src: (PPCfctidz:f64 F8RC:f64:$frB) - Complexity = 3
            // Dst: (FCTIDZ:f64 F8RC:f64:$frB)
          /*SwitchOpcode*/ 113,  TARGET_VAL(ISD::INTRINSIC_W_CHAIN),// ->8010
/*7897*/    OPC_RecordNode,   // #0 = 'intrinsic_w_chain' chained node
/*7898*/    OPC_MoveChild, 1,
/*7900*/    OPC_Scope, 18, /*->7920*/ // 6 children in Scope
/*7902*/      OPC_CheckInteger, 42|128,10/*1322*/, 
/*7905*/      OPC_MoveParent,
/*7906*/      OPC_RecordChild2, // #1 = $src
/*7907*/      OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrIdxOnly:$src #2 #3
/*7910*/      OPC_EmitMergeInputChains1_0,
/*7911*/      OPC_MorphNodeTo, TARGET_VAL(PPC::LVEBX), 0|OPFL_Chain,
                  1/*#VTs*/, MVT::v16i8, 2/*#Ops*/, 2, 3, 
              // Src: (intrinsic_w_chain:v16i8 1322:iPTR, xoaddr:iPTR:$src) - Complexity = 17
              // Dst: (LVEBX:v16i8 xoaddr:iPTR:$src)
/*7920*/    /*Scope*/ 18, /*->7939*/
/*7921*/      OPC_CheckInteger, 43|128,10/*1323*/, 
/*7924*/      OPC_MoveParent,
/*7925*/      OPC_RecordChild2, // #1 = $src
/*7926*/      OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrIdxOnly:$src #2 #3
/*7929*/      OPC_EmitMergeInputChains1_0,
/*7930*/      OPC_MorphNodeTo, TARGET_VAL(PPC::LVEHX), 0|OPFL_Chain,
                  1/*#VTs*/, MVT::v8i16, 2/*#Ops*/, 2, 3, 
              // Src: (intrinsic_w_chain:v8i16 1323:iPTR, xoaddr:iPTR:$src) - Complexity = 17
              // Dst: (LVEHX:v8i16 xoaddr:iPTR:$src)
/*7939*/    /*Scope*/ 18, /*->7958*/
/*7940*/      OPC_CheckInteger, 44|128,10/*1324*/, 
/*7943*/      OPC_MoveParent,
/*7944*/      OPC_RecordChild2, // #1 = $src
/*7945*/      OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrIdxOnly:$src #2 #3
/*7948*/      OPC_EmitMergeInputChains1_0,
/*7949*/      OPC_MorphNodeTo, TARGET_VAL(PPC::LVEWX), 0|OPFL_Chain,
                  1/*#VTs*/, MVT::v4i32, 2/*#Ops*/, 2, 3, 
              // Src: (intrinsic_w_chain:v4i32 1324:iPTR, xoaddr:iPTR:$src) - Complexity = 17
              // Dst: (LVEWX:v4i32 xoaddr:iPTR:$src)
/*7958*/    /*Scope*/ 18, /*->7977*/
/*7959*/      OPC_CheckInteger, 47|128,10/*1327*/, 
/*7962*/      OPC_MoveParent,
/*7963*/      OPC_RecordChild2, // #1 = $src
/*7964*/      OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrIdxOnly:$src #2 #3
/*7967*/      OPC_EmitMergeInputChains1_0,
/*7968*/      OPC_MorphNodeTo, TARGET_VAL(PPC::LVX), 0|OPFL_Chain,
                  1/*#VTs*/, MVT::v4i32, 2/*#Ops*/, 2, 3, 
              // Src: (intrinsic_w_chain:v4i32 1327:iPTR, xoaddr:iPTR:$src) - Complexity = 17
              // Dst: (LVX:v4i32 xoaddr:iPTR:$src)
/*7977*/    /*Scope*/ 18, /*->7996*/
/*7978*/      OPC_CheckInteger, 48|128,10/*1328*/, 
/*7981*/      OPC_MoveParent,
/*7982*/      OPC_RecordChild2, // #1 = $src
/*7983*/      OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrIdxOnly:$src #2 #3
/*7986*/      OPC_EmitMergeInputChains1_0,
/*7987*/      OPC_MorphNodeTo, TARGET_VAL(PPC::LVXL), 0|OPFL_Chain,
                  1/*#VTs*/, MVT::v4i32, 2/*#Ops*/, 2, 3, 
              // Src: (intrinsic_w_chain:v4i32 1328:iPTR, xoaddr:iPTR:$src) - Complexity = 17
              // Dst: (LVXL:v4i32 xoaddr:iPTR:$src)
/*7996*/    /*Scope*/ 12, /*->8009*/
/*7997*/      OPC_CheckInteger, 49|128,10/*1329*/, 
/*8000*/      OPC_MoveParent,
/*8001*/      OPC_EmitMergeInputChains1_0,
/*8002*/      OPC_MorphNodeTo, TARGET_VAL(PPC::MFVSCR), 0|OPFL_Chain,
                  1/*#VTs*/, MVT::v8i16, 0/*#Ops*/, 
              // Src: (intrinsic_w_chain:v8i16 1329:iPTR) - Complexity = 8
              // Dst: (MFVSCR:v8i16)
/*8009*/    0, /*End of Scope*/
          /*SwitchOpcode*/ 22|128,13/*1686*/,  TARGET_VAL(ISD::INTRINSIC_WO_CHAIN),// ->9700
/*8014*/    OPC_MoveChild, 0,
/*8016*/    OPC_Scope, 17, /*->8035*/ // 103 children in Scope
/*8018*/      OPC_CheckInteger, 45|128,10/*1325*/, 
/*8021*/      OPC_MoveParent,
/*8022*/      OPC_RecordChild1, // #0 = $src
/*8023*/      OPC_CheckComplexPat, /*CP*/0, /*#*/0, // SelectAddrIdxOnly:$src #1 #2
/*8026*/      OPC_MorphNodeTo, TARGET_VAL(PPC::LVSL), 0,
                  1/*#VTs*/, MVT::v16i8, 2/*#Ops*/, 1, 2, 
              // Src: (intrinsic_wo_chain:v16i8 1325:iPTR, xoaddr:iPTR:$src) - Complexity = 17
              // Dst: (LVSL:v16i8 xoaddr:iPTR:$src)
/*8035*/    /*Scope*/ 17, /*->8053*/
/*8036*/      OPC_CheckInteger, 46|128,10/*1326*/, 
/*8039*/      OPC_MoveParent,
/*8040*/      OPC_RecordChild1, // #0 = $src
/*8041*/      OPC_CheckComplexPat, /*CP*/0, /*#*/0, // SelectAddrIdxOnly:$src #1 #2
/*8044*/      OPC_MorphNodeTo, TARGET_VAL(PPC::LVSR), 0,
                  1/*#VTs*/, MVT::v16i8, 2/*#Ops*/, 1, 2, 
              // Src: (intrinsic_wo_chain:v16i8 1326:iPTR, xoaddr:iPTR:$src) - Complexity = 17
              // Dst: (LVSR:v16i8 xoaddr:iPTR:$src)
/*8053*/    /*Scope*/ 23, /*->8077*/
/*8054*/      OPC_CheckInteger, 97|128,10/*1377*/, 
/*8057*/      OPC_MoveParent,
/*8058*/      OPC_RecordChild1, // #0 = $vB
/*8059*/      OPC_RecordChild2, // #1 = $UIMM
/*8060*/      OPC_MoveChild, 2,
/*8062*/      OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/*8065*/      OPC_MoveParent,
/*8066*/      OPC_EmitConvertToTarget, 1,
/*8068*/      OPC_MorphNodeTo, TARGET_VAL(PPC::VCTSXS), 0,
                  1/*#VTs*/, MVT::v4i32, 2/*#Ops*/, 2, 0, 
              // Src: (intrinsic_wo_chain:v4i32 1377:iPTR, VRRC:v4f32:$vB, (imm:i32):$UIMM) - Complexity = 11
              // Dst: (VCTSXS:v4i32 (imm:i32):$UIMM, VRRC:v4f32:$vB)
/*8077*/    /*Scope*/ 23, /*->8101*/
/*8078*/      OPC_CheckInteger, 98|128,10/*1378*/, 
/*8081*/      OPC_MoveParent,
/*8082*/      OPC_RecordChild1, // #0 = $vB
/*8083*/      OPC_RecordChild2, // #1 = $UIMM
/*8084*/      OPC_MoveChild, 2,
/*8086*/      OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/*8089*/      OPC_MoveParent,
/*8090*/      OPC_EmitConvertToTarget, 1,
/*8092*/      OPC_MorphNodeTo, TARGET_VAL(PPC::VCTUXS), 0,
                  1/*#VTs*/, MVT::v4i32, 2/*#Ops*/, 2, 0, 
              // Src: (intrinsic_wo_chain:v4i32 1378:iPTR, VRRC:v4f32:$vB, (imm:i32):$UIMM) - Complexity = 11
              // Dst: (VCTUXS:v4i32 (imm:i32):$UIMM, VRRC:v4f32:$vB)
/*8101*/    /*Scope*/ 17, /*->8119*/
/*8102*/      OPC_CheckInteger, 109|128,10/*1389*/, 
/*8105*/      OPC_MoveParent,
/*8106*/      OPC_RecordChild1, // #0 = $vA
/*8107*/      OPC_RecordChild2, // #1 = $vB
/*8108*/      OPC_RecordChild3, // #2 = $vC
/*8109*/      OPC_MorphNodeTo, TARGET_VAL(PPC::VMHADDSHS), 0,
                  1/*#VTs*/, MVT::v8i16, 3/*#Ops*/, 0, 1, 2, 
              // Src: (intrinsic_wo_chain:v8i16 1389:iPTR, VRRC:v8i16:$vA, VRRC:v8i16:$vB, VRRC:v8i16:$vC) - Complexity = 8
              // Dst: (VMHADDSHS:v8i16 VRRC:v8i16:$vA, VRRC:v8i16:$vB, VRRC:v8i16:$vC)
/*8119*/    /*Scope*/ 17, /*->8137*/
/*8120*/      OPC_CheckInteger, 110|128,10/*1390*/, 
/*8123*/      OPC_MoveParent,
/*8124*/      OPC_RecordChild1, // #0 = $vA
/*8125*/      OPC_RecordChild2, // #1 = $vB
/*8126*/      OPC_RecordChild3, // #2 = $vC
/*8127*/      OPC_MorphNodeTo, TARGET_VAL(PPC::VMHRADDSHS), 0,
                  1/*#VTs*/, MVT::v8i16, 3/*#Ops*/, 0, 1, 2, 
              // Src: (intrinsic_wo_chain:v8i16 1390:iPTR, VRRC:v8i16:$vA, VRRC:v8i16:$vB, VRRC:v8i16:$vC) - Complexity = 8
              // Dst: (VMHRADDSHS:v8i16 VRRC:v8i16:$vA, VRRC:v8i16:$vB, VRRC:v8i16:$vC)
/*8137*/    /*Scope*/ 17, /*->8155*/
/*8138*/      OPC_CheckInteger, 118|128,10/*1398*/, 
/*8141*/      OPC_MoveParent,
/*8142*/      OPC_RecordChild1, // #0 = $vA
/*8143*/      OPC_RecordChild2, // #1 = $vB
/*8144*/      OPC_RecordChild3, // #2 = $vC
/*8145*/      OPC_MorphNodeTo, TARGET_VAL(PPC::VMLADDUHM), 0,
                  1/*#VTs*/, MVT::v8i16, 3/*#Ops*/, 0, 1, 2, 
              // Src: (intrinsic_wo_chain:v8i16 1398:iPTR, VRRC:v8i16:$vA, VRRC:v8i16:$vB, VRRC:v8i16:$vC) - Complexity = 8
              // Dst: (VMLADDUHM:v8i16 VRRC:v8i16:$vA, VRRC:v8i16:$vB, VRRC:v8i16:$vC)
/*8155*/    /*Scope*/ 17, /*->8173*/
/*8156*/      OPC_CheckInteger, 6|128,11/*1414*/, 
/*8159*/      OPC_MoveParent,
/*8160*/      OPC_RecordChild1, // #0 = $vA
/*8161*/      OPC_RecordChild2, // #1 = $vB
/*8162*/      OPC_RecordChild3, // #2 = $vC
/*8163*/      OPC_MorphNodeTo, TARGET_VAL(PPC::VPERM), 0,
                  1/*#VTs*/, MVT::v4i32, 3/*#Ops*/, 0, 1, 2, 
              // Src: (intrinsic_wo_chain:v4i32 1414:iPTR, VRRC:v4i32:$vA, VRRC:v4i32:$vB, VRRC:v16i8:$vC) - Complexity = 8
              // Dst: (VPERM:v4i32 VRRC:v4i32:$vA, VRRC:v4i32:$vB, VRRC:v16i8:$vC)
/*8173*/    /*Scope*/ 17, /*->8191*/
/*8174*/      OPC_CheckInteger, 23|128,11/*1431*/, 
/*8177*/      OPC_MoveParent,
/*8178*/      OPC_RecordChild1, // #0 = $vA
/*8179*/      OPC_RecordChild2, // #1 = $vB
/*8180*/      OPC_RecordChild3, // #2 = $vC
/*8181*/      OPC_MorphNodeTo, TARGET_VAL(PPC::VSEL), 0,
                  1/*#VTs*/, MVT::v4i32, 3/*#Ops*/, 0, 1, 2, 
              // Src: (intrinsic_wo_chain:v4i32 1431:iPTR, VRRC:v4i32:$vA, VRRC:v4i32:$vB, VRRC:v4i32:$vC) - Complexity = 8
              // Dst: (VSEL:v4i32 VRRC:v4i32:$vA, VRRC:v4i32:$vB, VRRC:v4i32:$vC)
/*8191*/    /*Scope*/ 15, /*->8207*/
/*8192*/      OPC_CheckInteger, 56|128,10/*1336*/, 
/*8195*/      OPC_MoveParent,
/*8196*/      OPC_RecordChild1, // #0 = $vA
/*8197*/      OPC_RecordChild2, // #1 = $vB
/*8198*/      OPC_MorphNodeTo, TARGET_VAL(PPC::VADDCUW), 0,
                  1/*#VTs*/, MVT::v4i32, 2/*#Ops*/, 0, 1, 
              // Src: (intrinsic_wo_chain:v4i32 1336:iPTR, VRRC:v4i32:$vA, VRRC:v4i32:$vB) - Complexity = 8
              // Dst: (VADDCUW:v4i32 VRRC:v4i32:$vA, VRRC:v4i32:$vB)
/*8207*/    /*Scope*/ 15, /*->8223*/
/*8208*/      OPC_CheckInteger, 57|128,10/*1337*/, 
/*8211*/      OPC_MoveParent,
/*8212*/      OPC_RecordChild1, // #0 = $vA
/*8213*/      OPC_RecordChild2, // #1 = $vB
/*8214*/      OPC_MorphNodeTo, TARGET_VAL(PPC::VADDSBS), 0,
                  1/*#VTs*/, MVT::v16i8, 2/*#Ops*/, 0, 1, 
              // Src: (intrinsic_wo_chain:v16i8 1337:iPTR, VRRC:v16i8:$vA, VRRC:v16i8:$vB) - Complexity = 8
              // Dst: (VADDSBS:v16i8 VRRC:v16i8:$vA, VRRC:v16i8:$vB)
/*8223*/    /*Scope*/ 15, /*->8239*/
/*8224*/      OPC_CheckInteger, 58|128,10/*1338*/, 
/*8227*/      OPC_MoveParent,
/*8228*/      OPC_RecordChild1, // #0 = $vA
/*8229*/      OPC_RecordChild2, // #1 = $vB
/*8230*/      OPC_MorphNodeTo, TARGET_VAL(PPC::VADDSHS), 0,
                  1/*#VTs*/, MVT::v8i16, 2/*#Ops*/, 0, 1, 
              // Src: (intrinsic_wo_chain:v8i16 1338:iPTR, VRRC:v8i16:$vA, VRRC:v8i16:$vB) - Complexity = 8
              // Dst: (VADDSHS:v8i16 VRRC:v8i16:$vA, VRRC:v8i16:$vB)
/*8239*/    /*Scope*/ 15, /*->8255*/
/*8240*/      OPC_CheckInteger, 59|128,10/*1339*/, 
/*8243*/      OPC_MoveParent,
/*8244*/      OPC_RecordChild1, // #0 = $vA
/*8245*/      OPC_RecordChild2, // #1 = $vB
/*8246*/      OPC_MorphNodeTo, TARGET_VAL(PPC::VADDSWS), 0,
                  1/*#VTs*/, MVT::v4i32, 2/*#Ops*/, 0, 1, 
              // Src: (intrinsic_wo_chain:v4i32 1339:iPTR, VRRC:v4i32:$vA, VRRC:v4i32:$vB) - Complexity = 8
              // Dst: (VADDSWS:v4i32 VRRC:v4i32:$vA, VRRC:v4i32:$vB)
/*8255*/    /*Scope*/ 15, /*->8271*/
/*8256*/      OPC_CheckInteger, 60|128,10/*1340*/, 
/*8259*/      OPC_MoveParent,
/*8260*/      OPC_RecordChild1, // #0 = $vA
/*8261*/      OPC_RecordChild2, // #1 = $vB
/*8262*/      OPC_MorphNodeTo, TARGET_VAL(PPC::VADDUBS), 0,
                  1/*#VTs*/, MVT::v16i8, 2/*#Ops*/, 0, 1, 
              // Src: (intrinsic_wo_chain:v16i8 1340:iPTR, VRRC:v16i8:$vA, VRRC:v16i8:$vB) - Complexity = 8
              // Dst: (VADDUBS:v16i8 VRRC:v16i8:$vA, VRRC:v16i8:$vB)
/*8271*/    /*Scope*/ 15, /*->8287*/
/*8272*/      OPC_CheckInteger, 61|128,10/*1341*/, 
/*8275*/      OPC_MoveParent,
/*8276*/      OPC_RecordChild1, // #0 = $vA
/*8277*/      OPC_RecordChild2, // #1 = $vB
/*8278*/      OPC_MorphNodeTo, TARGET_VAL(PPC::VADDUHS), 0,
                  1/*#VTs*/, MVT::v8i16, 2/*#Ops*/, 0, 1, 
              // Src: (intrinsic_wo_chain:v8i16 1341:iPTR, VRRC:v8i16:$vA, VRRC:v8i16:$vB) - Complexity = 8
              // Dst: (VADDUHS:v8i16 VRRC:v8i16:$vA, VRRC:v8i16:$vB)
/*8287*/    /*Scope*/ 15, /*->8303*/
/*8288*/      OPC_CheckInteger, 62|128,10/*1342*/, 
/*8291*/      OPC_MoveParent,
/*8292*/      OPC_RecordChild1, // #0 = $vA
/*8293*/      OPC_RecordChild2, // #1 = $vB
/*8294*/      OPC_MorphNodeTo, TARGET_VAL(PPC::VADDUWS), 0,
                  1/*#VTs*/, MVT::v4i32, 2/*#Ops*/, 0, 1, 
              // Src: (intrinsic_wo_chain:v4i32 1342:iPTR, VRRC:v4i32:$vA, VRRC:v4i32:$vB) - Complexity = 8
              // Dst: (VADDUWS:v4i32 VRRC:v4i32:$vA, VRRC:v4i32:$vB)
/*8303*/    /*Scope*/ 15, /*->8319*/
/*8304*/      OPC_CheckInteger, 63|128,10/*1343*/, 
/*8307*/      OPC_MoveParent,
/*8308*/      OPC_RecordChild1, // #0 = $vA
/*8309*/      OPC_RecordChild2, // #1 = $vB
/*8310*/      OPC_MorphNodeTo, TARGET_VAL(PPC::VAVGSB), 0,
                  1/*#VTs*/, MVT::v16i8, 2/*#Ops*/, 0, 1, 
              // Src: (intrinsic_wo_chain:v16i8 1343:iPTR, VRRC:v16i8:$vA, VRRC:v16i8:$vB) - Complexity = 8
              // Dst: (VAVGSB:v16i8 VRRC:v16i8:$vA, VRRC:v16i8:$vB)
/*8319*/    /*Scope*/ 15, /*->8335*/
/*8320*/      OPC_CheckInteger, 64|128,10/*1344*/, 
/*8323*/      OPC_MoveParent,
/*8324*/      OPC_RecordChild1, // #0 = $vA
/*8325*/      OPC_RecordChild2, // #1 = $vB
/*8326*/      OPC_MorphNodeTo, TARGET_VAL(PPC::VAVGSH), 0,
                  1/*#VTs*/, MVT::v8i16, 2/*#Ops*/, 0, 1, 
              // Src: (intrinsic_wo_chain:v8i16 1344:iPTR, VRRC:v8i16:$vA, VRRC:v8i16:$vB) - Complexity = 8
              // Dst: (VAVGSH:v8i16 VRRC:v8i16:$vA, VRRC:v8i16:$vB)
/*8335*/    /*Scope*/ 15, /*->8351*/
/*8336*/      OPC_CheckInteger, 65|128,10/*1345*/, 
/*8339*/      OPC_MoveParent,
/*8340*/      OPC_RecordChild1, // #0 = $vA
/*8341*/      OPC_RecordChild2, // #1 = $vB
/*8342*/      OPC_MorphNodeTo, TARGET_VAL(PPC::VAVGSW), 0,
                  1/*#VTs*/, MVT::v4i32, 2/*#Ops*/, 0, 1, 
              // Src: (intrinsic_wo_chain:v4i32 1345:iPTR, VRRC:v4i32:$vA, VRRC:v4i32:$vB) - Complexity = 8
              // Dst: (VAVGSW:v4i32 VRRC:v4i32:$vA, VRRC:v4i32:$vB)
/*8351*/    /*Scope*/ 15, /*->8367*/
/*8352*/      OPC_CheckInteger, 66|128,10/*1346*/, 
/*8355*/      OPC_MoveParent,
/*8356*/      OPC_RecordChild1, // #0 = $vA
/*8357*/      OPC_RecordChild2, // #1 = $vB
/*8358*/      OPC_MorphNodeTo, TARGET_VAL(PPC::VAVGUB), 0,
                  1/*#VTs*/, MVT::v16i8, 2/*#Ops*/, 0, 1, 
              // Src: (intrinsic_wo_chain:v16i8 1346:iPTR, VRRC:v16i8:$vA, VRRC:v16i8:$vB) - Complexity = 8
              // Dst: (VAVGUB:v16i8 VRRC:v16i8:$vA, VRRC:v16i8:$vB)
/*8367*/    /*Scope*/ 15, /*->8383*/
/*8368*/      OPC_CheckInteger, 67|128,10/*1347*/, 
/*8371*/      OPC_MoveParent,
/*8372*/      OPC_RecordChild1, // #0 = $vA
/*8373*/      OPC_RecordChild2, // #1 = $vB
/*8374*/      OPC_MorphNodeTo, TARGET_VAL(PPC::VAVGUH), 0,
                  1/*#VTs*/, MVT::v8i16, 2/*#Ops*/, 0, 1, 
              // Src: (intrinsic_wo_chain:v8i16 1347:iPTR, VRRC:v8i16:$vA, VRRC:v8i16:$vB) - Complexity = 8
              // Dst: (VAVGUH:v8i16 VRRC:v8i16:$vA, VRRC:v8i16:$vB)
/*8383*/    /*Scope*/ 15, /*->8399*/
/*8384*/      OPC_CheckInteger, 68|128,10/*1348*/, 
/*8387*/      OPC_MoveParent,
/*8388*/      OPC_RecordChild1, // #0 = $vA
/*8389*/      OPC_RecordChild2, // #1 = $vB
/*8390*/      OPC_MorphNodeTo, TARGET_VAL(PPC::VAVGUW), 0,
                  1/*#VTs*/, MVT::v4i32, 2/*#Ops*/, 0, 1, 
              // Src: (intrinsic_wo_chain:v4i32 1348:iPTR, VRRC:v4i32:$vA, VRRC:v4i32:$vB) - Complexity = 8
              // Dst: (VAVGUW:v4i32 VRRC:v4i32:$vA, VRRC:v4i32:$vB)
/*8399*/    /*Scope*/ 15, /*->8415*/
/*8400*/      OPC_CheckInteger, 103|128,10/*1383*/, 
/*8403*/      OPC_MoveParent,
/*8404*/      OPC_RecordChild1, // #0 = $vA
/*8405*/      OPC_RecordChild2, // #1 = $vB
/*8406*/      OPC_MorphNodeTo, TARGET_VAL(PPC::VMAXSB), 0,
                  1/*#VTs*/, MVT::v16i8, 2/*#Ops*/, 0, 1, 
              // Src: (intrinsic_wo_chain:v16i8 1383:iPTR, VRRC:v16i8:$vA, VRRC:v16i8:$vB) - Complexity = 8
              // Dst: (VMAXSB:v16i8 VRRC:v16i8:$vA, VRRC:v16i8:$vB)
/*8415*/    /*Scope*/ 15, /*->8431*/
/*8416*/      OPC_CheckInteger, 104|128,10/*1384*/, 
/*8419*/      OPC_MoveParent,
/*8420*/      OPC_RecordChild1, // #0 = $vA
/*8421*/      OPC_RecordChild2, // #1 = $vB
/*8422*/      OPC_MorphNodeTo, TARGET_VAL(PPC::VMAXSH), 0,
                  1/*#VTs*/, MVT::v8i16, 2/*#Ops*/, 0, 1, 
              // Src: (intrinsic_wo_chain:v8i16 1384:iPTR, VRRC:v8i16:$vA, VRRC:v8i16:$vB) - Complexity = 8
              // Dst: (VMAXSH:v8i16 VRRC:v8i16:$vA, VRRC:v8i16:$vB)
/*8431*/    /*Scope*/ 15, /*->8447*/
/*8432*/      OPC_CheckInteger, 105|128,10/*1385*/, 
/*8435*/      OPC_MoveParent,
/*8436*/      OPC_RecordChild1, // #0 = $vA
/*8437*/      OPC_RecordChild2, // #1 = $vB
/*8438*/      OPC_MorphNodeTo, TARGET_VAL(PPC::VMAXSW), 0,
                  1/*#VTs*/, MVT::v4i32, 2/*#Ops*/, 0, 1, 
              // Src: (intrinsic_wo_chain:v4i32 1385:iPTR, VRRC:v4i32:$vA, VRRC:v4i32:$vB) - Complexity = 8
              // Dst: (VMAXSW:v4i32 VRRC:v4i32:$vA, VRRC:v4i32:$vB)
/*8447*/    /*Scope*/ 15, /*->8463*/
/*8448*/      OPC_CheckInteger, 106|128,10/*1386*/, 
/*8451*/      OPC_MoveParent,
/*8452*/      OPC_RecordChild1, // #0 = $vA
/*8453*/      OPC_RecordChild2, // #1 = $vB
/*8454*/      OPC_MorphNodeTo, TARGET_VAL(PPC::VMAXUB), 0,
                  1/*#VTs*/, MVT::v16i8, 2/*#Ops*/, 0, 1, 
              // Src: (intrinsic_wo_chain:v16i8 1386:iPTR, VRRC:v16i8:$vA, VRRC:v16i8:$vB) - Complexity = 8
              // Dst: (VMAXUB:v16i8 VRRC:v16i8:$vA, VRRC:v16i8:$vB)
/*8463*/    /*Scope*/ 15, /*->8479*/
/*8464*/      OPC_CheckInteger, 107|128,10/*1387*/, 
/*8467*/      OPC_MoveParent,
/*8468*/      OPC_RecordChild1, // #0 = $vA
/*8469*/      OPC_RecordChild2, // #1 = $vB
/*8470*/      OPC_MorphNodeTo, TARGET_VAL(PPC::VMAXUH), 0,
                  1/*#VTs*/, MVT::v8i16, 2/*#Ops*/, 0, 1, 
              // Src: (intrinsic_wo_chain:v8i16 1387:iPTR, VRRC:v8i16:$vA, VRRC:v8i16:$vB) - Complexity = 8
              // Dst: (VMAXUH:v8i16 VRRC:v8i16:$vA, VRRC:v8i16:$vB)
/*8479*/    /*Scope*/ 15, /*->8495*/
/*8480*/      OPC_CheckInteger, 108|128,10/*1388*/, 
/*8483*/      OPC_MoveParent,
/*8484*/      OPC_RecordChild1, // #0 = $vA
/*8485*/      OPC_RecordChild2, // #1 = $vB
/*8486*/      OPC_MorphNodeTo, TARGET_VAL(PPC::VMAXUW), 0,
                  1/*#VTs*/, MVT::v4i32, 2/*#Ops*/, 0, 1, 
              // Src: (intrinsic_wo_chain:v4i32 1388:iPTR, VRRC:v4i32:$vA, VRRC:v4i32:$vB) - Complexity = 8
              // Dst: (VMAXUW:v4i32 VRRC:v4i32:$vA, VRRC:v4i32:$vB)
/*8495*/    /*Scope*/ 15, /*->8511*/
/*8496*/      OPC_CheckInteger, 112|128,10/*1392*/, 
/*8499*/      OPC_MoveParent,
/*8500*/      OPC_RecordChild1, // #0 = $vA
/*8501*/      OPC_RecordChild2, // #1 = $vB
/*8502*/      OPC_MorphNodeTo, TARGET_VAL(PPC::VMINSB), 0,
                  1/*#VTs*/, MVT::v16i8, 2/*#Ops*/, 0, 1, 
              // Src: (intrinsic_wo_chain:v16i8 1392:iPTR, VRRC:v16i8:$vA, VRRC:v16i8:$vB) - Complexity = 8
              // Dst: (VMINSB:v16i8 VRRC:v16i8:$vA, VRRC:v16i8:$vB)
/*8511*/    /*Scope*/ 15, /*->8527*/
/*8512*/      OPC_CheckInteger, 113|128,10/*1393*/, 
/*8515*/      OPC_MoveParent,
/*8516*/      OPC_RecordChild1, // #0 = $vA
/*8517*/      OPC_RecordChild2, // #1 = $vB
/*8518*/      OPC_MorphNodeTo, TARGET_VAL(PPC::VMINSH), 0,
                  1/*#VTs*/, MVT::v8i16, 2/*#Ops*/, 0, 1, 
              // Src: (intrinsic_wo_chain:v8i16 1393:iPTR, VRRC:v8i16:$vA, VRRC:v8i16:$vB) - Complexity = 8
              // Dst: (VMINSH:v8i16 VRRC:v8i16:$vA, VRRC:v8i16:$vB)
/*8527*/    /*Scope*/ 15, /*->8543*/
/*8528*/      OPC_CheckInteger, 114|128,10/*1394*/, 
/*8531*/      OPC_MoveParent,
/*8532*/      OPC_RecordChild1, // #0 = $vA
/*8533*/      OPC_RecordChild2, // #1 = $vB
/*8534*/      OPC_MorphNodeTo, TARGET_VAL(PPC::VMINSW), 0,
                  1/*#VTs*/, MVT::v4i32, 2/*#Ops*/, 0, 1, 
              // Src: (intrinsic_wo_chain:v4i32 1394:iPTR, VRRC:v4i32:$vA, VRRC:v4i32:$vB) - Complexity = 8
              // Dst: (VMINSW:v4i32 VRRC:v4i32:$vA, VRRC:v4i32:$vB)
/*8543*/    /*Scope*/ 15, /*->8559*/
/*8544*/      OPC_CheckInteger, 115|128,10/*1395*/, 
/*8547*/      OPC_MoveParent,
/*8548*/      OPC_RecordChild1, // #0 = $vA
/*8549*/      OPC_RecordChild2, // #1 = $vB
/*8550*/      OPC_MorphNodeTo, TARGET_VAL(PPC::VMINUB), 0,
                  1/*#VTs*/, MVT::v16i8, 2/*#Ops*/, 0, 1, 
              // Src: (intrinsic_wo_chain:v16i8 1395:iPTR, VRRC:v16i8:$vA, VRRC:v16i8:$vB) - Complexity = 8
              // Dst: (VMINUB:v16i8 VRRC:v16i8:$vA, VRRC:v16i8:$vB)
/*8559*/    /*Scope*/ 15, /*->8575*/
/*8560*/      OPC_CheckInteger, 116|128,10/*1396*/, 
/*8563*/      OPC_MoveParent,
/*8564*/      OPC_RecordChild1, // #0 = $vA
/*8565*/      OPC_RecordChild2, // #1 = $vB
/*8566*/      OPC_MorphNodeTo, TARGET_VAL(PPC::VMINUH), 0,
                  1/*#VTs*/, MVT::v8i16, 2/*#Ops*/, 0, 1, 
              // Src: (intrinsic_wo_chain:v8i16 1396:iPTR, VRRC:v8i16:$vA, VRRC:v8i16:$vB) - Complexity = 8
              // Dst: (VMINUH:v8i16 VRRC:v8i16:$vA, VRRC:v8i16:$vB)
/*8575*/    /*Scope*/ 15, /*->8591*/
/*8576*/      OPC_CheckInteger, 117|128,10/*1397*/, 
/*8579*/      OPC_MoveParent,
/*8580*/      OPC_RecordChild1, // #0 = $vA
/*8581*/      OPC_RecordChild2, // #1 = $vB
/*8582*/      OPC_MorphNodeTo, TARGET_VAL(PPC::VMINUW), 0,
                  1/*#VTs*/, MVT::v4i32, 2/*#Ops*/, 0, 1, 
              // Src: (intrinsic_wo_chain:v4i32 1397:iPTR, VRRC:v4i32:$vA, VRRC:v4i32:$vB) - Complexity = 8
              // Dst: (VMINUW:v4i32 VRRC:v4i32:$vA, VRRC:v4i32:$vB)
/*8591*/    /*Scope*/ 17, /*->8609*/
/*8592*/      OPC_CheckInteger, 119|128,10/*1399*/, 
/*8595*/      OPC_MoveParent,
/*8596*/      OPC_RecordChild1, // #0 = $vA
/*8597*/      OPC_RecordChild2, // #1 = $vB
/*8598*/      OPC_RecordChild3, // #2 = $vC
/*8599*/      OPC_MorphNodeTo, TARGET_VAL(PPC::VMSUMMBM), 0,
                  1/*#VTs*/, MVT::v4i32, 3/*#Ops*/, 0, 1, 2, 
              // Src: (intrinsic_wo_chain:v4i32 1399:iPTR, VRRC:v16i8:$vA, VRRC:v16i8:$vB, VRRC:v4i32:$vC) - Complexity = 8
              // Dst: (VMSUMMBM:v4i32 VRRC:v16i8:$vA, VRRC:v16i8:$vB, VRRC:v4i32:$vC)
/*8609*/    /*Scope*/ 17, /*->8627*/
/*8610*/      OPC_CheckInteger, 120|128,10/*1400*/, 
/*8613*/      OPC_MoveParent,
/*8614*/      OPC_RecordChild1, // #0 = $vA
/*8615*/      OPC_RecordChild2, // #1 = $vB
/*8616*/      OPC_RecordChild3, // #2 = $vC
/*8617*/      OPC_MorphNodeTo, TARGET_VAL(PPC::VMSUMSHM), 0,
                  1/*#VTs*/, MVT::v4i32, 3/*#Ops*/, 0, 1, 2, 
              // Src: (intrinsic_wo_chain:v4i32 1400:iPTR, VRRC:v8i16:$vA, VRRC:v8i16:$vB, VRRC:v4i32:$vC) - Complexity = 8
              // Dst: (VMSUMSHM:v4i32 VRRC:v8i16:$vA, VRRC:v8i16:$vB, VRRC:v4i32:$vC)
/*8627*/    /*Scope*/ 17, /*->8645*/
/*8628*/      OPC_CheckInteger, 121|128,10/*1401*/, 
/*8631*/      OPC_MoveParent,
/*8632*/      OPC_RecordChild1, // #0 = $vA
/*8633*/      OPC_RecordChild2, // #1 = $vB
/*8634*/      OPC_RecordChild3, // #2 = $vC
/*8635*/      OPC_MorphNodeTo, TARGET_VAL(PPC::VMSUMSHS), 0,
                  1/*#VTs*/, MVT::v4i32, 3/*#Ops*/, 0, 1, 2, 
              // Src: (intrinsic_wo_chain:v4i32 1401:iPTR, VRRC:v8i16:$vA, VRRC:v8i16:$vB, VRRC:v4i32:$vC) - Complexity = 8
              // Dst: (VMSUMSHS:v4i32 VRRC:v8i16:$vA, VRRC:v8i16:$vB, VRRC:v4i32:$vC)
/*8645*/    /*Scope*/ 17, /*->8663*/
/*8646*/      OPC_CheckInteger, 122|128,10/*1402*/, 
/*8649*/      OPC_MoveParent,
/*8650*/      OPC_RecordChild1, // #0 = $vA
/*8651*/      OPC_RecordChild2, // #1 = $vB
/*8652*/      OPC_RecordChild3, // #2 = $vC
/*8653*/      OPC_MorphNodeTo, TARGET_VAL(PPC::VMSUMUBM), 0,
                  1/*#VTs*/, MVT::v4i32, 3/*#Ops*/, 0, 1, 2, 
              // Src: (intrinsic_wo_chain:v4i32 1402:iPTR, VRRC:v16i8:$vA, VRRC:v16i8:$vB, VRRC:v4i32:$vC) - Complexity = 8
              // Dst: (VMSUMUBM:v4i32 VRRC:v16i8:$vA, VRRC:v16i8:$vB, VRRC:v4i32:$vC)
/*8663*/    /*Scope*/ 17, /*->8681*/
/*8664*/      OPC_CheckInteger, 123|128,10/*1403*/, 
/*8667*/      OPC_MoveParent,
/*8668*/      OPC_RecordChild1, // #0 = $vA
/*8669*/      OPC_RecordChild2, // #1 = $vB
/*8670*/      OPC_RecordChild3, // #2 = $vC
/*8671*/      OPC_MorphNodeTo, TARGET_VAL(PPC::VMSUMUHM), 0,
                  1/*#VTs*/, MVT::v4i32, 3/*#Ops*/, 0, 1, 2, 
              // Src: (intrinsic_wo_chain:v4i32 1403:iPTR, VRRC:v8i16:$vA, VRRC:v8i16:$vB, VRRC:v4i32:$vC) - Complexity = 8
              // Dst: (VMSUMUHM:v4i32 VRRC:v8i16:$vA, VRRC:v8i16:$vB, VRRC:v4i32:$vC)
/*8681*/    /*Scope*/ 17, /*->8699*/
/*8682*/      OPC_CheckInteger, 124|128,10/*1404*/, 
/*8685*/      OPC_MoveParent,
/*8686*/      OPC_RecordChild1, // #0 = $vA
/*8687*/      OPC_RecordChild2, // #1 = $vB
/*8688*/      OPC_RecordChild3, // #2 = $vC
/*8689*/      OPC_MorphNodeTo, TARGET_VAL(PPC::VMSUMUHS), 0,
                  1/*#VTs*/, MVT::v4i32, 3/*#Ops*/, 0, 1, 2, 
              // Src: (intrinsic_wo_chain:v4i32 1404:iPTR, VRRC:v8i16:$vA, VRRC:v8i16:$vB, VRRC:v4i32:$vC) - Complexity = 8
              // Dst: (VMSUMUHS:v4i32 VRRC:v8i16:$vA, VRRC:v8i16:$vB, VRRC:v4i32:$vC)
/*8699*/    /*Scope*/ 15, /*->8715*/
/*8700*/      OPC_CheckInteger, 125|128,10/*1405*/, 
/*8703*/      OPC_MoveParent,
/*8704*/      OPC_RecordChild1, // #0 = $vA
/*8705*/      OPC_RecordChild2, // #1 = $vB
/*8706*/      OPC_MorphNodeTo, TARGET_VAL(PPC::VMULESB), 0,
                  1/*#VTs*/, MVT::v8i16, 2/*#Ops*/, 0, 1, 
              // Src: (intrinsic_wo_chain:v8i16 1405:iPTR, VRRC:v16i8:$vA, VRRC:v16i8:$vB) - Complexity = 8
              // Dst: (VMULESB:v8i16 VRRC:v16i8:$vA, VRRC:v16i8:$vB)
/*8715*/    /*Scope*/ 15, /*->8731*/
/*8716*/      OPC_CheckInteger, 126|128,10/*1406*/, 
/*8719*/      OPC_MoveParent,
/*8720*/      OPC_RecordChild1, // #0 = $vA
/*8721*/      OPC_RecordChild2, // #1 = $vB
/*8722*/      OPC_MorphNodeTo, TARGET_VAL(PPC::VMULESH), 0,
                  1/*#VTs*/, MVT::v4i32, 2/*#Ops*/, 0, 1, 
              // Src: (intrinsic_wo_chain:v4i32 1406:iPTR, VRRC:v8i16:$vA, VRRC:v8i16:$vB) - Complexity = 8
              // Dst: (VMULESH:v4i32 VRRC:v8i16:$vA, VRRC:v8i16:$vB)
/*8731*/    /*Scope*/ 15, /*->8747*/
/*8732*/      OPC_CheckInteger, 127|128,10/*1407*/, 
/*8735*/      OPC_MoveParent,
/*8736*/      OPC_RecordChild1, // #0 = $vA
/*8737*/      OPC_RecordChild2, // #1 = $vB
/*8738*/      OPC_MorphNodeTo, TARGET_VAL(PPC::VMULEUB), 0,
                  1/*#VTs*/, MVT::v8i16, 2/*#Ops*/, 0, 1, 
              // Src: (intrinsic_wo_chain:v8i16 1407:iPTR, VRRC:v16i8:$vA, VRRC:v16i8:$vB) - Complexity = 8
              // Dst: (VMULEUB:v8i16 VRRC:v16i8:$vA, VRRC:v16i8:$vB)
/*8747*/    /*Scope*/ 15, /*->8763*/
/*8748*/      OPC_CheckInteger, 0|128,11/*1408*/, 
/*8751*/      OPC_MoveParent,
/*8752*/      OPC_RecordChild1, // #0 = $vA
/*8753*/      OPC_RecordChild2, // #1 = $vB
/*8754*/      OPC_MorphNodeTo, TARGET_VAL(PPC::VMULEUH), 0,
                  1/*#VTs*/, MVT::v4i32, 2/*#Ops*/, 0, 1, 
              // Src: (intrinsic_wo_chain:v4i32 1408:iPTR, VRRC:v8i16:$vA, VRRC:v8i16:$vB) - Complexity = 8
              // Dst: (VMULEUH:v4i32 VRRC:v8i16:$vA, VRRC:v8i16:$vB)
/*8763*/    /*Scope*/ 15, /*->8779*/
/*8764*/      OPC_CheckInteger, 1|128,11/*1409*/, 
/*8767*/      OPC_MoveParent,
/*8768*/      OPC_RecordChild1, // #0 = $vA
/*8769*/      OPC_RecordChild2, // #1 = $vB
/*8770*/      OPC_MorphNodeTo, TARGET_VAL(PPC::VMULOSB), 0,
                  1/*#VTs*/, MVT::v8i16, 2/*#Ops*/, 0, 1, 
              // Src: (intrinsic_wo_chain:v8i16 1409:iPTR, VRRC:v16i8:$vA, VRRC:v16i8:$vB) - Complexity = 8
              // Dst: (VMULOSB:v8i16 VRRC:v16i8:$vA, VRRC:v16i8:$vB)
/*8779*/    /*Scope*/ 15, /*->8795*/
/*8780*/      OPC_CheckInteger, 2|128,11/*1410*/, 
/*8783*/      OPC_MoveParent,
/*8784*/      OPC_RecordChild1, // #0 = $vA
/*8785*/      OPC_RecordChild2, // #1 = $vB
/*8786*/      OPC_MorphNodeTo, TARGET_VAL(PPC::VMULOSH), 0,
                  1/*#VTs*/, MVT::v4i32, 2/*#Ops*/, 0, 1, 
              // Src: (intrinsic_wo_chain:v4i32 1410:iPTR, VRRC:v8i16:$vA, VRRC:v8i16:$vB) - Complexity = 8
              // Dst: (VMULOSH:v4i32 VRRC:v8i16:$vA, VRRC:v8i16:$vB)
/*8795*/    /*Scope*/ 15, /*->8811*/
/*8796*/      OPC_CheckInteger, 3|128,11/*1411*/, 
/*8799*/      OPC_MoveParent,
/*8800*/      OPC_RecordChild1, // #0 = $vA
/*8801*/      OPC_RecordChild2, // #1 = $vB
/*8802*/      OPC_MorphNodeTo, TARGET_VAL(PPC::VMULOUB), 0,
                  1/*#VTs*/, MVT::v8i16, 2/*#Ops*/, 0, 1, 
              // Src: (intrinsic_wo_chain:v8i16 1411:iPTR, VRRC:v16i8:$vA, VRRC:v16i8:$vB) - Complexity = 8
              // Dst: (VMULOUB:v8i16 VRRC:v16i8:$vA, VRRC:v16i8:$vB)
/*8811*/    /*Scope*/ 15, /*->8827*/
/*8812*/      OPC_CheckInteger, 4|128,11/*1412*/, 
/*8815*/      OPC_MoveParent,
/*8816*/      OPC_RecordChild1, // #0 = $vA
/*8817*/      OPC_RecordChild2, // #1 = $vB
/*8818*/      OPC_MorphNodeTo, TARGET_VAL(PPC::VMULOUH), 0,
                  1/*#VTs*/, MVT::v4i32, 2/*#Ops*/, 0, 1, 
              // Src: (intrinsic_wo_chain:v4i32 1412:iPTR, VRRC:v8i16:$vA, VRRC:v8i16:$vB) - Complexity = 8
              // Dst: (VMULOUH:v4i32 VRRC:v8i16:$vA, VRRC:v8i16:$vB)
/*8827*/    /*Scope*/ 15, /*->8843*/
/*8828*/      OPC_CheckInteger, 37|128,11/*1445*/, 
/*8831*/      OPC_MoveParent,
/*8832*/      OPC_RecordChild1, // #0 = $vA
/*8833*/      OPC_RecordChild2, // #1 = $vB
/*8834*/      OPC_MorphNodeTo, TARGET_VAL(PPC::VSUBCUW), 0,
                  1/*#VTs*/, MVT::v4i32, 2/*#Ops*/, 0, 1, 
              // Src: (intrinsic_wo_chain:v4i32 1445:iPTR, VRRC:v4i32:$vA, VRRC:v4i32:$vB) - Complexity = 8
              // Dst: (VSUBCUW:v4i32 VRRC:v4i32:$vA, VRRC:v4i32:$vB)
/*8843*/    /*Scope*/ 15, /*->8859*/
/*8844*/      OPC_CheckInteger, 38|128,11/*1446*/, 
/*8847*/      OPC_MoveParent,
/*8848*/      OPC_RecordChild1, // #0 = $vA
/*8849*/      OPC_RecordChild2, // #1 = $vB
/*8850*/      OPC_MorphNodeTo, TARGET_VAL(PPC::VSUBSBS), 0,
                  1/*#VTs*/, MVT::v16i8, 2/*#Ops*/, 0, 1, 
              // Src: (intrinsic_wo_chain:v16i8 1446:iPTR, VRRC:v16i8:$vA, VRRC:v16i8:$vB) - Complexity = 8
              // Dst: (VSUBSBS:v16i8 VRRC:v16i8:$vA, VRRC:v16i8:$vB)
/*8859*/    /*Scope*/ 15, /*->8875*/
/*8860*/      OPC_CheckInteger, 39|128,11/*1447*/, 
/*8863*/      OPC_MoveParent,
/*8864*/      OPC_RecordChild1, // #0 = $vA
/*8865*/      OPC_RecordChild2, // #1 = $vB
/*8866*/      OPC_MorphNodeTo, TARGET_VAL(PPC::VSUBSHS), 0,
                  1/*#VTs*/, MVT::v8i16, 2/*#Ops*/, 0, 1, 
              // Src: (intrinsic_wo_chain:v8i16 1447:iPTR, VRRC:v8i16:$vA, VRRC:v8i16:$vB) - Complexity = 8
              // Dst: (VSUBSHS:v8i16 VRRC:v8i16:$vA, VRRC:v8i16:$vB)
/*8875*/    /*Scope*/ 15, /*->8891*/
/*8876*/      OPC_CheckInteger, 40|128,11/*1448*/, 
/*8879*/      OPC_MoveParent,
/*8880*/      OPC_RecordChild1, // #0 = $vA
/*8881*/      OPC_RecordChild2, // #1 = $vB
/*8882*/      OPC_MorphNodeTo, TARGET_VAL(PPC::VSUBSWS), 0,
                  1/*#VTs*/, MVT::v4i32, 2/*#Ops*/, 0, 1, 
              // Src: (intrinsic_wo_chain:v4i32 1448:iPTR, VRRC:v4i32:$vA, VRRC:v4i32:$vB) - Complexity = 8
              // Dst: (VSUBSWS:v4i32 VRRC:v4i32:$vA, VRRC:v4i32:$vB)
/*8891*/    /*Scope*/ 15, /*->8907*/
/*8892*/      OPC_CheckInteger, 41|128,11/*1449*/, 
/*8895*/      OPC_MoveParent,
/*8896*/      OPC_RecordChild1, // #0 = $vA
/*8897*/      OPC_RecordChild2, // #1 = $vB
/*8898*/      OPC_MorphNodeTo, TARGET_VAL(PPC::VSUBUBS), 0,
                  1/*#VTs*/, MVT::v16i8, 2/*#Ops*/, 0, 1, 
              // Src: (intrinsic_wo_chain:v16i8 1449:iPTR, VRRC:v16i8:$vA, VRRC:v16i8:$vB) - Complexity = 8
              // Dst: (VSUBUBS:v16i8 VRRC:v16i8:$vA, VRRC:v16i8:$vB)
/*8907*/    /*Scope*/ 15, /*->8923*/
/*8908*/      OPC_CheckInteger, 42|128,11/*1450*/, 
/*8911*/      OPC_MoveParent,
/*8912*/      OPC_RecordChild1, // #0 = $vA
/*8913*/      OPC_RecordChild2, // #1 = $vB
/*8914*/      OPC_MorphNodeTo, TARGET_VAL(PPC::VSUBUHS), 0,
                  1/*#VTs*/, MVT::v8i16, 2/*#Ops*/, 0, 1, 
              // Src: (intrinsic_wo_chain:v8i16 1450:iPTR, VRRC:v8i16:$vA, VRRC:v8i16:$vB) - Complexity = 8
              // Dst: (VSUBUHS:v8i16 VRRC:v8i16:$vA, VRRC:v8i16:$vB)
/*8923*/    /*Scope*/ 15, /*->8939*/
/*8924*/      OPC_CheckInteger, 43|128,11/*1451*/, 
/*8927*/      OPC_MoveParent,
/*8928*/      OPC_RecordChild1, // #0 = $vA
/*8929*/      OPC_RecordChild2, // #1 = $vB
/*8930*/      OPC_MorphNodeTo, TARGET_VAL(PPC::VSUBUWS), 0,
                  1/*#VTs*/, MVT::v4i32, 2/*#Ops*/, 0, 1, 
              // Src: (intrinsic_wo_chain:v4i32 1451:iPTR, VRRC:v4i32:$vA, VRRC:v4i32:$vB) - Complexity = 8
              // Dst: (VSUBUWS:v4i32 VRRC:v4i32:$vA, VRRC:v4i32:$vB)
/*8939*/    /*Scope*/ 15, /*->8955*/
/*8940*/      OPC_CheckInteger, 48|128,11/*1456*/, 
/*8943*/      OPC_MoveParent,
/*8944*/      OPC_RecordChild1, // #0 = $vA
/*8945*/      OPC_RecordChild2, // #1 = $vB
/*8946*/      OPC_MorphNodeTo, TARGET_VAL(PPC::VSUMSWS), 0,
                  1/*#VTs*/, MVT::v4i32, 2/*#Ops*/, 0, 1, 
              // Src: (intrinsic_wo_chain:v4i32 1456:iPTR, VRRC:v4i32:$vA, VRRC:v4i32:$vB) - Complexity = 8
              // Dst: (VSUMSWS:v4i32 VRRC:v4i32:$vA, VRRC:v4i32:$vB)
/*8955*/    /*Scope*/ 15, /*->8971*/
/*8956*/      OPC_CheckInteger, 44|128,11/*1452*/, 
/*8959*/      OPC_MoveParent,
/*8960*/      OPC_RecordChild1, // #0 = $vA
/*8961*/      OPC_RecordChild2, // #1 = $vB
/*8962*/      OPC_MorphNodeTo, TARGET_VAL(PPC::VSUM2SWS), 0,
                  1/*#VTs*/, MVT::v4i32, 2/*#Ops*/, 0, 1, 
              // Src: (intrinsic_wo_chain:v4i32 1452:iPTR, VRRC:v4i32:$vA, VRRC:v4i32:$vB) - Complexity = 8
              // Dst: (VSUM2SWS:v4i32 VRRC:v4i32:$vA, VRRC:v4i32:$vB)
/*8971*/    /*Scope*/ 15, /*->8987*/
/*8972*/      OPC_CheckInteger, 45|128,11/*1453*/, 
/*8975*/      OPC_MoveParent,
/*8976*/      OPC_RecordChild1, // #0 = $vA
/*8977*/      OPC_RecordChild2, // #1 = $vB
/*8978*/      OPC_MorphNodeTo, TARGET_VAL(PPC::VSUM4SBS), 0,
                  1/*#VTs*/, MVT::v4i32, 2/*#Ops*/, 0, 1, 
              // Src: (intrinsic_wo_chain:v4i32 1453:iPTR, VRRC:v16i8:$vA, VRRC:v4i32:$vB) - Complexity = 8
              // Dst: (VSUM4SBS:v4i32 VRRC:v16i8:$vA, VRRC:v4i32:$vB)
/*8987*/    /*Scope*/ 15, /*->9003*/
/*8988*/      OPC_CheckInteger, 46|128,11/*1454*/, 
/*8991*/      OPC_MoveParent,
/*8992*/      OPC_RecordChild1, // #0 = $vA
/*8993*/      OPC_RecordChild2, // #1 = $vB
/*8994*/      OPC_MorphNodeTo, TARGET_VAL(PPC::VSUM4SHS), 0,
                  1/*#VTs*/, MVT::v4i32, 2/*#Ops*/, 0, 1, 
              // Src: (intrinsic_wo_chain:v4i32 1454:iPTR, VRRC:v8i16:$vA, VRRC:v4i32:$vB) - Complexity = 8
              // Dst: (VSUM4SHS:v4i32 VRRC:v8i16:$vA, VRRC:v4i32:$vB)
/*9003*/    /*Scope*/ 15, /*->9019*/
/*9004*/      OPC_CheckInteger, 47|128,11/*1455*/, 
/*9007*/      OPC_MoveParent,
/*9008*/      OPC_RecordChild1, // #0 = $vA
/*9009*/      OPC_RecordChild2, // #1 = $vB
/*9010*/      OPC_MorphNodeTo, TARGET_VAL(PPC::VSUM4UBS), 0,
                  1/*#VTs*/, MVT::v4i32, 2/*#Ops*/, 0, 1, 
              // Src: (intrinsic_wo_chain:v4i32 1455:iPTR, VRRC:v16i8:$vA, VRRC:v4i32:$vB) - Complexity = 8
              // Dst: (VSUM4UBS:v4i32 VRRC:v16i8:$vA, VRRC:v4i32:$vB)
/*9019*/    /*Scope*/ 15, /*->9035*/
/*9020*/      OPC_CheckInteger, 19|128,11/*1427*/, 
/*9023*/      OPC_MoveParent,
/*9024*/      OPC_RecordChild1, // #0 = $vA
/*9025*/      OPC_RecordChild2, // #1 = $vB
/*9026*/      OPC_MorphNodeTo, TARGET_VAL(PPC::VRLB), 0,
                  1/*#VTs*/, MVT::v16i8, 2/*#Ops*/, 0, 1, 
              // Src: (intrinsic_wo_chain:v16i8 1427:iPTR, VRRC:v16i8:$vA, VRRC:v16i8:$vB) - Complexity = 8
              // Dst: (VRLB:v16i8 VRRC:v16i8:$vA, VRRC:v16i8:$vB)
/*9035*/    /*Scope*/ 15, /*->9051*/
/*9036*/      OPC_CheckInteger, 20|128,11/*1428*/, 
/*9039*/      OPC_MoveParent,
/*9040*/      OPC_RecordChild1, // #0 = $vA
/*9041*/      OPC_RecordChild2, // #1 = $vB
/*9042*/      OPC_MorphNodeTo, TARGET_VAL(PPC::VRLH), 0,
                  1/*#VTs*/, MVT::v8i16, 2/*#Ops*/, 0, 1, 
              // Src: (intrinsic_wo_chain:v8i16 1428:iPTR, VRRC:v8i16:$vA, VRRC:v8i16:$vB) - Complexity = 8
              // Dst: (VRLH:v8i16 VRRC:v8i16:$vA, VRRC:v8i16:$vB)
/*9051*/    /*Scope*/ 15, /*->9067*/
/*9052*/      OPC_CheckInteger, 21|128,11/*1429*/, 
/*9055*/      OPC_MoveParent,
/*9056*/      OPC_RecordChild1, // #0 = $vA
/*9057*/      OPC_RecordChild2, // #1 = $vB
/*9058*/      OPC_MorphNodeTo, TARGET_VAL(PPC::VRLW), 0,
                  1/*#VTs*/, MVT::v4i32, 2/*#Ops*/, 0, 1, 
              // Src: (intrinsic_wo_chain:v4i32 1429:iPTR, VRRC:v4i32:$vA, VRRC:v4i32:$vB) - Complexity = 8
              // Dst: (VRLW:v4i32 VRRC:v4i32:$vA, VRRC:v4i32:$vB)
/*9067*/    /*Scope*/ 15, /*->9083*/
/*9068*/      OPC_CheckInteger, 24|128,11/*1432*/, 
/*9071*/      OPC_MoveParent,
/*9072*/      OPC_RecordChild1, // #0 = $vA
/*9073*/      OPC_RecordChild2, // #1 = $vB
/*9074*/      OPC_MorphNodeTo, TARGET_VAL(PPC::VSL), 0,
                  1/*#VTs*/, MVT::v4i32, 2/*#Ops*/, 0, 1, 
              // Src: (intrinsic_wo_chain:v4i32 1432:iPTR, VRRC:v4i32:$vA, VRRC:v4i32:$vB) - Complexity = 8
              // Dst: (VSL:v4i32 VRRC:v4i32:$vA, VRRC:v4i32:$vB)
/*9083*/    /*Scope*/ 15, /*->9099*/
/*9084*/      OPC_CheckInteger, 27|128,11/*1435*/, 
/*9087*/      OPC_MoveParent,
/*9088*/      OPC_RecordChild1, // #0 = $vA
/*9089*/      OPC_RecordChild2, // #1 = $vB
/*9090*/      OPC_MorphNodeTo, TARGET_VAL(PPC::VSLO), 0,
                  1/*#VTs*/, MVT::v4i32, 2/*#Ops*/, 0, 1, 
              // Src: (intrinsic_wo_chain:v4i32 1435:iPTR, VRRC:v4i32:$vA, VRRC:v4i32:$vB) - Complexity = 8
              // Dst: (VSLO:v4i32 VRRC:v4i32:$vA, VRRC:v4i32:$vB)
/*9099*/    /*Scope*/ 15, /*->9115*/
/*9100*/      OPC_CheckInteger, 25|128,11/*1433*/, 
/*9103*/      OPC_MoveParent,
/*9104*/      OPC_RecordChild1, // #0 = $vA
/*9105*/      OPC_RecordChild2, // #1 = $vB
/*9106*/      OPC_MorphNodeTo, TARGET_VAL(PPC::VSLB), 0,
                  1/*#VTs*/, MVT::v16i8, 2/*#Ops*/, 0, 1, 
              // Src: (intrinsic_wo_chain:v16i8 1433:iPTR, VRRC:v16i8:$vA, VRRC:v16i8:$vB) - Complexity = 8
              // Dst: (VSLB:v16i8 VRRC:v16i8:$vA, VRRC:v16i8:$vB)
/*9115*/    /*Scope*/ 15, /*->9131*/
/*9116*/      OPC_CheckInteger, 26|128,11/*1434*/, 
/*9119*/      OPC_MoveParent,
/*9120*/      OPC_RecordChild1, // #0 = $vA
/*9121*/      OPC_RecordChild2, // #1 = $vB
/*9122*/      OPC_MorphNodeTo, TARGET_VAL(PPC::VSLH), 0,
                  1/*#VTs*/, MVT::v8i16, 2/*#Ops*/, 0, 1, 
              // Src: (intrinsic_wo_chain:v8i16 1434:iPTR, VRRC:v8i16:$vA, VRRC:v8i16:$vB) - Complexity = 8
              // Dst: (VSLH:v8i16 VRRC:v8i16:$vA, VRRC:v8i16:$vB)
/*9131*/    /*Scope*/ 15, /*->9147*/
/*9132*/      OPC_CheckInteger, 28|128,11/*1436*/, 
/*9135*/      OPC_MoveParent,
/*9136*/      OPC_RecordChild1, // #0 = $vA
/*9137*/      OPC_RecordChild2, // #1 = $vB
/*9138*/      OPC_MorphNodeTo, TARGET_VAL(PPC::VSLW), 0,
                  1/*#VTs*/, MVT::v4i32, 2/*#Ops*/, 0, 1, 
              // Src: (intrinsic_wo_chain:v4i32 1436:iPTR, VRRC:v4i32:$vA, VRRC:v4i32:$vB) - Complexity = 8
              // Dst: (VSLW:v4i32 VRRC:v4i32:$vA, VRRC:v4i32:$vB)
/*9147*/    /*Scope*/ 15, /*->9163*/
/*9148*/      OPC_CheckInteger, 29|128,11/*1437*/, 
/*9151*/      OPC_MoveParent,
/*9152*/      OPC_RecordChild1, // #0 = $vA
/*9153*/      OPC_RecordChild2, // #1 = $vB
/*9154*/      OPC_MorphNodeTo, TARGET_VAL(PPC::VSR), 0,
                  1/*#VTs*/, MVT::v4i32, 2/*#Ops*/, 0, 1, 
              // Src: (intrinsic_wo_chain:v4i32 1437:iPTR, VRRC:v4i32:$vA, VRRC:v4i32:$vB) - Complexity = 8
              // Dst: (VSR:v4i32 VRRC:v4i32:$vA, VRRC:v4i32:$vB)
/*9163*/    /*Scope*/ 15, /*->9179*/
/*9164*/      OPC_CheckInteger, 35|128,11/*1443*/, 
/*9167*/      OPC_MoveParent,
/*9168*/      OPC_RecordChild1, // #0 = $vA
/*9169*/      OPC_RecordChild2, // #1 = $vB
/*9170*/      OPC_MorphNodeTo, TARGET_VAL(PPC::VSRO), 0,
                  1/*#VTs*/, MVT::v4i32, 2/*#Ops*/, 0, 1, 
              // Src: (intrinsic_wo_chain:v4i32 1443:iPTR, VRRC:v4i32:$vA, VRRC:v4i32:$vB) - Complexity = 8
              // Dst: (VSRO:v4i32 VRRC:v4i32:$vA, VRRC:v4i32:$vB)
/*9179*/    /*Scope*/ 15, /*->9195*/
/*9180*/      OPC_CheckInteger, 30|128,11/*1438*/, 
/*9183*/      OPC_MoveParent,
/*9184*/      OPC_RecordChild1, // #0 = $vA
/*9185*/      OPC_RecordChild2, // #1 = $vB
/*9186*/      OPC_MorphNodeTo, TARGET_VAL(PPC::VSRAB), 0,
                  1/*#VTs*/, MVT::v16i8, 2/*#Ops*/, 0, 1, 
              // Src: (intrinsic_wo_chain:v16i8 1438:iPTR, VRRC:v16i8:$vA, VRRC:v16i8:$vB) - Complexity = 8
              // Dst: (VSRAB:v16i8 VRRC:v16i8:$vA, VRRC:v16i8:$vB)
/*9195*/    /*Scope*/ 15, /*->9211*/
/*9196*/      OPC_CheckInteger, 31|128,11/*1439*/, 
/*9199*/      OPC_MoveParent,
/*9200*/      OPC_RecordChild1, // #0 = $vA
/*9201*/      OPC_RecordChild2, // #1 = $vB
/*9202*/      OPC_MorphNodeTo, TARGET_VAL(PPC::VSRAH), 0,
                  1/*#VTs*/, MVT::v8i16, 2/*#Ops*/, 0, 1, 
              // Src: (intrinsic_wo_chain:v8i16 1439:iPTR, VRRC:v8i16:$vA, VRRC:v8i16:$vB) - Complexity = 8
              // Dst: (VSRAH:v8i16 VRRC:v8i16:$vA, VRRC:v8i16:$vB)
/*9211*/    /*Scope*/ 15, /*->9227*/
/*9212*/      OPC_CheckInteger, 32|128,11/*1440*/, 
/*9215*/      OPC_MoveParent,
/*9216*/      OPC_RecordChild1, // #0 = $vA
/*9217*/      OPC_RecordChild2, // #1 = $vB
/*9218*/      OPC_MorphNodeTo, TARGET_VAL(PPC::VSRAW), 0,
                  1/*#VTs*/, MVT::v4i32, 2/*#Ops*/, 0, 1, 
              // Src: (intrinsic_wo_chain:v4i32 1440:iPTR, VRRC:v4i32:$vA, VRRC:v4i32:$vB) - Complexity = 8
              // Dst: (VSRAW:v4i32 VRRC:v4i32:$vA, VRRC:v4i32:$vB)
/*9227*/    /*Scope*/ 15, /*->9243*/
/*9228*/      OPC_CheckInteger, 33|128,11/*1441*/, 
/*9231*/      OPC_MoveParent,
/*9232*/      OPC_RecordChild1, // #0 = $vA
/*9233*/      OPC_RecordChild2, // #1 = $vB
/*9234*/      OPC_MorphNodeTo, TARGET_VAL(PPC::VSRB), 0,
                  1/*#VTs*/, MVT::v16i8, 2/*#Ops*/, 0, 1, 
              // Src: (intrinsic_wo_chain:v16i8 1441:iPTR, VRRC:v16i8:$vA, VRRC:v16i8:$vB) - Complexity = 8
              // Dst: (VSRB:v16i8 VRRC:v16i8:$vA, VRRC:v16i8:$vB)
/*9243*/    /*Scope*/ 15, /*->9259*/
/*9244*/      OPC_CheckInteger, 34|128,11/*1442*/, 
/*9247*/      OPC_MoveParent,
/*9248*/      OPC_RecordChild1, // #0 = $vA
/*9249*/      OPC_RecordChild2, // #1 = $vB
/*9250*/      OPC_MorphNodeTo, TARGET_VAL(PPC::VSRH), 0,
                  1/*#VTs*/, MVT::v8i16, 2/*#Ops*/, 0, 1, 
              // Src: (intrinsic_wo_chain:v8i16 1442:iPTR, VRRC:v8i16:$vA, VRRC:v8i16:$vB) - Complexity = 8
              // Dst: (VSRH:v8i16 VRRC:v8i16:$vA, VRRC:v8i16:$vB)
/*9259*/    /*Scope*/ 15, /*->9275*/
/*9260*/      OPC_CheckInteger, 36|128,11/*1444*/, 
/*9263*/      OPC_MoveParent,
/*9264*/      OPC_RecordChild1, // #0 = $vA
/*9265*/      OPC_RecordChild2, // #1 = $vB
/*9266*/      OPC_MorphNodeTo, TARGET_VAL(PPC::VSRW), 0,
                  1/*#VTs*/, MVT::v4i32, 2/*#Ops*/, 0, 1, 
              // Src: (intrinsic_wo_chain:v4i32 1444:iPTR, VRRC:v4i32:$vA, VRRC:v4i32:$vB) - Complexity = 8
              // Dst: (VSRW:v4i32 VRRC:v4i32:$vA, VRRC:v4i32:$vB)
/*9275*/    /*Scope*/ 15, /*->9291*/
/*9276*/      OPC_CheckInteger, 7|128,11/*1415*/, 
/*9279*/      OPC_MoveParent,
/*9280*/      OPC_RecordChild1, // #0 = $vA
/*9281*/      OPC_RecordChild2, // #1 = $vB
/*9282*/      OPC_MorphNodeTo, TARGET_VAL(PPC::VPKPX), 0,
                  1/*#VTs*/, MVT::v8i16, 2/*#Ops*/, 0, 1, 
              // Src: (intrinsic_wo_chain:v8i16 1415:iPTR, VRRC:v4i32:$vA, VRRC:v4i32:$vB) - Complexity = 8
              // Dst: (VPKPX:v8i16 VRRC:v4i32:$vA, VRRC:v4i32:$vB)
/*9291*/    /*Scope*/ 15, /*->9307*/
/*9292*/      OPC_CheckInteger, 8|128,11/*1416*/, 
/*9295*/      OPC_MoveParent,
/*9296*/      OPC_RecordChild1, // #0 = $vA
/*9297*/      OPC_RecordChild2, // #1 = $vB
/*9298*/      OPC_MorphNodeTo, TARGET_VAL(PPC::VPKSHSS), 0,
                  1/*#VTs*/, MVT::v16i8, 2/*#Ops*/, 0, 1, 
              // Src: (intrinsic_wo_chain:v16i8 1416:iPTR, VRRC:v8i16:$vA, VRRC:v8i16:$vB) - Complexity = 8
              // Dst: (VPKSHSS:v16i8 VRRC:v8i16:$vA, VRRC:v8i16:$vB)
/*9307*/    /*Scope*/ 15, /*->9323*/
/*9308*/      OPC_CheckInteger, 9|128,11/*1417*/, 
/*9311*/      OPC_MoveParent,
/*9312*/      OPC_RecordChild1, // #0 = $vA
/*9313*/      OPC_RecordChild2, // #1 = $vB
/*9314*/      OPC_MorphNodeTo, TARGET_VAL(PPC::VPKSHUS), 0,
                  1/*#VTs*/, MVT::v16i8, 2/*#Ops*/, 0, 1, 
              // Src: (intrinsic_wo_chain:v16i8 1417:iPTR, VRRC:v8i16:$vA, VRRC:v8i16:$vB) - Complexity = 8
              // Dst: (VPKSHUS:v16i8 VRRC:v8i16:$vA, VRRC:v8i16:$vB)
/*9323*/    /*Scope*/ 15, /*->9339*/
/*9324*/      OPC_CheckInteger, 10|128,11/*1418*/, 
/*9327*/      OPC_MoveParent,
/*9328*/      OPC_RecordChild1, // #0 = $vA
/*9329*/      OPC_RecordChild2, // #1 = $vB
/*9330*/      OPC_MorphNodeTo, TARGET_VAL(PPC::VPKSWSS), 0,
                  1/*#VTs*/, MVT::v16i8, 2/*#Ops*/, 0, 1, 
              // Src: (intrinsic_wo_chain:v16i8 1418:iPTR, VRRC:v4i32:$vA, VRRC:v4i32:$vB) - Complexity = 8
              // Dst: (VPKSWSS:v16i8 VRRC:v4i32:$vA, VRRC:v4i32:$vB)
/*9339*/    /*Scope*/ 15, /*->9355*/
/*9340*/      OPC_CheckInteger, 11|128,11/*1419*/, 
/*9343*/      OPC_MoveParent,
/*9344*/      OPC_RecordChild1, // #0 = $vA
/*9345*/      OPC_RecordChild2, // #1 = $vB
/*9346*/      OPC_MorphNodeTo, TARGET_VAL(PPC::VPKSWUS), 0,
                  1/*#VTs*/, MVT::v8i16, 2/*#Ops*/, 0, 1, 
              // Src: (intrinsic_wo_chain:v8i16 1419:iPTR, VRRC:v4i32:$vA, VRRC:v4i32:$vB) - Complexity = 8
              // Dst: (VPKSWUS:v8i16 VRRC:v4i32:$vA, VRRC:v4i32:$vB)
/*9355*/    /*Scope*/ 15, /*->9371*/
/*9356*/      OPC_CheckInteger, 12|128,11/*1420*/, 
/*9359*/      OPC_MoveParent,
/*9360*/      OPC_RecordChild1, // #0 = $vA
/*9361*/      OPC_RecordChild2, // #1 = $vB
/*9362*/      OPC_MorphNodeTo, TARGET_VAL(PPC::VPKUHUS), 0,
                  1/*#VTs*/, MVT::v16i8, 2/*#Ops*/, 0, 1, 
              // Src: (intrinsic_wo_chain:v16i8 1420:iPTR, VRRC:v8i16:$vA, VRRC:v8i16:$vB) - Complexity = 8
              // Dst: (VPKUHUS:v16i8 VRRC:v8i16:$vA, VRRC:v8i16:$vB)
/*9371*/    /*Scope*/ 15, /*->9387*/
/*9372*/      OPC_CheckInteger, 13|128,11/*1421*/, 
/*9375*/      OPC_MoveParent,
/*9376*/      OPC_RecordChild1, // #0 = $vA
/*9377*/      OPC_RecordChild2, // #1 = $vB
/*9378*/      OPC_MorphNodeTo, TARGET_VAL(PPC::VPKUWUS), 0,
                  1/*#VTs*/, MVT::v8i16, 2/*#Ops*/, 0, 1, 
              // Src: (intrinsic_wo_chain:v8i16 1421:iPTR, VRRC:v4i32:$vA, VRRC:v4i32:$vB) - Complexity = 8
              // Dst: (VPKUWUS:v8i16 VRRC:v4i32:$vA, VRRC:v4i32:$vB)
/*9387*/    /*Scope*/ 13, /*->9401*/
/*9388*/      OPC_CheckInteger, 49|128,11/*1457*/, 
/*9391*/      OPC_MoveParent,
/*9392*/      OPC_RecordChild1, // #0 = $vB
/*9393*/      OPC_MorphNodeTo, TARGET_VAL(PPC::VUPKHPX), 0,
                  1/*#VTs*/, MVT::v4i32, 1/*#Ops*/, 0, 
              // Src: (intrinsic_wo_chain:v4i32 1457:iPTR, VRRC:v8i16:$vB) - Complexity = 8
              // Dst: (VUPKHPX:v4i32 VRRC:v8i16:$vB)
/*9401*/    /*Scope*/ 13, /*->9415*/
/*9402*/      OPC_CheckInteger, 50|128,11/*1458*/, 
/*9405*/      OPC_MoveParent,
/*9406*/      OPC_RecordChild1, // #0 = $vB
/*9407*/      OPC_MorphNodeTo, TARGET_VAL(PPC::VUPKHSB), 0,
                  1/*#VTs*/, MVT::v8i16, 1/*#Ops*/, 0, 
              // Src: (intrinsic_wo_chain:v8i16 1458:iPTR, VRRC:v16i8:$vB) - Complexity = 8
              // Dst: (VUPKHSB:v8i16 VRRC:v16i8:$vB)
/*9415*/    /*Scope*/ 13, /*->9429*/
/*9416*/      OPC_CheckInteger, 51|128,11/*1459*/, 
/*9419*/      OPC_MoveParent,
/*9420*/      OPC_RecordChild1, // #0 = $vB
/*9421*/      OPC_MorphNodeTo, TARGET_VAL(PPC::VUPKHSH), 0,
                  1/*#VTs*/, MVT::v4i32, 1/*#Ops*/, 0, 
              // Src: (intrinsic_wo_chain:v4i32 1459:iPTR, VRRC:v8i16:$vB) - Complexity = 8
              // Dst: (VUPKHSH:v4i32 VRRC:v8i16:$vB)
/*9429*/    /*Scope*/ 13, /*->9443*/
/*9430*/      OPC_CheckInteger, 52|128,11/*1460*/, 
/*9433*/      OPC_MoveParent,
/*9434*/      OPC_RecordChild1, // #0 = $vB
/*9435*/      OPC_MorphNodeTo, TARGET_VAL(PPC::VUPKLPX), 0,
                  1/*#VTs*/, MVT::v4i32, 1/*#Ops*/, 0, 
              // Src: (intrinsic_wo_chain:v4i32 1460:iPTR, VRRC:v8i16:$vB) - Complexity = 8
              // Dst: (VUPKLPX:v4i32 VRRC:v8i16:$vB)
/*9443*/    /*Scope*/ 13, /*->9457*/
/*9444*/      OPC_CheckInteger, 53|128,11/*1461*/, 
/*9447*/      OPC_MoveParent,
/*9448*/      OPC_RecordChild1, // #0 = $vB
/*9449*/      OPC_MorphNodeTo, TARGET_VAL(PPC::VUPKLSB), 0,
                  1/*#VTs*/, MVT::v8i16, 1/*#Ops*/, 0, 
              // Src: (intrinsic_wo_chain:v8i16 1461:iPTR, VRRC:v16i8:$vB) - Complexity = 8
              // Dst: (VUPKLSB:v8i16 VRRC:v16i8:$vB)
/*9457*/    /*Scope*/ 13, /*->9471*/
/*9458*/      OPC_CheckInteger, 54|128,11/*1462*/, 
/*9461*/      OPC_MoveParent,
/*9462*/      OPC_RecordChild1, // #0 = $vB
/*9463*/      OPC_MorphNodeTo, TARGET_VAL(PPC::VUPKLSH), 0,
                  1/*#VTs*/, MVT::v4i32, 1/*#Ops*/, 0, 
              // Src: (intrinsic_wo_chain:v4i32 1462:iPTR, VRRC:v8i16:$vB) - Complexity = 8
              // Dst: (VUPKLSH:v4i32 VRRC:v8i16:$vB)
/*9471*/    /*Scope*/ 23, /*->9495*/
/*9472*/      OPC_CheckInteger, 69|128,10/*1349*/, 
/*9475*/      OPC_MoveParent,
/*9476*/      OPC_RecordChild1, // #0 = $vB
/*9477*/      OPC_RecordChild2, // #1 = $UIMM
/*9478*/      OPC_MoveChild, 2,
/*9480*/      OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/*9483*/      OPC_MoveParent,
/*9484*/      OPC_EmitConvertToTarget, 1,
/*9486*/      OPC_MorphNodeTo, TARGET_VAL(PPC::VCFSX), 0,
                  1/*#VTs*/, MVT::v4f32, 2/*#Ops*/, 2, 0, 
              // Src: (intrinsic_wo_chain:v4f32 1349:iPTR, VRRC:v4i32:$vB, (imm:i32):$UIMM) - Complexity = 11
              // Dst: (VCFSX:v4f32 (imm:i32):$UIMM, VRRC:v4i32:$vB)
/*9495*/    /*Scope*/ 23, /*->9519*/
/*9496*/      OPC_CheckInteger, 70|128,10/*1350*/, 
/*9499*/      OPC_MoveParent,
/*9500*/      OPC_RecordChild1, // #0 = $vB
/*9501*/      OPC_RecordChild2, // #1 = $UIMM
/*9502*/      OPC_MoveChild, 2,
/*9504*/      OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/*9507*/      OPC_MoveParent,
/*9508*/      OPC_EmitConvertToTarget, 1,
/*9510*/      OPC_MorphNodeTo, TARGET_VAL(PPC::VCFUX), 0,
                  1/*#VTs*/, MVT::v4f32, 2/*#Ops*/, 2, 0, 
              // Src: (intrinsic_wo_chain:v4f32 1350:iPTR, VRRC:v4i32:$vB, (imm:i32):$UIMM) - Complexity = 11
              // Dst: (VCFUX:v4f32 (imm:i32):$UIMM, VRRC:v4i32:$vB)
/*9519*/    /*Scope*/ 13, /*->9533*/
/*9520*/      OPC_CheckInteger, 99|128,10/*1379*/, 
/*9523*/      OPC_MoveParent,
/*9524*/      OPC_RecordChild1, // #0 = $vB
/*9525*/      OPC_MorphNodeTo, TARGET_VAL(PPC::VEXPTEFP), 0,
                  1/*#VTs*/, MVT::v4f32, 1/*#Ops*/, 0, 
              // Src: (intrinsic_wo_chain:v4f32 1379:iPTR, VRRC:v4f32:$vB) - Complexity = 8
              // Dst: (VEXPTEFP:v4f32 VRRC:v4f32:$vB)
/*9533*/    /*Scope*/ 13, /*->9547*/
/*9534*/      OPC_CheckInteger, 100|128,10/*1380*/, 
/*9537*/      OPC_MoveParent,
/*9538*/      OPC_RecordChild1, // #0 = $vB
/*9539*/      OPC_MorphNodeTo, TARGET_VAL(PPC::VLOGEFP), 0,
                  1/*#VTs*/, MVT::v4f32, 1/*#Ops*/, 0, 
              // Src: (intrinsic_wo_chain:v4f32 1380:iPTR, VRRC:v4f32:$vB) - Complexity = 8
              // Dst: (VLOGEFP:v4f32 VRRC:v4f32:$vB)
/*9547*/    /*Scope*/ 15, /*->9563*/
/*9548*/      OPC_CheckInteger, 102|128,10/*1382*/, 
/*9551*/      OPC_MoveParent,
/*9552*/      OPC_RecordChild1, // #0 = $vA
/*9553*/      OPC_RecordChild2, // #1 = $vB
/*9554*/      OPC_MorphNodeTo, TARGET_VAL(PPC::VMAXFP), 0,
                  1/*#VTs*/, MVT::v4f32, 2/*#Ops*/, 0, 1, 
              // Src: (intrinsic_wo_chain:v4f32 1382:iPTR, VRRC:v4f32:$vA, VRRC:v4f32:$vB) - Complexity = 8
              // Dst: (VMAXFP:v4f32 VRRC:v4f32:$vA, VRRC:v4f32:$vB)
/*9563*/    /*Scope*/ 15, /*->9579*/
/*9564*/      OPC_CheckInteger, 111|128,10/*1391*/, 
/*9567*/      OPC_MoveParent,
/*9568*/      OPC_RecordChild1, // #0 = $vA
/*9569*/      OPC_RecordChild2, // #1 = $vB
/*9570*/      OPC_MorphNodeTo, TARGET_VAL(PPC::VMINFP), 0,
                  1/*#VTs*/, MVT::v4f32, 2/*#Ops*/, 0, 1, 
              // Src: (intrinsic_wo_chain:v4f32 1391:iPTR, VRRC:v4f32:$vA, VRRC:v4f32:$vB) - Complexity = 8
              // Dst: (VMINFP:v4f32 VRRC:v4f32:$vA, VRRC:v4f32:$vB)
/*9579*/    /*Scope*/ 13, /*->9593*/
/*9580*/      OPC_CheckInteger, 14|128,11/*1422*/, 
/*9583*/      OPC_MoveParent,
/*9584*/      OPC_RecordChild1, // #0 = $vB
/*9585*/      OPC_MorphNodeTo, TARGET_VAL(PPC::VREFP), 0,
                  1/*#VTs*/, MVT::v4f32, 1/*#Ops*/, 0, 
              // Src: (intrinsic_wo_chain:v4f32 1422:iPTR, VRRC:v4f32:$vB) - Complexity = 8
              // Dst: (VREFP:v4f32 VRRC:v4f32:$vB)
/*9593*/    /*Scope*/ 13, /*->9607*/
/*9594*/      OPC_CheckInteger, 15|128,11/*1423*/, 
/*9597*/      OPC_MoveParent,
/*9598*/      OPC_RecordChild1, // #0 = $vB
/*9599*/      OPC_MorphNodeTo, TARGET_VAL(PPC::VRFIM), 0,
                  1/*#VTs*/, MVT::v4f32, 1/*#Ops*/, 0, 
              // Src: (intrinsic_wo_chain:v4f32 1423:iPTR, VRRC:v4f32:$vB) - Complexity = 8
              // Dst: (VRFIM:v4f32 VRRC:v4f32:$vB)
/*9607*/    /*Scope*/ 13, /*->9621*/
/*9608*/      OPC_CheckInteger, 16|128,11/*1424*/, 
/*9611*/      OPC_MoveParent,
/*9612*/      OPC_RecordChild1, // #0 = $vB
/*9613*/      OPC_MorphNodeTo, TARGET_VAL(PPC::VRFIN), 0,
                  1/*#VTs*/, MVT::v4f32, 1/*#Ops*/, 0, 
              // Src: (intrinsic_wo_chain:v4f32 1424:iPTR, VRRC:v4f32:$vB) - Complexity = 8
              // Dst: (VRFIN:v4f32 VRRC:v4f32:$vB)
/*9621*/    /*Scope*/ 13, /*->9635*/
/*9622*/      OPC_CheckInteger, 17|128,11/*1425*/, 
/*9625*/      OPC_MoveParent,
/*9626*/      OPC_RecordChild1, // #0 = $vB
/*9627*/      OPC_MorphNodeTo, TARGET_VAL(PPC::VRFIP), 0,
                  1/*#VTs*/, MVT::v4f32, 1/*#Ops*/, 0, 
              // Src: (intrinsic_wo_chain:v4f32 1425:iPTR, VRRC:v4f32:$vB) - Complexity = 8
              // Dst: (VRFIP:v4f32 VRRC:v4f32:$vB)
/*9635*/    /*Scope*/ 13, /*->9649*/
/*9636*/      OPC_CheckInteger, 18|128,11/*1426*/, 
/*9639*/      OPC_MoveParent,
/*9640*/      OPC_RecordChild1, // #0 = $vB
/*9641*/      OPC_MorphNodeTo, TARGET_VAL(PPC::VRFIZ), 0,
                  1/*#VTs*/, MVT::v4f32, 1/*#Ops*/, 0, 
              // Src: (intrinsic_wo_chain:v4f32 1426:iPTR, VRRC:v4f32:$vB) - Complexity = 8
              // Dst: (VRFIZ:v4f32 VRRC:v4f32:$vB)
/*9649*/    /*Scope*/ 13, /*->9663*/
/*9650*/      OPC_CheckInteger, 22|128,11/*1430*/, 
/*9653*/      OPC_MoveParent,
/*9654*/      OPC_RecordChild1, // #0 = $vB
/*9655*/      OPC_MorphNodeTo, TARGET_VAL(PPC::VRSQRTEFP), 0,
                  1/*#VTs*/, MVT::v4f32, 1/*#Ops*/, 0, 
              // Src: (intrinsic_wo_chain:v4f32 1430:iPTR, VRRC:v4f32:$vB) - Complexity = 8
              // Dst: (VRSQRTEFP:v4f32 VRRC:v4f32:$vB)
/*9663*/    /*Scope*/ 17, /*->9681*/
/*9664*/      OPC_CheckInteger, 101|128,10/*1381*/, 
/*9667*/      OPC_MoveParent,
/*9668*/      OPC_RecordChild1, // #0 = $A
/*9669*/      OPC_RecordChild2, // #1 = $B
/*9670*/      OPC_RecordChild3, // #2 = $C
/*9671*/      OPC_MorphNodeTo, TARGET_VAL(PPC::VMADDFP), 0,
                  1/*#VTs*/, MVT::v4f32, 3/*#Ops*/, 0, 1, 2, 
              // Src: (intrinsic_wo_chain:v4f32 1381:iPTR, VRRC:v4f32:$A, VRRC:v4f32:$B, VRRC:v4f32:$C) - Complexity = 8
              // Dst: (VMADDFP:v4f32 VRRC:v4f32:$A, VRRC:v4f32:$B, VRRC:v4f32:$C)
/*9681*/    /*Scope*/ 17, /*->9699*/
/*9682*/      OPC_CheckInteger, 5|128,11/*1413*/, 
/*9685*/      OPC_MoveParent,
/*9686*/      OPC_RecordChild1, // #0 = $A
/*9687*/      OPC_RecordChild2, // #1 = $B
/*9688*/      OPC_RecordChild3, // #2 = $C
/*9689*/      OPC_MorphNodeTo, TARGET_VAL(PPC::VNMSUBFP), 0,
                  1/*#VTs*/, MVT::v4f32, 3/*#Ops*/, 0, 1, 2, 
              // Src: (intrinsic_wo_chain:v4f32 1413:iPTR, VRRC:v4f32:$A, VRRC:v4f32:$B, VRRC:v4f32:$C) - Complexity = 8
              // Dst: (VNMSUBFP:v4f32 VRRC:v4f32:$A, VRRC:v4f32:$B, VRRC:v4f32:$C)
/*9699*/    0, /*End of Scope*/
          /*SwitchOpcode*/ 84|128,1/*212*/,  TARGET_VAL(PPCISD::VCMP),// ->9916
/*9704*/    OPC_RecordChild0, // #0 = $vA
/*9705*/    OPC_RecordChild1, // #1 = $vB
/*9706*/    OPC_MoveChild, 2,
/*9708*/    OPC_Scope, 14, /*->9724*/ // 13 children in Scope
/*9710*/      OPC_CheckInteger, 6, 
/*9712*/      OPC_MoveParent,
/*9713*/      OPC_CheckType, MVT::v16i8,
/*9715*/      OPC_MorphNodeTo, TARGET_VAL(PPC::VCMPEQUB), 0,
                  1/*#VTs*/, MVT::v16i8, 2/*#Ops*/, 0, 1, 
              // Src: (PPCvcmp:v16i8 VRRC:v16i8:$vA, VRRC:v16i8:$vB, 6:i32) - Complexity = 8
              // Dst: (VCMPEQUB:v16i8 VRRC:v16i8:$vA, VRRC:v16i8:$vB)
/*9724*/    /*Scope*/ 15, /*->9740*/
/*9725*/      OPC_CheckInteger, 6|128,6/*774*/, 
/*9728*/      OPC_MoveParent,
/*9729*/      OPC_CheckType, MVT::v16i8,
/*9731*/      OPC_MorphNodeTo, TARGET_VAL(PPC::VCMPGTSB), 0,
                  1/*#VTs*/, MVT::v16i8, 2/*#Ops*/, 0, 1, 
              // Src: (PPCvcmp:v16i8 VRRC:v16i8:$vA, VRRC:v16i8:$vB, 774:i32) - Complexity = 8
              // Dst: (VCMPGTSB:v16i8 VRRC:v16i8:$vA, VRRC:v16i8:$vB)
/*9740*/    /*Scope*/ 15, /*->9756*/
/*9741*/      OPC_CheckInteger, 6|128,4/*518*/, 
/*9744*/      OPC_MoveParent,
/*9745*/      OPC_CheckType, MVT::v16i8,
/*9747*/      OPC_MorphNodeTo, TARGET_VAL(PPC::VCMPGTUB), 0,
                  1/*#VTs*/, MVT::v16i8, 2/*#Ops*/, 0, 1, 
              // Src: (PPCvcmp:v16i8 VRRC:v16i8:$vA, VRRC:v16i8:$vB, 518:i32) - Complexity = 8
              // Dst: (VCMPGTUB:v16i8 VRRC:v16i8:$vA, VRRC:v16i8:$vB)
/*9756*/    /*Scope*/ 14, /*->9771*/
/*9757*/      OPC_CheckInteger, 70, 
/*9759*/      OPC_MoveParent,
/*9760*/      OPC_CheckType, MVT::v8i16,
/*9762*/      OPC_MorphNodeTo, TARGET_VAL(PPC::VCMPEQUH), 0,
                  1/*#VTs*/, MVT::v8i16, 2/*#Ops*/, 0, 1, 
              // Src: (PPCvcmp:v8i16 VRRC:v8i16:$vA, VRRC:v8i16:$vB, 70:i32) - Complexity = 8
              // Dst: (VCMPEQUH:v8i16 VRRC:v8i16:$vA, VRRC:v8i16:$vB)
/*9771*/    /*Scope*/ 15, /*->9787*/
/*9772*/      OPC_CheckInteger, 70|128,6/*838*/, 
/*9775*/      OPC_MoveParent,
/*9776*/      OPC_CheckType, MVT::v8i16,
/*9778*/      OPC_MorphNodeTo, TARGET_VAL(PPC::VCMPGTSH), 0,
                  1/*#VTs*/, MVT::v8i16, 2/*#Ops*/, 0, 1, 
              // Src: (PPCvcmp:v8i16 VRRC:v8i16:$vA, VRRC:v8i16:$vB, 838:i32) - Complexity = 8
              // Dst: (VCMPGTSH:v8i16 VRRC:v8i16:$vA, VRRC:v8i16:$vB)
/*9787*/    /*Scope*/ 15, /*->9803*/
/*9788*/      OPC_CheckInteger, 70|128,4/*582*/, 
/*9791*/      OPC_MoveParent,
/*9792*/      OPC_CheckType, MVT::v8i16,
/*9794*/      OPC_MorphNodeTo, TARGET_VAL(PPC::VCMPGTUH), 0,
                  1/*#VTs*/, MVT::v8i16, 2/*#Ops*/, 0, 1, 
              // Src: (PPCvcmp:v8i16 VRRC:v8i16:$vA, VRRC:v8i16:$vB, 582:i32) - Complexity = 8
              // Dst: (VCMPGTUH:v8i16 VRRC:v8i16:$vA, VRRC:v8i16:$vB)
/*9803*/    /*Scope*/ 15, /*->9819*/
/*9804*/      OPC_CheckInteger, 6|128,1/*134*/, 
/*9807*/      OPC_MoveParent,
/*9808*/      OPC_CheckType, MVT::v4i32,
/*9810*/      OPC_MorphNodeTo, TARGET_VAL(PPC::VCMPEQUW), 0,
                  1/*#VTs*/, MVT::v4i32, 2/*#Ops*/, 0, 1, 
              // Src: (PPCvcmp:v4i32 VRRC:v4i32:$vA, VRRC:v4i32:$vB, 134:i32) - Complexity = 8
              // Dst: (VCMPEQUW:v4i32 VRRC:v4i32:$vA, VRRC:v4i32:$vB)
/*9819*/    /*Scope*/ 15, /*->9835*/
/*9820*/      OPC_CheckInteger, 6|128,7/*902*/, 
/*9823*/      OPC_MoveParent,
/*9824*/      OPC_CheckType, MVT::v4i32,
/*9826*/      OPC_MorphNodeTo, TARGET_VAL(PPC::VCMPGTSW), 0,
                  1/*#VTs*/, MVT::v4i32, 2/*#Ops*/, 0, 1, 
              // Src: (PPCvcmp:v4i32 VRRC:v4i32:$vA, VRRC:v4i32:$vB, 902:i32) - Complexity = 8
              // Dst: (VCMPGTSW:v4i32 VRRC:v4i32:$vA, VRRC:v4i32:$vB)
/*9835*/    /*Scope*/ 15, /*->9851*/
/*9836*/      OPC_CheckInteger, 6|128,5/*646*/, 
/*9839*/      OPC_MoveParent,
/*9840*/      OPC_CheckType, MVT::v4i32,
/*9842*/      OPC_MorphNodeTo, TARGET_VAL(PPC::VCMPGTUW), 0,
                  1/*#VTs*/, MVT::v4i32, 2/*#Ops*/, 0, 1, 
              // Src: (PPCvcmp:v4i32 VRRC:v4i32:$vA, VRRC:v4i32:$vB, 646:i32) - Complexity = 8
              // Dst: (VCMPGTUW:v4i32 VRRC:v4i32:$vA, VRRC:v4i32:$vB)
/*9851*/    /*Scope*/ 15, /*->9867*/
/*9852*/      OPC_CheckInteger, 70|128,7/*966*/, 
/*9855*/      OPC_MoveParent,
/*9856*/      OPC_CheckType, MVT::v4f32,
/*9858*/      OPC_MorphNodeTo, TARGET_VAL(PPC::VCMPBFP), 0,
                  1/*#VTs*/, MVT::v4f32, 2/*#Ops*/, 0, 1, 
              // Src: (PPCvcmp:v4f32 VRRC:v4f32:$vA, VRRC:v4f32:$vB, 966:i32) - Complexity = 8
              // Dst: (VCMPBFP:v4f32 VRRC:v4f32:$vA, VRRC:v4f32:$vB)
/*9867*/    /*Scope*/ 15, /*->9883*/
/*9868*/      OPC_CheckInteger, 70|128,1/*198*/, 
/*9871*/      OPC_MoveParent,
/*9872*/      OPC_CheckType, MVT::v4f32,
/*9874*/      OPC_MorphNodeTo, TARGET_VAL(PPC::VCMPEQFP), 0,
                  1/*#VTs*/, MVT::v4f32, 2/*#Ops*/, 0, 1, 
              // Src: (PPCvcmp:v4f32 VRRC:v4f32:$vA, VRRC:v4f32:$vB, 198:i32) - Complexity = 8
              // Dst: (VCMPEQFP:v4f32 VRRC:v4f32:$vA, VRRC:v4f32:$vB)
/*9883*/    /*Scope*/ 15, /*->9899*/
/*9884*/      OPC_CheckInteger, 70|128,3/*454*/, 
/*9887*/      OPC_MoveParent,
/*9888*/      OPC_CheckType, MVT::v4f32,
/*9890*/      OPC_MorphNodeTo, TARGET_VAL(PPC::VCMPGEFP), 0,
                  1/*#VTs*/, MVT::v4f32, 2/*#Ops*/, 0, 1, 
              // Src: (PPCvcmp:v4f32 VRRC:v4f32:$vA, VRRC:v4f32:$vB, 454:i32) - Complexity = 8
              // Dst: (VCMPGEFP:v4f32 VRRC:v4f32:$vA, VRRC:v4f32:$vB)
/*9899*/    /*Scope*/ 15, /*->9915*/
/*9900*/      OPC_CheckInteger, 70|128,5/*710*/, 
/*9903*/      OPC_MoveParent,
/*9904*/      OPC_CheckType, MVT::v4f32,
/*9906*/      OPC_MorphNodeTo, TARGET_VAL(PPC::VCMPGTFP), 0,
                  1/*#VTs*/, MVT::v4f32, 2/*#Ops*/, 0, 1, 
              // Src: (PPCvcmp:v4f32 VRRC:v4f32:$vA, VRRC:v4f32:$vB, 710:i32) - Complexity = 8
              // Dst: (VCMPGTFP:v4f32 VRRC:v4f32:$vA, VRRC:v4f32:$vB)
/*9915*/    0, /*End of Scope*/
          /*SwitchOpcode*/ 97|128,1/*225*/,  TARGET_VAL(PPCISD::VCMPo),// ->10145
/*9920*/    OPC_RecordChild0, // #0 = $vA
/*9921*/    OPC_RecordChild1, // #1 = $vB
/*9922*/    OPC_MoveChild, 2,
/*9924*/    OPC_Scope, 15, /*->9941*/ // 13 children in Scope
/*9926*/      OPC_CheckInteger, 6, 
/*9928*/      OPC_MoveParent,
/*9929*/      OPC_CheckType, MVT::v16i8,
/*9931*/      OPC_MorphNodeTo, TARGET_VAL(PPC::VCMPEQUBo), 0|OPFL_GlueOutput,
                  2/*#VTs*/, MVT::v16i8, MVT::i32, 2/*#Ops*/, 0, 1, 
              // Src: (PPCvcmp_o:v16i8 VRRC:v16i8:$vA, VRRC:v16i8:$vB, 6:i32) - Complexity = 8
              // Dst: (VCMPEQUBo:v16i8:i32 VRRC:v16i8:$vA, VRRC:v16i8:$vB)
/*9941*/    /*Scope*/ 16, /*->9958*/
/*9942*/      OPC_CheckInteger, 6|128,6/*774*/, 
/*9945*/      OPC_MoveParent,
/*9946*/      OPC_CheckType, MVT::v16i8,
/*9948*/      OPC_MorphNodeTo, TARGET_VAL(PPC::VCMPGTSBo), 0|OPFL_GlueOutput,
                  2/*#VTs*/, MVT::v16i8, MVT::i32, 2/*#Ops*/, 0, 1, 
              // Src: (PPCvcmp_o:v16i8 VRRC:v16i8:$vA, VRRC:v16i8:$vB, 774:i32) - Complexity = 8
              // Dst: (VCMPGTSBo:v16i8:i32 VRRC:v16i8:$vA, VRRC:v16i8:$vB)
/*9958*/    /*Scope*/ 16, /*->9975*/
/*9959*/      OPC_CheckInteger, 6|128,4/*518*/, 
/*9962*/      OPC_MoveParent,
/*9963*/      OPC_CheckType, MVT::v16i8,
/*9965*/      OPC_MorphNodeTo, TARGET_VAL(PPC::VCMPGTUBo), 0|OPFL_GlueOutput,
                  2/*#VTs*/, MVT::v16i8, MVT::i32, 2/*#Ops*/, 0, 1, 
              // Src: (PPCvcmp_o:v16i8 VRRC:v16i8:$vA, VRRC:v16i8:$vB, 518:i32) - Complexity = 8
              // Dst: (VCMPGTUBo:v16i8:i32 VRRC:v16i8:$vA, VRRC:v16i8:$vB)
/*9975*/    /*Scope*/ 15, /*->9991*/
/*9976*/      OPC_CheckInteger, 70, 
/*9978*/      OPC_MoveParent,
/*9979*/      OPC_CheckType, MVT::v8i16,
/*9981*/      OPC_MorphNodeTo, TARGET_VAL(PPC::VCMPEQUHo), 0|OPFL_GlueOutput,
                  2/*#VTs*/, MVT::v8i16, MVT::i32, 2/*#Ops*/, 0, 1, 
              // Src: (PPCvcmp_o:v8i16 VRRC:v8i16:$vA, VRRC:v8i16:$vB, 70:i32) - Complexity = 8
              // Dst: (VCMPEQUHo:v8i16:i32 VRRC:v8i16:$vA, VRRC:v8i16:$vB)
/*9991*/    /*Scope*/ 16, /*->10008*/
/*9992*/      OPC_CheckInteger, 70|128,6/*838*/, 
/*9995*/      OPC_MoveParent,
/*9996*/      OPC_CheckType, MVT::v8i16,
/*9998*/      OPC_MorphNodeTo, TARGET_VAL(PPC::VCMPGTSHo), 0|OPFL_GlueOutput,
                  2/*#VTs*/, MVT::v8i16, MVT::i32, 2/*#Ops*/, 0, 1, 
              // Src: (PPCvcmp_o:v8i16 VRRC:v8i16:$vA, VRRC:v8i16:$vB, 838:i32) - Complexity = 8
              // Dst: (VCMPGTSHo:v8i16:i32 VRRC:v8i16:$vA, VRRC:v8i16:$vB)
/*10008*/   /*Scope*/ 16, /*->10025*/
/*10009*/     OPC_CheckInteger, 70|128,4/*582*/, 
/*10012*/     OPC_MoveParent,
/*10013*/     OPC_CheckType, MVT::v8i16,
/*10015*/     OPC_MorphNodeTo, TARGET_VAL(PPC::VCMPGTUHo), 0|OPFL_GlueOutput,
                  2/*#VTs*/, MVT::v8i16, MVT::i32, 2/*#Ops*/, 0, 1, 
              // Src: (PPCvcmp_o:v8i16 VRRC:v8i16:$vA, VRRC:v8i16:$vB, 582:i32) - Complexity = 8
              // Dst: (VCMPGTUHo:v8i16:i32 VRRC:v8i16:$vA, VRRC:v8i16:$vB)
/*10025*/   /*Scope*/ 16, /*->10042*/
/*10026*/     OPC_CheckInteger, 6|128,1/*134*/, 
/*10029*/     OPC_MoveParent,
/*10030*/     OPC_CheckType, MVT::v4i32,
/*10032*/     OPC_MorphNodeTo, TARGET_VAL(PPC::VCMPEQUWo), 0|OPFL_GlueOutput,
                  2/*#VTs*/, MVT::v4i32, MVT::i32, 2/*#Ops*/, 0, 1, 
              // Src: (PPCvcmp_o:v4i32 VRRC:v4i32:$vA, VRRC:v4i32:$vB, 134:i32) - Complexity = 8
              // Dst: (VCMPEQUWo:v4i32:i32 VRRC:v4i32:$vA, VRRC:v4i32:$vB)
/*10042*/   /*Scope*/ 16, /*->10059*/
/*10043*/     OPC_CheckInteger, 6|128,7/*902*/, 
/*10046*/     OPC_MoveParent,
/*10047*/     OPC_CheckType, MVT::v4i32,
/*10049*/     OPC_MorphNodeTo, TARGET_VAL(PPC::VCMPGTSWo), 0|OPFL_GlueOutput,
                  2/*#VTs*/, MVT::v4i32, MVT::i32, 2/*#Ops*/, 0, 1, 
              // Src: (PPCvcmp_o:v4i32 VRRC:v4i32:$vA, VRRC:v4i32:$vB, 902:i32) - Complexity = 8
              // Dst: (VCMPGTSWo:v4i32:i32 VRRC:v4i32:$vA, VRRC:v4i32:$vB)
/*10059*/   /*Scope*/ 16, /*->10076*/
/*10060*/     OPC_CheckInteger, 6|128,5/*646*/, 
/*10063*/     OPC_MoveParent,
/*10064*/     OPC_CheckType, MVT::v4i32,
/*10066*/     OPC_MorphNodeTo, TARGET_VAL(PPC::VCMPGTUWo), 0|OPFL_GlueOutput,
                  2/*#VTs*/, MVT::v4i32, MVT::i32, 2/*#Ops*/, 0, 1, 
              // Src: (PPCvcmp_o:v4i32 VRRC:v4i32:$vA, VRRC:v4i32:$vB, 646:i32) - Complexity = 8
              // Dst: (VCMPGTUWo:v4i32:i32 VRRC:v4i32:$vA, VRRC:v4i32:$vB)
/*10076*/   /*Scope*/ 16, /*->10093*/
/*10077*/     OPC_CheckInteger, 70|128,7/*966*/, 
/*10080*/     OPC_MoveParent,
/*10081*/     OPC_CheckType, MVT::v4f32,
/*10083*/     OPC_MorphNodeTo, TARGET_VAL(PPC::VCMPBFPo), 0|OPFL_GlueOutput,
                  2/*#VTs*/, MVT::v4f32, MVT::i32, 2/*#Ops*/, 0, 1, 
              // Src: (PPCvcmp_o:v4f32 VRRC:v4f32:$vA, VRRC:v4f32:$vB, 966:i32) - Complexity = 8
              // Dst: (VCMPBFPo:v4f32:i32 VRRC:v4f32:$vA, VRRC:v4f32:$vB)
/*10093*/   /*Scope*/ 16, /*->10110*/
/*10094*/     OPC_CheckInteger, 70|128,1/*198*/, 
/*10097*/     OPC_MoveParent,
/*10098*/     OPC_CheckType, MVT::v4f32,
/*10100*/     OPC_MorphNodeTo, TARGET_VAL(PPC::VCMPEQFPo), 0|OPFL_GlueOutput,
                  2/*#VTs*/, MVT::v4f32, MVT::i32, 2/*#Ops*/, 0, 1, 
              // Src: (PPCvcmp_o:v4f32 VRRC:v4f32:$vA, VRRC:v4f32:$vB, 198:i32) - Complexity = 8
              // Dst: (VCMPEQFPo:v4f32:i32 VRRC:v4f32:$vA, VRRC:v4f32:$vB)
/*10110*/   /*Scope*/ 16, /*->10127*/
/*10111*/     OPC_CheckInteger, 70|128,3/*454*/, 
/*10114*/     OPC_MoveParent,
/*10115*/     OPC_CheckType, MVT::v4f32,
/*10117*/     OPC_MorphNodeTo, TARGET_VAL(PPC::VCMPGEFPo), 0|OPFL_GlueOutput,
                  2/*#VTs*/, MVT::v4f32, MVT::i32, 2/*#Ops*/, 0, 1, 
              // Src: (PPCvcmp_o:v4f32 VRRC:v4f32:$vA, VRRC:v4f32:$vB, 454:i32) - Complexity = 8
              // Dst: (VCMPGEFPo:v4f32:i32 VRRC:v4f32:$vA, VRRC:v4f32:$vB)
/*10127*/   /*Scope*/ 16, /*->10144*/
/*10128*/     OPC_CheckInteger, 70|128,5/*710*/, 
/*10131*/     OPC_MoveParent,
/*10132*/     OPC_CheckType, MVT::v4f32,
/*10134*/     OPC_MorphNodeTo, TARGET_VAL(PPC::VCMPGTFPo), 0|OPFL_GlueOutput,
                  2/*#VTs*/, MVT::v4f32, MVT::i32, 2/*#Ops*/, 0, 1, 
              // Src: (PPCvcmp_o:v4f32 VRRC:v4f32:$vA, VRRC:v4f32:$vB, 710:i32) - Complexity = 8
              // Dst: (VCMPGTFPo:v4f32:i32 VRRC:v4f32:$vA, VRRC:v4f32:$vB)
/*10144*/   0, /*End of Scope*/
          /*SwitchOpcode*/ 52|128,2/*308*/,  TARGET_VAL(ISD::VECTOR_SHUFFLE),// ->10457
/*10149*/   OPC_Scope, 73, /*->10224*/ // 4 children in Scope
/*10151*/     OPC_RecordNode, // #0 = $UIMM
/*10152*/     OPC_RecordChild0, // #1 = $vB
/*10153*/     OPC_MoveChild, 1,
/*10155*/     OPC_CheckOpcode, TARGET_VAL(ISD::UNDEF),
/*10158*/     OPC_MoveParent,
/*10159*/     OPC_CheckType, MVT::v16i8,
/*10161*/     OPC_Scope, 14, /*->10177*/ // 4 children in Scope
/*10163*/       OPC_CheckPredicate, 68, // Predicate_vspltb_shuffle
/*10165*/       OPC_EmitNodeXForm, 9, 0, // VSPLTB_get_imm
/*10168*/       OPC_MorphNodeTo, TARGET_VAL(PPC::VSPLTB), 0,
                    1/*#VTs*/, MVT::v16i8, 2/*#Ops*/, 2, 1, 
                // Src: (vector_shuffle:v16i8 VRRC:v16i8:$vB, (undef:v16i8))<<P:Predicate_vspltb_shuffle>><<X:VSPLTB_get_imm>>:$UIMM - Complexity = 7
                // Dst: (VSPLTB:v16i8 (VSPLTB_get_imm:i32 (vector_shuffle:v16i8 VRRC:v16i8:$vB, (undef:v16i8)):$UIMM), VRRC:v16i8:$vB)
/*10177*/     /*Scope*/ 14, /*->10192*/
/*10178*/       OPC_CheckPredicate, 69, // Predicate_vsplth_shuffle
/*10180*/       OPC_EmitNodeXForm, 10, 0, // VSPLTH_get_imm
/*10183*/       OPC_MorphNodeTo, TARGET_VAL(PPC::VSPLTH), 0,
                    1/*#VTs*/, MVT::v16i8, 2/*#Ops*/, 2, 1, 
                // Src: (vector_shuffle:v16i8 VRRC:v16i8:$vB, (undef:v16i8))<<P:Predicate_vsplth_shuffle>><<X:VSPLTH_get_imm>>:$UIMM - Complexity = 7
                // Dst: (VSPLTH:v16i8 (VSPLTH_get_imm:i32 (vector_shuffle:v16i8 VRRC:v16i8:$vB, (undef:v16i8)):$UIMM), VRRC:v16i8:$vB)
/*10192*/     /*Scope*/ 14, /*->10207*/
/*10193*/       OPC_CheckPredicate, 70, // Predicate_vspltw_shuffle
/*10195*/       OPC_EmitNodeXForm, 11, 0, // VSPLTW_get_imm
/*10198*/       OPC_MorphNodeTo, TARGET_VAL(PPC::VSPLTW), 0,
                    1/*#VTs*/, MVT::v16i8, 2/*#Ops*/, 2, 1, 
                // Src: (vector_shuffle:v16i8 VRRC:v16i8:$vB, (undef:v16i8))<<P:Predicate_vspltw_shuffle>><<X:VSPLTW_get_imm>>:$UIMM - Complexity = 7
                // Dst: (VSPLTW:v16i8 (VSPLTW_get_imm:i32 (vector_shuffle:v16i8 VRRC:v16i8:$vB, (undef:v16i8)):$UIMM), VRRC:v16i8:$vB)
/*10207*/     /*Scope*/ 15, /*->10223*/
/*10208*/       OPC_CheckPredicate, 71, // Predicate_vsldoi_unary_shuffle
/*10210*/       OPC_EmitNodeXForm, 12, 0, // VSLDOI_unary_get_imm
/*10213*/       OPC_MorphNodeTo, TARGET_VAL(PPC::VSLDOI), 0,
                    1/*#VTs*/, MVT::v16i8, 3/*#Ops*/, 1, 1, 2, 
                // Src: (vector_shuffle:v16i8 VRRC:v16i8:$vA, (undef:v16i8))<<P:Predicate_vsldoi_unary_shuffle>><<X:VSLDOI_unary_get_imm>>:$in - Complexity = 7
                // Dst: (VSLDOI:v16i8 VRRC:v16i8:$vA, VRRC:v16i8:$vA, (VSLDOI_unary_get_imm:i32 VRRC:v16i8:$in))
/*10223*/     0, /*End of Scope*/
/*10224*/   /*Scope*/ 107, /*->10332*/
/*10225*/     OPC_RecordChild0, // #0 = $vA
/*10226*/     OPC_MoveChild, 1,
/*10228*/     OPC_CheckOpcode, TARGET_VAL(ISD::UNDEF),
/*10231*/     OPC_MoveParent,
/*10232*/     OPC_CheckType, MVT::v16i8,
/*10234*/     OPC_Scope, 11, /*->10247*/ // 8 children in Scope
/*10236*/       OPC_CheckPredicate, 72, // Predicate_vpkuwum_unary_shuffle
/*10238*/       OPC_MorphNodeTo, TARGET_VAL(PPC::VPKUWUM), 0,
                    1/*#VTs*/, MVT::v16i8, 2/*#Ops*/, 0, 0, 
                // Src: (vector_shuffle:v16i8 VRRC:v16i8:$vA, (undef:v16i8))<<P:Predicate_vpkuwum_unary_shuffle>> - Complexity = 7
                // Dst: (VPKUWUM:v16i8 VRRC:v16i8:$vA, VRRC:v16i8:$vA)
/*10247*/     /*Scope*/ 11, /*->10259*/
/*10248*/       OPC_CheckPredicate, 73, // Predicate_vpkuhum_unary_shuffle
/*10250*/       OPC_MorphNodeTo, TARGET_VAL(PPC::VPKUHUM), 0,
                    1/*#VTs*/, MVT::v16i8, 2/*#Ops*/, 0, 0, 
                // Src: (vector_shuffle:v16i8 VRRC:v16i8:$vA, (undef:v16i8))<<P:Predicate_vpkuhum_unary_shuffle>> - Complexity = 7
                // Dst: (VPKUHUM:v16i8 VRRC:v16i8:$vA, VRRC:v16i8:$vA)
/*10259*/     /*Scope*/ 11, /*->10271*/
/*10260*/       OPC_CheckPredicate, 74, // Predicate_vmrglb_unary_shuffle
/*10262*/       OPC_MorphNodeTo, TARGET_VAL(PPC::VMRGLB), 0,
                    1/*#VTs*/, MVT::v16i8, 2/*#Ops*/, 0, 0, 
                // Src: (vector_shuffle:v16i8 VRRC:v16i8:$vA, (undef:v16i8))<<P:Predicate_vmrglb_unary_shuffle>> - Complexity = 7
                // Dst: (VMRGLB:v16i8 VRRC:v16i8:$vA, VRRC:v16i8:$vA)
/*10271*/     /*Scope*/ 11, /*->10283*/
/*10272*/       OPC_CheckPredicate, 75, // Predicate_vmrglh_unary_shuffle
/*10274*/       OPC_MorphNodeTo, TARGET_VAL(PPC::VMRGLH), 0,
                    1/*#VTs*/, MVT::v16i8, 2/*#Ops*/, 0, 0, 
                // Src: (vector_shuffle:v16i8 VRRC:v16i8:$vA, (undef:v16i8))<<P:Predicate_vmrglh_unary_shuffle>> - Complexity = 7
                // Dst: (VMRGLH:v16i8 VRRC:v16i8:$vA, VRRC:v16i8:$vA)
/*10283*/     /*Scope*/ 11, /*->10295*/
/*10284*/       OPC_CheckPredicate, 76, // Predicate_vmrglw_unary_shuffle
/*10286*/       OPC_MorphNodeTo, TARGET_VAL(PPC::VMRGLW), 0,
                    1/*#VTs*/, MVT::v16i8, 2/*#Ops*/, 0, 0, 
                // Src: (vector_shuffle:v16i8 VRRC:v16i8:$vA, (undef:v16i8))<<P:Predicate_vmrglw_unary_shuffle>> - Complexity = 7
                // Dst: (VMRGLW:v16i8 VRRC:v16i8:$vA, VRRC:v16i8:$vA)
/*10295*/     /*Scope*/ 11, /*->10307*/
/*10296*/       OPC_CheckPredicate, 77, // Predicate_vmrghb_unary_shuffle
/*10298*/       OPC_MorphNodeTo, TARGET_VAL(PPC::VMRGHB), 0,
                    1/*#VTs*/, MVT::v16i8, 2/*#Ops*/, 0, 0, 
                // Src: (vector_shuffle:v16i8 VRRC:v16i8:$vA, (undef:v16i8))<<P:Predicate_vmrghb_unary_shuffle>> - Complexity = 7
                // Dst: (VMRGHB:v16i8 VRRC:v16i8:$vA, VRRC:v16i8:$vA)
/*10307*/     /*Scope*/ 11, /*->10319*/
/*10308*/       OPC_CheckPredicate, 78, // Predicate_vmrghh_unary_shuffle
/*10310*/       OPC_MorphNodeTo, TARGET_VAL(PPC::VMRGHH), 0,
                    1/*#VTs*/, MVT::v16i8, 2/*#Ops*/, 0, 0, 
                // Src: (vector_shuffle:v16i8 VRRC:v16i8:$vA, (undef:v16i8))<<P:Predicate_vmrghh_unary_shuffle>> - Complexity = 7
                // Dst: (VMRGHH:v16i8 VRRC:v16i8:$vA, VRRC:v16i8:$vA)
/*10319*/     /*Scope*/ 11, /*->10331*/
/*10320*/       OPC_CheckPredicate, 79, // Predicate_vmrghw_unary_shuffle
/*10322*/       OPC_MorphNodeTo, TARGET_VAL(PPC::VMRGHW), 0,
                    1/*#VTs*/, MVT::v16i8, 2/*#Ops*/, 0, 0, 
                // Src: (vector_shuffle:v16i8 VRRC:v16i8:$vA, (undef:v16i8))<<P:Predicate_vmrghw_unary_shuffle>> - Complexity = 7
                // Dst: (VMRGHW:v16i8 VRRC:v16i8:$vA, VRRC:v16i8:$vA)
/*10331*/     0, /*End of Scope*/
/*10332*/   /*Scope*/ 20, /*->10353*/
/*10333*/     OPC_RecordNode, // #0 = $SH
/*10334*/     OPC_RecordChild0, // #1 = $vA
/*10335*/     OPC_RecordChild1, // #2 = $vB
/*10336*/     OPC_CheckPredicate, 80, // Predicate_vsldoi_shuffle
/*10338*/     OPC_CheckType, MVT::v16i8,
/*10340*/     OPC_EmitNodeXForm, 13, 0, // VSLDOI_get_imm
/*10343*/     OPC_MorphNodeTo, TARGET_VAL(PPC::VSLDOI), 0,
                  1/*#VTs*/, MVT::v16i8, 3/*#Ops*/, 1, 2, 3, 
              // Src: (vector_shuffle:v16i8 VRRC:v16i8:$vA, VRRC:v16i8:$vB)<<P:Predicate_vsldoi_shuffle>><<X:VSLDOI_get_imm>>:$SH - Complexity = 4
              // Dst: (VSLDOI:v16i8 VRRC:v16i8:$vA, VRRC:v16i8:$vB, (VSLDOI_get_imm:i32 (vector_shuffle:v16i8 VRRC:v16i8:$vA, VRRC:v16i8:$vB):$SH))
/*10353*/   /*Scope*/ 102, /*->10456*/
/*10354*/     OPC_RecordChild0, // #0 = $vA
/*10355*/     OPC_RecordChild1, // #1 = $vB
/*10356*/     OPC_CheckType, MVT::v16i8,
/*10358*/     OPC_Scope, 11, /*->10371*/ // 8 children in Scope
/*10360*/       OPC_CheckPredicate, 81, // Predicate_vmrghb_shuffle
/*10362*/       OPC_MorphNodeTo, TARGET_VAL(PPC::VMRGHB), 0,
                    1/*#VTs*/, MVT::v16i8, 2/*#Ops*/, 0, 1, 
                // Src: (vector_shuffle:v16i8 VRRC:v16i8:$vA, VRRC:v16i8:$vB)<<P:Predicate_vmrghb_shuffle>> - Complexity = 4
                // Dst: (VMRGHB:v16i8 VRRC:v16i8:$vA, VRRC:v16i8:$vB)
/*10371*/     /*Scope*/ 11, /*->10383*/
/*10372*/       OPC_CheckPredicate, 82, // Predicate_vmrghh_shuffle
/*10374*/       OPC_MorphNodeTo, TARGET_VAL(PPC::VMRGHH), 0,
                    1/*#VTs*/, MVT::v16i8, 2/*#Ops*/, 0, 1, 
                // Src: (vector_shuffle:v16i8 VRRC:v16i8:$vA, VRRC:v16i8:$vB)<<P:Predicate_vmrghh_shuffle>> - Complexity = 4
                // Dst: (VMRGHH:v16i8 VRRC:v16i8:$vA, VRRC:v16i8:$vB)
/*10383*/     /*Scope*/ 11, /*->10395*/
/*10384*/       OPC_CheckPredicate, 83, // Predicate_vmrghw_shuffle
/*10386*/       OPC_MorphNodeTo, TARGET_VAL(PPC::VMRGHW), 0,
                    1/*#VTs*/, MVT::v16i8, 2/*#Ops*/, 0, 1, 
                // Src: (vector_shuffle:v16i8 VRRC:v16i8:$vA, VRRC:v16i8:$vB)<<P:Predicate_vmrghw_shuffle>> - Complexity = 4
                // Dst: (VMRGHW:v16i8 VRRC:v16i8:$vA, VRRC:v16i8:$vB)
/*10395*/     /*Scope*/ 11, /*->10407*/
/*10396*/       OPC_CheckPredicate, 84, // Predicate_vmrglb_shuffle
/*10398*/       OPC_MorphNodeTo, TARGET_VAL(PPC::VMRGLB), 0,
                    1/*#VTs*/, MVT::v16i8, 2/*#Ops*/, 0, 1, 
                // Src: (vector_shuffle:v16i8 VRRC:v16i8:$vA, VRRC:v16i8:$vB)<<P:Predicate_vmrglb_shuffle>> - Complexity = 4
                // Dst: (VMRGLB:v16i8 VRRC:v16i8:$vA, VRRC:v16i8:$vB)
/*10407*/     /*Scope*/ 11, /*->10419*/
/*10408*/       OPC_CheckPredicate, 85, // Predicate_vmrglh_shuffle
/*10410*/       OPC_MorphNodeTo, TARGET_VAL(PPC::VMRGLH), 0,
                    1/*#VTs*/, MVT::v16i8, 2/*#Ops*/, 0, 1, 
                // Src: (vector_shuffle:v16i8 VRRC:v16i8:$vA, VRRC:v16i8:$vB)<<P:Predicate_vmrglh_shuffle>> - Complexity = 4
                // Dst: (VMRGLH:v16i8 VRRC:v16i8:$vA, VRRC:v16i8:$vB)
/*10419*/     /*Scope*/ 11, /*->10431*/
/*10420*/       OPC_CheckPredicate, 86, // Predicate_vmrglw_shuffle
/*10422*/       OPC_MorphNodeTo, TARGET_VAL(PPC::VMRGLW), 0,
                    1/*#VTs*/, MVT::v16i8, 2/*#Ops*/, 0, 1, 
                // Src: (vector_shuffle:v16i8 VRRC:v16i8:$vA, VRRC:v16i8:$vB)<<P:Predicate_vmrglw_shuffle>> - Complexity = 4
                // Dst: (VMRGLW:v16i8 VRRC:v16i8:$vA, VRRC:v16i8:$vB)
/*10431*/     /*Scope*/ 11, /*->10443*/
/*10432*/       OPC_CheckPredicate, 87, // Predicate_vpkuhum_shuffle
/*10434*/       OPC_MorphNodeTo, TARGET_VAL(PPC::VPKUHUM), 0,
                    1/*#VTs*/, MVT::v16i8, 2/*#Ops*/, 0, 1, 
                // Src: (vector_shuffle:v16i8 VRRC:v16i8:$vA, VRRC:v16i8:$vB)<<P:Predicate_vpkuhum_shuffle>> - Complexity = 4
                // Dst: (VPKUHUM:v16i8 VRRC:v16i8:$vA, VRRC:v16i8:$vB)
/*10443*/     /*Scope*/ 11, /*->10455*/
/*10444*/       OPC_CheckPredicate, 88, // Predicate_vpkuwum_shuffle
/*10446*/       OPC_MorphNodeTo, TARGET_VAL(PPC::VPKUWUM), 0,
                    1/*#VTs*/, MVT::v16i8, 2/*#Ops*/, 0, 1, 
                // Src: (vector_shuffle:v16i8 VRRC:v16i8:$vA, VRRC:v16i8:$vB)<<P:Predicate_vpkuwum_shuffle>> - Complexity = 4
                // Dst: (VPKUWUM:v16i8 VRRC:v16i8:$vA, VRRC:v16i8:$vB)
/*10455*/     0, /*End of Scope*/
/*10456*/   0, /*End of Scope*/
          /*SwitchOpcode*/ 17,  TARGET_VAL(ISD::CALLSEQ_START),// ->10477
/*10460*/   OPC_RecordNode,   // #0 = 'callseq_start' chained node
/*10461*/   OPC_RecordChild1, // #1 = $amt
/*10462*/   OPC_MoveChild, 1,
/*10464*/   OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/*10467*/   OPC_MoveParent,
/*10468*/   OPC_EmitMergeInputChains1_0,
/*10469*/   OPC_MorphNodeTo, TARGET_VAL(PPC::ADJCALLSTACKDOWN), 0|OPFL_Chain|OPFL_GlueOutput,
                1/*#VTs*/, MVT::i32, 1/*#Ops*/, 1, 
            // Src: (callseq_start (timm:i32):$amt) - Complexity = 6
            // Dst: (ADJCALLSTACKDOWN:i32 (timm:i32):$amt)
          /*SwitchOpcode*/ 98,  TARGET_VAL(PPCISD::CALL_Darwin),// ->10578
/*10480*/   OPC_RecordNode,   // #0 = 'PPCcall_Darwin' chained node
/*10481*/   OPC_CaptureGlueInput,
/*10482*/   OPC_RecordChild1, // #1 = $func
/*10483*/   OPC_MoveChild, 1,
/*10485*/   OPC_SwitchOpcode /*3 cases */, 30,  TARGET_VAL(ISD::Constant),// ->10519
/*10489*/     OPC_SwitchType /*2 cases */, 12,  MVT::i32,// ->10504
/*10492*/       OPC_MoveParent,
/*10493*/       OPC_EmitMergeInputChains1_0,
/*10494*/       OPC_EmitConvertToTarget, 1,
/*10496*/       OPC_MorphNodeTo, TARGET_VAL(PPC::BLA_Darwin), 0|OPFL_Chain|OPFL_GlueInput|OPFL_GlueOutput|OPFL_Variadic1,
                    1/*#VTs*/, MVT::i32, 1/*#Ops*/, 2, 
                // Src: (PPCcall_Darwin (imm:i32):$func) - Complexity = 6
                // Dst: (BLA_Darwin:i32 (imm:i32):$func)
              /*SwitchType*/ 12,  MVT::i64,// ->10518
/*10506*/       OPC_MoveParent,
/*10507*/       OPC_EmitMergeInputChains1_0,
/*10508*/       OPC_EmitConvertToTarget, 1,
/*10510*/       OPC_MorphNodeTo, TARGET_VAL(PPC::BLA8_Darwin), 0|OPFL_Chain|OPFL_GlueInput|OPFL_GlueOutput|OPFL_Variadic1,
                    1/*#VTs*/, MVT::i64, 1/*#Ops*/, 2, 
                // Src: (PPCcall_Darwin (imm:i64):$func) - Complexity = 6
                // Dst: (BLA8_Darwin:i64 (imm:i64):$func)
              0, // EndSwitchType
            /*SwitchOpcode*/ 26,  TARGET_VAL(ISD::TargetGlobalAddress),// ->10548
/*10522*/     OPC_SwitchType /*2 cases */, 10,  MVT::i32,// ->10535
/*10525*/       OPC_MoveParent,
/*10526*/       OPC_EmitMergeInputChains1_0,
/*10527*/       OPC_MorphNodeTo, TARGET_VAL(PPC::BL_Darwin), 0|OPFL_Chain|OPFL_GlueInput|OPFL_GlueOutput|OPFL_Variadic1,
                    1/*#VTs*/, MVT::i32, 1/*#Ops*/, 1, 
                // Src: (PPCcall_Darwin (tglobaladdr:i32):$dst) - Complexity = 6
                // Dst: (BL_Darwin:i32 (tglobaladdr:i32):$dst)
              /*SwitchType*/ 10,  MVT::i64,// ->10547
/*10537*/       OPC_MoveParent,
/*10538*/       OPC_EmitMergeInputChains1_0,
/*10539*/       OPC_MorphNodeTo, TARGET_VAL(PPC::BL8_Darwin), 0|OPFL_Chain|OPFL_GlueInput|OPFL_GlueOutput|OPFL_Variadic1,
                    1/*#VTs*/, MVT::i64, 1/*#Ops*/, 1, 
                // Src: (PPCcall_Darwin (tglobaladdr:i64):$dst) - Complexity = 6
                // Dst: (BL8_Darwin:i64 (tglobaladdr:i64):$dst)
              0, // EndSwitchType
            /*SwitchOpcode*/ 26,  TARGET_VAL(ISD::TargetExternalSymbol),// ->10577
/*10551*/     OPC_SwitchType /*2 cases */, 10,  MVT::i32,// ->10564
/*10554*/       OPC_MoveParent,
/*10555*/       OPC_EmitMergeInputChains1_0,
/*10556*/       OPC_MorphNodeTo, TARGET_VAL(PPC::BL_Darwin), 0|OPFL_Chain|OPFL_GlueInput|OPFL_GlueOutput|OPFL_Variadic1,
                    1/*#VTs*/, MVT::i32, 1/*#Ops*/, 1, 
                // Src: (PPCcall_Darwin (texternalsym:i32):$dst) - Complexity = 6
                // Dst: (BL_Darwin:i32 (texternalsym:i32):$dst)
              /*SwitchType*/ 10,  MVT::i64,// ->10576
/*10566*/       OPC_MoveParent,
/*10567*/       OPC_EmitMergeInputChains1_0,
/*10568*/       OPC_MorphNodeTo, TARGET_VAL(PPC::BL8_Darwin), 0|OPFL_Chain|OPFL_GlueInput|OPFL_GlueOutput|OPFL_Variadic1,
                    1/*#VTs*/, MVT::i64, 1/*#Ops*/, 1, 
                // Src: (PPCcall_Darwin (texternalsym:i64):$dst) - Complexity = 6
                // Dst: (BL8_Darwin:i64 (texternalsym:i64):$dst)
              0, // EndSwitchType
            0, // EndSwitchOpcode
          /*SwitchOpcode*/ 98,  TARGET_VAL(PPCISD::CALL_SVR4),// ->10679
/*10581*/   OPC_RecordNode,   // #0 = 'PPCcall_SVR4' chained node
/*10582*/   OPC_CaptureGlueInput,
/*10583*/   OPC_RecordChild1, // #1 = $func
/*10584*/   OPC_MoveChild, 1,
/*10586*/   OPC_SwitchOpcode /*3 cases */, 30,  TARGET_VAL(ISD::Constant),// ->10620
/*10590*/     OPC_SwitchType /*2 cases */, 12,  MVT::i32,// ->10605
/*10593*/       OPC_MoveParent,
/*10594*/       OPC_EmitMergeInputChains1_0,
/*10595*/       OPC_EmitConvertToTarget, 1,
/*10597*/       OPC_MorphNodeTo, TARGET_VAL(PPC::BLA_SVR4), 0|OPFL_Chain|OPFL_GlueInput|OPFL_GlueOutput|OPFL_Variadic1,
                    1/*#VTs*/, MVT::i32, 1/*#Ops*/, 2, 
                // Src: (PPCcall_SVR4 (imm:i32):$func) - Complexity = 6
                // Dst: (BLA_SVR4:i32 (imm:i32):$func)
              /*SwitchType*/ 12,  MVT::i64,// ->10619
/*10607*/       OPC_MoveParent,
/*10608*/       OPC_EmitMergeInputChains1_0,
/*10609*/       OPC_EmitConvertToTarget, 1,
/*10611*/       OPC_MorphNodeTo, TARGET_VAL(PPC::BLA8_ELF), 0|OPFL_Chain|OPFL_GlueInput|OPFL_GlueOutput|OPFL_Variadic1,
                    1/*#VTs*/, MVT::i64, 1/*#Ops*/, 2, 
                // Src: (PPCcall_SVR4 (imm:i64):$func) - Complexity = 6
                // Dst: (BLA8_ELF:i64 (imm:i64):$func)
              0, // EndSwitchType
            /*SwitchOpcode*/ 26,  TARGET_VAL(ISD::TargetGlobalAddress),// ->10649
/*10623*/     OPC_SwitchType /*2 cases */, 10,  MVT::i32,// ->10636
/*10626*/       OPC_MoveParent,
/*10627*/       OPC_EmitMergeInputChains1_0,
/*10628*/       OPC_MorphNodeTo, TARGET_VAL(PPC::BL_SVR4), 0|OPFL_Chain|OPFL_GlueInput|OPFL_GlueOutput|OPFL_Variadic1,
                    1/*#VTs*/, MVT::i32, 1/*#Ops*/, 1, 
                // Src: (PPCcall_SVR4 (tglobaladdr:i32):$dst) - Complexity = 6
                // Dst: (BL_SVR4:i32 (tglobaladdr:i32):$dst)
              /*SwitchType*/ 10,  MVT::i64,// ->10648
/*10638*/       OPC_MoveParent,
/*10639*/       OPC_EmitMergeInputChains1_0,
/*10640*/       OPC_MorphNodeTo, TARGET_VAL(PPC::BL8_ELF), 0|OPFL_Chain|OPFL_GlueInput|OPFL_GlueOutput|OPFL_Variadic1,
                    1/*#VTs*/, MVT::i64, 1/*#Ops*/, 1, 
                // Src: (PPCcall_SVR4 (tglobaladdr:i64):$dst) - Complexity = 6
                // Dst: (BL8_ELF:i64 (tglobaladdr:i64):$dst)
              0, // EndSwitchType
            /*SwitchOpcode*/ 26,  TARGET_VAL(ISD::TargetExternalSymbol),// ->10678
/*10652*/     OPC_SwitchType /*2 cases */, 10,  MVT::i32,// ->10665
/*10655*/       OPC_MoveParent,
/*10656*/       OPC_EmitMergeInputChains1_0,
/*10657*/       OPC_MorphNodeTo, TARGET_VAL(PPC::BL_SVR4), 0|OPFL_Chain|OPFL_GlueInput|OPFL_GlueOutput|OPFL_Variadic1,
                    1/*#VTs*/, MVT::i32, 1/*#Ops*/, 1, 
                // Src: (PPCcall_SVR4 (texternalsym:i32):$dst) - Complexity = 6
                // Dst: (BL_SVR4:i32 (texternalsym:i32):$dst)
              /*SwitchType*/ 10,  MVT::i64,// ->10677
/*10667*/       OPC_MoveParent,
/*10668*/       OPC_EmitMergeInputChains1_0,
/*10669*/       OPC_MorphNodeTo, TARGET_VAL(PPC::BL8_ELF), 0|OPFL_Chain|OPFL_GlueInput|OPFL_GlueOutput|OPFL_Variadic1,
                    1/*#VTs*/, MVT::i64, 1/*#Ops*/, 1, 
                // Src: (PPCcall_SVR4 (texternalsym:i64):$dst) - Complexity = 6
                // Dst: (BL8_ELF:i64 (texternalsym:i64):$dst)
              0, // EndSwitchType
            0, // EndSwitchOpcode
          /*SwitchOpcode*/ 19,  TARGET_VAL(PPCISD::MTFSB0),// ->10701
/*10682*/   OPC_CaptureGlueInput,
/*10683*/   OPC_RecordChild0, // #0 = $FM
/*10684*/   OPC_MoveChild, 0,
/*10686*/   OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/*10689*/   OPC_CheckType, MVT::i32,
/*10691*/   OPC_MoveParent,
/*10692*/   OPC_EmitConvertToTarget, 0,
/*10694*/   OPC_MorphNodeTo, TARGET_VAL(PPC::MTFSB0), 0|OPFL_GlueInput|OPFL_GlueOutput,
                0/*#VTs*/, 1/*#Ops*/, 1, 
            // Src: (PPCmtfsb0 (imm:i32):$FM) - Complexity = 6
            // Dst: (MTFSB0 (imm:i32):$FM)
          /*SwitchOpcode*/ 19,  TARGET_VAL(PPCISD::MTFSB1),// ->10723
/*10704*/   OPC_CaptureGlueInput,
/*10705*/   OPC_RecordChild0, // #0 = $FM
/*10706*/   OPC_MoveChild, 0,
/*10708*/   OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/*10711*/   OPC_CheckType, MVT::i32,
/*10713*/   OPC_MoveParent,
/*10714*/   OPC_EmitConvertToTarget, 0,
/*10716*/   OPC_MorphNodeTo, TARGET_VAL(PPC::MTFSB1), 0|OPFL_GlueInput|OPFL_GlueOutput,
                0/*#VTs*/, 1/*#Ops*/, 1, 
            // Src: (PPCmtfsb1 (imm:i32):$FM) - Complexity = 6
            // Dst: (MTFSB1 (imm:i32):$FM)
          /*SwitchOpcode*/ 54,  TARGET_VAL(PPCISD::CALL_NOP_SVR4),// ->10780
/*10726*/   OPC_RecordNode,   // #0 = 'PPCcall_nop_SVR4' chained node
/*10727*/   OPC_CaptureGlueInput,
/*10728*/   OPC_RecordChild1, // #1 = $func
/*10729*/   OPC_MoveChild, 1,
/*10731*/   OPC_SwitchOpcode /*3 cases */, 14,  TARGET_VAL(ISD::Constant),// ->10749
/*10735*/     OPC_CheckType, MVT::i64,
/*10737*/     OPC_MoveParent,
/*10738*/     OPC_EmitMergeInputChains1_0,
/*10739*/     OPC_EmitConvertToTarget, 1,
/*10741*/     OPC_MorphNodeTo, TARGET_VAL(PPC::BLA8_NOP_ELF), 0|OPFL_Chain|OPFL_GlueInput|OPFL_GlueOutput|OPFL_Variadic1,
                  1/*#VTs*/, MVT::i64, 1/*#Ops*/, 2, 
              // Src: (PPCcall_nop_SVR4 (imm:i64):$func) - Complexity = 6
              // Dst: (BLA8_NOP_ELF:i64 (imm:i64):$func)
            /*SwitchOpcode*/ 12,  TARGET_VAL(ISD::TargetGlobalAddress),// ->10764
/*10752*/     OPC_CheckType, MVT::i64,
/*10754*/     OPC_MoveParent,
/*10755*/     OPC_EmitMergeInputChains1_0,
/*10756*/     OPC_MorphNodeTo, TARGET_VAL(PPC::BL8_NOP_ELF), 0|OPFL_Chain|OPFL_GlueInput|OPFL_GlueOutput|OPFL_Variadic1,
                  1/*#VTs*/, MVT::i64, 1/*#Ops*/, 1, 
              // Src: (PPCcall_nop_SVR4 (tglobaladdr:i64):$dst) - Complexity = 6
              // Dst: (BL8_NOP_ELF:i64 (tglobaladdr:i64):$dst)
            /*SwitchOpcode*/ 12,  TARGET_VAL(ISD::TargetExternalSymbol),// ->10779
/*10767*/     OPC_CheckType, MVT::i64,
/*10769*/     OPC_MoveParent,
/*10770*/     OPC_EmitMergeInputChains1_0,
/*10771*/     OPC_MorphNodeTo, TARGET_VAL(PPC::BL8_NOP_ELF), 0|OPFL_Chain|OPFL_GlueInput|OPFL_GlueOutput|OPFL_Variadic1,
                  1/*#VTs*/, MVT::i64, 1/*#Ops*/, 1, 
              // Src: (PPCcall_nop_SVR4 (texternalsym:i64):$dst) - Complexity = 6
              // Dst: (BL8_NOP_ELF:i64 (texternalsym:i64):$dst)
            0, // EndSwitchOpcode
          /*SwitchOpcode*/ 63,  TARGET_VAL(ISD::BUILD_VECTOR),// ->10846
/*10783*/   OPC_Scope, 48, /*->10833*/ // 2 children in Scope
/*10785*/     OPC_RecordNode, // #0 = $SIMM
/*10786*/     OPC_SwitchType /*3 cases */, 13,  MVT::v16i8,// ->10802
/*10789*/       OPC_CheckPredicate, 89, // Predicate_vecspltisb
/*10791*/       OPC_EmitNodeXForm, 14, 0, // VSPLTISB_get_imm
/*10794*/       OPC_MorphNodeTo, TARGET_VAL(PPC::VSPLTISB), 0,
                    1/*#VTs*/, MVT::v16i8, 1/*#Ops*/, 1, 
                // Src: (build_vector:v16i8)<<P:Predicate_vecspltisb>><<X:VSPLTISB_get_imm>>:$SIMM - Complexity = 4
                // Dst: (VSPLTISB:v16i8 (VSPLTISB_get_imm:i32 (build_vector:v16i8):$SIMM))
              /*SwitchType*/ 13,  MVT::v8i16,// ->10817
/*10804*/       OPC_CheckPredicate, 90, // Predicate_vecspltish
/*10806*/       OPC_EmitNodeXForm, 15, 0, // VSPLTISH_get_imm
/*10809*/       OPC_MorphNodeTo, TARGET_VAL(PPC::VSPLTISH), 0,
                    1/*#VTs*/, MVT::v8i16, 1/*#Ops*/, 1, 
                // Src: (build_vector:v8i16)<<P:Predicate_vecspltish>><<X:VSPLTISH_get_imm>>:$SIMM - Complexity = 4
                // Dst: (VSPLTISH:v8i16 (VSPLTISH_get_imm:i32 (build_vector:v8i16):$SIMM))
              /*SwitchType*/ 13,  MVT::v4i32,// ->10832
/*10819*/       OPC_CheckPredicate, 91, // Predicate_vecspltisw
/*10821*/       OPC_EmitNodeXForm, 16, 0, // VSPLTISW_get_imm
/*10824*/       OPC_MorphNodeTo, TARGET_VAL(PPC::VSPLTISW), 0,
                    1/*#VTs*/, MVT::v4i32, 1/*#Ops*/, 1, 
                // Src: (build_vector:v4i32)<<P:Predicate_vecspltisw>><<X:VSPLTISW_get_imm>>:$SIMM - Complexity = 4
                // Dst: (VSPLTISW:v4i32 (VSPLTISW_get_imm:i32 (build_vector:v4i32):$SIMM))
              0, // EndSwitchType
/*10833*/   /*Scope*/ 11, /*->10845*/
/*10834*/     OPC_CheckPredicate, 92, // Predicate_immAllZerosV
/*10836*/     OPC_CheckType, MVT::v4i32,
/*10838*/     OPC_MorphNodeTo, TARGET_VAL(PPC::V_SET0), 0,
                  1/*#VTs*/, MVT::v4i32, 0/*#Ops*/, 
              // Src: (build_vector:v4i32)<<P:Predicate_immAllZerosV>> - Complexity = 4
              // Dst: (V_SET0:v4i32)
/*10845*/   0, /*End of Scope*/
          /*SwitchOpcode*/ 83,  TARGET_VAL(ISD::BITCAST),// ->10932
/*10849*/   OPC_RecordChild0, // #0 = $src
/*10850*/   OPC_Scope, 19, /*->10871*/ // 4 children in Scope
/*10852*/     OPC_CheckChild0Type, MVT::v8i16,
/*10854*/     OPC_SwitchType /*3 cases */, 3,  MVT::v16i8,// ->10860
/*10857*/       OPC_CompleteMatch, 1, 0, 
                // Src: (bitconvert:v16i8 VRRC:v8i16:$src) - Complexity = 3
                // Dst: VRRC:v16i8:$src
              /*SwitchType*/ 3,  MVT::v4i32,// ->10865
/*10862*/       OPC_CompleteMatch, 1, 0, 
                // Src: (bitconvert:v4i32 VRRC:v8i16:$src) - Complexity = 3
                // Dst: VRRC:v4i32:$src
              /*SwitchType*/ 3,  MVT::v4f32,// ->10870
/*10867*/       OPC_CompleteMatch, 1, 0, 
                // Src: (bitconvert:v4f32 VRRC:v8i16:$src) - Complexity = 3
                // Dst: VRRC:v4f32:$src
              0, // EndSwitchType
/*10871*/   /*Scope*/ 19, /*->10891*/
/*10872*/     OPC_CheckChild0Type, MVT::v4i32,
/*10874*/     OPC_SwitchType /*3 cases */, 3,  MVT::v16i8,// ->10880
/*10877*/       OPC_CompleteMatch, 1, 0, 
                // Src: (bitconvert:v16i8 VRRC:v4i32:$src) - Complexity = 3
                // Dst: VRRC:v16i8:$src
              /*SwitchType*/ 3,  MVT::v8i16,// ->10885
/*10882*/       OPC_CompleteMatch, 1, 0, 
                // Src: (bitconvert:v8i16 VRRC:v4i32:$src) - Complexity = 3
                // Dst: VRRC:v8i16:$src
              /*SwitchType*/ 3,  MVT::v4f32,// ->10890
/*10887*/       OPC_CompleteMatch, 1, 0, 
                // Src: (bitconvert:v4f32 VRRC:v4i32:$src) - Complexity = 3
                // Dst: VRRC:v4f32:$src
              0, // EndSwitchType
/*10891*/   /*Scope*/ 19, /*->10911*/
/*10892*/     OPC_CheckChild0Type, MVT::v4f32,
/*10894*/     OPC_SwitchType /*3 cases */, 3,  MVT::v16i8,// ->10900
/*10897*/       OPC_CompleteMatch, 1, 0, 
                // Src: (bitconvert:v16i8 VRRC:v4f32:$src) - Complexity = 3
                // Dst: VRRC:v16i8:$src
              /*SwitchType*/ 3,  MVT::v8i16,// ->10905
/*10902*/       OPC_CompleteMatch, 1, 0, 
                // Src: (bitconvert:v8i16 VRRC:v4f32:$src) - Complexity = 3
                // Dst: VRRC:v8i16:$src
              /*SwitchType*/ 3,  MVT::v4i32,// ->10910
/*10907*/       OPC_CompleteMatch, 1, 0, 
                // Src: (bitconvert:v4i32 VRRC:v4f32:$src) - Complexity = 3
                // Dst: VRRC:v4i32:$src
              0, // EndSwitchType
/*10911*/   /*Scope*/ 19, /*->10931*/
/*10912*/     OPC_CheckChild0Type, MVT::v16i8,
/*10914*/     OPC_SwitchType /*3 cases */, 3,  MVT::v8i16,// ->10920
/*10917*/       OPC_CompleteMatch, 1, 0, 
                // Src: (bitconvert:v8i16 VRRC:v16i8:$src) - Complexity = 3
                // Dst: VRRC:v8i16:$src
              /*SwitchType*/ 3,  MVT::v4i32,// ->10925
/*10922*/       OPC_CompleteMatch, 1, 0, 
                // Src: (bitconvert:v4i32 VRRC:v16i8:$src) - Complexity = 3
                // Dst: VRRC:v4i32:$src
              /*SwitchType*/ 3,  MVT::v4f32,// ->10930
/*10927*/       OPC_CompleteMatch, 1, 0, 
                // Src: (bitconvert:v4f32 VRRC:v16i8:$src) - Complexity = 3
                // Dst: VRRC:v4f32:$src
              0, // EndSwitchType
/*10931*/   0, /*End of Scope*/
          /*SwitchOpcode*/ 17,  TARGET_VAL(PPCISD::RET_FLAG),// ->10952
/*10935*/   OPC_RecordNode,   // #0 = 'retflag' chained node
/*10936*/   OPC_CaptureGlueInput,
/*10937*/   OPC_EmitMergeInputChains1_0,
/*10938*/   OPC_EmitInteger, MVT::i32, 20, 
/*10941*/   OPC_EmitRegister, MVT::i32, 0 /*zero_reg*/,
/*10944*/   OPC_MorphNodeTo, TARGET_VAL(PPC::BLR), 0|OPFL_Chain|OPFL_GlueInput|OPFL_Variadic0,
                0/*#VTs*/, 2/*#Ops*/, 1, 2, 
            // Src: (retflag) - Complexity = 3
            // Dst: (BLR)
          /*SwitchOpcode*/ 16,  TARGET_VAL(ISD::BR),// ->10971
/*10955*/   OPC_RecordNode,   // #0 = 'br' chained node
/*10956*/   OPC_RecordChild1, // #1 = $dst
/*10957*/   OPC_MoveChild, 1,
/*10959*/   OPC_CheckOpcode, TARGET_VAL(ISD::BasicBlock),
/*10962*/   OPC_MoveParent,
/*10963*/   OPC_EmitMergeInputChains1_0,
/*10964*/   OPC_MorphNodeTo, TARGET_VAL(PPC::B), 0|OPFL_Chain,
                0/*#VTs*/, 1/*#Ops*/, 1, 
            // Src: (br (bb:Other):$dst) - Complexity = 3
            // Dst: (B (bb:Other):$dst)
          /*SwitchOpcode*/ 26,  TARGET_VAL(PPCISD::BCTRL_Darwin),// ->11000
/*10974*/   OPC_RecordNode,   // #0 = 'PPCbctrl_Darwin' chained node
/*10975*/   OPC_CaptureGlueInput,
/*10976*/   OPC_Scope, 10, /*->10988*/ // 2 children in Scope
/*10978*/     OPC_CheckPatternPredicate, 1, // (!PPCSubTarget.isPPC64())
/*10980*/     OPC_EmitMergeInputChains1_0,
/*10981*/     OPC_MorphNodeTo, TARGET_VAL(PPC::BCTRL_Darwin), 0|OPFL_Chain|OPFL_GlueInput|OPFL_GlueOutput|OPFL_Variadic0,
                  1/*#VTs*/, MVT::i32, 0/*#Ops*/, 
              // Src: (PPCbctrl_Darwin) - Complexity = 3
              // Dst: (BCTRL_Darwin:i32)
/*10988*/   /*Scope*/ 10, /*->10999*/
/*10989*/     OPC_CheckPatternPredicate, 2, // (PPCSubTarget.isPPC64())
/*10991*/     OPC_EmitMergeInputChains1_0,
/*10992*/     OPC_MorphNodeTo, TARGET_VAL(PPC::BCTRL8_Darwin), 0|OPFL_Chain|OPFL_GlueInput|OPFL_GlueOutput|OPFL_Variadic0,
                  1/*#VTs*/, MVT::i64, 0/*#Ops*/, 
              // Src: (PPCbctrl_Darwin) - Complexity = 3
              // Dst: (BCTRL8_Darwin:i64)
/*10999*/   0, /*End of Scope*/
          /*SwitchOpcode*/ 26,  TARGET_VAL(PPCISD::BCTRL_SVR4),// ->11029
/*11003*/   OPC_RecordNode,   // #0 = 'PPCbctrl_SVR4' chained node
/*11004*/   OPC_CaptureGlueInput,
/*11005*/   OPC_Scope, 10, /*->11017*/ // 2 children in Scope
/*11007*/     OPC_CheckPatternPredicate, 1, // (!PPCSubTarget.isPPC64())
/*11009*/     OPC_EmitMergeInputChains1_0,
/*11010*/     OPC_MorphNodeTo, TARGET_VAL(PPC::BCTRL_SVR4), 0|OPFL_Chain|OPFL_GlueInput|OPFL_GlueOutput|OPFL_Variadic0,
                  1/*#VTs*/, MVT::i32, 0/*#Ops*/, 
              // Src: (PPCbctrl_SVR4) - Complexity = 3
              // Dst: (BCTRL_SVR4:i32)
/*11017*/   /*Scope*/ 10, /*->11028*/
/*11018*/     OPC_CheckPatternPredicate, 2, // (PPCSubTarget.isPPC64())
/*11020*/     OPC_EmitMergeInputChains1_0,
/*11021*/     OPC_MorphNodeTo, TARGET_VAL(PPC::BCTRL8_ELF), 0|OPFL_Chain|OPFL_GlueInput|OPFL_GlueOutput|OPFL_Variadic0,
                  1/*#VTs*/, MVT::i64, 0/*#Ops*/, 
              // Src: (PPCbctrl_SVR4) - Complexity = 3
              // Dst: (BCTRL8_ELF:i64)
/*11028*/   0, /*End of Scope*/
          /*SwitchOpcode*/ 8,  TARGET_VAL(ISD::TRAP),// ->11040
/*11032*/   OPC_RecordNode,   // #0 = 'trap' chained node
/*11033*/   OPC_EmitMergeInputChains1_0,
/*11034*/   OPC_MorphNodeTo, TARGET_VAL(PPC::TRAP), 0|OPFL_Chain,
                0/*#VTs*/, 0/*#Ops*/, 
            // Src: (trap) - Complexity = 3
            // Dst: (TRAP)
          /*SwitchOpcode*/ 29,  TARGET_VAL(PPCISD::MTCTR),// ->11072
/*11043*/   OPC_RecordNode,   // #0 = 'PPCmtctr' chained node
/*11044*/   OPC_CaptureGlueInput,
/*11045*/   OPC_RecordChild1, // #1 = $rS
/*11046*/   OPC_Scope, 11, /*->11059*/ // 2 children in Scope
/*11048*/     OPC_CheckChild1Type, MVT::i32,
/*11050*/     OPC_EmitMergeInputChains1_0,
/*11051*/     OPC_MorphNodeTo, TARGET_VAL(PPC::MTCTR), 0|OPFL_Chain|OPFL_GlueInput|OPFL_GlueOutput,
                  1/*#VTs*/, MVT::i32, 1/*#Ops*/, 1, 
              // Src: (PPCmtctr GPRC:i32:$rS) - Complexity = 3
              // Dst: (MTCTR:i32 GPRC:i32:$rS)
/*11059*/   /*Scope*/ 11, /*->11071*/
/*11060*/     OPC_CheckChild1Type, MVT::i64,
/*11062*/     OPC_EmitMergeInputChains1_0,
/*11063*/     OPC_MorphNodeTo, TARGET_VAL(PPC::MTCTR8), 0|OPFL_Chain|OPFL_GlueInput|OPFL_GlueOutput,
                  1/*#VTs*/, MVT::i64, 1/*#Ops*/, 1, 
              // Src: (PPCmtctr G8RC:i64:$rS) - Complexity = 3
              // Dst: (MTCTR8:i64 G8RC:i64:$rS)
/*11071*/   0, /*End of Scope*/
          /*SwitchOpcode*/ 15,  TARGET_VAL(PPCISD::VPERM),// ->11090
/*11075*/   OPC_RecordChild0, // #0 = $vA
/*11076*/   OPC_RecordChild1, // #1 = $vB
/*11077*/   OPC_RecordChild2, // #2 = $vC
/*11078*/   OPC_CheckType, MVT::v16i8,
/*11080*/   OPC_MorphNodeTo, TARGET_VAL(PPC::VPERM), 0,
                1/*#VTs*/, MVT::v16i8, 3/*#Ops*/, 0, 1, 2, 
            // Src: (PPCvperm:v16i8 VRRC:v16i8:$vA, VRRC:v16i8:$vB, VRRC:v16i8:$vC) - Complexity = 3
            // Dst: (VPERM:v16i8 VRRC:v16i8:$vA, VRRC:v16i8:$vB, VRRC:v16i8:$vC)
          /*SwitchOpcode*/ 15,  TARGET_VAL(PPCISD::VMADDFP),// ->11108
/*11093*/   OPC_RecordChild0, // #0 = $A
/*11094*/   OPC_RecordChild1, // #1 = $B
/*11095*/   OPC_RecordChild2, // #2 = $C
/*11096*/   OPC_CheckType, MVT::v4f32,
/*11098*/   OPC_MorphNodeTo, TARGET_VAL(PPC::VMADDFP), 0,
                1/*#VTs*/, MVT::v4f32, 3/*#Ops*/, 0, 1, 2, 
            // Src: (PPCvmaddfp:v4f32 VRRC:v4f32:$A, VRRC:v4f32:$B, VRRC:v4f32:$C) - Complexity = 3
            // Dst: (VMADDFP:v4f32 VRRC:v4f32:$A, VRRC:v4f32:$B, VRRC:v4f32:$C)
          /*SwitchOpcode*/ 15,  TARGET_VAL(PPCISD::VNMSUBFP),// ->11126
/*11111*/   OPC_RecordChild0, // #0 = $A
/*11112*/   OPC_RecordChild1, // #1 = $B
/*11113*/   OPC_RecordChild2, // #2 = $C
/*11114*/   OPC_CheckType, MVT::v4f32,
/*11116*/   OPC_MorphNodeTo, TARGET_VAL(PPC::VNMSUBFP), 0,
                1/*#VTs*/, MVT::v4f32, 3/*#Ops*/, 0, 1, 2, 
            // Src: (PPCvnmsubfp:v4f32 VRRC:v4f32:$A, VRRC:v4f32:$B, VRRC:v4f32:$C) - Complexity = 3
            // Dst: (VNMSUBFP:v4f32 VRRC:v4f32:$A, VRRC:v4f32:$B, VRRC:v4f32:$C)
          /*SwitchOpcode*/ 7,  TARGET_VAL(PPCISD::NOP),// ->11136
/*11129*/   OPC_CaptureGlueInput,
/*11130*/   OPC_MorphNodeTo, TARGET_VAL(PPC::NOP), 0|OPFL_GlueInput|OPFL_GlueOutput,
                0/*#VTs*/, 0/*#Ops*/, 
            // Src: (PPCnop) - Complexity = 3
            // Dst: (NOP)
          /*SwitchOpcode*/ 13,  TARGET_VAL(PPCISD::LOAD_TOC),// ->11152
/*11139*/   OPC_RecordNode,   // #0 = 'PPCload_toc' chained node
/*11140*/   OPC_CaptureGlueInput,
/*11141*/   OPC_RecordChild1, // #1 = $reg
/*11142*/   OPC_CheckChild1Type, MVT::i64,
/*11144*/   OPC_EmitMergeInputChains1_0,
/*11145*/   OPC_MorphNodeTo, TARGET_VAL(PPC::LDinto_toc), 0|OPFL_Chain|OPFL_GlueInput|OPFL_GlueOutput,
                0/*#VTs*/, 1/*#Ops*/, 1, 
            // Src: (PPCload_toc G8RC:i64:$reg) - Complexity = 3
            // Dst: (LDinto_toc G8RC:i64:$reg)
          /*SwitchOpcode*/ 9,  TARGET_VAL(PPCISD::TOC_RESTORE),// ->11164
/*11155*/   OPC_RecordNode,   // #0 = 'PPCtoc_restore' chained node
/*11156*/   OPC_CaptureGlueInput,
/*11157*/   OPC_EmitMergeInputChains1_0,
/*11158*/   OPC_MorphNodeTo, TARGET_VAL(PPC::LDtoc_restore), 0|OPFL_Chain|OPFL_GlueInput|OPFL_GlueOutput,
                0/*#VTs*/, 0/*#Ops*/, 
            // Src: (PPCtoc_restore) - Complexity = 3
            // Dst: (LDtoc_restore)
          0, // EndSwitchOpcode
    0
  }; // Total Array size is 11166 bytes

  // Opcode Histogram:
  // #OPC_Scope                          = 110
  // #OPC_RecordNode                     = 41
  // #OPC_RecordChild                    = 497
  // #OPC_RecordMemRef                   = 11
  // #OPC_CaptureGlueInput               = 19
  // #OPC_MoveChild                      = 146
  // #OPC_MoveParent                     = 368
  // #OPC_CheckSame                      = 0
  // #OPC_CheckPatternPredicate          = 21
  // #OPC_CheckPredicate                 = 177
  // #OPC_CheckOpcode                    = 90
  // #OPC_SwitchOpcode                   = 15
  // #OPC_CheckType                      = 151
  // #OPC_SwitchType                     = 96
  // #OPC_CheckChildType                 = 50
  // #OPC_CheckInteger                   = 193
  // #OPC_CheckCondCode                  = 0
  // #OPC_CheckValueType                 = 7
  // #OPC_CheckComplexPat                = 141
  // #OPC_CheckAndImm                    = 0
  // #OPC_CheckOrImm                     = 0
  // #OPC_CheckFoldableChainNode         = 0
  // #OPC_EmitInteger                    = 26
  // #OPC_EmitStringInteger              = 6
  // #OPC_EmitRegister                   = 1
  // #OPC_EmitConvertToTarget            = 79
  // #OPC_EmitMergeInputChains           = 190
  // #OPC_EmitCopyToReg                  = 0
  // #OPC_EmitNode                       = 10
  // #OPC_EmitNodeXForm                  = 38
  // #OPC_MarkGlueResults                = 0
  // #OPC_CompleteMatch                  = 12
  // #OPC_MorphNodeTo                    = 585

  #undef TARGET_VAL
  return SelectCodeCommon(N, MatcherTable,sizeof(MatcherTable));
}

bool CheckPatternPredicate(unsigned PredNo) const {
  switch (PredNo) {
  default: llvm_unreachable("Invalid predicate in table?");
  case 0: return (!TM.Options.NoExcessFPPrecision);
  case 1: return (!PPCSubTarget.isPPC64());
  case 2: return (PPCSubTarget.isPPC64());
  }
}

bool CheckNodePredicate(SDNode *Node, unsigned PredNo) const {
  switch (PredNo) {
  default: llvm_unreachable("Invalid predicate in table?");
  case 0: { // Predicate_immSExt16
    ConstantSDNode*N = cast<ConstantSDNode>(Node);

  // immSExt16 predicate - True if the immediate fits in a 16-bit sign extended
  // field.  Used by instructions like 'addi'.
  if (N->getValueType(0) == MVT::i32)
    return (int32_t)N->getZExtValue() == (short)N->getZExtValue();
  else
    return (int64_t)N->getZExtValue() == (short)N->getZExtValue();

  }
  case 1: { // Predicate_imm16ShiftedSExt
    ConstantSDNode*N = cast<ConstantSDNode>(Node);

  // imm16ShiftedSExt predicate - True if only bits in the top 16-bits of the
  // immediate are set.  Used by instructions like 'addis'.  Identical to 
  // imm16ShiftedZExt in 32-bit mode.
  if (N->getZExtValue() & 0xFFFF) return false;
  if (N->getValueType(0) == MVT::i32)
    return true;
  // For 64-bit, make sure it is sext right.
  return N->getZExtValue() == (uint64_t)(int)N->getZExtValue();

  }
  case 2: { // Predicate_unindexedload
    SDNode *N = Node;

  return cast<LoadSDNode>(N)->getAddressingMode() == ISD::UNINDEXED;

  }
  case 3: { // Predicate_zextload
    SDNode *N = Node;

  return cast<LoadSDNode>(N)->getExtensionType() == ISD::ZEXTLOAD;

  }
  case 4: { // Predicate_zextloadi8
    SDNode *N = Node;

  return cast<LoadSDNode>(N)->getMemoryVT() == MVT::i8;

  }
  case 5: { // Predicate_sextload
    SDNode *N = Node;

  return cast<LoadSDNode>(N)->getExtensionType() == ISD::SEXTLOAD;

  }
  case 6: { // Predicate_sextloadi16
    SDNode *N = Node;

  return cast<LoadSDNode>(N)->getMemoryVT() == MVT::i16;

  }
  case 7: { // Predicate_zextloadi16
    SDNode *N = Node;

  return cast<LoadSDNode>(N)->getMemoryVT() == MVT::i16;

  }
  case 8: { // Predicate_load
    SDNode *N = Node;

  return cast<LoadSDNode>(N)->getExtensionType() == ISD::NON_EXTLOAD;

  }
  case 9: { // Predicate_zextloadi1
    SDNode *N = Node;

  return cast<LoadSDNode>(N)->getMemoryVT() == MVT::i1;

  }
  case 10: { // Predicate_extload
    SDNode *N = Node;

  return cast<LoadSDNode>(N)->getExtensionType() == ISD::EXTLOAD;

  }
  case 11: { // Predicate_extloadi1
    SDNode *N = Node;

  return cast<LoadSDNode>(N)->getMemoryVT() == MVT::i1;

  }
  case 12: { // Predicate_extloadi8
    SDNode *N = Node;

  return cast<LoadSDNode>(N)->getMemoryVT() == MVT::i8;

  }
  case 13: { // Predicate_extloadi16
    SDNode *N = Node;

  return cast<LoadSDNode>(N)->getMemoryVT() == MVT::i16;

  }
  case 14: { // Predicate_sextloadi32
    SDNode *N = Node;

  return cast<LoadSDNode>(N)->getMemoryVT() == MVT::i32;

  }
  case 15: { // Predicate_zextloadi32
    SDNode *N = Node;

  return cast<LoadSDNode>(N)->getMemoryVT() == MVT::i32;

  }
  case 16: { // Predicate_extloadi32
    SDNode *N = Node;

  return cast<LoadSDNode>(N)->getMemoryVT() == MVT::i32;

  }
  case 17: { // Predicate_extloadf32
    SDNode *N = Node;

  return cast<LoadSDNode>(N)->getMemoryVT() == MVT::f32;

  }
  case 18: { // Predicate_unindexedstore
    SDNode *N = Node;

  return cast<StoreSDNode>(N)->getAddressingMode() == ISD::UNINDEXED;

  }
  case 19: { // Predicate_truncstore
    SDNode *N = Node;

  return cast<StoreSDNode>(N)->isTruncatingStore();

  }
  case 20: { // Predicate_truncstorei8
    SDNode *N = Node;

  return cast<StoreSDNode>(N)->getMemoryVT() == MVT::i8;

  }
  case 21: { // Predicate_truncstorei16
    SDNode *N = Node;

  return cast<StoreSDNode>(N)->getMemoryVT() == MVT::i16;

  }
  case 22: { // Predicate_store
    SDNode *N = Node;

  return !cast<StoreSDNode>(N)->isTruncatingStore();

  }
  case 23: { // Predicate_itruncstore
    SDNode *N = Node;

  return cast<StoreSDNode>(N)->isTruncatingStore();

  }
  case 24: { // Predicate_pre_truncst
    SDNode *N = Node;

  ISD::MemIndexedMode AM = cast<StoreSDNode>(N)->getAddressingMode();
  return AM == ISD::PRE_INC || AM == ISD::PRE_DEC;

  }
  case 25: { // Predicate_pre_truncsti8
    SDNode *N = Node;

  return cast<StoreSDNode>(N)->getMemoryVT() == MVT::i8;

  }
  case 26: { // Predicate_pre_truncsti16
    SDNode *N = Node;

  return cast<StoreSDNode>(N)->getMemoryVT() == MVT::i16;

  }
  case 27: { // Predicate_istore
    SDNode *N = Node;

  return !cast<StoreSDNode>(N)->isTruncatingStore();

  }
  case 28: { // Predicate_pre_store
    SDNode *N = Node;

  ISD::MemIndexedMode AM = cast<StoreSDNode>(N)->getAddressingMode();
  return AM == ISD::PRE_INC || AM == ISD::PRE_DEC;

  }
  case 29: { // Predicate_truncstorei32
    SDNode *N = Node;

  return cast<StoreSDNode>(N)->getMemoryVT() == MVT::i32;

  }
  case 30: { // Predicate_pre_truncsti32
    SDNode *N = Node;

  return cast<StoreSDNode>(N)->getMemoryVT() == MVT::i32;

  }
  case 31: { // Predicate_atomic_load_add_8
    SDNode *N = Node;

    return cast<AtomicSDNode>(N)->getMemoryVT() == MVT::i8;
  
  }
  case 32: { // Predicate_atomic_load_add_16
    SDNode *N = Node;

    return cast<AtomicSDNode>(N)->getMemoryVT() == MVT::i16;
  
  }
  case 33: { // Predicate_atomic_load_add_32
    SDNode *N = Node;

    return cast<AtomicSDNode>(N)->getMemoryVT() == MVT::i32;
  
  }
  case 34: { // Predicate_atomic_load_add_64
    SDNode *N = Node;

    return cast<AtomicSDNode>(N)->getMemoryVT() == MVT::i64;
  
  }
  case 35: { // Predicate_atomic_load_sub_8
    SDNode *N = Node;

    return cast<AtomicSDNode>(N)->getMemoryVT() == MVT::i8;
  
  }
  case 36: { // Predicate_atomic_load_sub_16
    SDNode *N = Node;

    return cast<AtomicSDNode>(N)->getMemoryVT() == MVT::i16;
  
  }
  case 37: { // Predicate_atomic_load_sub_32
    SDNode *N = Node;

    return cast<AtomicSDNode>(N)->getMemoryVT() == MVT::i32;
  
  }
  case 38: { // Predicate_atomic_load_sub_64
    SDNode *N = Node;

    return cast<AtomicSDNode>(N)->getMemoryVT() == MVT::i64;
  
  }
  case 39: { // Predicate_atomic_load_and_8
    SDNode *N = Node;

    return cast<AtomicSDNode>(N)->getMemoryVT() == MVT::i8;
  
  }
  case 40: { // Predicate_atomic_load_and_16
    SDNode *N = Node;

    return cast<AtomicSDNode>(N)->getMemoryVT() == MVT::i16;
  
  }
  case 41: { // Predicate_atomic_load_and_32
    SDNode *N = Node;

    return cast<AtomicSDNode>(N)->getMemoryVT() == MVT::i32;
  
  }
  case 42: { // Predicate_atomic_load_and_64
    SDNode *N = Node;

    return cast<AtomicSDNode>(N)->getMemoryVT() == MVT::i64;
  
  }
  case 43: { // Predicate_atomic_load_or_8
    SDNode *N = Node;

    return cast<AtomicSDNode>(N)->getMemoryVT() == MVT::i8;
  
  }
  case 44: { // Predicate_atomic_load_or_16
    SDNode *N = Node;

    return cast<AtomicSDNode>(N)->getMemoryVT() == MVT::i16;
  
  }
  case 45: { // Predicate_atomic_load_or_32
    SDNode *N = Node;

    return cast<AtomicSDNode>(N)->getMemoryVT() == MVT::i32;
  
  }
  case 46: { // Predicate_atomic_load_or_64
    SDNode *N = Node;

    return cast<AtomicSDNode>(N)->getMemoryVT() == MVT::i64;
  
  }
  case 47: { // Predicate_atomic_load_xor_8
    SDNode *N = Node;

    return cast<AtomicSDNode>(N)->getMemoryVT() == MVT::i8;
  
  }
  case 48: { // Predicate_atomic_load_xor_16
    SDNode *N = Node;

    return cast<AtomicSDNode>(N)->getMemoryVT() == MVT::i16;
  
  }
  case 49: { // Predicate_atomic_load_xor_32
    SDNode *N = Node;

    return cast<AtomicSDNode>(N)->getMemoryVT() == MVT::i32;
  
  }
  case 50: { // Predicate_atomic_load_xor_64
    SDNode *N = Node;

    return cast<AtomicSDNode>(N)->getMemoryVT() == MVT::i64;
  
  }
  case 51: { // Predicate_atomic_load_nand_8
    SDNode *N = Node;

    return cast<AtomicSDNode>(N)->getMemoryVT() == MVT::i8;
  
  }
  case 52: { // Predicate_atomic_load_nand_16
    SDNode *N = Node;

    return cast<AtomicSDNode>(N)->getMemoryVT() == MVT::i16;
  
  }
  case 53: { // Predicate_atomic_load_nand_32
    SDNode *N = Node;

    return cast<AtomicSDNode>(N)->getMemoryVT() == MVT::i32;
  
  }
  case 54: { // Predicate_atomic_load_nand_64
    SDNode *N = Node;

    return cast<AtomicSDNode>(N)->getMemoryVT() == MVT::i64;
  
  }
  case 55: { // Predicate_atomic_cmp_swap_8
    SDNode *N = Node;

  return cast<AtomicSDNode>(N)->getMemoryVT() == MVT::i8;

  }
  case 56: { // Predicate_atomic_cmp_swap_16
    SDNode *N = Node;

  return cast<AtomicSDNode>(N)->getMemoryVT() == MVT::i16;

  }
  case 57: { // Predicate_atomic_cmp_swap_32
    SDNode *N = Node;

  return cast<AtomicSDNode>(N)->getMemoryVT() == MVT::i32;

  }
  case 58: { // Predicate_atomic_cmp_swap_64
    SDNode *N = Node;

  return cast<AtomicSDNode>(N)->getMemoryVT() == MVT::i64;

  }
  case 59: { // Predicate_atomic_swap_8
    SDNode *N = Node;

    return cast<AtomicSDNode>(N)->getMemoryVT() == MVT::i8;
  
  }
  case 60: { // Predicate_atomic_swap_16
    SDNode *N = Node;

    return cast<AtomicSDNode>(N)->getMemoryVT() == MVT::i16;
  
  }
  case 61: { // Predicate_atomic_swap_32
    SDNode *N = Node;

    return cast<AtomicSDNode>(N)->getMemoryVT() == MVT::i32;
  
  }
  case 62: { // Predicate_atomic_swap_64
    SDNode *N = Node;

    return cast<AtomicSDNode>(N)->getMemoryVT() == MVT::i64;
  
  }
  case 63: { // Predicate_immZExt16
    ConstantSDNode*N = cast<ConstantSDNode>(Node);

  // immZExt16 predicate - True if the immediate fits in a 16-bit zero extended
  // field.  Used by instructions like 'ori'.
  return (uint64_t)N->getZExtValue() == (unsigned short)N->getZExtValue();

  }
  case 64: { // Predicate_imm16ShiftedZExt
    ConstantSDNode*N = cast<ConstantSDNode>(Node);

  // imm16ShiftedZExt predicate - True if only bits in the top 16-bits of the
  // immediate are set.  Used by instructions like 'xoris'.
  return (N->getZExtValue() & ~uint64_t(0xFFFF0000)) == 0;

  }
  case 65: { // Predicate_immAllOnesV
    SDNode *N = Node;

  return ISD::isBuildVectorAllOnes(N);

  }
  case 66: { // Predicate_maskimm32
    ConstantSDNode*N = cast<ConstantSDNode>(Node);

  // maskImm predicate - True if immediate is a run of ones.
  unsigned mb, me;
  if (N->getValueType(0) == MVT::i32)
    return isRunOfOnes((unsigned)N->getZExtValue(), mb, me);
  else
    return false;

  }
  case 67: { // Predicate_V_immneg0
    SDNode *N = Node;

  return PPC::isAllNegativeZeroVector(N);

  }
  case 68: { // Predicate_vspltb_shuffle
    SDNode *N = Node;

  return PPC::isSplatShuffleMask(cast<ShuffleVectorSDNode>(N), 1);

  }
  case 69: { // Predicate_vsplth_shuffle
    SDNode *N = Node;

  return PPC::isSplatShuffleMask(cast<ShuffleVectorSDNode>(N), 2);

  }
  case 70: { // Predicate_vspltw_shuffle
    SDNode *N = Node;

  return PPC::isSplatShuffleMask(cast<ShuffleVectorSDNode>(N), 4);

  }
  case 71: { // Predicate_vsldoi_unary_shuffle
    SDNode *N = Node;

  return PPC::isVSLDOIShuffleMask(N, true) != -1;

  }
  case 72: { // Predicate_vpkuwum_unary_shuffle
    SDNode *N = Node;

  return PPC::isVPKUWUMShuffleMask(cast<ShuffleVectorSDNode>(N), true);

  }
  case 73: { // Predicate_vpkuhum_unary_shuffle
    SDNode *N = Node;

  return PPC::isVPKUHUMShuffleMask(cast<ShuffleVectorSDNode>(N), true);

  }
  case 74: { // Predicate_vmrglb_unary_shuffle
    SDNode *N = Node;

  return PPC::isVMRGLShuffleMask(cast<ShuffleVectorSDNode>(N), 1, true);

  }
  case 75: { // Predicate_vmrglh_unary_shuffle
    SDNode *N = Node;

  return PPC::isVMRGLShuffleMask(cast<ShuffleVectorSDNode>(N), 2, true);

  }
  case 76: { // Predicate_vmrglw_unary_shuffle
    SDNode *N = Node;

  return PPC::isVMRGLShuffleMask(cast<ShuffleVectorSDNode>(N), 4, true);

  }
  case 77: { // Predicate_vmrghb_unary_shuffle
    SDNode *N = Node;

  return PPC::isVMRGHShuffleMask(cast<ShuffleVectorSDNode>(N), 1, true);

  }
  case 78: { // Predicate_vmrghh_unary_shuffle
    SDNode *N = Node;

  return PPC::isVMRGHShuffleMask(cast<ShuffleVectorSDNode>(N), 2, true);

  }
  case 79: { // Predicate_vmrghw_unary_shuffle
    SDNode *N = Node;

  return PPC::isVMRGHShuffleMask(cast<ShuffleVectorSDNode>(N), 4, true);

  }
  case 80: { // Predicate_vsldoi_shuffle
    SDNode *N = Node;

  return PPC::isVSLDOIShuffleMask(N, false) != -1;

  }
  case 81: { // Predicate_vmrghb_shuffle
    SDNode *N = Node;

  return PPC::isVMRGHShuffleMask(cast<ShuffleVectorSDNode>(N), 1, false);

  }
  case 82: { // Predicate_vmrghh_shuffle
    SDNode *N = Node;

  return PPC::isVMRGHShuffleMask(cast<ShuffleVectorSDNode>(N), 2, false);

  }
  case 83: { // Predicate_vmrghw_shuffle
    SDNode *N = Node;

  return PPC::isVMRGHShuffleMask(cast<ShuffleVectorSDNode>(N), 4, false);

  }
  case 84: { // Predicate_vmrglb_shuffle
    SDNode *N = Node;

  return PPC::isVMRGLShuffleMask(cast<ShuffleVectorSDNode>(N), 1, false);

  }
  case 85: { // Predicate_vmrglh_shuffle
    SDNode *N = Node;

  return PPC::isVMRGLShuffleMask(cast<ShuffleVectorSDNode>(N), 2, false);

  }
  case 86: { // Predicate_vmrglw_shuffle
    SDNode *N = Node;

  return PPC::isVMRGLShuffleMask(cast<ShuffleVectorSDNode>(N), 4, false);

  }
  case 87: { // Predicate_vpkuhum_shuffle
    SDNode *N = Node;

  return PPC::isVPKUHUMShuffleMask(cast<ShuffleVectorSDNode>(N), false);

  }
  case 88: { // Predicate_vpkuwum_shuffle
    SDNode *N = Node;

  return PPC::isVPKUWUMShuffleMask(cast<ShuffleVectorSDNode>(N), false);

  }
  case 89: { // Predicate_vecspltisb
    SDNode *N = Node;

  return PPC::get_VSPLTI_elt(N, 1, *CurDAG).getNode() != 0;

  }
  case 90: { // Predicate_vecspltish
    SDNode *N = Node;

  return PPC::get_VSPLTI_elt(N, 2, *CurDAG).getNode() != 0;

  }
  case 91: { // Predicate_vecspltisw
    SDNode *N = Node;

  return PPC::get_VSPLTI_elt(N, 4, *CurDAG).getNode() != 0;

  }
  case 92: { // Predicate_immAllZerosV
    SDNode *N = Node;

  return ISD::isBuildVectorAllZeros(N);

  }
  }
}

bool CheckComplexPattern(SDNode *Root, SDNode *Parent, SDValue N,
                         unsigned PatternNo,
         SmallVectorImpl<std::pair<SDValue, SDNode*> > &Result) {
  unsigned NextRes = Result.size();
  switch (PatternNo) {
  default: llvm_unreachable("Invalid pattern # in table?");
  case 0:
    Result.resize(NextRes+2);
    return SelectAddrIdxOnly(N, Result[NextRes+0].first, Result[NextRes+1].first);
  case 1:
    Result.resize(NextRes+2);
    return SelectAddrImm(N, Result[NextRes+0].first, Result[NextRes+1].first);
  case 2:
    Result.resize(NextRes+2);
    return SelectAddrIdx(N, Result[NextRes+0].first, Result[NextRes+1].first);
  case 3:
    Result.resize(NextRes+2);
    return SelectAddrImmShift(N, Result[NextRes+0].first, Result[NextRes+1].first);
  case 4:
    Result.resize(NextRes+1);
    return SelectAddrImmOffs(N, Result[NextRes+0].first);
  }
}

SDValue RunSDNodeXForm(SDValue V, unsigned XFormNo) {
  switch (XFormNo) {
  default: llvm_unreachable("Invalid xform # in table?");
  case 0: {  // HI16
    ConstantSDNode *N = cast<ConstantSDNode>(V.getNode());

  // Transformation function: shift the immediate value down into the low bits.
  return getI32Imm((unsigned)N->getZExtValue() >> 16);

  }
  case 1: {  // LO16
    ConstantSDNode *N = cast<ConstantSDNode>(V.getNode());

  // Transformation function: get the low 16 bits.
  return getI32Imm((unsigned short)N->getZExtValue());

  }
  case 2: {  // HA16
    ConstantSDNode *N = cast<ConstantSDNode>(V.getNode());

  // Transformation function: shift the immediate value down into the low bits.
  signed int Val = N->getZExtValue();
  return getI32Imm((Val - (signed short)Val) >> 16);

  }
  case 3: {  // MB
    ConstantSDNode *N = cast<ConstantSDNode>(V.getNode());

  // Transformation function: get the start bit of a mask
  unsigned mb = 0, me;
  (void)isRunOfOnes((unsigned)N->getZExtValue(), mb, me);
  return getI32Imm(mb);

  }
  case 4: {  // ME
    ConstantSDNode *N = cast<ConstantSDNode>(V.getNode());

  // Transformation function: get the end bit of a mask
  unsigned mb, me = 0;
  (void)isRunOfOnes((unsigned)N->getZExtValue(), mb, me);
  return getI32Imm(me);

  }
  case 5: {  // SHL32
    ConstantSDNode *N = cast<ConstantSDNode>(V.getNode());

  // Transformation function: 31 - imm
  return getI32Imm(31 - N->getZExtValue());

  }
  case 6: {  // SHL64
    ConstantSDNode *N = cast<ConstantSDNode>(V.getNode());

  // Transformation function: 63 - imm
  return getI32Imm(63 - N->getZExtValue());

  }
  case 7: {  // SRL32
    ConstantSDNode *N = cast<ConstantSDNode>(V.getNode());

  // Transformation function: 32 - imm
  return N->getZExtValue() ? getI32Imm(32 - N->getZExtValue()) : getI32Imm(0);

  }
  case 8: {  // SRL64
    ConstantSDNode *N = cast<ConstantSDNode>(V.getNode());

  // Transformation function: 64 - imm
  return N->getZExtValue() ? getI32Imm(64 - N->getZExtValue()) : getI32Imm(0);

  }
  case 9: {  // VSPLTB_get_imm
    SDNode *N = V.getNode();

  return getI32Imm(PPC::getVSPLTImmediate(N, 1));

  }
  case 10: {  // VSPLTH_get_imm
    SDNode *N = V.getNode();

  return getI32Imm(PPC::getVSPLTImmediate(N, 2));

  }
  case 11: {  // VSPLTW_get_imm
    SDNode *N = V.getNode();

  return getI32Imm(PPC::getVSPLTImmediate(N, 4));

  }
  case 12: {  // VSLDOI_unary_get_imm
    SDNode *N = V.getNode();

  return getI32Imm(PPC::isVSLDOIShuffleMask(N, true));

  }
  case 13: {  // VSLDOI_get_imm
    SDNode *N = V.getNode();

  return getI32Imm(PPC::isVSLDOIShuffleMask(N, false));

  }
  case 14: {  // VSPLTISB_get_imm
    SDNode *N = V.getNode();

  return PPC::get_VSPLTI_elt(N, 1, *CurDAG);

  }
  case 15: {  // VSPLTISH_get_imm
    SDNode *N = V.getNode();

  return PPC::get_VSPLTI_elt(N, 2, *CurDAG);

  }
  case 16: {  // VSPLTISW_get_imm
    SDNode *N = V.getNode();

  return PPC::get_VSPLTI_elt(N, 4, *CurDAG);

  }
  }
}

